SystemOrganization addCategory: #Exupery!
SystemOrganization addCategory: #'Exupery-Intermediate'!
SystemOrganization addCategory: #'Exupery-Plugin'!
SystemOrganization addCategory: #'Exupery-Customer Tests'!
SystemOrganization addCategory: #'Exupery-Programmer Tests'!
SystemOrganization addCategory: #'Exupery-Inspectors'!

Object subclass: #AssembleInstruction
	instanceVariableNames: 'stream assembler instruction name encodingRules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

AssembleInstruction subclass: #AssembleArithmatic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!AssembleArithmatic methodsFor: 'misc' stamp: 'wbk 3/16/2003 21:07'!
arg1
	^ instruction arg1! !

!AssembleArithmatic methodsFor: 'misc' stamp: 'wbk 3/16/2003 21:07'!
arg2
	^ instruction arg2! !

!AssembleInstruction class methodsFor: 'instance creation' stamp: 'wbk 4/7/2003 14:25'!
instruction: aMedMov assembler: anAssembler
	|assembler|
	assembler := self new 
		initialiseInstruction: aMedMov
		assembler: anAssembler.
	assembler run.! !

!AssembleInstruction class methodsFor: 'instance creation' stamp: 'wbk 4/7/2003 14:25'!
name: aSymbol assembler: anAssemblerExupery 
	^ self new
		initializeName: aSymbol 
		assembler: anAssemblerExupery! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:06'!
addEncoding: anEncoder
	encodingRules add: anEncoder.
	anEncoder registerInstruction: self.! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 3/16/2003 21:08'!
arg1
	^ instruction from! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 3/16/2003 21:08'!
arg2
	^ instruction to! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 4/4/2003 17:30'!
assembler
	^ assembler! !

!AssembleInstruction methodsFor: 'Assembling' stamp: 'wbk 4/4/2003 17:10'!
encode: aMedAssembly 
	instruction := aMedAssembly.
	self run.! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 4/18/2003 16:17'!
initializeName: aSymbol assembler: anAssemblerExupery
	name := aSymbol.
	assembler := anAssemblerExupery.
	stream := assembler stream.
	encodingRules := OrderedCollection new.
	anAssemblerExupery 
		addInstruction: self
		named: name.! !

!AssembleInstruction methodsFor: 'Assembling' stamp: 'wbk 4/7/2003 14:21'!
run
	| rule |
	rule := encodingRules detect: [:each| each isFirable].
	rule fire.! !

AssembleInstruction subclass: #AssembleJump
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!AssembleJump methodsFor: 'Assembling' stamp: 'wbk 1/14/2004 22:03'!
encodeOpcode
	instruction type = #jz | (instruction type = #je) ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 132].
	instruction type = #jg ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r8F].
	instruction type = #jo ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r80].
	instruction type = #jmp ifTrue:
		[^ stream nextPut: 16rE9].
	instruction type = #jnz | (instruction type = #jne) ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r85].
	instruction type = #jl ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r8C].
	instruction type = #jle ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r8E].
	instruction type = #jge ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r8D].

	self error: 'Unknown jump type'.! !

!AssembleJump methodsFor: 'Assembling' stamp: 'wbk 4/11/2003 15:58'!
encodeTarget
	stream nextPut: 0.
	stream nextPut: 0.
	stream nextPut: 0.
	stream nextPut: 0.
	assembler patchJumpTo: instruction target! !

!AssembleJump methodsFor: 'misc' stamp: 'wbk 4/18/2003 16:16'!
initialiseInstruction: aMedMov assembler: anAssembler 
	instruction := aMedMov.
	assembler := anAssembler.
	stream := assembler stream.
	encodingRules := OrderedCollection new.! !

!AssembleJump methodsFor: 'Assembling' stamp: 'wbk 2/6/2005 19:12'!
run
	instruction target isMedBlock
		ifTrue:
			[self encodeOpcode.
			self encodeTarget]
		ifFalse:
			[assembler stream nextPut: 16rFF.
			assembler
				encodeModRm: instruction target
				registerOpcode: 4]! !

Object subclass: #AssemblerExupery
	instanceVariableNames: 'stream blockAddresses jumpOffsets bytecodes instructionEncoders plugin relocator picEntries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!AssemblerExupery class methodsFor: 'as yet unclassified' stamp: 'wbk 1/21/2005 22:30'!
assemble: aMedMethod withPlugin: aPlugin relocator: aRelocator
	| assembler |
	assembler := self new 
		initializePlugin: aPlugin
		relocator: aRelocator.
	aMedMethod visitWith: assembler.
	^assembler ! !

!AssemblerExupery class methodsFor: 'as yet unclassified' stamp: 'wbk 1/21/2005 22:30'!
basicAssemble: aMedMethod withPlugin: aPlugin relocator: aRelocator
	| assembler |
	assembler := self new 
		initializePlugin: aPlugin
		relocator: aRelocator.
	aMedMethod visitWith: assembler.
	^assembler! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 4/18/2003 16:19'!
addInstruction: anInstruction named: aSymbol
	instructionEncoders 
		at: aSymbol 
		put: anInstruction.! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 1/21/2005 22:03'!
addRelocationFor: aMedBlock 
	relocator
		addRelocationAt: stream position
		for: aMedBlock! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 2/26/2005 20:22'!
addressFor: aMedBlock 
	^ blockAddresses at: aMedBlock blockNumber! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 2/27/2005 10:05'!
addressOfLiteral: aLiteral 
	^ plugin addressOf: aLiteral! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 1/21/2005 22:28'!
blockPositions
	^ blockAddresses! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 4/3/2003 20:53'!
byteCodes
	^ bytecodes! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 2/27/2005 10:05'!
encodeImmediate: aLiteral
	| value |
	value := aLiteral valueUsing: self.
	stream nextPut: (value bitAnd: 255).
	stream nextPut: ((value bitShift: -8) bitAnd: 255).
	stream nextPut: ((value bitShift: -16) bitAnd: 255).
	stream nextPut: ((value bitShift: -24) bitAnd: 255).! !

!AssemblerExupery methodsFor: 'Addressing Modes' stamp: 'wbk 3/16/2003 21:05'!
encodeModRm: modRmMed register: registerMed 
	^ self 
		encodeModRm: modRmMed 
		registerOpcode: (self registerEncoding: registerMed)! !

!AssemblerExupery methodsFor: 'Addressing Modes' stamp: 'wbk 6/2/2004 22:07'!
encodeModRm: modRmMed registerOpcode: anInteger 
	| mod rm result |
	modRmMed isLiteral 
		ifTrue: 
			[mod := 0.
			rm := 2r101]
		ifFalse:
			[modRmMed isAddressingMode 
				ifTrue: 
					[modRmMed hasOffset 
						ifTrue: [modRmMed offset <= 127
							ifTrue: [mod := 1]
							ifFalse: [mod := 2r10]] 
				ifFalse: [mod := 0].
			rm := self registerEncoding: modRmMed base]
		ifFalse: 
			[mod := 3.
			rm := self registerEncoding: modRmMed]].
	result := (mod bitShift: 6) + (anInteger bitShift: 3) + rm.
	stream nextPut: result.
	modRmMed isLiteral ifTrue: [^ self encodeImmediate: modRmMed.].
	modRmMed hasOffset ifTrue: 
		[modRmMed offset >= 0
			ifTrue:
				[modRmMed offset <= 127
					ifTrue: [stream nextPut: modRmMed offset]
					ifFalse: [self encodeImmediate: (MedLiteral literal: modRmMed offset)]]
			ifFalse:
				[modRmMed offset >= -128
					ifTrue: [stream nextPut: 256 + modRmMed offset]
					ifFalse: [Error signal: 'NOT YET IMPLEMENTED']]].! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 4/18/2003 18:34'!
initializeArithmaticInstructionNamed: nameSymbol toAddressingCode: toInteger fromAddressingCode: fromInteger fromImmediateCode: fromImmediateInteger fromImmediateModRmCode: fromImmediateToModRmInteger 
	| instruction |
	instruction := AssembleArithmatic 
		name: nameSymbol 
		assembler: self.
	instruction addEncoding: (EncodeToAddressingMode opcode: toInteger).
	instruction addEncoding: (EncodeFromAddressingMode opcode: fromInteger).
	instruction addEncoding: (EncodeFromLiteral 
				opcode: fromImmediateInteger
				modRmOpcode: fromImmediateToModRmInteger).! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 2/8/2004 22:12'!
initializeEncodingRules
	self 
		initializeShiftInstructionName: #sar
		firstByte: 193
		modRmOpcode: 7
		fixedRegiser: #ecx
		fixedOpcode: 16rD3
		fixedModRm: 7.
	self 
		initializeShiftInstructionName: #sal
		firstByte: 193
		modRmOpcode: 4
		fixedRegiser: #ecx
		fixedOpcode: 16rD3
		fixedModRm: 4.
	self 
		initializeArithmaticInstructionNamed: #add
		toAddressingCode: 1
		fromAddressingCode: 3
		fromImmediateCode: 129
		fromImmediateModRmCode: 0.
	self 
		initializeArithmaticInstructionNamed: #and
		toAddressingCode: 33
		fromAddressingCode: 35
		fromImmediateCode: 129
		fromImmediateModRmCode: 4.
	self initializeMoveInstruction.
	self 
		initializeArithmaticInstructionNamed: #sub
		toAddressingCode: 41
		fromAddressingCode: 43
		fromImmediateCode: 129
		fromImmediateModRmCode: 5.
	self initializeMulInstruction.
	self 
		initializeArithmaticInstructionNamed: #or
		toAddressingCode: 9
		fromAddressingCode: 11
		fromImmediateCode: 129
		fromImmediateModRmCode: 1! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 4/18/2003 18:34'!
initializeMoveInstruction
	| instruction |
	instruction := (AssembleInstruction
			name: #mov
			assembler: self).
	instruction addEncoding: (EncodeToAddressingMode opcode: 137).
	instruction addEncoding: (EncodeFromAddressingMode opcode: 139).
	instruction addEncoding: (EncodeFromLiteralToRegister opcode: 184).
	instruction addEncoding: (EncodeFromLiteral
		opcode: 199
		modRmOpcode: 0).! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 12/25/2004 22:30'!
initializeMulInstruction
	| instruction aSymbol |
	aSymbol := #mul.
	instruction := (AssembleArithmatic
			name: aSymbol
			assembler: self).
	instruction addEncoding: (EncodeFromAddressingMode opcodes: #(16r0F 16rAF)).! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 2/27/2005 15:02'!
initializePlugin: aPlugin relocator: aRelocator 
	plugin := aPlugin.
	relocator := aRelocator.
	stream := WriteStream on: ByteArray new.
	blockAddresses := Dictionary new.
	jumpOffsets := OrderedCollection new.
	instructionEncoders := Dictionary new.
	picEntries := OrderedCollection new.
	self initializeEncodingRules.
	^ self! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 2/8/2004 21:35'!
initializeShiftInstructionName: aSymbol firstByte: firstByte modRmOpcode: modRmInteger fixedRegiser: registerSymbol fixedOpcode: fixedOpcodeInteger fixedModRm: fixedModRmInteger 
	| instruction |
	instruction := AssembleArithmatic 
				name: aSymbol
				assembler: self.
	instruction addEncoding: (EncodeImm8Rm32 
				firstByte: firstByte
				modRmValue: modRmInteger).
	instruction addEncoding: (EncodeFixedRegRm32
		fixedRegister: registerSymbol
		fixedOpcode: fixedOpcodeInteger
		fixedModRm: fixedModRmInteger).! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 4/3/2003 23:17'!
patchByteAt: locationInteger with: valueInteger 
	bytecodes
		at: locationInteger
		put: valueInteger! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 2/26/2005 19:35'!
patchJumpTo: aMedBlock 
	jumpOffsets add: (OffsetPatcher
		target: aMedBlock
		location: stream position
		assembler: self)! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 2/27/2005 15:01'!
picEntries
	^ picEntries! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 1/21/2005 21:56'!
position
	^ stream position! !

!AssemblerExupery methodsFor: 'Addressing Modes' stamp: 'wbk 4/18/2003 16:10'!
registerEncoding: aRegister
	aRegister name = #eax ifTrue: [^ 2r000].
	aRegister name = #ebx ifTrue: [^ 2r011].
	aRegister name = #ecx ifTrue: [^ 2r001].
	aRegister name = #edx ifTrue: [^ 2r010].

	aRegister name = #esi ifTrue: [^ 2r110].
	aRegister name = #edi ifTrue: [^ 2r111].

	aRegister name = #esp ifTrue: [^ 2r100].
	aRegister name = #ebp ifTrue: [^ 2r101].

	self error: ' Unrecognised register'.! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 3/16/2003 18:34'!
stream
	^ stream! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 4/6/2003 21:24'!
visitAssembly: aMed 
	| encoder |
	encoder := instructionEncoders at: aMed name.
	encoder encode: aMed
! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 1/17/2005 20:06'!
visitBlock: aMedBlock 
	[aMedBlock isAligned & (stream position \\ 2 ~= 0)] whileTrue: [stream nextPut: 0].
	blockAddresses 
		at: aMedBlock blockNumber
		put: stream position.
	aMedBlock instructionsDo: [:each | each visitWith: self]! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 6/30/2003 20:28'!
visitCall: aMedCall 
	stream nextPut: 16rFF.
	self 
		encodeModRm: aMedCall function
		registerOpcode: 2.! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 1/31/2004 18:32'!
visitDivide: aMedDivide 
		stream nextPut: 16rF7.
	self 
		encodeModRm: aMedDivide argument
		registerOpcode: 7.! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 3/31/2003 21:33'!
visitJump: aMedJump 
	AssembleJump
		instruction: aMedJump
		assembler: self! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 2/27/2005 10:07'!
visitMethod: aMedMethod 
	aMedMethod blocksDo: [:each | each visitWith: self].
	bytecodes _ stream contents.
	jumpOffsets do: [:each | each patch].! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 4/7/2003 14:55'!
visitMov: aMedMov 
	self visitAssembly: aMedMov! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 2/9/2004 21:13'!
visitNegate: aMedNegate 
	stream nextPut: 16rF7.
	self
		encodeModRm: aMedNegate argument
		registerOpcode: 3
	! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 2/27/2005 15:06'!
visitPic: aMedPic.
	aMedPic picEntry picMethodLocation: stream position.
	picEntries add: aMedPic picEntry.
	1 
		to: 36
		do: [:each| stream nextPut: 16r90]! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 3/4/2005 16:18'!
visitPop: aMedPop 
	stream nextPut: 16r58 + (self registerEncoding: aMedPop argument).! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 6/25/2003 16:36'!
visitPush: aMedPush 
	"This will probably need to be refactored. Possilby adding a class AssembleUnaryInstruction that assembles
	instructions with just one argument, it should be possible to stub out the other argument for mod/rm 
 	instructions. Single register instructions may be a little harder, the encoder for single registers also
	adds a literal, see EncodeFromLiteralToRegister."
	stream nextPut: 16r50 + (self registerEncoding: aMedPush argument).! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 3/4/2005 17:36'!
visitRet: aMedRet 
	"The postamble. This is the C return sequence"
	stream nextPutAll: #( "16r83 16rC4 64 16r5F 16r5E 16r5B 16r89 16rEC 16r5D" 16rC3)! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 2/2/2004 21:25'!
visitX86Cdq: aMedX86CDQ 
	stream nextPut: 16r99! !

Object subclass: #ByteCodeReader
	instanceVariableNames: 'method generator stack stackHeights jumpTargets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!ByteCodeReader class methodsFor: 'reading' stamp: 'wbk 5/30/2004 23:34'!
newMethod: aMethod using: aGenerator jumpTargets: jumpArray stackHeights: stackArray
	^ (self new
		initialiseMethod: aMethod
		using: aGenerator
		stack: (ExuperyStack 
			newPC: aMethod initialPC
			emitter: aGenerator emitter)
		jumpTargets: jumpArray
		stackHeights: stackArray) run	! !

!ByteCodeReader class methodsFor: 'reading' stamp: 'wbk 5/30/2004 23:29'!
newMethod: aMethod using: aGenerator stack: aStack
	^ (self new
		initialiseMethod: aMethod
		using: aGenerator
		stack: aStack
		jumpTargets: #()
		stackHeights: #()) run! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:23'!
add
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				add: second)! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/22/2004 15:48'!
binarySendWithSpecialSelector: anObject 
	| sendResult receiver argument |
	argument := stack pop.
	receiver := stack pop.	"Remove the two arguments"
	sendResult := generator 
				generateBinarySelector: anObject
				receiver: receiver
				argument: argument.
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
bitAnd
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				bitAnd: second)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/7/2004 20:39'!
bitOr
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				bitOr: second)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 19:08'!
bitShift
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator
		generate: first
		bitShift: second)! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 6/16/2004 22:31'!
byteCodeActionFor: anInteger 
	anInteger = 118 ifTrue: [^self pushConstant: 1 slot: -1].
	anInteger = 119 ifTrue: [^self pushConstant: 2 slot: -1].
	anInteger = 176 ifTrue: [^self add].
	anInteger = 124 ifTrue: [^self returnTop].
	anInteger >= 32 & (anInteger <= 63) ifTrue: [^self pushLiteralConstant].
	anInteger >= 104 & (anInteger <= 111) ifTrue: [^self popIntoTemp].
	anInteger = 120 ifTrue: [^self returnSelf].
	anInteger >= 16 & (anInteger <= 31) ifTrue: [^self pushTemp].
	anInteger = 180 ifTrue: [^self lessThanEquals].
	anInteger >= 152 & (anInteger <= 159) ifTrue: [^self shortConditionalJump].
	anInteger >= 172 & (anInteger <= 175) ifTrue: [^self longJumpIfFalse].
	anInteger = 184 ifTrue: [^self multiply].
	anInteger >= 160 & (anInteger <= 167) 
		ifTrue: [^self longUnconditionalJump].
	anInteger = 177 ifTrue: [^self subtract].
	anInteger = 112 ifTrue: [^self pushSelf].
	anInteger >= 208 & (anInteger <= 255) ifTrue: [^self sendLiteralSelector].
	anInteger = 117 ifTrue: [^self pushConstant: 0 slot: -1].
	anInteger >= 64 & (anInteger <= 95) ifTrue: [^self pushConstantVariable].
	anInteger = 205 ifTrue: [^self binarySendWithSpecialSelector: 29].
	anInteger = 113 ifTrue: [^self pushTrue].
	anInteger = 192 ifTrue: [^self sendAt].
	anInteger = 114 ifTrue: [^self pushFalse].
	anInteger = 193 ifTrue: [^self sendAtPut].
	anInteger = 135 ifTrue: [^self popStack].
	anInteger >= 0 & (anInteger <= 15) ifTrue: [^self pushInstanceVariable].
	anInteger >= 96 & (anInteger <= 103) 
		ifTrue: [^self storeAndPopReceiverVariable].
	anInteger = 116 ifTrue: [^self pushConstant: -1 slot: -1].
	anInteger = 115 ifTrue: [^self pushNil].
	anInteger = 123 ifTrue: [^self returnNil].
	anInteger = 121 ifTrue: [^self returnTrue].
	anInteger = 122 ifTrue: [^self returnFalse].
	anInteger = 178 ifTrue: [^self lessThan].
	anInteger = 179 ifTrue: [^self greaterThan].
	anInteger = 181 ifTrue: [^self greaterThanEqual].
	anInteger = 182 ifTrue: [^self equals].
	anInteger = 183 ifTrue: [^self notEquals].
	anInteger = 185 ifTrue: [^self divide].
	anInteger = 190 ifTrue: [^self bitAnd].
	anInteger = 191 ifTrue: [^self bitOr].
	anInteger = 189 ifTrue: [^self div].
	anInteger = 186 ifTrue: [^self mod].
	anInteger = 188 ifTrue: [^self bitShift].
	anInteger = 187 ifTrue: [^self makePoint].
	anInteger >= 168 & (anInteger <= 171) ifTrue: [^self longJumpIfTrue].
	anInteger = 204 ifTrue: [^self unarySendWithSelector: 28].
	anInteger = 194 ifTrue: [^self unarySendWithSelector: 18].
	anInteger = 195 ifTrue: [^self unarySendWithSelector: 19].
	anInteger = 196 ifTrue: [^self binarySendWithSpecialSelector: 20].
	anInteger = 197 ifTrue: [^self unarySendWithSelector: 21].
	anInteger = 198 ifTrue: [^self equivilent].
	anInteger >= 144 & (anInteger <= 151) 
		ifTrue: [^self shortUnconditionalJump].
	anInteger = 206 ifTrue: [^self unarySendWithSelector: 30].
	anInteger = 207 ifTrue: [^self unarySendWithSelector: 31].
	anInteger = 199 ifTrue: [^self sendClass].
	anInteger = 130 ifTrue: [^self extendedPopAndStore].
	anInteger = 128 ifTrue: [^self extendedPushBytecode].
	anInteger = 129 ifTrue: [^self extendedStore].
	anInteger = 131 ifTrue: [^self extendedSend].
	
	generator addUnknownByteCode! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 5/31/2004 20:25'!
byteCodeAddressing: anInteger
	| jumpIndex |
	generator byteCodeAddress: anInteger.
	jumpIndex := jumpTargets 
		indexOf: anInteger
		ifAbsent: [^ self].
	stack heightTo: (stackHeights at: jumpIndex) ! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 7/28/2003 13:03'!
currentByteCode
	^method at: stack pc! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/7/2004 20:39'!
div
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				div: second)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:18'!
divide
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				divide: second)! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
equals
	| secondMed firstMed |
	secondMed := stack pop.
	firstMed := stack pop.
	stack push: (generator 
				prim: firstMed
				equals: secondMed)! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/27/2004 21:25'!
equivilent
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator
		generate: first
		equivilent: second).! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 12/8/2004 20:35'!
extendedPopAndStore
	| answer |
	answer := self extendedStoreBody.
	generator addExpression: answer.
	^ answer

	! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 6/13/2004 12:36'!
extendedPushBytecode
	| argument variableType variableIndex answer |
	argument := self fetchByte.
	variableType := (argument >> 6) bitAnd: 16r3.
	variableIndex := argument bitAnd: 16r3F.
	
	variableType = 0 ifTrue: 
		[answer := generator pushInstanceVariable: variableIndex.
		^ stack push: answer].
	variableType = 1 ifTrue:
		[answer := generator pushTempAt: variableIndex.
		^ stack push: answer].
	
	Error signal: 'Not Yet Handled'.! !

!ByteCodeReader methodsFor: 'Sends' stamp: 'wbk 6/16/2004 22:38'!
extendedSend
	| argument selectorIndex argumentCount sendResult |
	argument := self fetchByte.
	selectorIndex := argument bitAnd: 16r1F.
	argumentCount := argument >> 5.
	sendResult := generator
		sendSelector: (method literalAt: selectorIndex +1)
		inSlot: selectorIndex
		arguments: (stack pop: argumentCount + 1).
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 12/8/2004 20:32'!
extendedStore
	^ stack push: self extendedStoreBody! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 12/8/2004 20:33'!
extendedStoreBody
	| argument variableType variableIndex |
	argument := self fetchByte.
	variableType := (argument >> 6) bitAnd: 16r3.
	variableIndex := argument bitAnd: 16r3F.
	variableType = 0 ifTrue:
		[^ generator
			storeAndPopReceiverVariableIndex: variableIndex
			value: stack pop]. 
	variableType = 1 ifTrue:
		[^ generator
			popIntoTemp: stack pop
			slot: variableIndex].
	
	Error signal: 'Not Handled Yet'.
	! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 7/28/2003 13:03'!
fetchByte
	stack incrementPC.
	^method at: stack pc! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
greaterThan
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				prim: first
				greaterThan: second)! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
greaterThanEqual
	| secondMed firstMed |
	secondMed := stack pop.
	firstMed := stack pop.
	stack push: (generator 
				prim: firstMed
				greaterThanEqual: secondMed)! !

!ByteCodeReader methodsFor: 'Misc' stamp: 'wbk 5/31/2004 20:21'!
initialiseMethod: aMethod using: aGenerator stack: aStack jumpTargets: jumpArray stackHeights: heightArray
	method := aMethod.
	generator := aGenerator.
	stack := aStack.
	generator state: stack.
	stackHeights := heightArray.
	jumpTargets := jumpArray.! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
lessThan
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				prim: first
				lessThan: second)! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 9/22/2004 21:40'!
lessThanEquals
	| first second |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
		prim: first
		lessThanEquals: second)! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/7/2004 20:38'!
longJumpIfFalse
	| boolean target |
	boolean := stack pop.
	target := stack pc + ((self currentByteCode bitAnd: 3) * 256) + self fetchByte + 2.
	generator 
		jumpIfFalse: boolean
		to: target! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/14/2004 11:50'!
longJumpIfTrue
	| boolean target |
	boolean := stack pop.
	target := stack pc + ((self currentByteCode bitAnd: 3) * 256) + self fetchByte + 2.
	generator 
		jumpIfTrue: boolean
		to: target! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/13/2005 12:46'!
longUnconditionalJump
	| target |
	target _ stack pc + (((self currentByteCode bitAnd: 7) - 4) * 256) + self fetchByte + 2.
	generator jumpTo: target! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/13/2004 20:30'!
makePoint
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: 
		(generator 
			generate: first
			makePoint: second).! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/7/2004 20:39'!
mod
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				mod: second)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:27'!
multiply
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				multiply: second)! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
notEquals
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				prim: first
				notEquals: second)! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 10/23/2004 20:29'!
popIntoTemp
	generator addExpression: (generator 
		popIntoTemp: stack pop
		slot: self currentByteCode - 104)! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:38'!
popStack
	^generator popStack: stack pop! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 10/4/2004 20:32'!
processByteCode: anInteger
	self byteCodeAddressing: stack pc.
	^self byteCodeActionFor: anInteger! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 4/23/2004 22:31'!
pushConstant: aLiteral slot: aNumber 
	| answer |
	answer := generator 
				pushConstant: aLiteral
				slot: aNumber.
	stack push: answer.
	^answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 7/12/2003 10:05'!
pushConstantVariable
	|position|
	position := self currentByteCode bitAnd: 16r1F.
	self 
		pushLiteralVariable: (method literalAt: position + 1)
		slot: position! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushFalse
	stack push: generator pushFalse! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushInstanceVariable
	| position answer |
	position := self currentByteCode bitAnd: 15.
	answer := generator pushInstanceVariable: position.
	stack push: answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 9/18/2002 22:18'!
pushLiteralConstant
	|position|
	position := self currentByteCode bitAnd: 16r1F.
	self 
		pushConstant: (method literalAt: position + 1)
		slot: position
	! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushLiteralVariable: aLiteral slot: aSmallInteger 
	| answer |
	answer := generator 
				pushLiteralVariable: aLiteral
				slot: aSmallInteger.
	stack push: answer.
	^answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushNil
	stack push: generator pushNil! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushSelf
	| answer |
	answer := generator pushSelf.
	stack push: answer.
	^answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushTemp
	| answer |
	answer := generator pushTempAt: (self currentByteCode bitAnd: 15).
	stack push: answer.
	^answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushTrue
	| answer |
	answer := generator pushTrue.
	stack push: answer! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 11/27/2003 21:17'!
returnFalse
	generator returnFalse! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 10/18/2003 12:53'!
returnNil
	generator returnNil! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 10/4/2003 00:04'!
returnSelf
	generator returnSelf.! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 9/28/2004 22:45'!
returnTop
	generator returnTop: stack pop.
	"self assert: [stack isEmpty]" "This isn't always true, the problem is demonstrated with the
									shortUnconditionalJumpTests. There they push a return value
									onto the stack to be used if the block is not evaluated."! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 11/27/2003 19:38'!
returnTrue
	generator returnTrue! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 10/20/2004 22:39'!
run
	method primitive ~= 0 ifTrue: [generator setPrimitive: method primitive].
	generator numberOfTemporaries: method numTemps.
	[stack pc <= method endPC] whileTrue: 
			[self processByteCode: (method at: stack pc).
			stack incrementPC].
	generator finish! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/7/2004 20:39'!
sendAt
	| argument receiver sendResult |
	argument := stack pop.
	receiver := stack pop.
	sendResult := generator 
				sendAtTo: receiver
				with: argument.
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/7/2004 20:39'!
sendAtPut
	| value location receiver sendResult |
	value := stack pop.
	location := stack pop.
	receiver := stack pop.
	sendResult := generator 
				sendAtPutTo: receiver
				location: location
				value: value.
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 3/1/2004 19:47'!
sendClass
	stack push: (generator generateClass: stack pop)! !

!ByteCodeReader methodsFor: 'Sends' stamp: 'wbk 2/7/2004 20:39'!
sendLiteralSelector
	| selectorPosition argumentCount sendResult arguments |
	selectorPosition := self currentByteCode bitAnd: 15.
	argumentCount := (self currentByteCode >> 4 bitAnd: 3) - 1.
	arguments := stack pop: argumentCount + 1.
	sendResult := generator 
				sendSelector: (method literalAt: selectorPosition + 1)
				inSlot: selectorPosition
				arguments: arguments.
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/14/2004 15:19'!
sendNew
	| argument |
	argument := stack pop.
	stack push: (generator generateNew: argument)! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/7/2004 20:38'!
shortConditionalJump
	| boolean destination |
	boolean := stack pop.
	destination := stack pc + (self currentByteCode bitAnd: 7) + 1 + 1.
	generator 
		jumpIfFalse: boolean
		to: destination! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/13/2005 12:46'!
shortUnconditionalJump
	| target |
	target _ stack pc + (self currentByteCode bitAnd: 7) + 2.
	generator jumpTo: target! !

!ByteCodeReader methodsFor: 'Misc' stamp: 'wbk 5/31/2004 20:20'!
stackHeight
	^ stack stackSize! !

!ByteCodeReader methodsFor: 'Misc' stamp: 'wbk 5/30/2004 23:09'!
stackHeights
	^ stackHeights! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 12/2/2004 19:42'!
storeAndPopReceiverVariable
	generator addExpression: (generator 
		storeAndPopReceiverVariableIndex: (self currentByteCode bitAnd: 7)
		value: stack pop)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:24'!
subtract
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				subtract: second)! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/22/2004 13:27'!
unarySendWithSelector: aSmallInteger 
	| argument |
	argument := stack pop.
	stack push: (generator 
		generateUnarySelector: aSmallInteger
		receiver: argument)! !

Object subclass: #ColouringRegisterAllocator
	instanceVariableNames: 'source result machine interferenceGraph registerStack registerFile registerTable spiltRegisters hasSpilt coloursUsed simplifyWorklist spillWorklist moveWorklist coalescedMoves'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!ColouringRegisterAllocator class methodsFor: 'instance creation' stamp: 'wbk 10/23/2002 13:47'!
on: aMethod for: aMachine
	| allocator |
	allocator := self new
		initialiseSource: aMethod
		machine: aMachine.
	allocator run.
	^ allocator! !

!ColouringRegisterAllocator methodsFor: 'Interference Graph' stamp: 'wbk 11/2/2002 16:15'!
addInterferenceEdge: firstRegister to: secondRegister
	| firstNode secondNode |
	firstRegister = secondRegister ifTrue: [^ self]. "Arcs to ourself are meaningless, they also allow 
													collections to be modified inside iterations"
	(machine isSpecialRegister: firstRegister) | (machine isSpecialRegister: secondRegister)
		ifTrue: [^ self]. "Special registers do not interfere with colourable registers"
	firstNode := interferenceGraph at: firstRegister.
	secondNode := interferenceGraph at: secondRegister.
	firstNode addEdgeTo: secondNode.
	secondNode addEdgeTo: firstNode! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 10/23/2002 14:02'!
analyseLiveness
	LivenessAnalyser on: source.! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 5/22/2004 22:15'!
assert: aBoolean
	aBoolean ifFalse: [TestResult failure sunitSignalWith: 'Verification failed'].! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 6/2/2004 22:48'!
assignColourTo: aNode 
	| colour |
	self clearRegisterTable.
	coloursUsed := 0.
	aNode neighboursDo: [:each | self markRegisterUsedFor: each].
	colour := self 
				firstFreeRegisterFor: aNode
				ifAbsent: [^self spillFor: aNode].
	aNode colour: colour.! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 6/2/2004 22:53'!
assignRegisters
	"coalescedMoves
		do: [:t1 | (registerAssignments includesKey: t1 from)
				ifFalse: [registerAssignments 
					at: t1 from 
					put: (interferenceGraph at: t1 from) currentVersion colour]]."

	| assignments |
	assignments := self assignmentDictionary.
	self assignRegisters: assignments! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 6/2/2004 21:30'!
assignRegisters: assignments 
	result := RegisterReassigner 
				assignments: assignments
				method: source
				for: machine! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 6/2/2004 22:53'!
assignmentDictionary
	| assignments |
	assignments := Dictionary new.
	interferenceGraph do: 
			[:each | 
			assignments 
				at: each register
				put: each currentVersion colour].
	^assignments! !

!ColouringRegisterAllocator methodsFor: 'Interference Graph' stamp: 'wbk 3/4/2005 16:54'!
buildInterferenceGraph
	interferenceGraph := Dictionary new.
	source registersDo: 
			[:each | 
			(machine isSpecialRegister: each) not ifTrue: 
					[interferenceGraph 
						at: each
						ifAbsentPut: 
							[InterferenceNode 
								for: each
								with: machine
								interferenceGraph: interferenceGraph]]].
	interferenceGraph
		at: (machine registerNamed: #eax)
		put: (InterferenceNode
			for: (machine registerNamed: #eax)
			with: machine
			interferenceGraph: interferenceGraph).
	source instructionsDo: [:each | each buildInterferenceWith: self]! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 8/2/2004 21:29'!
calculateStatistics
	source registersDo: 
		[:each| (machine isSpecialRegister: each) ifFalse: 
			[(interferenceGraph at: each) incrementRegisterCount]].! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 10/23/2002 18:08'!
clearRegisterTable
	registerTable := registerFile collect: [:each| false].! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 6/20/2004 10:53'!
coalesce
	| toCoalesce |
	toCoalesce := moveWorklist 
		detect: [:each | each isCoalescable]
		ifNone: [^false].
	self coalesceNode: toCoalesce.
	moveWorklist copy do: 
		[:each | (each doesInterfere) ifTrue: [self freezeMove: each]].
	^true! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 7/25/2004 18:11'!
coalesceNode: node 
	| fromNode toNode temporaryNode |
	fromNode := node fromCurrentNode.
	toNode := node toCurrentNode.
	fromNode register isMachineRegister ifTrue:
		[temporaryNode := fromNode.
		fromNode := toNode.
		toNode := temporaryNode].
	fromNode decrementCurrentMoves.
	toNode addInterferenceEdgesFrom: fromNode.
	toNode = fromNode ifFalse:
		[toNode incrementCurrentMovesBy: fromNode currentMoves.
		fromNode simplify].
	fromNode currentVersion: toNode.
	self queueNode: toNode.
	coalescedMoves add: node.
	moveWorklist remove: node.! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/5/2002 13:16'!
coalescedMoves
	^ coalescedMoves! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 10/23/2002 17:18'!
createWorkingEdges
	interferenceGraph do: [:each| each createWorkingEdges]! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 3/4/2005 16:56'!
createWorklists
	source instructionsDo: 
			[:each | 
			(self isCoalescableMove: each) ifTrue: 
					[moveWorklist add: (MoveNode 
								move: each
								withGraph: interferenceGraph
								maxColours: machine numberOfColours)]].
	interferenceGraph do: 
			[:each | 
			each isMoveRelated | each register isMachineRegister ifFalse: 
					[each currentSize < machine numberOfColours & each isSelected not 
						ifTrue: [simplifyWorklist add: each]
						ifFalse: [spillWorklist add: each]]]! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 3/6/2005 10:54'!
findNodeToSpill
	| spillable |
	"This is just a basic heuristic, spill the register that interferes with the most
	other registers. It is possible to do a lot better. 
	The heuristic should concider how much each register is used while it is alive"
	spillable := spillWorklist select: [:each | (self hasSpill: each register) not].
	spillable := spillable asSortedCollection: [:a :b| a spillWeight > b spillWeight].
	^ spillable first! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 11/4/2002 16:56'!
firstFreeRegisterFor: aNode ifAbsent: aBlock
	| index |
	coloursUsed >= registerFile size & aNode isSpilled ifTrue: aBlock.
	index := registerTable indexOf: false.
	^ registerFile at: index! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 8/2/2004 22:24'!
freeze
	| moves |
	moveWorklist isEmpty ifTrue: [^false].
	moves := moveWorklist 
		select: 
			[:each |  each fromNode currentSize < machine numberOfColours |
	 			( each toNode currentSize < machine numberOfColours)].
	moves ifEmpty: [^ false].
	moves := moves asSortedCollection: [:a :b| a freezeWeight > b freezeWeight].
	"self halt."
	self freezeMove: moves first.
	^true! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 6/21/2004 22:11'!
freezeMove: move 
	| fromNode toNode |
	moveWorklist remove: move.
	fromNode := move fromCurrentNode.
	toNode :=  move toCurrentNode.
	self queueNode: fromNode.
	self queueNode: toNode! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 5/29/2004 15:22'!
gatherSimplifyableNodes
	| toSimplify |
	toSimplify := spillWorklist select: [:each | each currentSize < machine numberOfColours].
	spillWorklist removeAll: toSimplify.
	simplifyWorklist addAll: toSimplify! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 6/21/2004 22:16'!
getMoveFrom: aSymbol to: aSymbol2 
	^ moveWorklist detect: 
		[:each| each fromNode register name = aSymbol & (each toNode register name = aSymbol2)]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 8/2/2004 21:24'!
hasNoTemporaries
	result registersDo: [:each| each isMachineRegister ifFalse: [^false]].
	^ true.! !

!ColouringRegisterAllocator methodsFor: 'Misc' stamp: 'wbk 5/26/2004 22:28'!
hasSpill: aMedTemporaryRegister 
	^ hasSpilt includes: aMedTemporaryRegister! !

!ColouringRegisterAllocator methodsFor: 'Misc' stamp: 'wbk 5/29/2004 16:04'!
initialiseSource: aMethod machine: aMachine
	source := aMethod.
	machine := aMachine.
	interferenceGraph := Dictionary new.
	registerStack := OrderedCollection new.
	registerFile := aMachine useableRegisters.
	spiltRegisters := OrderedCollection new.
	hasSpilt := Set new.
	simplifyWorklist := OrderedCollection new.
	spillWorklist := OrderedCollection new.
	moveWorklist := OrderedCollection new.
	coalescedMoves := OrderedCollection new.
	^ self! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 5/29/2004 14:03'!
insertSpills
	source := SpillInserter
		spiltRegisters: spiltRegisters
		method: source
		for: machine
		allocator: self! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/2/2002 15:50'!
interferenceGraph
	^ interferenceGraph! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2002 21:59'!
interferenceNode: aRegister
	^ interferenceGraph
		at: aRegister ! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/7/2002 15:35'!
interferes: firstRegister with: secondRegister 
	^(interferenceGraph at: firstRegister) 
		interferesWith: (interferenceGraph at: secondRegister)! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2002 22:12'!
intermediateForm
	^ self result intermediateForm! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 6/24/2003 13:28'!
isCoalescableMove: aMove 
	(aMove isMov and: [aMove to isRegister & aMove from isRegister]) ifFalse: [^ false].
	(machine isSpecialRegister: aMove from) | (machine isSpecialRegister: aMove to)
		ifTrue: [^ false]. "Copied from ColouringRegisterAllocator>>addInterferenceEdge:to:"
	^ (self
		interferes: aMove to
		with: aMove from) not! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 11/4/2002 17:04'!
markRegisterUsedFor: aNode 
	aNode isSpilled ifTrue: [^ self].
	coloursUsed := coloursUsed + 1.
	aNode hasColour ifFalse: [^ self].
	registerTable 
		at: (registerFile indexOf: aNode colour) 
		put: true! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/5/2002 10:34'!
moveWorklist
	^ moveWorklist! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 11/7/2002 15:38'!
processWorkLists
	simplifyWorklist isEmpty ifFalse: [^ self simplify].
	self coalesce ifTrue: [^ self].
	self freeze ifTrue: [^ self].
	spillWorklist isEmpty ifFalse: [^ self spillRegister].
	self spillMove! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 6/21/2004 22:25'!
queueNode: aNode 
	aNode decrementCurrentMoves.
	aNode isCurrentlyInvolvedInMoves ifTrue: [^self].
	aNode currentSize < machine numberOfColours 
		ifTrue: [simplifyWorklist add: aNode.]
		ifFalse: [spillWorklist add: aNode]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 6/2/2004 22:54'!
registerAssignments
	^ self assignmentDictionary! !

!ColouringRegisterAllocator methodsFor: 'Misc' stamp: 'wbk 5/26/2004 23:56'!
registerIsSpilled: aMedTemporaryRegister 
	hasSpilt add: aMedTemporaryRegister! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/3/2002 12:20'!
registerStack
	^ registerStack! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/1/2002 23:09'!
registerStack: aCollection
	registerStack := aCollection collect: [:each| interferenceGraph at: (machine registerNamed: each)] ! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 11/5/2002 13:30'!
registersToSimplify
	^ spillWorklist isEmpty not | simplifyWorklist isEmpty not | moveWorklist isEmpty not! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/2/2002 17:02'!
result
	^ result! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 3/6/2005 10:38'!
run
	| hadSpills |
	hadSpills := true.
	[hadSpills] whileTrue: 
			[self setUp.
			self simplifyAndSpill.
			self select.
			hadSpills := spiltRegisters size ~= 0.
			hadSpills 
				ifTrue: [self insertSpills]
				ifFalse: [self assignRegisters]].! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 6/2/2004 22:48'!
select
	spiltRegisters := OrderedCollection new.
	registerStack reverseDo: [:each | self assignColourTo: each]! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 8/2/2004 21:18'!
setUp
	self analyseLiveness.
	self buildInterferenceGraph.
	registerStack := OrderedCollection new.
	self createWorkingEdges.
	self createWorklists.
	self calculateStatistics.! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 5/29/2004 16:03'!
simplify
	simplifyWorklist do: 
			[:each | 
			registerStack addLast: each.
			each simplify].
	simplifyWorklist := OrderedCollection new.
	self gatherSimplifyableNodes! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 8/2/2004 21:13'!
simplifyAndSpill
	[self registersToSimplify] whileTrue: [self processWorkLists]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/5/2002 10:40'!
simplifyWorklist
	^ simplifyWorklist! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/28/2002 21:36'!
source
	^ source! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 11/3/2002 14:52'!
spillFor: aNode 
	spiltRegisters add: aNode register.
	hasSpilt add: aNode register! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 11/7/2002 15:52'!
spillMove
	self freezeMove: moveWorklist first! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 3/5/2005 23:15'!
spillRegister
	| toSpill |
	toSpill := self findNodeToSpill.
	registerStack addLast: toSpill.
	toSpill simplify.
	toSpill markAsSpilled.
	spillWorklist remove: toSpill.
	self gatherSimplifyableNodes.
	! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/5/2002 11:04'!
spillWorklist
	^ spillWorklist! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/28/2002 17:58'!
spiltRegisters
	^ spiltRegisters! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/28/2002 19:29'!
spiltRegisters: aCollection
	spiltRegisters := aCollection! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2002 22:35'!
stackIncludes: aRegister
	^ registerStack includes: (interferenceGraph at: aRegister).! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/28/2002 10:25'!
stackSize
	^ registerStack size! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 3/4/2005 16:57'!
unallocated
	| answer |
	answer := OrderedCollection new.
	interferenceGraph do: [:each| each isSelected | each register isMachineRegister ifFalse: [answer add: each]].
	^ answer! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 7/25/2004 16:26'!
verify
	"Copied from ColouringRegisterAllocatorTests>>verifyAllocationCounts. 	verifyAllocationMoveCounds should be modified to use this in the future."

	self verifyMoveCounts.
	self verifyInterferenceGraph.
	self verifyCoalescableNodesNotSimplified.! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 7/25/2004 16:34'!
verifyCoalescableNodesNotSimplified
	moveWorklist do:
		[:each| self assert: each fromNode currentVersion isSimplified not.
		self assert: each toNode currentVersion isSimplified not]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 7/25/2004 16:00'!
verifyInterferenceGraph
	"Check that all machine registers are at the top of the merge trees"
	interferenceGraph do:
		[:each| each register isMachineRegister ifTrue:
			[self assert: each = each  currentVersion]].! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 7/25/2004 15:54'!
verifyMoveCounts
	| moveCount |
	moveCount := Dictionary new.
	moveWorklist do: 
			[:each | 
			moveCount 
				at: each fromCurrentNode
				put: (moveCount 
						at: each fromCurrentNode
						ifAbsent: [0]) + 1.
			moveCount 
				at: each toCurrentNode
				put: (moveCount 
						at: each toCurrentNode
						ifAbsent: [0]) + 1].
	interferenceGraph do: 
			[:each | 
			self assert: each currentVersion currentMoves = (moveCount 
								at: each currentVersion
								ifAbsent: [0])]! !

Object subclass: #CompilerToys
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!CompilerToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/6/2004 20:10'!
minus! !

!CompilerToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/4/2004 21:36'!
sal! !

!CompilerToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/4/2004 20:50'!
sar! !

!CompilerToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/6/2004 20:10'!
sub! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 10/14/2002 19:06'!
conditionalJumps
	^ 1 <= 2
		ifTrue: [^ 3]
		ifFalse: [^ 4]! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/29/2002 18:36'!
iterativeFactorial: n
	|acc|
	acc := 1.
	1
		to: n
		do: [:each| acc := acc * each].
	^ acc! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 10/13/2002 19:02'!
lessThanEquals
	^ 1<=2! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 10/13/2002 19:04'!
nestedConditionals
	^ 1 + (1 <= 3)! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 9/3/2002 12:09'!
return42
	^ 42! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:15'!
simpleMethod
	^ 1! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:17'!
simpleMethod2
	^ 1 + 2! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:18'!
simpleMethod3
	^ 1 + 100! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:20'!
simpleMethod4
	^ 100 + 101! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:32'!
simpleMethod5
	^ 1 + 2 + 3 + 4 + 5 + 6! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 18:43'!
simpleMethod6
	^ 100 times: 2 * 3! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 10/2/2002 18:04'!
stringConcatenate
	^ 'abc', 'def'! !

Object subclass: #EncodeFixedRegRm32
	instanceVariableNames: 'registerName opcode rmOpcode instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeFixedRegRm32 class methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:36'!
fixedRegister: aSymbol fixedOpcode: anUndefinedObject fixedModRm: anUndefinedObject3 
	^ self new
		initialiseFixedRegister: aSymbol 
		fixedOpcode: anUndefinedObject 
		fixedModRm: anUndefinedObject3 ! !

!EncodeFixedRegRm32 methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:53'!
fire
	instruction assembler stream nextPut: opcode.
	instruction assembler 
		encodeModRm: instruction arg2
		registerOpcode: rmOpcode! !

!EncodeFixedRegRm32 methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:39'!
initialiseFixedRegister: aSymbol fixedOpcode: opcodeInteger fixedModRm: rmInteger 
	registerName := aSymbol.
	opcode := opcodeInteger.
	rmOpcode := rmInteger! !

!EncodeFixedRegRm32 methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:53'!
isFirable
	instruction arg1 isRegister ifFalse: [^false].
	^instruction arg1 name = registerName! !

!EncodeFixedRegRm32 methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:53'!
registerInstruction: anAssembleArithmatic 
	instruction := anAssembleArithmatic! !

Object subclass: #EncodeFromLiteral
	instanceVariableNames: 'opcode modRmOpcode assembler instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeFromLiteral class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:19'!
opcode: aSmallInteger modRmOpcode: aSmallInteger2
	^ self new
		initializeOpcode: aSmallInteger 
		modRmOpcode: aSmallInteger2 ! !

!EncodeFromLiteral methodsFor: 'Encoding' stamp: 'wbk 4/7/2003 21:12'!
fire
	assembler stream nextPut: opcode.
	assembler 
		encodeModRm: instruction arg2 
		registerOpcode: modRmOpcode.
	assembler encodeImmediate: instruction arg1
	! !

!EncodeFromLiteral methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:18'!
initializeOpcode: aSmallInteger modRmOpcode: aSmallInteger2
	opcode := aSmallInteger.
	modRmOpcode := aSmallInteger2.	
	^ self.! !

!EncodeFromLiteral methodsFor: 'Encoding' stamp: 'wbk 4/6/2003 21:17'!
isFirable
	^ instruction arg1 isLiteral! !

!EncodeFromLiteral methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:17'!
registerInstruction: anAssembleArithmatic 
	instruction := anAssembleArithmatic.
	assembler := instruction assembler.! !

Object subclass: #EncodeFromLiteralToRegister
	instanceVariableNames: 'opcode assembler instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeFromLiteralToRegister class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:21'!
opcode: aSmallInteger
	^ self new
		initializeOpcode: aSmallInteger ! !

!EncodeFromLiteralToRegister methodsFor: 'Encoding' stamp: 'wbk 4/7/2003 14:18'!
fire
	assembler stream nextPut: opcode + (assembler registerEncoding: instruction arg2).
	assembler encodeImmediate: instruction arg1.! !

!EncodeFromLiteralToRegister methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:21'!
initializeOpcode: aSmallInteger
	opcode := aSmallInteger.
	^ self! !

!EncodeFromLiteralToRegister methodsFor: 'Encoding' stamp: 'wbk 4/7/2003 14:15'!
isFirable
	^ instruction arg2 isRegister & instruction arg1 isLiteral! !

!EncodeFromLiteralToRegister methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:20'!
registerInstruction: anAssembleInstruction 
	instruction := anAssembleInstruction.
	assembler := instruction assembler.! !

Object subclass: #EncodeImm8Rm32
	instanceVariableNames: 'instructionByte modRmValue assembler instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeImm8Rm32 class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:24'!
firstByte: aSmallInteger modRmValue: aSmallInteger2
	^ self new
		initializeFirstByte: aSmallInteger 
		modRmValue: aSmallInteger2! !

!EncodeImm8Rm32 methodsFor: 'Encoding' stamp: 'wbk 2/8/2004 21:52'!
fire
	assembler stream nextPut: instructionByte.
	assembler 
		encodeModRm: instruction arg2 
		registerOpcode: modRmValue.
	assembler stream nextPut: instruction arg1 literal! !

!EncodeImm8Rm32 methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:23'!
initializeFirstByte: aSmallInteger modRmValue: aSmallInteger2
	instructionByte :=  aSmallInteger.
	modRmValue := aSmallInteger2.
	^ self! !

!EncodeImm8Rm32 methodsFor: 'Encoding' stamp: 'wbk 4/4/2003 17:28'!
isFirable
	^ instruction arg1 isLiteral & instruction arg2 isRegister! !

!EncodeImm8Rm32 methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:23'!
registerInstruction: anAssembleArithmatic 
	instruction := anAssembleArithmatic .
	assembler := instruction assembler.! !

Object subclass: #EncodeToAddressingMode
	instanceVariableNames: 'opcode assembler instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

EncodeToAddressingMode subclass: #EncodeFromAddressingMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeFromAddressingMode methodsFor: 'Encoding' stamp: 'wbk 4/11/2003 18:07'!
fire
	assembler stream nextPutAll: opcode.
	assembler 
		encodeModRm: instruction arg1
		register: instruction arg2	! !

!EncodeFromAddressingMode methodsFor: 'Encoding' stamp: 'wbk 4/6/2003 21:03'!
isFirable
	^ instruction arg2 isRegister & (instruction arg1 isAddressingMode | instruction arg1 isRegister)! !

!EncodeToAddressingMode class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:11'!
opcode: aSmallInteger
	^ self new
		initializeOpcodes: (Array with: aSmallInteger)! !

!EncodeToAddressingMode class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:16'!
opcodes: aSmallInteger
	^ self new
		initializeOpcodes: aSmallInteger! !

!EncodeToAddressingMode methodsFor: 'Encoding' stamp: 'wbk 4/11/2003 18:08'!
fire
	assembler stream nextPutAll: opcode.
	assembler 
		encodeModRm: instruction arg2 
		register: instruction arg1	! !

!EncodeToAddressingMode methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:12'!
initializeOpcodes: aSmallInteger
	opcode := aSmallInteger.
	^ self! !

!EncodeToAddressingMode methodsFor: 'Encoding' stamp: 'wbk 4/6/2003 20:57'!
isFirable
	^ instruction arg1 isRegister & (instruction arg2 isAddressingMode | instruction arg2 isRegister)! !

!EncodeToAddressingMode methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:11'!
registerInstruction: anAssembleArithmatic 
	instruction := anAssembleArithmatic.
	assembler := instruction assembler.! !

Object subclass: #Exupery
	instanceVariableNames: 'method assembly machine instructions allocated functionName generator byteCodes lowLevel optimised relocations blockPositions lowLevelOptimised picEntries'
	classVariableNames: 'Methods'
	poolDictionaries: ''
	category: 'Exupery'!

!Exupery class methodsFor: 'instance creation' stamp: 'wbk 1/2/2005 14:14'!
compileMethod: aCompiledMethod 
	| compiler |
	compiler := self new 
				initializeMethod: aCompiledMethod
				functionName: nil.
	compiler run.
	^compiler ! !

!Exupery class methodsFor: 'compiling' stamp: 'wbk 7/25/2004 19:38'!
compileMethod: aSymbol class: aClass 
	self 
		compileMethod: aSymbol
		into: aSymbol
		forClass: aClass! !

!Exupery class methodsFor: 'compiling' stamp: 'wbk 3/7/2005 20:18'!
compileMethod: aSymbol into: aSymbol2 forClass: aClass 
	| method code compiler |
	method := aClass compiledMethodAt: aSymbol.
	compiler := self 
				compileMethod: method.
	"Load the compiled method into the code cache"
	code := self loadCode: compiler byteCodes.
	compiler relocateMethodAt: code.
	self
		register: code
		method: (aClass compiledMethodAt: aSymbol2).
	aSymbol2 flushCache.! !

!Exupery class methodsFor: 'instance creation' stamp: 'wbk 9/18/2002 16:50'!
compileMethod: aCompiledMethod intoFile: aString functionName: aNameString
	|compiler file|
	compiler := self new 
		initializeMethod: aCompiledMethod
		functionName: aNameString.
	compiler run.
	file := CrLfFileStream fileNamed: aString.
	file nextPutAll: compiler assembly.
	file close.! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 7/8/2004 22:11'!
initialiseExupery
	"This dictionary must be of size zero, this allows us to replace a divsion with a
	bit mask. This is also true for classes method dictionaries."
	Methods := (ExuperyMethodDictionary new).
	self initialiseExupery: Methods.! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 4/15/2004 22:02'!
initialiseExupery: aDictionary
	"Don't call this method directly, use initialiseExupery. The argument is just to pass
	a dictionary into the VM. The dictionary will then be used to find compiled code for
	methods"
	<primitive: 'initialiseExupery' module: 'ExuperyPlugin'>
	TestFailure signal! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 4/15/2004 21:39'!
loadCode: anArray
	<primitive: 'loadCode' module: 'ExuperyPlugin'>
	TestFailure signal! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 7/16/2004 22:21'!
register: aSmallInteger method: aMethod
	"<primitive: 'registerCompiledMethod' module: 'ExuperyPlugin'>
	TestFailure signal"
	Methods
		at: aMethod
		put: aSmallInteger.! !

!Exupery methodsFor: 'Relocation' stamp: 'wbk 1/21/2005 22:07'!
addRelocationAt: aSmallInteger for: aMedBlock 
	relocations add: aSmallInteger -> aMedBlock! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 10/24/2002 13:42'!
allocateRegisters
	| withRegisters |
	withRegisters := ColouringRegisterAllocator 
		on: instructions
		for: machine.
	allocated := withRegisters result.! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 3/3/2005 21:46'!
assemble
	| assembler |
	assembler := AssemblerExupery 
		assemble: allocated
		withPlugin: machine
		relocator: self.
	blockPositions := assembler blockPositions.
	byteCodes := assembler byteCodes.
	picEntries := assembler picEntries.! !

!Exupery methodsFor: 'Misc' stamp: 'wbk 9/16/2002 15:54'!
assembly
	^ assembly! !

!Exupery methodsFor: 'Misc' stamp: 'wbk 3/17/2003 14:32'!
byteCodes
	^ byteCodes! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 12/21/2004 11:57'!
convertIntermediate
	| simplifer |
	simplifer:= IntermediateSimplifier 
				from: optimised
				machine: machine.
	lowLevel := simplifer run.! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 10/21/2004 20:29'!
generateIntermediate
	| jumpFinder reader |
	jumpFinder := JumpTargetRecorder new.
	ByteCodeReader 
		newMethod: method
		using: jumpFinder
		jumpTargets: #()
		stackHeights: #().
	generator := IntermediateGenerator 
				for: machine
				jumpTargets: jumpFinder targets.
	reader := ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: jumpFinder targets
		stackHeights: jumpFinder stackTrace.
	method := generator result.
	^ reader! !

!Exupery methodsFor: 'Misc' stamp: 'wbk 10/15/2002 18:39'!
generator
	^ generator! !

!Exupery methodsFor: 'Misc' stamp: 'wbk 1/2/2005 14:11'!
initializeMethod: aCompiledMethod functionName: aString
	method := aCompiledMethod.
	functionName := aString.
	assembly := ''.
	machine :=  MachineX86 new.
	relocations := OrderedCollection new.
	^ self! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 1/22/2005 14:45'!
lowLevelOptimiser
	| optimiser |
	optimiser := LowLevelOptimiser 
				from: lowLevel
				machine: machine.
	lowLevelOptimised := optimiser run.! !

!Exupery methodsFor: 'Relocation' stamp: 'wbk 3/3/2005 22:58'!
relocateMethodAt: anInteger
	relocations do:
		[:each| machine 
			machineWordIn: anInteger
			at: each key
			put: (blockPositions at: each value blockNumber) "0"].
	picEntries do: [:each| each relocateInMethodAt: anInteger].! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 3/7/2005 20:18'!
run
	self generateIntermediate.
	self treeOptimiser.
	self convertIntermediate.
	self lowLevelOptimiser.
	self selectInstructions.
	self allocateRegisters.
	self assemble.! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 1/22/2005 14:44'!
selectInstructions
	| selector |
	selector := InstructionSelector 
		on: lowLevelOptimised
		for: machine.
	instructions := selector result.! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 12/21/2004 11:52'!
treeOptimiser
	| optimiser |
	optimiser := TreeOptimiser 
				from: method
				machine: machine.
	optimised := optimiser run.! !

Object subclass: #ExuperyBenchmarks
	instanceVariableNames: 'time compiledTime cumulativeTime cumulativeCompiledTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:20'!
arithmaticLoopBenchmark
	^ Time millisecondsToRun: [self arithmeticLoop].! !

!ExuperyBenchmarks methodsFor: 'benchmark methods' stamp: 'wbk 8/2/2004 22:31'!
arithmeticLoop
	| acc |
	acc := 0.
	1
		to: 20000000
		do: [:each| acc := acc + 1].
	^ acc! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:05'!
bytecodeBenchmark
	^ Time millisecondsToRun: [1000 benchmark].! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:20'!
compileArithmaticLoop
	Exupery
		compileMethod: #arithmeticLoop
		class: ExuperyBenchmarks! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 19:52'!
compileBytecodeBenchmark
	Exupery
		compileMethod: #benchmark
		class: Integer.! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 19:51'!
compileGifConversion
	Exupery 
		compileMethod: #writeBitData:
		class: GIFReadWriter. ! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:25'!
compileSendBenchmark
	Exupery
		compileMethod: #benchFib
		class: Integer.! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 8/2/2004 22:43'!
gifConversion
	"Smalltalk garbageCollect." "To stabilise the benchmark. It generates a lot of garbage
								and so does compiling"
	^ Time millisecondsToRun:
		[GIFReadWriter
			putForm: (Form
				extent: 1000@1000
				depth: 32)
			onStream: (WriteStream on: (ByteArray new: 10000))].! !

!ExuperyBenchmarks methodsFor: 'execution' stamp: 'wbk 8/1/2004 11:44'!
initialize
	cumulativeTime := 1.
	cumulativeCompiledTime := 1.! !

!ExuperyBenchmarks methodsFor: 'execution' stamp: 'wbk 2/6/2005 21:49'!
run
	#((arithmaticLoopBenchmark compileArithmaticLoop)
		(bytecodeBenchmark compileBytecodeBenchmark)
		(sendBenchmark compileSendBenchmark)
		(gifConversion compileGifConversion)) do:
			[:each| self
				runBenchmark: (each at: 1)
				compilingWith: (each at: 2)].
			
	Transcript cr.
	time := (cumulativeTime ln / 4) exp. "Calculate the root of 4"
	compiledTime := (cumulativeCompiledTime ln / 4) exp.
	Transcript show: 'Cumulative Time '.
	Transcript show: (time printShowingDecimalPlaces: 3).
	Transcript show: ' compiled '.
	Transcript show: (compiledTime printShowingDecimalPlaces: 3).
	Transcript show: ' ratio '.
	Transcript show: ((time / compiledTime) asFloat printShowingDecimalPlaces: 3).
	Transcript cr.! !

!ExuperyBenchmarks methodsFor: 'execution' stamp: 'wbk 2/6/2005 21:50'!
runBenchmark: benchmarkSymbol compilingWith: compilingSymbol 
	Exupery initialiseExupery.
	Transcript cr.
	Transcript show: benchmarkSymbol.
	Transcript space.
	time := self perform: benchmarkSymbol.
	Transcript show: time.
	Transcript show: ' compiled '.
	self perform: compilingSymbol.
	compiledTime := self perform: benchmarkSymbol.
	Transcript show: compiledTime.
	Transcript show: ' ratio: '.
	Transcript show: ((time / compiledTime) asFloat printShowingDecimalPlaces: 3).
	cumulativeTime := cumulativeTime * time.
	cumulativeCompiledTime := cumulativeCompiledTime * compiledTime.! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:05'!
sendBenchmark
	^ Time millisecondsToRun: [33 benchFib].! !

Object subclass: #ExuperyInstanceVariables
	instanceVariableNames: 'a b i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15 i16 i17 i18'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 8/30/2003 20:29'!
a
	"Adding zero to avoid a primitive shortcut"
	^ a + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 10/3/2003 23:56'!
a: firstObject
	a := firstObject.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 11/16/2003 17:51'!
a: firstObject b: secondObject
	a := firstObject.
	b := secondObject.
	^ 5 "Because Exupery doesn't handle returnSelf yet"! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 8/30/2003 20:28'!
b
	"Adding zero to avoid a primitive short-cut"
	^ b + 0! !

!ExuperyInstanceVariables methodsFor: 'Temporary Variables' stamp: 'wbk 6/13/2004 12:16'!
basicTemps
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|
	t7 := 7.
	t8 := 8.
	t17 := 17.
	t18 := 18.
	^ t17 + t18.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 11/22/2003 16:47'!
getA
	^ a! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 11/22/2003 16:48'!
getB
	^ b! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:00'!
i16
	^ i16 + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:01'!
i16: anObject
	i16 := anObject! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:00'!
i17
	^ i17 + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:01'!
i17: anObject
	i17 := anObject! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:01'!
i18
	^ i18 + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:02'!
i18: anObject
	i18 := anObject! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:18'!
i8
	^ i8 + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:18'!
i8: anObject
	i8 := anObject.! !

!ExuperyInstanceVariables methodsFor: 'Experiments' stamp: 'wbk 6/12/2004 18:17'!
iNNN: anObject
	i9 := anObject
	! !

!ExuperyInstanceVariables methodsFor: 'Temporary Variables' stamp: 'wbk 6/13/2004 12:24'!
loadExtendedTemp
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|
	^ t17! !

!ExuperyInstanceVariables methodsFor: 'Temporary Variables' stamp: 'wbk 10/21/2004 20:28'!
sideEffects
	a := 2.
	^ (a := a +1) + (a := a + 1)! !

!ExuperyInstanceVariables methodsFor: 'Temporary Variables' stamp: 'wbk 6/13/2004 12:23'!
storeExtendedTemp
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|
	t17 := 17.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/13/2004 13:43'!
storeInstanceExtended
 ^ true ifTrue: [i16:= 10].! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/13/2004 13:53'!
storeInstanceExtended2
 ^ (true ifTrue: [i16:= 10]) + i16.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/14/2004 22:31'!
storeTempExtended
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|	
 	^ (true ifTrue: [t16:= 15]) + t16.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/14/2004 22:36'!
storeTempExtended2
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|	
 	^ true ifTrue: [t16:= 15].! !

Object subclass: #ExuperyStack
	instanceVariableNames: 'PC emitter concreteStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!ExuperyStack class methodsFor: 'as yet unclassified' stamp: 'wbk 4/26/2004 22:30'!
newPC: aSmallInteger emitter: anEmitter
	^ self new 
		initializePC: aSmallInteger
		emitter: anEmitter.! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 9/28/2004 22:54'!
heightTo: aSmallInteger 
	aSmallInteger > self stackHeight
		ifTrue: 
			[concreteStack addAll: ((self stackHeight + 1 to: aSmallInteger)
				collect: [:each| emitter stackRegister: each])]
		ifFalse:
			[concreteStack removeLast:  self stackHeight - aSmallInteger]! !

!ExuperyStack methodsFor: 'Program Counter' stamp: 'wbk 7/28/2003 12:34'!
incrementPC
	PC := PC + 1.! !

!ExuperyStack methodsFor: 'Misc' stamp: 'wbk 9/24/2004 23:10'!
initializePC: aSmallInteger emitter: anEmitter 
	PC := aSmallInteger.
	emitter := anEmitter.
	concreteStack := OrderedCollection new.! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 9/24/2004 21:26'!
isEmpty
	^ concreteStack isEmpty! !

!ExuperyStack methodsFor: 'Misc' stamp: 'wbk 2/13/2005 12:44'!
materialiseStack
	concreteStack _ ((1 to: concreteStack size) collect: 
					[:each | 
					emitter 
						moveFrom: (concreteStack at: each)
						to: (emitter stackRegister: each).
					emitter stackRegister: each]) asOrderedCollection! !

!ExuperyStack methodsFor: 'Program Counter' stamp: 'wbk 7/28/2003 12:39'!
pc
	^ PC! !

!ExuperyStack methodsFor: 'Program Counter' stamp: 'wbk 7/28/2003 21:38'!
pc: aSmallInteger 
	PC := aSmallInteger! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 10/4/2004 21:42'!
peek
	^ concreteStack last! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 9/25/2004 08:54'!
pop
	| answer |
	answer := concreteStack removeLast.
	"answer := emitter stackRegister: self stackHeight + 1."
	^answer! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 5/31/2004 23:49'!
pop: aSmallInteger 
	| answer |
	answer := OrderedCollection new.
	1 to: aSmallInteger do: [:each | answer addFirst: self pop].	"Remove arguments from the stack"
	^ answer! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 2/13/2005 12:44'!
push: aMed 
	| stackVariable storedValue |
	aMed isStackable 
		ifTrue: [storedValue _ aMed]
		ifFalse: 
			[stackVariable _ emitter stackRegister: self stackHeight + 1.
			emitter 
				moveFrom: aMed
				to: stackVariable.
			storedValue _ stackVariable].
	concreteStack addLast: storedValue! !

!ExuperyStack methodsFor: 'Misc' stamp: 'wbk 9/24/2004 21:12'!
stackHeight
	^ concreteStack size! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 9/24/2004 20:27'!
stackSize
	^ self stackHeight! !

ExuperyStack subclass: #TestExuperyStack
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!TestExuperyStack methodsFor: 'stubbed methods' stamp: 'wbk 8/21/2004 21:44'!
initializePC: aSmallInteger emitter: anEmitter 
	super
		initializePC: aSmallInteger
		emitter: anEmitter.
	stack := OrderedCollection new.! !

!TestExuperyStack methodsFor: 'stubbed methods' stamp: 'wbk 6/13/2004 15:08'!
peek
	^ stack last! !

!TestExuperyStack methodsFor: 'stubbed methods' stamp: 'wbk 4/26/2004 23:29'!
pop
	^stack removeLast! !

!TestExuperyStack methodsFor: 'stubbed methods' stamp: 'wbk 4/26/2004 23:29'!
push: anArray
	stack addLast: anArray! !

Object subclass: #InstructionSelector
	instanceVariableNames: 'source result machine currentBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!InstructionSelector class methodsFor: 'instance creation' stamp: 'WBK 8/28/2002 20:13'!
on: aMed for: aMachine
	|selector|
	selector := self new 
		initializeMed: aMed
		for: aMachine.
	selector run.
	^ selector! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 14:57'!
buildArithmaticOperator: operator arg1: arg1 arg2: arg2 
	| destReg |
	destReg := machine createTemporaryRegister.
	currentBlock add: (MedMov 
		from: arg2 
		to: destReg).
	currentBlock add: (MedAssembly 
		name: operator
		arguments: {arg1. destReg}).
	^destReg! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 15:02'!
buildMoveFrom: from to: to 
	| instr |
	instr := MedMov 
		from: from 
		to: to.
	currentBlock add: instr.
	^ to! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 4/11/2003 13:33'!
getAddressingModeFor: aNode	
	| answer address |
	(aNode address isAdd and: [aNode address arg2 isMachineInteger])
		ifTrue: 
			[answer := MedAddressingMode
				offset: aNode address arg2 literal
				base: (self getRegFor: aNode address arg1)]
		ifFalse: 
			[address := self getRegFor: aNode address.
			answer := MedAddressingMode indirectRegister: address].
	^ answer! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/5/2002 14:38'!
getRegFor: aMed
	|reg|
	aMed isRegister ifTrue: [^ aMed].
	aMed isLiteral ifTrue:
		[reg := machine createTemporaryRegister.
		currentBlock add: (MedMov
			from: aMed
			to: reg).
		^ reg].
	^ aMed visitWith: self
		! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 10/6/2002 17:15'!
getRegOrLiteralFor: aMed
	aMed isLiteral ifTrue: [^ aMed].
	^ self getRegFor: aMed! !

!InstructionSelector methodsFor: 'Misc' stamp: 'wbk 3/17/2003 18:24'!
initializeMed: aMed for: aMachine
	source := aMed.
 	machine := aMachine.
	result := OrderedCollection new.
	^ self	! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 3/6/2004 21:15'!
matchArithmatic: anArithmatic 
	anArithmatic arg1 isMem ifTrue: [^self matchArithmaticArg1Address: anArithmatic].
	^self matchBasicArithmatic: anArithmatic! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 14:59'!
matchArithmaticArg1Address: anArithmatic 
	^ self 
		buildArithmaticOperator: anArithmatic operator
		arg1: (self getAddressingModeFor: anArithmatic arg1)
		arg2: (self getRegFor: anArithmatic arg2)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 14:58'!
matchBasicArithmatic: anArithmatic 
	^ self 
		buildArithmaticOperator: anArithmatic operator
		arg1: (self getRegOrLiteralFor: anArithmatic arg1)
		arg2: (self getRegFor: anArithmatic arg2)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 15:03'!
matchBasicMove: aMed 
	^ self 
		buildMoveFrom: (self getRegOrLiteralFor: aMed from)
		to: (self getRegFor: aMed to)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 15:04'!
matchMoveFromAddress: aMed
	^ self
		buildMoveFrom: (self getAddressingModeFor: aMed from)
		to: (self getRegFor: aMed to)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 15:05'!
matchMoveToAddress: aMed
	^ self
		buildMoveFrom: (self getRegOrLiteralFor: aMed from)
		to: (self getAddressingModeFor: aMed to)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 3/6/2004 19:01'!
matchShift: anArithmatic 
	| shiftAmnt shiftAmount |
	shiftAmnt := self getRegOrLiteralFor: anArithmatic arg2.
	shiftAmount := shiftAmnt isRegister 
				ifTrue: 
					[currentBlock add: (MedMov 
								from: shiftAmnt
								to: (machine registerNamed: #ecx)).
					machine registerNamed: #ecx]
				ifFalse: [shiftAmnt].
	^self 
		buildArithmaticOperator: anArithmatic operator
		arg1: shiftAmount
		arg2: (self getRegFor: anArithmatic arg1)! !

!InstructionSelector methodsFor: 'Misc' stamp: 'wbk 9/11/2002 21:25'!
result
	^ result! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 10/6/2002 16:57'!
run
	result := MedMethod from: source.
	source blocksDo: [:each| each visitWith: self].
	^ result! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 1/20/2005 21:29'!
visitAddress: aMedAddress 
	self shouldBeImplemented! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 12/25/2004 22:48'!
visitArithmatic: anArithmatic 
	| instruction |
	(#(#sal #sar) includes: anArithmatic operator) ifTrue: [^self matchShift: anArithmatic].
	anArithmatic operator = #mul ifTrue:
		[^ self 
		buildArithmaticOperator: anArithmatic operator
			arg1: (self getRegFor: anArithmatic arg1)
			arg2: (self getRegFor: anArithmatic arg2)].
	instruction := anArithmatic operator = #sub
		ifTrue:
			[MedArithmatic
				operator: #sub
				arg1: anArithmatic arg2
				arg2: anArithmatic arg1]
		ifFalse: [anArithmatic].
	^self matchArithmatic: instruction! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 1/16/2005 19:27'!
visitBlock: aBlock
	|block|
	block := result blockNumbered: aBlock blockNumber.
	aBlock isAligned ifTrue: [block makeAligned].
	currentBlock := block.
	aBlock do: [:each| each visitWith: self].
	currentBlock := nil.
	^ block! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 2/9/2005 22:32'!
visitCall: aMedCall 
	currentBlock add: (MedCall 
				function: aMedCall function
				machine: machine)! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 2/1/2004 22:16'!
visitDivide: aMedDivide 
	|answer arg1 arg2 |
	answer := machine createTemporaryRegister.
	arg1 := self getRegFor: aMedDivide arg1.
	arg2 := self getRegFor: aMedDivide arg2.
	currentBlock add: (MedMov
		from: arg1
		to: (machine registerNamed: #eax)).
	currentBlock add: (MedX86CDQ 
		eax: (machine registerNamed: #eax)
		edx: (machine registerNamed: #edx)).
	currentBlock add: (MedX86Divide 
		register: arg2
		eax: (machine registerNamed: #eax)
		edx: (machine registerNamed: #edx)).
	currentBlock add: (MedMov
		from: (machine registerNamed: #eax)
		to: answer).
	currentBlock add: (MedMov
		from: (machine registerNamed: #edx)
		to: aMedDivide remainder).
	^ answer
		! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 2/4/2005 21:29'!
visitJump: aJump 
	| instructionReg target |
	instructionReg := aJump instruction isNil 
				ifTrue: [nil]
				ifFalse: [self getRegFor: aJump instruction].
	target := aJump target isMedBlock
		ifTrue: [result newBlockFor: aJump target]
		ifFalse: [self getRegFor: aJump target].
	currentBlock add: (MedJump 
				type: aJump type
				target: target).
	^ instructionReg! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 11/9/2002 15:17'!
visitMem: aMem
	^ self 
		buildMoveFrom: (self getAddressingModeFor: aMem)
		to: (machine createTemporaryRegister)! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 3/5/2005 00:01'!
visitMov: aMov
	(aMov from isArithmatic and: [aMov from arg1 = aMov to]) ifTrue: 
		[^ currentBlock add: (MedAssembly 
			name: aMov from operator
			arguments: {self getRegOrLiteralFor: aMov from arg2. self getRegFor: aMov from arg1})].
	aMov to isMem ifTrue: [^ self matchMoveToAddress: aMov].
	aMov from isMem ifTrue: [ ^ self matchMoveFromAddress: aMov].
	^ self matchBasicMove: aMov! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 2/9/2004 20:56'!
visitNegate: aMedNegate 
	| destReg |
	destReg := machine createTemporaryRegister.
	currentBlock add: (MedMov 
		from: (self getRegFor: aMedNegate argument) 
		to: destReg).
	currentBlock add: (MedNegate argument: destReg).
	^ destReg! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 2/27/2005 14:47'!
visitPic: aMedPic 
	currentBlock add: (MedPic 
				selectionRegister: aMedPic location
				picEntry: aMedPic picEntry)! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 3/4/2005 15:57'!
visitPop: aMedPop 
	currentBlock add: (MedPop argument: (self getRegFor: aMedPop argument))! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 6/21/2003 17:19'!
visitPush: aMedPush 
	currentBlock add: (MedPush argument: (self getRegFor: aMedPush argument))! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 3/4/2005 16:29'!
visitRet: aRet
	currentBlock add: (MedRet resultRegister: (machine registerNamed: #eax)).
	^ nil.! !

!InstructionSelector methodsFor: 'Unit testing' stamp: 'wbk 2/9/2004 20:59'!
writtenResult
	^ result intermediateForm! !

Object subclass: #InterferenceNode
	instanceVariableNames: 'register edges currentEdges colour isSelected isSpilled isMoveRelated currentMoves currentVersion registerCount'
	classVariableNames: 'CountCurrentEdges CountEdges'
	poolDictionaries: ''
	category: 'Exupery'!

!InterferenceNode class methodsFor: 'instance creation' stamp: 'wbk 7/1/2004 21:12'!
for: aRegister with: aMachine interferenceGraph: aGraph
	^self new 
		initializeFor: aRegister
		with: aMachine
		interferenceGraph: aGraph! !

!InterferenceNode class methodsFor: 'as yet unclassified' stamp: 'wbk 6/22/2004 23:15'!
initialize
	CountCurrentEdges := Dictionary new.
	CountEdges := Dictionary new.! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/5/2002 18:48'!
addBackCurrentInterferenceEdge: aNode
	currentEdges add: aNode.! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/25/2004 23:47'!
addBackInterferenceEdge: aNode
	edges addNode: aNode.! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/25/2004 23:30'!
addEdgeTo: aRegister
	edges addNode: aRegister! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/28/2004 22:36'!
addInterferenceEdgesFrom: aNode
	aNode currentEdgesDo:
		[:each| currentEdges add: each.
		each addBackCurrentInterferenceEdge: self].
	edges := edges + aNode edges.
	aNode neighboursDo: 
		[:each| each addBackInterferenceEdge: self].! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/26/2004 00:31'!
basicInterferesWith: aRegister 
	^ edges includesNode: aRegister! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/2/2004 18:12'!
colour
	register isMachineRegister ifTrue: [^ register].
	^ colour! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 18:14'!
colour: aRegister
	colour := aRegister! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/23/2004 22:16'!
createWorkingEdges
	currentEdges := edges asSet! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/6/2002 13:36'!
currentEdges
	^ currentEdges ! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/5/2002 16:54'!
currentEdgesDo: aBlock
	currentEdges do: aBlock! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 11/6/2002 17:09'!
currentMoves
	^ currentMoves! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 22:39'!
currentSize
	^ currentEdges size! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/16/2004 17:26'!
currentVersion
	currentVersion ifNotNil: [^ currentVersion currentVersion].
	^ self! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/17/2004 21:28'!
currentVersion: anInterferenceNode 
	anInterferenceNode = self currentVersion ifTrue: [^ self].
	currentVersion := anInterferenceNode! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 5/22/2004 21:51'!
decrementCurrentMoves
	currentMoves := currentMoves - 1! !

!InterferenceNode methodsFor: 'as yet unclassified' stamp: 'wbk 6/25/2004 23:36'!
edges
	^ edges! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/2/2004 18:18'!
hasColour
	register isMachineRegister ifTrue: [^ true].
	^ colour isNil not! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 11/6/2002 17:13'!
incrementCurrentMoves
	currentMoves := currentMoves + 1! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 5/22/2004 21:59'!
incrementCurrentMovesBy: aSmallInteger 
	currentMoves := currentMoves + aSmallInteger! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 8/2/2004 21:22'!
incrementRegisterCount
	registerCount := registerCount + 1! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/27/2004 22:08'!
index
	^ register index! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 8/2/2004 21:07'!
initializeFor: aRegister with: aMachine interferenceGraph: aGraph 
	register := aRegister.
	"edges := NodeLattice 
				newWith: aMachine
				interferenceGraph: aGraph.	"
	edges := NodeLattice new.
	isSelected := false.
	isSpilled := false.
	isMoveRelated := false.
	currentMoves := 0.
	registerCount := 0.
	^self! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/15/2004 15:20'!
interferesWith: aRegister 
	^ self currentVersion basicInterferesWith: aRegister currentVersion! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 11/6/2002 17:24'!
isCurrentlyInvolvedInMoves
	^ currentMoves > 0! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/5/2002 11:03'!
isMoveRelated
	^ isMoveRelated! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 20:43'!
isSelected
	^ isSelected! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 7/25/2004 16:34'!
isSimplified
	^ currentEdges class = Array! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/2/2002 18:44'!
isSpilled
	^ isSpilled! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/5/2002 10:59'!
markAsMoveRelated
	isMoveRelated := true! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/3/2002 12:25'!
markAsSpilled
	isSpilled := true.! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/26/2004 00:26'!
neighboursDo: aBlock
	"Could be obselete soon"
	edges nodesDo: aBlock! !

!InterferenceNode methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2002 17:32'!
printOn: aStream
	aStream nextPutAll: 'Node ['.
	register printOn: aStream.
	aStream nextPut: $].! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 18:14'!
register
	^ register! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 8/2/2004 21:07'!
registerCount
	^ registerCount! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 17:37'!
removeEdgeTo: aNode
	currentEdges remove: aNode! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 3/5/2005 22:41'!
simplify
	self register isMachineRegister ifFalse:
		[currentEdges do: [:each | each removeEdgeTo: self].
		currentEdges := #()].
	isSelected := true! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 3/5/2005 23:33'!
spillWeight
	^ self currentSize - (registerCount / 100)! !

Object subclass: #IntermediateCopier
	instanceVariableNames: 'source result emitter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!IntermediateCopier class methodsFor: 'instance creation' stamp: 'wbk 12/21/2004 11:54'!
from: aMedMethod emitter: anEmitter
	^ self new 
		convertFrom: aMedMethod
		emitter: anEmitter! !

!IntermediateCopier class methodsFor: 'instance creation' stamp: 'wbk 12/21/2004 11:54'!
from: aMedMethod machine: aMachine 
	| emitter answer |
	emitter := IntermediateEmitter 
				machine: aMachine
				jumpTargets: #()
				result: (MedMethod from: aMedMethod).
	answer := self  
		from: aMedMethod
		emitter: emitter.
	^ answer! !

!IntermediateCopier methodsFor: 'Misc' stamp: 'wbk 12/21/2004 11:55'!
convertFrom: aMedMethod emitter: anEmitter
	source := aMedMethod.
	emitter := anEmitter.
	result := emitter result.
	result nextBlockNumber: source numberOfBlocks + 1.
	result numberOfTemporaries: source numberOfTemporaries.
	source entryPoints do:
		[:each| result
			registerEntryPointWithPC: each address
			label: (self resultBlockFor: each label)].
	
! !

!IntermediateCopier methodsFor: 'Misc' stamp: 'wbk 1/3/2005 20:16'!
finishUp! !

!IntermediateCopier methodsFor: 'Misc' stamp: 'wbk 1/22/2005 15:54'!
resultBlockFor: aBlock 
	| answer |
	answer :=  result blockNumbered: aBlock blockNumber.
	aBlock isAligned ifTrue: [answer makeAligned].
	^ answer! !

!IntermediateCopier methodsFor: 'Misc' stamp: 'wbk 1/3/2005 20:16'!
run	
	source visitWith: self.
	self finishUp.
	^emitter result! !

!IntermediateCopier methodsFor: 'Misc' stamp: 'wbk 12/21/2004 12:49'!
runBasic
	source visitWith: self.
	^emitter result! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/21/2004 11:56'!
simplifyBlock: aMedBlock 
	aMedBlock instructionsDo: [:each | emitter addExpression: (each visitWith: self)]! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:52'!
visitArithmatic: aMed 
	^ emitter 
		arithmaticOperator: aMed operator
		arg1: (aMed arg1 visitWith: self)
		arg2: (aMed arg2 visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 1/22/2005 15:51'!
visitBlock: aMedBlock 
	^ result blockNumbered: aMedBlock blockNumber! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 2/9/2005 22:41'!
visitCall: aMedCall 
	^ MedCall 
		function: (aMedCall function visitWith: self)
		machine: emitter machine! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:37'!
visitDivide: aMedDivide 
	^ MedDivide
		emit: (aMedDivide arg1 visitWith: self)
		divide: (aMedDivide arg2 visitWith: self)
		remander: (aMedDivide remainder visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:46'!
visitJump: aJump 
	| target |
	aJump target isMedBlock 
		ifTrue: [target _ self resultBlockFor: aJump target]
		ifFalse: [target _ aJump target visitWith: self].
	aJump instruction ifNil: [^ emitter basicJumpTo: target].
	^ MedJump 
		type: aJump type
		target: target
		instruction: (aJump instruction visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:38'!
visitLiteral: aMedLiteral 
	^  aMedLiteral.! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:38'!
visitMachineRegister: aMedMachineRegister 
	^ aMedMachineRegister
! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:38'!
visitMem: aMedMem 
	^ MedMem address: (aMedMem address visitWith: self).! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:39'!
visitMethod: aMedMethod 
	aMedMethod blocksDo: 
			[:each | 
			emitter currentBlock: (self resultBlockFor: each).
			self simplifyBlock: each]! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:44'!
visitMov: aMedMov 
	^ emitter 
		basicMoveFrom: (aMedMov from visitWith: self)
		to: (aMedMov to visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:40'!
visitNegate: aMedNegate 
	^ MedNegate argument: (aMedNegate argument visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 2/27/2005 14:48'!
visitPic: aMedPic 
	^ MedPic 
		selectionRegister: aMedPic location
		picEntry: aMedPic picEntry! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 3/4/2005 15:38'!
visitPop: aMedPop 
	^ MedPop argument: (aMedPop argument visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:40'!
visitPush: aMedPush 
	^ MedPush argument: (aMedPush argument visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 3/4/2005 17:40'!
visitRet: aMedRet 
	^ MedRet resultRegister: aMedRet resultRegister! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:41'!
visitTemporaryRegister: aMedTemporaryRegister 
	^ aMedTemporaryRegister! !

IntermediateCopier subclass: #IntermediateSimplifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

IntermediateSimplifier class
	instanceVariableNames: 'source'!

!IntermediateSimplifier methodsFor: 'Misc' stamp: 'wbk 1/3/2005 20:16'!
finishUp
	emitter createProlog.! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:28'!
visitAtElementAddress: aMedAtElementAddress 
	^ emitter 
		expandedAtElementAddressFor: (aMedAtElementAddress object visitWith: self)
		with: (aMedAtElementAddress index visitWith: self)
		failTo: (aMedAtElementAddress failureBlock visitWith: self)
		cacheOffset: aMedAtElementAddress cacheOffset! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:44'!
visitAtPut: aMedAtPut 
	| object value index |
	object _ aMedAtPut object visitWith: self.
	value _ aMedAtPut value visitWith: self.
	index _ aMedAtPut index visitWith: self.
	emitter 
		beRoot: object
		ifNeededBy: value.
	emitter 
		moveFrom: value
		to: (emitter 
				expandedAtElementAddressFor: object
				with: index
				failTo: (aMedAtPut failureBlock visitWith: self)
				cacheOffset: 32).
	^ value! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:52'!
visitBitShift: aMedBitShift 
	^ emitter 
		expanded: (aMedBitShift firstArgument visitWith: self)
		bitShift: (aMedBitShift secondArgument visitWith: self)
		failingTo: (aMedBitShift failureBlock visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:20'!
visitConvertBoolean: aConvertBoolean 
	^ emitter 
		convertExpandedComparisionToBoolean: (aConvertBoolean expression visitWith: self)
		jumpType: aConvertBoolean jumpType! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:49'!
visitDeconvertBoolean: aMedDeconvertBoolean 
	emitter 
		conditionalJumpTo: (aMedDeconvertBoolean target visitWith: self)
		onBoolean: (aMedDeconvertBoolean boolean visitWith: self)
		ifBooleanIs: aMedDeconvertBoolean desiredBoolean
		pc: aMedDeconvertBoolean pc
		stackHeight: aMedDeconvertBoolean stackHeight.
	^ nil! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:22'!
visitIntegerValueOf: aMedIntegerValueOf 
	^ emitter 
		expandedIntegerValueOf: (aMedIntegerValueOf argument visitWith: self)
		failTo: (aMedIntegerValueOf failureBlock visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:46'!
visitLabel: aMedLabel 
	| overflowBlock answer nextBlock failureCode |
	overflowBlock _ self resultBlockFor: aMedLabel failureBlock.
	nextBlock _ emitter newBlock.
	aMedLabel arguments 
		with: aMedLabel argumentRegisters
		do: 
			[:argument :register | 
			emitter 
				moveFrom: (argument visitWith: self)
				to: register].
	answer _ emitter machine createTemporaryRegister.
	emitter 
		moveFrom: (aMedLabel code visitWith: self)
		to: answer.
	emitter jumpTo: nextBlock.
	emitter currentBlock: overflowBlock.
	failureCode _ aMedLabel failureCode visitWith: self.
	failureCode isNil ifFalse: 
			[emitter 
				moveFrom: failureCode
				to: answer].
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock.
	^ answer! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:51'!
visitMidDiv: aMedMidDiv 
	^ emitter 
		expanded: (aMedMidDiv firstArgument visitWith: self)
		div: (aMedMidDiv secondArgument visitWith: self)
		failingTo: (aMedMidDiv failureBlock visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:52'!
visitMidDivide: aMedMidDivide 
	^ emitter 
		expanded: (aMedMidDivide firstArgument visitWith: self)
		divide: (aMedMidDivide secondArgument visitWith: self)
		failingTo: (aMedMidDivide failureBlock visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:52'!
visitMidMod: aMedMidMod 
	^ emitter 
		expanded: (aMedMidMod firstArgument visitWith: self)
		mod: (aMedMidMod secondArgument visitWith: self)
		failingTo: (aMedMidMod failureBlock visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:02'!
visitReturn: aMedReturn 
	^ emitter expandedReturnValue: (aMedReturn value visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:03'!
visitSend: aMedSend 
	^ emitter 
		expandedSendSelector: aMedSend selector
		arguments: (aMedSend arguments collect: [:each | each visitWith: self])
		pc: aMedSend programCounter
		stackHeight: aMedSend stackHeight! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:58'!
visitStoreInReceiver: aMedStoreInReceiver 
	| answer |
	answer _ emitter createTemporaryRegister.
	emitter 
		moveFrom: (aMedStoreInReceiver value visitWith: self)
		to: answer.
	emitter 
		beRoot: emitter receiverAddress
		ifNeededBy: answer.
	emitter 
		moveFrom: answer
		to: (emitter instanceVariableAddress: aMedStoreInReceiver slot).
	^ answer! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:28'!
visitStoreInTemp: aMedStoreInTemp 
	^ emitter 
		expandedPopIntoTemp: (aMedStoreInTemp value visitWith: self)
		slot: aMedStoreInTemp slot! !

IntermediateCopier subclass: #LowLevelOptimiser
	instanceVariableNames: 'isAfterJump'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!LowLevelOptimiser methodsFor: 'Misc' stamp: 'wbk 1/22/2005 16:11'!
initialize
	isAfterJump := false.! !

!LowLevelOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/22/2005 16:20'!
simplifyBlock: aMedBlock 
	isAfterJump := false.
	^ super simplifyBlock: aMedBlock! !

!LowLevelOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/22/2005 15:25'!
visitAddress: aMedAddress 
	^ aMedAddress! !

!LowLevelOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/22/2005 16:18'!
visitJump: aJump
	isAfterJump ifTrue: [^ nil.].
	aJump instruction ifNil: [isAfterJump := true].
	^ super visitJump: aJump! !

!LowLevelOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/22/2005 17:53'!
visitRet: aMedRet 
	isAfterJump := true.
	^ super visitRet: aMedRet! !

IntermediateCopier subclass: #RegisterReassigner
	instanceVariableNames: 'machine assignments newBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!RegisterReassigner class methodsFor: 'instance creation' stamp: 'wbk 10/23/2002 19:09'!
assignments: aDictionary method: aMethod for: aMachine
	| assigner |
	assigner := self new
		initializeAssignments: aDictionary 
		method: aMethod 
		for: aMachine.
	assigner run.
	^ assigner result! !

!RegisterReassigner methodsFor: 'misc' stamp: 'wbk 7/6/2003 21:15'!
initializeAssignments: aDictionary method: aMethod for: aMachine
	assignments := aDictionary.
	source := aMethod.
	machine := aMachine.
	result _ MedMethod from: aMethod.
	^ self! !

!RegisterReassigner methodsFor: 'misc' stamp: 'wbk 10/23/2002 19:09'!
result
	^ result! !

!RegisterReassigner methodsFor: 'misc' stamp: 'wbk 10/31/2002 18:04'!
run
	source blocksDo: [:each| each visitWith: self]! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 1/20/2005 21:47'!
visitAddress: aMedAddress 
	^ aMedAddress! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 11/3/2002 13:34'!
visitAddressingMode: anAddressingMode
	^ MedAddressingMode
		offset: anAddressingMode offset 
		base: (anAddressingMode address visitWith: self).! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 10/23/2002 19:07'!
visitAssembly: anAssembly
	| newArgs |
	newArgs := OrderedCollection new.
	anAssembly argumentsDo: [:each| newArgs add: (each visitWith: self)].
	 ^ MedAssembly
		name: anAssembly name
		arguments: newArgs! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 1/16/2005 22:02'!
visitBlock: aMedBlock 
	newBlock := result blockNumbered: aMedBlock blockNumber.
	aMedBlock isAligned ifTrue: [newBlock makeAligned].
	aMedBlock instructionsDo: [:each | newBlock add: (each visitWith: self)].
	^newBlock! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 2/9/2005 22:40'!
visitCall: aMedCall 
	^ MedCall 
		function: (aMedCall function visitWith: self)
		machine: machine! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 1/31/2004 15:32'!
visitDivide: aDivide 
	^ MedX86Divide
		register: (aDivide register visitWith: self)
		eax: (machine registerNamed: #eax)
		edx: (machine registerNamed: #edx)! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 2/4/2005 23:47'!
visitJump: aJump 
	| target |
	target := aJump target isMedBlock
		ifTrue: [result blockNumbered: aJump target blockNumber]
		ifFalse: [aJump target visitWith: self].
	^ MedJump 
		type: aJump type
		target: target! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 12/20/2004 22:55'!
visitMov: anAssembly
	| fromRegister toRegister |
	fromRegister :=(anAssembly from visitWith: self).
	toRegister := (anAssembly to visitWith: self).
	fromRegister = toRegister ifTrue: [^ nil]. "This move has been coalesced"
	 ^ MedMov
		from: fromRegister
		to: toRegister! !

!RegisterReassigner methodsFor: '-- all --' stamp: 'wbk 10/23/2002 19:08'!
visitTemporaryRegister: aReg
	| answer |
	answer := assignments at: aReg.
	^ answer! !

!RegisterReassigner methodsFor: 'Assignment Visiting' stamp: 'wbk 2/2/2004 21:17'!
visitX86Cdq: aMedX86CDQ 
	^ aMedX86CDQ! !

RegisterReassigner subclass: #SpillInserter
	instanceVariableNames: 'spiltRegisters spillMap spillVersions registerAllocator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!SpillInserter class methodsFor: 'instance creation' stamp: 'wbk 5/26/2004 23:50'!
spiltRegisters: someRegisters method: aMethod for: aMachine allocator: anAllocator
	| assigner |
	assigner := self new
		initializeSpills: someRegisters 
		method: aMethod 
		for: aMachine
		allocator: anAllocator.
	assigner run.
	^ assigner result! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 11/2/2002 12:35'!
createSpillMap: anAssembly 
	| spillRegisters |
	spillMap := Dictionary new.
	spillRegisters := (anAssembly registersIn: spiltRegisters).
	spillRegisters do: 
		[:each| spillMap
			at: each
			put: (self newRegisterFor: each)].
	^ spillRegisters! !

!SpillInserter methodsFor: 'misc' stamp: 'wbk 5/26/2004 23:52'!
initializeSpills: someRegisters method: aMethod for: aMachine allocator: anAllocator.
	source := aMethod.
	machine := aMachine.
	registerAllocator := anAllocator.
	result := MedMethod from: aMethod.
	spillVersions := Dictionary new.
	spiltRegisters := someRegisters asSet.
	someRegisters do: [:each| machine spillSlotFor: each].
	^ self! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 8/1/2004 14:46'!
loadSpiltRegisters: spillRegs forInstruction: anAssembly 
	spillRegs do: 
			[:each | 
			(anAssembly isRegisterRead: each) ifTrue: 
					[machine 
						reloadRegister: each
						usingMap: spillMap
						into: newBlock]]! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 5/26/2004 23:54'!
newRegisterFor: aRegister
	| newVersion oldVersion answer |
	oldVersion := spillVersions
		at: aRegister
		ifAbsent: [0].
	newVersion := oldVersion + 1.
	spillVersions
		at: aRegister
		put: newVersion.
	answer := machine registerNamed: (aRegister name, 'v', newVersion asString) asSymbol.
	registerAllocator registerIsSpilled: answer.
	^ answer! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 7/31/2004 11:44'!
saveSpiltRegisters: spillRegs forInstruction: anAssembly 
	spillRegs do: 
			[:each | 
			(anAssembly isRegisterWritten: each) ifTrue: 
					[machine 
						saveRegister: each
						usingMap: spillMap
						into: newBlock]]! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 8/1/2004 14:47'!
visitAssembly: anAssembly 
	| spillRegs |
	spillRegs := self createSpillMap: anAssembly.
	self 
		loadSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	newBlock add: (super visitAssembly: anAssembly).
	self 
		saveSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	^nil! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 12/18/2004 00:04'!
visitMov: anAssembly 
	| spillRegs |
	spillRegs := self createSpillMap: anAssembly.
	self 
		loadSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	newBlock add: (super visitMov: anAssembly).
	self 
		saveSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	^nil! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 11/2/2002 12:57'!
visitTemporaryRegister: aReg
	spillMap isNil ifTrue: [^ aReg].
	^ spillMap
		at: aReg
		ifAbsent: [aReg]! !

IntermediateCopier subclass: #TreeOptimiser
	instanceVariableNames: 'literalRegisters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!TreeOptimiser methodsFor: 'Misc' stamp: 'wbk 12/25/2004 16:44'!
initialize
	literalRegisters := Dictionary new.! !

!TreeOptimiser methodsFor: 'Optimisation' stamp: 'wbk 12/25/2004 11:43'!
invertJumpType: aSymbol 
	aSymbol = #jg ifTrue: [^ #jle].
	aSymbol = #jne ifTrue: [^ #je].
	aSymbol = #jz ifTrue: [^ #jnz].
	aSymbol = #je ifTrue: [^ #jne].
	aSymbol = #jo ifTrue: [^ #jno].
	aSymbol = #jnz ifTrue: [^ #jz].
	aSymbol = #jne ifTrue: [^ #je].
	aSymbol = #jl ifTrue: [^ #jge].
	aSymbol = #jle ifTrue: [^ #jg].
	aSymbol = #jge ifTrue: [^ #jl].

	self error: 'UnrecognisedJump'! !

!TreeOptimiser methodsFor: 'Optimisation' stamp: 'wbk 2/13/2005 12:52'!
optimiseBooleanConversion: aMedDeconvertBoolean 
	| label jumpType |
	label _ aMedDeconvertBoolean boolean.
	jumpType _ aMedDeconvertBoolean desiredBoolean = #trueObj 
				ifTrue: [self invertJumpType: label code jumpType]
				ifFalse: [label code jumpType].
	^ emitter 
		labelArguments: (label arguments collect: [:each | each visitWith: self])
		registers: (label argumentRegisters collect: [:each | each visitWith: self])
		around: (emitter 
				jumpType: jumpType
				to: (aMedDeconvertBoolean target visitWith: self)
				dependingOn: (label code expression visitWith: self))
		failingTo: (emitter 
				deconvertBooleanJumpingTo: (aMedDeconvertBoolean target visitWith: self)
				if: (label failureCode visitWith: self)
				is: aMedDeconvertBoolean desiredBoolean
				pc: aMedDeconvertBoolean pc
				stackHeight: aMedDeconvertBoolean stackHeight)
		failureBlock: (label failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:26'!
visitAtElementAddress: aMedAtElementAddress 
	^ emitter 
		atElementAddressFor: (aMedAtElementAddress object visitWith: self)
		with: (aMedAtElementAddress index visitWith: self)
		failTo: (aMedAtElementAddress failureBlock visitWith: self)
		cacheOffset: aMedAtElementAddress cacheOffset! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/22/2004 20:50'!
visitAtPut: aMedAtPut 
	^ emitter
		atPutReceiver: (aMedAtPut object visitWith: self)
		index: (aMedAtPut index visitWith: self)
		value: (aMedAtPut value visitWith: self)
		failTo: (aMedAtPut failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/22/2004 21:23'!
visitBitShift: aMedBitShift 
	^ emitter
		emit: (aMedBitShift firstArgument visitWith: self)
		bitShift: (aMedBitShift secondArgument visitWith: self)
		failingTo: (aMedBitShift failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:20'!
visitConvertBoolean: aMedConvertBoolean 
	^ emitter 
		convertComparisionToBoolean: (aMedConvertBoolean expression visitWith: self)
		jumpType: aMedConvertBoolean jumpType! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:21'!
visitDeconvertBoolean: aMedDeconvertBoolean 
	(aMedDeconvertBoolean boolean isLabel and: [aMedDeconvertBoolean boolean code isConvertBoolean]) ifTrue: [^ self optimiseBooleanConversion: aMedDeconvertBoolean].
	^ emitter 
		deconvertBooleanJumpingTo: (aMedDeconvertBoolean target visitWith: self)
		if: (aMedDeconvertBoolean boolean visitWith: self)
		is: aMedDeconvertBoolean desiredBoolean
		pc: aMedDeconvertBoolean pc
		stackHeight: aMedDeconvertBoolean stackHeight! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:22'!
visitIntegerValueOf: aMedIntegerValueOf 
	| value |
	value _ aMedIntegerValueOf argument visitWith: self.
	(value isLiteral and: [value literal isInteger]) ifTrue: [^ MedLiteral literal: value literal // 2].
	^ emitter 
		integerValueOf: value
		failTo: (aMedIntegerValueOf failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:52'!
visitLabel: aMedLabel 
	| arguments argumentRegisters |
	arguments _ OrderedCollection new.
	argumentRegisters _ OrderedCollection new.
	aMedLabel arguments 
		with: aMedLabel argumentRegisters
		do: 
			[:eachArgument :eachRegister | 
			(eachArgument isLiteral and: [eachArgument literal isInteger]) 
				ifTrue: 
					[literalRegisters 
						at: eachRegister
						put: eachArgument]
				ifFalse: 
					[arguments add: (eachArgument visitWith: self).
					argumentRegisters add: (eachRegister visitWith: self)]].
	^ emitter 
		labelArguments: arguments
		registers: argumentRegisters
		around: (aMedLabel code visitWith: self)
		failingTo: (aMedLabel failureCode visitWith: self)
		failureBlock: (aMedLabel failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/22/2004 21:45'!
visitMidDiv: aMedMidDiv 
	^emitter 
		emit: (aMedMidDiv firstArgument visitWith: self)
		div: (aMedMidDiv secondArgument visitWith: self)
		failingTo: (aMedMidDiv failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/22/2004 21:46'!
visitMidDivide: aMedDivide 
	^emitter 
		emit: (aMedDivide firstArgument visitWith: self)
		divide: (aMedDivide secondArgument visitWith: self)
		failingTo: (aMedDivide failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/22/2004 21:47'!
visitMidMod: aMedMod 
	^emitter 
		emit: (aMedMod firstArgument visitWith: self)
		mod: (aMedMod secondArgument visitWith: self)
		failingTo: (aMedMod failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:15'!
visitReturn: aMedReturn 
	emitter returnValue: (aMedReturn value visitWith: self).
	^ nil! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:16'!
visitSend: aMedSend 
	^ emitter 
		sendSelector: (aMedSend selector visitWith: self)
		arguments: (aMedSend arguments collect: [:each | each visitWith: self])
		pc: aMedSend programCounter
		stackHeight: aMedSend stackHeight! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:29'!
visitStoreInReceiver: aMedStoreInReceiver 
	^ emitter 
		popIntoReceiver: (aMedStoreInReceiver value visitWith: self)
		slot: aMedStoreInReceiver slot! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:29'!
visitStoreInTemp: aMedStoreInTemp 
	^ emitter 
		popIntoTemp: (aMedStoreInTemp value visitWith: self)
		slot: aMedStoreInTemp slot! !

!TreeOptimiser methodsFor: 'Optimisation' stamp: 'wbk 12/25/2004 17:03'!
visitTemporaryRegister: aMed
	(literalRegisters includesKey: aMed) ifTrue: [^ literalRegisters at: aMed].
	^ super visitTemporaryRegister: aMed! !

Object subclass: #IntermediateCreator
	instanceVariableNames: 'method machine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!IntermediateCreator class methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 18:37'!
createAssembly: anArray for: aMachine
	^ self new
		createAssembly: anArray
		for: aMachine! !

!IntermediateCreator class methodsFor: 'instance creation' stamp: 'wbk 12/19/2004 14:18'!
createExpression: anArray for: aMachineX86 
	^ self new
		createExpression: anArray
		for: aMachineX86! !

!IntermediateCreator class methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 18:36'!
createIntermediate: anArray for: aMachine
	^ self new
		createIntermediate: anArray
		for: aMachine! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 1/26/2004 22:49'!
createArithmatic: anArray
	|arg1 arg2|
	arg1 := self createExpression: (anArray at: 2).
	arg2 := self createExpression: (anArray at: 3).
	^ MedArithmatic
		operator: (anArray at: 1)
		arg1: arg1
		arg2: arg2! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 7/6/2003 21:30'!
createAssembly: anArray for: aMachine
	machine := aMachine.
	method := MedMethod new.
	anArray do: [:each| (self createJustTheBlocks: each)].
	anArray do: [:each|  (self createAssemblyBlock: each)].
	^ method


! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/24/2002 11:36'!
createAssemblyBlock: anArray
	|blockNumber block|
	self assert: [(anArray at: 1) = #block].
	blockNumber := anArray at: 2.
	block := method blockNumbered: blockNumber.
	3 to: anArray size do: [:each| block add: (self 
		createAssemblyInstr: (anArray at: each))].
	^ block	! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 3/4/2005 16:36'!
createAssemblyInstr: anArray 
	| arguments instruction |
	instruction := anArray at: 1.
	(self isJump: anArray) ifTrue: [^ self createJump: anArray].
	instruction = #ret ifTrue: [^ MedRet resultRegister: (machine registerNamed: #eax)].
	arguments := OrderedCollection new.
	2 
		to: anArray size
		do: [:each | arguments add: (self createExpression: (anArray at: each))].
	instruction = #mov ifTrue: 
			[^ MedMov 
				from: (arguments at: 1)
				to: (arguments at: 2)].
	instruction = #call ifTrue: 
			[^ MedCall 
				function: (arguments at: 1)
				machine: machine].
	instruction = #push ifTrue: [^ MedPush argument: (arguments at: 1)].
	instruction = #div ifTrue: 
			[^ MedX86Divide 
				register: (arguments at: 1)
				eax: (machine registerNamed: #eax)
				edx: (machine registerNamed: #edx)].
	instruction = #cdq ifTrue: 
			[^ MedX86CDQ 
				eax: (machine registerNamed: #eax)
				edx: (machine registerNamed: #edx)].
	instruction = #neg ifTrue: [^ MedNegate argument: (arguments at: 1)].
	instruction = #pic ifTrue: 
			[^ MedPic 
				selectionRegister: arguments first
				picEntry: MedPicEntry new].
	instruction = #pop ifTrue: [^MedPop argument: arguments first].
	^ MedAssembly 
		name: instruction
		arguments: arguments! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 12/18/2004 00:03'!
createBasicType: anObject 
	| operator |
	anObject isInteger ifTrue: [^MedLiteral literal: anObject].
	anObject isString 
		ifTrue: 
			[(self isMachineRegister: anObject) 
				ifTrue: [^machine machineRegister: anObject].
			(self isRegister: anObject) ifTrue: [^machine temporaryNamed: anObject].
			^MedLiteral literal: anObject].
	operator := anObject at: 1.
	anObject size = 2
		ifTrue: 
			[^MedAddressingMode 
				offset: operator
				base: (machine registerNamed: (anObject at: 2))].
	^MedAddressingMode address: (self createExpression: operator)! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/24/2002 11:32'!
createBlock: anArray
	|blockNumber block|
	self assert: [(anArray at: 1) = #block].
	blockNumber := anArray at: 2.
	block := method blockNumbered: blockNumber.
	3 to: anArray size do: [:each| block add: (self createExpression: (anArray at: each))].
	^ block	! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 3/4/2005 15:37'!
createExpression: anObject 
	| operator |
	(self isBasicType: anObject) ifTrue: [^ self createBasicType: anObject].
	operator := anObject at: 1.
	operator = #ret ifTrue: [^ MedRet new].
	operator = #mov ifTrue: [^ self createMove: anObject].
	operator = #mem ifTrue: [^ self createMem: anObject].
	operator = #push ifTrue: [^ MedPush argument: (self createExpression: (anObject at: 2))].
	operator = #call ifTrue: 
			[^ MedCall 
				function: (self createExpression: (anObject at: 2))
				machine: machine].
	operator = #deconvertBoolean ifTrue: 
			[^ MedDeconvertBoolean 
				jumpTo: (self createTarget: (anObject at: 4))
				if: (self createExpression: (anObject at: 3))
				is: (anObject at: 2)
				pc: (anObject at: 5)
				stackHeight: (anObject at: 6)].
	operator = #convertBoolean ifTrue: 
			[^ MedConvertBoolean 
				jumpType: (anObject at: 2)
				expression: (self createExpression: (anObject at: 3))].
	operator = #div ifTrue: 
			[^ MedDivide 
				emit: (self createExpression: (anObject at: 2))
				divide: (self createExpression: (anObject at: 3))
				remander: (self createExpression: (anObject at: 4))].
	operator = #label ifTrue: 
			[^ MedLabel 
				arguments: ((anObject at: 2) collect: [:each | self createExpression: each])
				registers: ((anObject at: 3) collect: [:each | self createExpression: each])
				around: (self createExpression: (anObject at: 4))
				failingTo: (self createExpression: (anObject at: 5))
				failureBlock: (self createTarget: (anObject at: 6))].
	operator = #send ifTrue: 
			[^ MedSend 
				selector: (self createExpression: (anObject at: 2))
				arguments: ((anObject 
						copyFrom: 5
						to: anObject size) collect: [:each | self createExpression: each])
				programCounter: (anObject at: 3)
				stackHeight: (anObject at: 4)].
	operator = #return ifTrue: [^ MedReturn value: (self createExpression: (anObject at: 2))].
	operator = #integerValueOf ifTrue: 
			[^ MedIntegerValueOf 
				argument: (self createExpression: (anObject at: 2))
				failureBlock: (self createTarget: (anObject at: 3))].
	operator = #storeInTemp ifTrue: 
			[^ MedStoreInTemp 
				slot: (anObject at: 2)
				value: (self createExpression: (anObject at: 3))].
	operator = #storeInReceiver ifTrue: 
			[^ MedStoreInReceiver 
				slot: (anObject at: 2)
				value: (self createExpression: (anObject at: 3))].
	operator = #bitShift ifTrue: 
			[^ MedBitShift 
				new: (self createExpression: (anObject at: 2))
				with: (self createExpression: (anObject at: 3))
				failingTo: (self createTarget: (anObject at: 4))].
	operator = #midDiv ifTrue: 
			[^ MedMidDiv 
				new: (self createExpression: (anObject at: 2))
				with: (self createExpression: (anObject at: 3))
				failingTo: (self createTarget: (anObject at: 4))].
	operator = #midDivide ifTrue: 
			[^ MedMidDivide 
				new: (self createExpression: (anObject at: 2))
				with: (self createExpression: (anObject at: 3))
				failingTo: (self createTarget: (anObject at: 4))].
	operator = #atElementAddress ifTrue: 
			[^ MedAtElementAddress 
				for: (self createExpression: (anObject at: 2))
				index: (self createExpression: (anObject at: 3))
				failTo: (self createTarget: (anObject at: 4))
				cacheOffset: (anObject at: 5)].
	operator = #atPut ifTrue: 
			[^ MedAtPut 
				receiver: (self createExpression: (anObject at: 2))
				index: (self createExpression: (anObject at: 3))
				value: (self createExpression: (anObject at: 4))
				failTo: (self createTarget: (anObject at: 5))].
	operator = #midMod ifTrue: 
			[^ MedMidMod 
				new: (self createExpression: (anObject at: 2))
				with: (self createExpression: (anObject at: 3))
				failingTo: (self createTarget: (anObject at: 4))].
	operator = #pic ifTrue: 
			[^ MedPic 
				selectionRegister: (self createExpression: (anObject at: 2))
				picEntry: MedPicEntry new].
	operator = #picEntry ifTrue: [^ MedPicEntry new].
	operator = #addressOf ifTrue: [^ MedAddress addressOf: (self createTarget: (anObject at: 2))].
	(self isJump: anObject) ifTrue: [^ self createJump: anObject].
	operator = #neg ifTrue: [^ MedNegate argument: (self createExpression: (anObject at: 2))].
	operator = #pop ifTrue: [^ MedPop argument: (self createExpression: (anObject at: 2))].
	^ self createArithmatic: anObject! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 12/19/2004 14:19'!
createExpression: anArray for: aMachineX86 
	machine := aMachineX86.
	^ self createExpression: anArray! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 20:32'!
createIntermediate: anArray for: aMachine
	method := MedMethod new.
	machine := aMachine.
	anArray do: [:each| (self createBlock: each)].
	^ method! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 2/4/2005 23:25'!
createJump: anArray 
	| testInstruction target targetAddress |
	testInstruction := anArray size = 3 
				ifTrue: [self createExpression: (anArray at: 3)]
				ifFalse: [nil].
	targetAddress := anArray at: 2.
	(targetAddress isSymbol and: [(targetAddress size > 4)]) 
			ifTrue: [target := self createTarget: targetAddress]
			ifFalse: [target := self createExpression: targetAddress].
	^MedJump 
		type: (anArray at: 1)
		target: target
		instruction: testInstruction! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 7/6/2003 21:30'!
createJustTheBlocks: anArray
	|blockNumber block|
	self assert: [(anArray at: 1) = #block].
	blockNumber := anArray at: 2.
	block := method blockNumbered: blockNumber.
	^ block	! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 20:32'!
createMem: anArray
	|address|
	address := self createExpression: (anArray at: 2).
	^ MedMem
		address: address! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 12/18/2004 00:04'!
createMove: anArray
	|arg1 arg2|
	arg1 := self createExpression: (anArray at: 2).
	arg2 := self createExpression: (anArray at: 3).
	^ MedMov
		from: arg1
		to: arg2! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 8/8/2004 11:40'!
createTarget: targetAddress 
	| blockNumber |
	blockNumber := (targetAddress 
				copyFrom: 6
				to: targetAddress size) asInteger.
	^method blockNumbered: blockNumber! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/22/2002 15:34'!
isBasicType: anObject 
	| operator |
	anObject isInteger | anObject isString ifTrue: [^true].
	operator := anObject at: 1.
	operator isNumber | (self isMachineRegister: operator) ifTrue: [^true].
	(anObject isCollection and: [self isRegister: (anObject at: 1)]) ifTrue: [^true].
	^false! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 1/14/2004 22:02'!
isJump: anObject
	anObject isCollection ifFalse: [^ false].
	^ #(jo jz jg jle jl jge je jmp jnz jne) includes: (anObject at: 1)
! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/22/2002 15:22'!
isMachineRegister: anObject 
	(#(#eax #ebx #ecx #edx #esi #edi #ebp #esp) includes: anObject) 
		ifTrue: [^true].
	"(anObject isString and: [(anObject at: 1) = $t]) ifTrue: [^ true]."
	^false! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 12/18/2004 00:03'!
isRegister: anObject 
	^(self isMachineRegister: anObject) 
		| (anObject isString and: [(anObject at: 2) isDigit])
		| (anObject = #currentContext)! !

Object subclass: #IntermediateEmitter
	instanceVariableNames: 'currentBlock machine jumpTargets numberOfTemporaries emitter stack result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!IntermediateEmitter class methodsFor: 'instance creation' stamp: 'wbk 8/8/2004 14:45'!
machine: aMachine jumpTargets: aCollection
	^ self
		machine: aMachine
		jumpTargets: aCollection
		result: MedMethod new.! !

!IntermediateEmitter class methodsFor: 'instance creation' stamp: 'wbk 8/8/2004 14:46'!
machine: aMachine jumpTargets: aCollection result: aMethod 
	^self new 
		initializeMachine: aMachine
		jumpTargets: aCollection
		result: aMethod! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 10/23/2004 22:35'!
addExpression: aMed 
	aMed isNil ifTrue: [^ self].
	aMed isRegister ifTrue: [^ self].
	aMed isLiteral ifTrue: [^ self].
	currentBlock add: aMed! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 1/19/2005 21:20'!
addressOf: aMedBlock 
	^ MedAddress addressOf: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/13/2005 12:49'!
alignedLabel
	| newBlock |
	newBlock _ self newBlock.
	newBlock makeAligned.
	self jumpTo: newBlock.
	currentBlock _ newBlock.
	^ newBlock! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/13/2005 12:49'!
alignedLabel: aBlock 
	aBlock makeAligned.
	self jumpTo: aBlock.
	currentBlock _ aBlock.
	^ aBlock! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 2/13/2005 12:52'!
arithmaticOperator: aSymbol arg1: firstMed arg2: secondMed 
	^ MedArithmatic 
		operator: aSymbol
		arg1: firstMed
		arg2: secondMed! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:26'!
atCacheEntryEntry: anInteger index: aMed 
	^ MedMem address: (MedArithmatic 
				operator: #add
				arg1: (MedLiteral literal: #atCache)
				arg2: (MedArithmatic 
						operator: #sal
						arg1: (MedArithmatic 
								operator: #add
								arg1: (MedLiteral literal: anInteger)
								arg2: aMed)
						arg2: (MedLiteral literal: 2)))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:26'!
atElementAddressFor: objectMed with: indexMed failTo: aMedBlock cacheOffset: anObject 
	^ MedAtElementAddress 
		for: objectMed
		index: indexMed
		failTo: aMedBlock
		cacheOffset: anObject! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 12/16/2004 17:36'!
atPutReceiver: aSymbol index: aSymbol2 value: aSymbol3 failTo: aMedBlock 
	^ MedAtPut 
		receiver: aSymbol
		index: aSymbol2
		value: aSymbol3 
		failTo: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/13/2005 12:46'!
basicJumpTo: aLabel 
	^ MedJump 
		type: #jmp
		target: aLabel! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 2/13/2005 12:44'!
basicMoveFrom: aMedMem to: aMedTemporaryRegister 
	^ MedMov 
		from: aMedMem
		to: aMedTemporaryRegister! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:27'!
beRoot: parentObject ifNeededBy: childObject 
	| nextBlock |
	nextBlock _ emitter newBlock.
	self 
		ifInNewSpace: childObject
		jumpTo: nextBlock.
	self 
		beRootIfNessisary: parentObject
		exitingTo: nextBlock! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:46'!
beRootIfNessisary: parentObject exitingTo: nextBlock 
	| header rootTableCount |
	emitter addExpression: (emitter 
				jumpType: #jge
				to: nextBlock
				dependingOn: (emitter 
						emit: parentObject
						minus: (emitter mem: emitter youngStartAddress))).
	header _ emitter createTemporaryRegister.
	emitter 
		moveFrom: (emitter mem: parentObject)
		to: header.
	emitter addExpression: (emitter 
				jumpType: #jnz
				to: nextBlock
				dependingOn: (emitter 
						emit: header
						and: (MedLiteral literal: 1073741824))).	"root flag in header"
	rootTableCount _ emitter createTemporaryRegister.
	emitter 
		moveFrom: (emitter 
				emit: (MedLiteral literal: 1)
				add: (emitter mem: emitter rootTableCountAddress))
		to: rootTableCount.
	emitter 
		moveFrom: rootTableCount
		to: (emitter mem: emitter rootTableCountAddress).
	emitter 
		moveFrom: parentObject
		to: (emitter mem: (emitter 
						emit: emitter rootTableAddress
						add: (emitter 
								emit: rootTableCount
								sal: (MedLiteral literal: 2)))).
	emitter 
		moveFrom: (emitter 
				emit: header
				or: (MedLiteral literal: 1073741824))
		to: (emitter mem: parentObject).
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/18/2005 21:54'!
callFunctionNamed: aSymbol with: someMeds 
	| functionAddress answer |
	someMeds reverseDo: [:each | emitter push: each].
	functionAddress := machine createTemporaryRegister.
	currentBlock add: (MedMov 
				from: (machine addressOf: (MedLiteral literal: aSymbol))
				to: functionAddress).
	currentBlock add: (MedCall 
				function: functionAddress
				machine: machine).
	answer := machine createTemporaryRegister.
	emitter 
		moveFrom: (machine registerNamed: #eax)
		to: answer.
	currentBlock add: (MedMov 
				from: (MedArithmatic 
						operator: #add
						arg1: (MedLiteral literal: someMeds size * 4)
						arg2: (machine registerNamed: #esp))
				to: (machine registerNamed: #esp)).
	^ answer! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 3/6/2005 10:56'!
callSendSelector: selector arguments: someArguments pc: nextPC stackHeight: stackInteger 
	| returnToInterpreter compiledAddress label picPosition picEntry |
	returnToInterpreter := emitter newBlock.
	label := emitter newBlock.
	emitter 
		restoreContextWithPC: nextPC
		stack: (self 
				stackHeight: stackInteger
				with: someArguments).
	emitter 
		moveFrom: (emitter addressOf: label)
		to: (emitter mem: (emitter 
						emit: emitter currentContextAddress
						add: (MedLiteral literal: 20))).
	emitter 
		moveFrom: (emitter classOf: someArguments first)
		to: (machine registerNamed: #eax).
	picPosition := machine registerNamed: #ecx.
	compiledAddress := machine registerNamed: #eax.
	picEntry := MedPicEntry new.
	emitter 
		moveFrom: picEntry
		to: picPosition.

	emitter
		moveFrom: selector
		to: (machine registerNamed: #edx).
	emitter restoreSendersFrame.
	emitter 
		picLocatedAt: (machine registerNamed: #eax)
		picEntry: picEntry.
	emitter 
		moveFrom: (emitter 
				callFunctionNamed: #exuperySetupMessageSend
				with: ({ 
						(machine registerNamed: #edx).
						MedLiteral literal: someArguments size - 1.
						picPosition}))
		to: compiledAddress.
	emitter addExpression: (emitter 
				jumpType: #jz
				to: returnToInterpreter
				dependingOn: (emitter 
						emit: compiledAddress
						minus: (MedLiteral literal: 0))).
	emitter jumpTo: compiledAddress.
	emitter currentBlock: returnToInterpreter.
	emitter
		moveFrom: (MedLiteral literal: 1)
		to: (machine registerNamed: #eax).
	emitter ret.
	^ label! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 2/13/2005 12:19'!
checkIsInteger: aMed failTo: aLabel 
	| check |
	check _ MedJump 
				type: #jz
				target: aLabel
				instruction: (MedArithmatic 
						operator: #and
						arg1: (MedLiteral literal: 1)
						arg2: aMed).
	currentBlock add: check! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 2/13/2005 12:20'!
checkIsNotInteger: aMedMem failTo: aMedBlock 
	| check |
	check _ MedJump 
				type: #jnz
				target: aMedBlock
				instruction: (MedArithmatic 
						operator: #and
						arg1: (MedLiteral literal: 1)
						arg2: aMedMem).
	currentBlock add: check! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 2/13/2005 12:51'!
checkRoundingNeedsAdjustingFor: result remainder: remander failingTo: nextBlock 
	self addExpression: (self 
				jumpType: #jge
				to: nextBlock
				dependingOn: (self 
						emit: result
						minus: (MedLiteral literal: 0))).
	self 
		ifZero: remander
		jumpTo: nextBlock! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:46'!
classOf: aMedLiteral 
	| result notInteger nextBlock classHeader classIndex |
	result _ emitter createTemporaryRegister.
	classIndex _ emitter createTemporaryRegister.
	notInteger _ emitter newBlock.
	classHeader _ emitter newBlock.
	nextBlock _ emitter newBlock.
	emitter 
		checkIsInteger: aMedLiteral
		failTo: notInteger.
	emitter 
		moveFrom: (emitter specialObject: 5)
		to: result.
	emitter jumpTo: nextBlock.
	emitter currentBlock: notInteger.
	emitter 
		moveFrom: (emitter 
				emit: (MedLiteral literal: 31)
				and: (emitter 
						emit: (emitter mem: aMedLiteral)
						sar: (MedLiteral literal: 12)))
		to: classIndex.
	self 
		ifZero: classIndex
		jumpTo: classHeader.
	emitter 
		moveFrom: (emitter 
				fetchVariableAddress: (emitter 
						emit: classIndex
						minus: (MedLiteral literal: 1))
				ofObject: (emitter specialObject: 28))
		to: result.
	emitter jumpTo: nextBlock.
	emitter currentBlock: classHeader.
	emitter 
		moveFrom: (emitter 
				emit: (MedLiteral literal: 4294967292)
				and: (emitter mem: (emitter 
								emit: aMedLiteral
								minus: (MedLiteral literal: 4))))
		to: result.
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock.
	^ result! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/13/2005 12:53'!
conditionalBytecodeArg1: firstMed arg2: secondMed withJump: aSymbol failureSelector: aNumber 
	| subtract |
	^ emitter 
		withFailTo: 
			[:arguments :overflowBlock | 
			subtract _ emitter 
						emit: (emitter 
								integerValueOf: arguments first
								failTo: overflowBlock)
						minus: (emitter 
								integerValueOf: arguments last
								failTo: overflowBlock).
			emitter 
				convertComparisionToBoolean: subtract
				jumpType: aSymbol]
		failureSpecialSelector: aNumber
		arguments: ({ 
				firstMed.
				secondMed})! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/13/2005 12:49'!
conditionalJumpTo: labelMed onBoolean: booleanMed ifBooleanIs: anObject 
	self 
		conditionalJumpTo: labelMed
		onBoolean: booleanMed
		ifBooleanIs: anObject
		pc: stack pc
		stackHeight: stack stackSize! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/13/2005 12:49'!
conditionalJumpTo: labelMed onBoolean: booleanMed ifBooleanIs: anObject pc: pcInteger stackHeight: stackInteger 
	| notBooleanBlock nextBlock failingBoolean |
	notBooleanBlock _ emitter newBlock.
	nextBlock _ emitter newBlock.
	failingBoolean _ anObject = #trueObj 
				ifTrue: [#falseObj]
				ifFalse: [#trueObj].
	self 
		jumpTo: labelMed
		if: booleanMed
		equals: (emitter mem: (MedLiteral literal: anObject)).
	self 
		jumpTo: notBooleanBlock
		if: booleanMed
		notEquals: (emitter mem: (MedLiteral literal: failingBoolean)).
	emitter jumpTo: nextBlock.
	emitter currentBlock: notBooleanBlock.
	emitter 
		expandedSendSelector: (emitter specialObject: 25)
		arguments: ({ 
				booleanMed})
		pc: pcInteger
		stackHeight: stackInteger.
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 2/13/2005 12:20'!
convertComparisionToBoolean: aMed jumpType: aSymbol 
	^ MedConvertBoolean 
		jumpType: aSymbol
		expression: aMed! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 2/13/2005 12:59'!
convertExpandedComparisionToBoolean: aMed jumpType: aSymbol 
	| answer falseLabel nextLabel |
	answer _ machine createTemporaryRegister.
	falseLabel _ result newBlock.
	nextLabel _ result newBlock.
	emitter addExpression: (emitter 
				jumpType: aSymbol
				to: falseLabel
				dependingOn: aMed).
	emitter 
		moveFrom: emitter trueAddress
		to: answer.
	emitter jumpTo: nextLabel.
	emitter currentBlock: falseLabel.
	emitter 
		moveFrom: emitter falseAddress
		to: answer.
	emitter jumpTo: nextLabel.
	currentBlock _ nextLabel.
	^ answer! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 2/13/2005 12:20'!
convertToSmallInteger: aMedObject failTo: aMedBlock 
	^ MedArithmatic 
		operator: #add
		arg1: (MedLiteral literal: 1)
		arg2: (MedJump 
				type: #jo
				target: aMedBlock
				instruction: (MedArithmatic 
						operator: #sal
						arg1: aMedObject
						arg2: (MedLiteral literal: 1)))! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/18/2005 21:16'!
createProlog
	| prolog |
	prolog := result prolog.
	currentBlock := prolog.
	self setUpStackFrame.
	emitter addExpression: (emitter
		callFunctionNamed: #exuperyCreateContext
		with: #()).
	self loadCurrentContext.
	emitter jumpTo: (result blockAt: 2)	" Jump to the next block,"! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 11/20/2003 23:26'!
createTemporaryRegister
	^ machine createTemporaryRegister! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 10/14/2002 14:17'!
currentBlock
	^ currentBlock! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/8/2003 22:26'!
currentBlock: aMedBlock 
	currentBlock := aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 1/29/2005 22:08'!
currentContextAddress
	^ MedMem address: (MedLiteral literal: #activeContext)! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:27'!
currentContextRegister
	| currentContext |
	currentContext _ machine createTemporaryRegister.
	currentBlock add: (MedMov 
				from: machine currentContext
				to: currentContext).
	^ currentContext! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 2/13/2005 12:53'!
currentContextsPC
	^ MedMem address: (MedArithmatic 
				operator: #add
				arg1: machine currentContext
				arg2: (MedLiteral literal: 4 * 2))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:28'!
currentContextsStack
	^ MedMem address: (MedArithmatic 
				operator: #add
				arg1: machine currentContext
				arg2: (MedLiteral literal: 4 * 3))! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 2/13/2005 12:21'!
deconvertBooleanJumpingTo: labelMed if: booleanMed is: aSymbol pc: pcInteger stackHeight: heightInteger 
	^ MedDeconvertBoolean 
		jumpTo: labelMed
		if: booleanMed
		is: aSymbol
		pc: pcInteger
		stackHeight: heightInteger! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 8/8/2003 20:36'!
emit: aMedLiteral add: aMedMem 
	^ MedArithmatic
		operator: #add
		arg1: aMedLiteral
		arg2: aMedMem! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 2/4/2004 23:38'!
emit: aMedMem and: aSmallInteger 
	^ MedArithmatic
		operator: #and
		arg1: aMedMem
		arg2: aSmallInteger! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 12/22/2004 21:43'!
emit: firstMed bitShift: secondMed failingTo: aBlock 
	^MedBitShift 
		new: firstMed
		with: secondMed
		failingTo: aBlock! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 12/22/2004 21:45'!
emit: firstMed div: secondMed failingTo: aMedBlock 
	^MedMidDiv 
		new: firstMed
		with: secondMed
		failingTo: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 12/22/2004 21:46'!
emit: firstMed divide: secondMed failingTo: aMedBlock 
	^MedMidDivide 
		new: firstMed
		with: secondMed
		failingTo: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 2/13/2005 12:44'!
emit: firstMed divide: secondMed into: result remainder: remander failingTo: aMedBlock 
	self 
		ifZero: secondMed
		jumpTo: aMedBlock.
	self 
		moveFrom: (MedDivide 
				emit: firstMed
				divide: secondMed
				remander: remander)
		to: result! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 3/6/2004 21:09'!
emit: firstMed minus: secondMed
	^ MedArithmatic
		operator: #sub
		arg1: firstMed
		arg2: secondMed! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 12/22/2004 21:47'!
emit: firstMed mod: secondMed failingTo: aMedBlock 
	^MedMidMod 
		new: firstMed
		with: secondMed
		failingTo: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 12/22/2004 21:44'!
emit: firstMed multiply: secondMed failingTo: aLabel 
	^MedJump 
		type: #jo
		target: aLabel
		instruction: (MedArithmatic 
				operator: #mul
				arg1: firstMed
				arg2: secondMed)! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 11/21/2003 00:03'!
emit: aMedTemporaryRegister or: aLargePositiveInteger 
	^ MedArithmatic
		operator: #or
		arg1: aMedTemporaryRegister
		arg2: aLargePositiveInteger! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 11/21/2003 00:01'!
emit: aSmallInteger sal: aMedTemporaryRegister 
	^ MedArithmatic
		operator: #sal
		arg1: aSmallInteger
		arg2: aMedTemporaryRegister! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 3/7/2004 23:33'!
emit: aMedLiteral sar: aMedLiteral2 
	^MedArithmatic 
		operator: #sar
		arg1: aMedLiteral
		arg2: aMedLiteral2! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 8/30/2004 16:17'!
emitter: aMockEmitter 
	emitter := aMockEmitter.
	aMockEmitter result: result.! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 2/13/2005 12:52'!
expanded: firstMed bitShift: secondMed failingTo: aBlock 
	| answer negativeBlock nextBlock firstArgument secondArgument |
	answer _ machine createTemporaryRegister.
	firstArgument _ machine createTemporaryRegister.
	secondArgument _ machine createTemporaryRegister.
	negativeBlock _ emitter newBlock.
	nextBlock _ emitter newBlock.
	emitter 
		moveFrom: firstMed
		to: firstArgument.
	emitter 
		moveFrom: secondMed
		to: secondArgument.
	self addExpression: (emitter 
				jumpType: #jl
				to: negativeBlock
				dependingOn: (self 
						emit: secondArgument
						minus: (MedLiteral literal: 0))).
	self addExpression: (emitter 
				jumpType: #jl
				to: aBlock
				dependingOn: (self 
						emit: (MedLiteral literal: 31)
						minus: secondArgument)).
	emitter 
		moveFrom: (emitter 
				emit: firstArgument
				sal: secondArgument)
		to: answer.
	self addExpression: (emitter 
				jumpType: #jnz
				to: aBlock
				dependingOn: (self 
						emit: firstArgument
						minus: (emitter 
								emit: answer
								sar: secondArgument))).
	emitter jumpTo: nextBlock.
	emitter currentBlock: negativeBlock.
	self addExpression: (emitter 
				jumpType: #jl
				to: aBlock
				dependingOn: (emitter 
						emit: secondArgument
						minus: (MedLiteral literal: -31))).
	self 
		moveFrom: (emitter 
				emit: firstArgument
				sar: (MedNegate argument: secondArgument))
		to: answer.
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock.
	^ answer! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 2/13/2005 12:51'!
expanded: firstMed div: secondMed failingTo: aMedBlock 
	| answer remander nextBlock |
	answer _ machine createTemporaryRegister.
	remander _ machine createTemporaryRegister.
	nextBlock _ emitter newBlock.
	self 
		emit: firstMed
		divide: secondMed
		into: answer
		remainder: remander
		failingTo: aMedBlock.
	self 
		checkRoundingNeedsAdjustingFor: answer
		remainder: remander
		failingTo: nextBlock.
	self 
		moveFrom: (self 
				emit: answer
				minus: (MedLiteral literal: 1))
		to: answer.
	self jumpTo: nextBlock.
	self currentBlock: nextBlock.
	^ answer! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 2/13/2005 12:52'!
expanded: firstMed divide: secondMed failingTo: aMedBlock 
	| answer remander |
	answer _ machine createTemporaryRegister.
	remander _ machine createTemporaryRegister.
	self 
		emit: firstMed
		divide: secondMed
		into: answer
		remainder: remander
		failingTo: aMedBlock.
	self 
		ifNotZero: remander
		jumpTo: aMedBlock.
	^ answer! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 2/13/2005 12:52'!
expanded: firstMed mod: secondMed failingTo: aMedBlock 
	| answer remander nextBlock |
	answer _ machine createTemporaryRegister.
	remander _ machine createTemporaryRegister.
	nextBlock _ emitter newBlock.
	self 
		emit: firstMed
		divide: secondMed
		into: answer
		remainder: remander
		failingTo: aMedBlock.
	self 
		checkRoundingNeedsAdjustingFor: answer
		remainder: remander
		failingTo: nextBlock.
	self 
		moveFrom: (self 
				emit: remander
				add: secondMed)
		to: remander.
	self jumpTo: nextBlock.
	emitter currentBlock: nextBlock.
	^ remander! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:44'!
expandedAtElementAddressFor: objectMed with: indexMed failTo: aMedBlock cacheOffset: anObject 
	| atIndex |
	emitter 
		checkIsNotInteger: objectMed
		failTo: aMedBlock.
	emitter 
		checkIsInteger: indexMed
		failTo: aMedBlock.
	atIndex _ emitter machine createTemporaryRegister.
	emitter 
		moveFrom: (emitter 
				emit: (emitter 
						emit: objectMed
						and: (MedLiteral literal: 28))
				add: (MedLiteral literal: anObject))
		to: atIndex.
	emitter addExpression: (emitter 
				jumpType: #jnz
				to: aMedBlock
				dependingOn: (emitter 
						emit: objectMed
						minus: (emitter 
								atCacheEntryEntry: 1
								index: atIndex))).
	emitter addExpression: (emitter 
				jumpType: #jl
				to: aMedBlock
				dependingOn: (emitter 
						emit: (emitter 
								atCacheEntryEntry: 2
								index: atIndex)
						minus: (emitter 
								emit: indexMed
								sar: (MedLiteral literal: 1)))).
	emitter addExpression: (emitter 
				jumpType: #jg
				to: aMedBlock
				dependingOn: (emitter 
						emit: (emitter 
								atCacheEntryEntry: 3
								index: atIndex)
						minus: (MedLiteral literal: 4))).
	^ emitter 
		fetchVariableAddress: (emitter 
				emit: (emitter 
						emit: (emitter 
								emit: indexMed
								sar: (MedLiteral literal: 1))
						add: (emitter 
								atCacheEntryEntry: 4
								index: atIndex))
				minus: (MedLiteral literal: 1))
		ofObject: objectMed! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 2/13/2005 12:44'!
expandedIntegerValueOf: aMed failTo: aLabel 
	| temporary |
	temporary _ emitter createTemporaryRegister.
	self 
		moveFrom: aMed
		to: temporary.
	self 
		checkIsInteger: temporary
		failTo: aLabel.
	^ MedArithmatic 
		operator: #sar
		arg1: temporary
		arg2: (MedLiteral literal: 1)! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/13/2005 12:49'!
expandedJumpIfFalseTo: labelMed onBoolean: booleanMed 
	self 
		conditionalJumpTo: labelMed
		onBoolean: booleanMed
		ifBooleanIs: #falseObj! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/13/2005 12:49'!
expandedJumpIfTrueTo: labelMed onBoolean: booleanMed 
	self 
		conditionalJumpTo: labelMed
		onBoolean: booleanMed
		ifBooleanIs: #trueObj! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:59'!
expandedPopIntoTemp: aMed slot: anInteger 
	| source |
	source _ emitter createTemporaryRegister.
	emitter 
		moveFrom: aMed
		to: source.
	emitter 
		moveFrom: source
		to: (emitter temporaryAddress: anInteger).
	^ source! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:58'!
expandedReturnValue: aMed 
	| sendersContext newStackPtr nextBlock returnAddress returnToInterpreter |
	sendersContext _ self sendersContext.
	newStackPtr _ self incrementStackPtrFor: sendersContext.
	self 
		stackFor: sendersContext
		at: newStackPtr
		put: aMed.
	emitter recycleContextIfPossible: machine currentContext.
	emitter 
		moveFrom: sendersContext
		to: emitter currentContextAddress.
	emitter 
		moveFrom: emitter nilAddress
		to: (emitter mem: (emitter 
						emit: machine currentContext
						add: (MedLiteral literal: 20))).
	nextBlock _ self newBlock.
	emitter 
		beRootIfNessisary: emitter currentContextAddress
		exitingTo: nextBlock.
	emitter currentBlock: nextBlock.
	returnToInterpreter _ self newBlock.
	emitter 
		checkIsNotInteger: (emitter mem: (emitter 
						emit: emitter currentContextAddress
						add: (MedLiteral literal: 20)))
		failTo: returnToInterpreter.
	returnAddress _ self createTemporaryRegister.
	emitter 
		moveFrom: (emitter mem: (emitter 
						emit: emitter currentContextAddress
						add: (MedLiteral literal: 20)))
		to: returnAddress.
	emitter 
		checkIsInteger: returnAddress
		failTo: returnToInterpreter.
	emitter returnToCompiledMethod: (emitter 
				emit: returnAddress
				minus: (MedLiteral literal: 1)).
	emitter currentBlock: returnToInterpreter.
	self returnToInterpreter.
	^ aMed! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:03'!
expandedSendSelector: selector arguments: someArguments 
	^ self 
		expandedSendSelector: selector
		arguments: someArguments
		pc: stack pc
		stackHeight: stack stackSize! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:03'!
expandedSendSelector: selector arguments: someArguments pc: pcInteger stackHeight: stackInteger 
	| nextPC label |
	nextPC _ pcInteger + 1.	"Set the PC to the next instruction"
	label _ self 
				callSendSelector: selector
				arguments: someArguments
				pc: nextPC
				stackHeight: stackInteger.
	nextPC _ pcInteger + 1.
	^ self 
		returnSendReturnBlock: label
		pc: nextPC
		stackHeight: stackInteger! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 8/21/2004 22:43'!
exuperyStack
	^ stack! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 2/13/2005 12:53'!
falseAddress
	^ MedMem address: (MedLiteral literal: #falseObj)! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:28'!
fetchAddress: field ofObject: compiledMethod 
	^ MedMem address: (MedArithmatic 
				operator: #add
				arg1: compiledMethod
				arg2: (MedLiteral literal: 4 * field literal + 4))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:29'!
fetchVariableAddress: indexMed ofObject: objectMed 
	^ MedMem address: (MedArithmatic 
				operator: #add
				arg1: objectMed
				arg2: (MedArithmatic 
						operator: #add
						arg1: (MedArithmatic 
								operator: #sal
								arg1: indexMed
								arg2: (MedLiteral literal: 2))
						arg2: (MedLiteral literal: 4)))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:30'!
ifInNewSpace: childObject jumpTo: nextBlock 
	emitter 
		checkIsNotInteger: childObject
		failTo: nextBlock.
	emitter addExpression: (emitter 
				jumpType: #jl
				to: nextBlock
				dependingOn: (emitter 
						emit: childObject
						minus: (emitter mem: emitter youngStartAddress)))! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/13/2005 12:31'!
ifNotZero: remander jumpTo: aMedBlock 
	emitter addExpression: (self 
				jumpType: #jne
				to: aMedBlock
				dependingOn: (self 
						emit: (MedLiteral literal: 0)
						minus: remander))! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/13/2005 12:31'!
ifZero: secondMed jumpTo: aMedBlock 
	emitter addExpression: (emitter 
				jumpType: #je
				to: aMedBlock
				dependingOn: (emitter 
						emit: (MedLiteral literal: 0)
						minus: secondMed))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:44'!
incrementStackPtrFor: aContext 
	| newStackPtr |
	newStackPtr _ machine createTemporaryRegister.
	emitter 
		moveFrom: (emitter 
				emit: (emitter mem: (emitter 
								emit: aContext
								add: (MedLiteral literal: 12)))
				add: (MedLiteral literal: 2))
		to: newStackPtr.
	emitter 
		moveFrom: newStackPtr
		to: (emitter mem: (emitter 
						emit: aContext
						add: (MedLiteral literal: 12))).
	^ newStackPtr! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 9/22/2004 20:10'!
initializeMachine: aMachine jumpTargets: aCollection result: aMethod 
	result := aMethod.
	machine := aMachine.
	currentBlock := result blockNumbered: 1.
	emitter := self.
	jumpTargets := Dictionary new.
	aCollection do: 
			[:each | 
			jumpTargets 
				at: each
				put: result newBlock].
	^self! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:58'!
instanceVariableAddress: aSmallInteger 
	^ emitter 
		fetchAddress: (MedLiteral literal: aSmallInteger)
		ofObject: emitter receiverAddress! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 2/13/2005 12:22'!
integerValueOf: aMed failTo: aLabel 
	^ MedIntegerValueOf 
		argument: aMed
		failureBlock: aLabel! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/13/2005 12:48'!
jumpIfFalseTo: labelMed onBoolean: booleanMed 
	self addExpression: (self 
				deconvertBooleanJumpingTo: labelMed
				if: booleanMed
				is: #falseObj
				pc: stack pc
				stackHeight: stack stackSize)! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/13/2005 12:48'!
jumpIfTrueTo: labelMed onBoolean: booleanMed 
	self addExpression: (self 
				deconvertBooleanJumpingTo: labelMed
				if: booleanMed
				is: #trueObj
				pc: stack pc
				stackHeight: stack stackSize)! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/13/2005 12:48'!
jumpTarget: anInteger 
	| targetLabel |
	targetLabel _ jumpTargets at: anInteger.
	currentBlock add: (MedJump 
				type: #jmp
				target: targetLabel).
	currentBlock _ targetLabel! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/13/2005 12:46'!
jumpTo: aLabel 
	emitter addExpression: (self basicJumpTo: aLabel)! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/13/2005 12:42'!
jumpTo: labelMed if: booleanMed equals: anObject 
	emitter addExpression: (emitter 
				jumpType: #je
				to: labelMed
				dependingOn: (emitter 
						emit: booleanMed
						minus: anObject))! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/13/2005 12:42'!
jumpTo: notBooleanBlock if: booleanMed notEquals: anObject1 
	emitter addExpression: (emitter 
				jumpType: #jne
				to: notBooleanBlock
				dependingOn: (emitter 
						emit: booleanMed
						minus: anObject1))! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 8/7/2004 21:08'!
jumpType: aSymbol to: aMedBlock dependingOn: aMedArithmatic 
	^ MedJump
		type: aSymbol
		target: aMedBlock
		instruction: aMedArithmatic! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/13/2005 12:47'!
label
	| newBlock |
	newBlock _ self newBlock.
	self jumpTo: newBlock.
	currentBlock _ newBlock.
	^ newBlock! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 2/13/2005 12:52'!
labelArguments: someArguments registers: someRegisters around: aMedArithmatic failingTo: aMedTemporaryRegister failureBlock: aMedBlock 
	^ MedLabel 
		arguments: someArguments
		registers: someRegisters
		around: aMedArithmatic
		failingTo: aMedTemporaryRegister
		failureBlock: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 2/13/2005 12:53'!
labelAround: aMedArithmatic failingTo: aMedTemporaryRegister failureBlock: aMedBlock 
	self removeMe.
	^ MedLabel 
		around: aMedArithmatic
		failingTo: aMedTemporaryRegister
		failureBlock: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Jump Bytecodes' stamp: 'wbk 2/13/2005 12:47'!
labelForByteCode: anInteger 
	^ jumpTargets at: anInteger! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 2/13/2005 12:54'!
literalAddress: aNumber 
	| compiledMethod field |
	compiledMethod _ MedMem address: (MedArithmatic 
						operator: #add
						arg1: machine currentContext
						arg2: (MedLiteral literal: 16)).
	field _ MedLiteral literal: aNumber + 1.	"Add the method header"
	^ self 
		fetchAddress: field
		ofObject: compiledMethod	"4 is object header"! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/18/2005 21:26'!
loadCurrentContext
	emitter 
		moveFrom: emitter currentContextAddress
		to: machine currentContext! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 10/14/2002 14:04'!
machine
	^ machine! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 10/2/2004 21:23'!
materialiseStack
	stack materialiseStack! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 2/13/2005 12:03'!
mem: aMedLiteral 
	^ MedMem address: aMedLiteral! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:08'!
method
	self removeMe.
	^result! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 2/13/2005 12:44'!
moveFrom: aMedMem to: aMedTemporaryRegister 
	currentBlock add: (MedMov 
				from: aMedMem
				to: aMedTemporaryRegister)! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 2/13/2005 12:45'!
moveToEax: aMedLiteral 
	currentBlock add: (MedMov 
				from: aMedLiteral
				to: (machine registerNamed: #eax))! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 2/13/2005 12:43'!
moveToTemp: aMedMem 
	| answer |
	answer _ machine createTemporaryRegister.
	currentBlock add: (MedMov 
				from: aMedMem
				to: answer).
	^ answer! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:08'!
newBlock
	^result newBlock! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 2/13/2005 12:54'!
nilAddress
	^ MedMem address: (MedLiteral literal: #nilObj)! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 9/22/2004 20:10'!
numberOfTemporaries
	^result numberOfTemporaries! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 9/22/2004 20:10'!
numberOfTemporaries: anInteger 
	result numberOfTemporaries: anInteger! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/27/2005 13:37'!
picLocatedAt: aMedLiteral picEntry: aPicEntry
	self addExpression: (MedPic 
				selectionRegister: aMedLiteral
				picEntry: aPicEntry)! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 3/4/2005 15:22'!
pop: aMed 
	currentBlock add: (MedPop argument: aMed)! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:29'!
popIntoReceiver: aMedLiteral slot: aSmallInteger 
	^ MedStoreInReceiver 
		slot: aSmallInteger
		value: aMedLiteral! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:29'!
popIntoTemp: aMed slot: anInteger 
	^ MedStoreInTemp 
		slot: anInteger
		value: aMed! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 19:23'!
preamble
	"The call preamble"

	"Load the current context, or get the context into registers"

	self setUpStackFrame.
	self loadCurrentContext! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 2/13/2005 12:25'!
push: aMed 
	currentBlock add: (MedPush argument: aMed)! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 2/13/2005 12:58'!
receiver
	self shouldBeImplemented! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 2/13/2005 12:58'!
receiverAddress
	^ MedMem address: (MedArithmatic 
				operator: #add
				arg1: machine currentContext
				arg2: (MedLiteral literal: 24))! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:46'!
recycleContextIfPossible: aMedLiteral 
	| nextBlock |
	nextBlock _ emitter newBlock.
	emitter addExpression: (emitter 
				jumpType: #jle
				to: nextBlock
				dependingOn: (emitter 
						emit: (emitter mem: (MedLiteral literal: #reclaimableContextCount))
						minus: (MedLiteral literal: 0))).
	emitter 
		moveFrom: (emitter 
				emit: (emitter mem: (MedLiteral literal: #reclaimableContextCount))
				minus: (MedLiteral literal: 1))
		to: (emitter mem: (MedLiteral literal: #reclaimableContextCount)).
	emitter addExpression: (emitter 
				jumpType: #jl
				to: nextBlock
				dependingOn: (emitter 
						emit: aMedLiteral
						minus: (emitter mem: emitter youngStartAddress))).
	emitter 
		moveFrom: (emitter mem: (MedLiteral literal: #freeContexts))
		to: (emitter 
				fetchAddress: (MedLiteral literal: 0)
				ofObject: aMedLiteral).
	emitter 
		moveFrom: aMedLiteral
		to: (emitter mem: (MedLiteral literal: #freeContexts)).
	emitter jumpTo: nextBlock.
	currentBlock _ nextBlock! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 9/19/2004 16:15'!
registerEntryPointWithPC: aSmallInteger label: anIntermediateEmitter 
	result
		registerEntryPointWithPC: aSmallInteger
		label: anIntermediateEmitter! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:59'!
reloadStack: aStack 
	| currentContext stackPosition |
	currentContext _ self currentContextRegister.
	stackPosition _ 0.
	aStack do: 
			[:each | 
			currentBlock add: (MedMov 
						from: (self 
								stackAddressAt: stackPosition
								context: currentContext)
						to: each).
			stackPosition _ stackPosition + 1]! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:59'!
restoreContextWithPC: aSmallInteger stack: aStack 
	| currentContext stackPosition |
	currentBlock add: (MedMov 
				from: (MedLiteral smallInteger: aSmallInteger)
				to: self currentContextsPC).
	currentBlock add: (MedMov 
				from: (MedLiteral smallInteger: aStack size + self numberOfTemporaries)
				to: self currentContextsStack).
	currentContext _ self currentContextRegister.
	stackPosition _ 0.
	aStack do: 
			[:each | 
			currentBlock add: (MedMov 
						from: each
						to: (self 
								stackAddressAt: stackPosition
								context: currentContext)).
			stackPosition _ stackPosition + 1]! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 3/5/2005 00:04'!
restoreSendersFrame
	emitter 
		moveFrom: (emitter 
				emit: (machine registerNamed: #esp)
				add: (MedLiteral literal: 64))
		to: (machine registerNamed: #esp).
	emitter pop: (machine registerNamed: #edi).
	emitter pop: (machine registerNamed: #esi).
	emitter pop: (machine registerNamed: #ebx).
	emitter 
		moveFrom: (machine registerNamed: #ebp)
		to: (machine registerNamed: #esp).
	emitter pop: (machine registerNamed: #ebp)! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:08'!
result
	^result! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 3/4/2005 14:09'!
ret
	currentBlock add: MedRet new! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:49'!
returnSendReturnBlock: label pc: nextPC stackHeight: stackInteger 
	| answer |
	answer _ machine createTemporaryRegister.
	emitter alignedLabel: label.
	emitter preamble.
	emitter reloadStack: (self 
				stackHeight: stackInteger
				with: (Array with: answer)).
	emitter 
		registerEntryPointWithPC: (MedLiteral smallInteger: nextPC)
		label: label.
	^ answer! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 3/4/2005 20:26'!
returnSequence
	emitter restoreSendersFrame.
	emitter ret! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 3/4/2005 20:28'!
returnToCompiledMethod: returnAddress 
	"emitter 
		moveFrom: (machine registerNamed: #ebp)
		to: (machine registerNamed: #esp).
	emitter 
		moveFrom: (emitter 
				emit: (machine registerNamed: #esp)
				add: (MedLiteral literal: 4))
		to: (machine registerNamed: #esp)."
	emitter restoreSendersFrame.
	emitter jumpTo: returnAddress! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 3/4/2005 13:49'!
returnToInterpreter
	emitter moveToEax: (MedLiteral literal: 1).
	emitter returnSequence! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:15'!
returnValue: aMed 
	^ emitter addExpression: (MedReturn value: aMed)! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:29'!
rootTableAddress
	^ MedLiteral literal: #rootTable! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:30'!
rootTableCountAddress
	^ MedLiteral literal: #rootTableCount! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:16'!
sendSelector: selector arguments: someArguments 
	^ self 
		sendSelector: selector
		arguments: someArguments
		pc: stack pc
		stackHeight: stack stackSize! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:16'!
sendSelector: selector arguments: someArguments pc: pcInteger stackHeight: stackInteger 
	^ MedSend 
		selector: selector
		arguments: someArguments
		programCounter: pcInteger
		stackHeight: stackInteger! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 2/13/2005 12:58'!
sendersContext
	| sendersContext |
	sendersContext _ machine createTemporaryRegister.
	emitter 
		moveFrom: (emitter mem: (emitter 
						emit: machine currentContext
						add: (MedLiteral literal: 4)))
		to: sendersContext.
	^ sendersContext! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 2/13/2005 12:25'!
setProgramCounter: aMedLiteral 
	self shouldBeImplemented! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 19:18'!
setUpStackFrame
	emitter push: (machine registerNamed: #ebp).
	emitter 
		moveFrom: (machine registerNamed: #esp)
		to: (machine registerNamed: #ebp).
	emitter push: (machine registerNamed: #ebx).
	emitter push: (machine registerNamed: #esi).
	emitter push: (machine registerNamed: #edi).
	emitter 
		moveFrom: (emitter 
				emit: (machine registerNamed: #esp)
				minus: (MedLiteral literal: 64))
		to: (machine registerNamed: #esp)! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:28'!
specialObject: anObject 
	^ emitter 
		fetchAddress: (MedLiteral literal: anObject)
		ofObject: (emitter mem: (MedLiteral literal: #specialObjectsOop))! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:28'!
specialSelector: aSmallInteger 
	^ emitter 
		fetchAddress: (MedLiteral literal: aSmallInteger * 2)
		ofObject: (self specialObject: 23)! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 2/13/2005 12:59'!
stackAddressAt: stackPosition context: currentContext 
	^ MedMem address: (MedArithmatic 
				operator: #add
				arg1: currentContext
				arg2: (MedLiteral literal: 28 + (stackPosition * 4) + (self numberOfTemporaries * 4)))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:44'!
stackFor: aContext at: newStackPtr put: aMed 
	emitter 
		moveFrom: aMed
		to: (emitter mem: (emitter 
						emit: (emitter 
								emit: aContext
								add: (emitter 
										emit: newStackPtr
										sal: (MedLiteral literal: 1)))
						add: (MedLiteral literal: 22)))! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 8/28/2004 16:03'!
stackHeight: anInteger with: anOrderedCollection 
	^ ((1 to: anInteger) collect: [:each| self stackRegister: each]), anOrderedCollection! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 4/29/2004 21:04'!
stackRegister: aSmallInteger 
	^ machine stackRegister: aSmallInteger! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 6/14/2004 18:48'!
state: anExuperyStack 
	stack := anExuperyStack! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 2/13/2005 12:59'!
temporaryAddress: anInteger 
	^ MedMem address: (MedArithmatic 
				operator: #add
				arg1: machine currentContext
				arg2: (MedLiteral literal: 4 * (7 + anInteger)))! !

!IntermediateEmitter methodsFor: 'Emit - Addresses' stamp: 'wbk 2/13/2005 12:59'!
trueAddress
	^ MedMem address: (MedLiteral literal: #trueObj)! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 8/17/2003 18:30'!
verify
	" Currently just a stub. The mock contains tests to make sure that the test succeeded here.
	It might be a good idea to have some basic verification tests on the real objects but this
	isn't done yet."! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 2/13/2005 12:53'!
withFailTo: aBlock failureSpecialSelector: aNumber arguments: someObjects 
	| overflowBlock argumentRegisters |
	overflowBlock _ emitter newBlock.
	argumentRegisters _ someObjects collect: [:each | machine createTemporaryRegister].
	^ emitter 
		labelArguments: someObjects
		registers: argumentRegisters
		around: (aBlock 
				value: argumentRegisters
				value: overflowBlock)
		failingTo: (emitter 
				sendSelector: (emitter specialSelector: aNumber)
				arguments: argumentRegisters)
		failureBlock: overflowBlock! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:30'!
youngStartAddress
	^ MedLiteral literal: #youngStart! !

Object subclass: #IntermediateGenerator
	instanceVariableNames: 'emitter jumpTargets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!IntermediateGenerator class methodsFor: 'instance creation' stamp: 'wbk 5/30/2004 18:22'!
for: aMachine
	^ self 
		for: aMachine
		jumpTargets: #()
		stackHeights: #()! !

!IntermediateGenerator class methodsFor: 'instance creation' stamp: 'wbk 5/30/2004 22:44'!
for: aMachine jumpTargets: aCollection
	^ self new 
		initializeMachine: aMachine
		jumpTargets: aCollection! !

!IntermediateGenerator class methodsFor: 'instance creation' stamp: 'wbk 5/30/2004 22:43'!
for: aMachine jumpTargets: aCollection stackHeights: heightsCollection
	^ self new 
		initializeMachine: aMachine
		jumpTargets: aCollection! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/23/2004 22:59'!
addExpression: aMed
	emitter addExpression: aMed! !

!IntermediateGenerator methodsFor: 'Byte Codes - Jumps' stamp: 'wbk 2/13/2005 12:48'!
byteCodeAddress: anInteger 
	(jumpTargets includes: anInteger) ifTrue: 
			[emitter materialiseStack.
			emitter jumpTarget: anInteger]! !

!IntermediateGenerator methodsFor: 'Unit Testing' stamp: 'wbk 10/14/2002 13:08'!
currentBlock
	^ emitter currentBlock! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/13/2005 12:53'!
emitWithIntegers: aBlock arg1: aFirstObject arg2: aSecondObject failToSpecialSelector: anInteger 
	| expression |
	^ emitter 
		withFailTo: 
			[:arguments :overflowBlock | 
			expression _ aBlock 
						value: (emitter 
								integerValueOf: arguments first
								failTo: overflowBlock)
						value: (emitter 
								integerValueOf: arguments second
								failTo: overflowBlock)
						value: overflowBlock.
			emitter 
				convertToSmallInteger: expression
				failTo: overflowBlock]
		failureSpecialSelector: anInteger
		arguments: ({ 
				aFirstObject.
				aSecondObject})! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/14/2002 13:37'!
emitter
	^ emitter! !

!IntermediateGenerator methodsFor: 'Unit Testing' stamp: 'wbk 10/14/2002 13:56'!
emitter: anEmitter
	emitter := anEmitter.! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 9/19/2004 16:45'!
finish
	"emitter createProlog"! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
generate: aFirstObject add: aSecondObject 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				add: arg2]
		arg1: aFirstObject
		arg2: aSecondObject
		failToSpecialSelector: 0! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
generate: firstMed bitAnd: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				and: arg2]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 14! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/5/2004 20:49'!
generate: aFirstObject bitOr: aSecondObject 
	^ self
		emitWithIntegers:
			[:arg1 :arg2 :overflowBlock| emitter
				emit: arg1
				or: arg2]
		arg1: aFirstObject
		arg2: aSecondObject
		failToSpecialSelector: 15
! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/9/2004 21:44'!
generate: firstMed bitShift: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				bitShift: arg2
				failingTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 12! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 12/22/2004 21:45'!
generate: firstMed div: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				div: arg2
				failingTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 13! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 12/22/2004 21:46'!
generate: firstMed divide: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				divide: arg2
				failingTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 9! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/13/2005 12:20'!
generate: aMedLiteral equivilent: aMedLiteral2 
	^ emitter 
		convertComparisionToBoolean: (emitter 
				emit: aMedLiteral
				minus: aMedLiteral2)
		jumpType: #jne! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 2/13/2005 12:18'!
generate: aMedLiteral makePoint: aMedLiteral2 
	^ emitter 
		sendSelector: (emitter specialSelector: 11)
		arguments: ({ 
				aMedLiteral.
				aMedLiteral2})! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 12/22/2004 21:47'!
generate: firstMed mod: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				mod: arg2
				failingTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 10! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 12/22/2004 21:44'!
generate: firstMed multiply: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				multiply: arg2
				failingTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 8! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/8/2004 16:20'!
generate: firstMed subtract: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				minus: arg2]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 1! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 2/13/2005 12:18'!
generateBinarySelector: anObject receiver: receiverMed argument: argumentMed 
	^ emitter 
		sendSelector: (emitter specialSelector: anObject)
		arguments: ({ 
				receiverMed.
				argumentMed})! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 2/13/2005 12:27'!
generateClass: aMedLiteral 
	^ emitter classOf: aMedLiteral! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 2/13/2005 12:18'!
generateUnarySelector: aSmallInteger receiver: aMedMem 
	^ emitter 
		sendSelector: (emitter specialSelector: aSmallInteger)
		arguments: ({ 
				aMedMem})! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 5/30/2004 22:44'!
initializeMachine: aMachine jumpTargets: aCollection
	emitter := IntermediateEmitter 
		machine: aMachine 
		jumpTargets: aCollection.
	jumpTargets := aCollection.
	^self! !

!IntermediateGenerator methodsFor: 'Helper Methods' stamp: 'wbk 2/13/2005 12:58'!
instanceVariableAddress: aSmallInteger 
	^ emitter 
		fetchAddress: (MedLiteral literal: aSmallInteger)
		ofObject: emitter receiverAddress! !

!IntermediateGenerator methodsFor: 'Unit Testing' stamp: 'wbk 8/8/2004 13:15'!
intermediateString
	^ emitter result intermediateForm! !

!IntermediateGenerator methodsFor: 'Byte Codes - Jumps' stamp: 'wbk 2/13/2005 12:48'!
jumpIfFalse: aMed to: anInteger 
	emitter materialiseStack.
	emitter 
		jumpIfFalseTo: (emitter labelForByteCode: anInteger)
		onBoolean: aMed! !

!IntermediateGenerator methodsFor: 'Byte Codes - Jumps' stamp: 'wbk 2/13/2005 12:48'!
jumpIfTrue: aMed to: anInteger 
	emitter materialiseStack.
	emitter 
		jumpIfTrueTo: (emitter labelForByteCode: anInteger)
		onBoolean: aMed! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/15/2002 18:39'!
jumpTargets
	^ jumpTargets! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 5/30/2004 21:46'!
jumpTargets: aCollection 
	jumpTargets := aCollection! !

!IntermediateGenerator methodsFor: 'Byte Codes - Jumps' stamp: 'wbk 2/13/2005 12:47'!
jumpTo: anInteger 
	emitter materialiseStack.
	emitter jumpTo: (emitter labelForByteCode: anInteger)! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/14/2002 14:04'!
machine
	^ emitter machine! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 8/8/2004 12:59'!
method
self removeMe.
	^ emitter method! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 7/4/2003 12:32'!
numberOfTemporaries: anInteger 
	emitter numberOfTemporaries: anInteger! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 2/13/2005 12:29'!
popIntoTemp: aMed slot: anInteger 
	^ emitter 
		popIntoTemp: aMed
		slot: anInteger! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 12/19/2004 14:46'!
popStack: aMed
	emitter addExpression: aMed

! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 2/13/2005 12:49'!
prim: firstMed equals: secondMed 
	^ emitter 
		conditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jne
		failureSelector: 6! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 2/13/2005 12:49'!
prim: firstMed greaterThan: secondMed 
	^ emitter 
		conditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jle
		failureSelector: 3! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 2/13/2005 12:49'!
prim: firstMed greaterThanEqual: secondMed 
	^ emitter 
		conditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jl
		failureSelector: 5! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 2/13/2005 12:49'!
prim: firstMed lessThan: secondMed 
	^ emitter 
		conditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jge
		failureSelector: 2! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 2/13/2005 12:49'!
prim: firstMed lessThanEquals: secondMed 
	^ emitter 
		conditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jg
		failureSelector: 4! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 2/13/2005 12:49'!
prim: firstMed notEquals: secondMed 
	^ emitter 
		conditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #je
		failureSelector: 7! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 2/13/2005 12:54'!
pushConstant: aLiteral slot: aNumber 
	aLiteral class = SmallInteger ifTrue: [^ MedLiteral smallInteger: aLiteral].
	^ emitter literalAddress: aNumber! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 2/13/2005 12:53'!
pushFalse
	^ emitter moveToTemp: emitter falseAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 11/1/2004 22:30'!
pushInstanceVariable: aSmallInteger 
	^emitter instanceVariableAddress: aSmallInteger! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 2/13/2005 12:54'!
pushLiteralVariable: aReadOnlyVariableBinding slot: aSmallInteger 
	| answer |
	answer _ emitter machine createTemporaryRegister.
	emitter 
		moveFrom: (emitter 
				fetchAddress: (MedLiteral literal: 1)
				ofObject: (emitter literalAddress: aSmallInteger))
		to: answer.	"Access the value but fetch address is 0 offset"
	^ answer! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 2/13/2005 12:54'!
pushNil
	^ emitter moveToTemp: emitter nilAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 2/13/2005 12:58'!
pushSelf
	^ emitter moveToTemp: emitter receiverAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 2/13/2005 12:59'!
pushTempAt: anInteger 
	^ emitter temporaryAddress: anInteger! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 2/13/2005 12:59'!
pushTrue
	^ emitter moveToTemp: emitter trueAddress! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 8/8/2004 13:15'!
result
	^ emitter result! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 2/13/2005 12:53'!
returnFalse
	emitter returnValue: emitter falseAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 2/13/2005 12:54'!
returnNil
	emitter returnValue: emitter nilAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 2/13/2005 12:58'!
returnSelf
	emitter returnValue: emitter receiverAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 2/13/2005 12:15'!
returnTop: aMed 
	^ emitter returnValue: aMed! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 2/13/2005 12:59'!
returnTrue
	emitter returnValue: emitter trueAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 2/13/2005 12:53'!
sendAtPutTo: objectMed location: indexMed value: valueMed 
	^ emitter 
		withFailTo: 
			[:arguments :failBlock | 
			emitter 
				atPutReceiver: (arguments at: 1)
				index: (arguments at: 2)
				value: (arguments at: 3)
				failTo: failBlock]
		failureSpecialSelector: 17
		arguments: ({ 
				objectMed.
				indexMed.
				valueMed})! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 2/13/2005 12:53'!
sendAtTo: aMedMem with: aMedLiteral 
	^ emitter 
		withFailTo: 
			[:arguments :failBlock | 
			emitter 
				atElementAddressFor: arguments first
				with: arguments last
				failTo: failBlock
				cacheOffset: 0]
		failureSpecialSelector: 16
		arguments: ({ 
				aMedMem.
				aMedLiteral})! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 2/13/2005 12:54'!
sendSelector: aSymbol inSlot: selectorInteger arguments: someArguments 
	| selector |
	selector _ emitter literalAddress: selectorInteger.
	^ emitter 
		sendSelector: selector
		arguments: someArguments! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 7/28/2003 13:30'!
state: anExuperyStack 
	emitter state: anExuperyStack! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 2/13/2005 12:29'!
storeAndPopReceiverVariableIndex: anInteger value: aMed 
	^ emitter 
		popIntoReceiver: aMed
		slot: anInteger! !

Object subclass: #JumpTargetRecorder
	instanceVariableNames: 'targets stackTrace stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!JumpTargetRecorder class methodsFor: 'instance creation' stamp: 'wbk 6/13/2004 23:45'!
new
	^ super new initialize! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 10/23/2004 22:23'!
addExpression: aJumpTargetRecorder 
! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 6/14/2004 21:26'!
addJumpTo: aTarget 
	targets add: aTarget.
	stackTrace add: stack stackSize! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:36'!
binaryOperation! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 6/14/2004 21:37'!
byteCodeAddress: anInteger 
	(targets includes: anInteger) ifTrue: 
			[stack heightTo: (stackTrace at: (targets indexOf: anInteger))]! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:22'!
bytecodePrimSendNewWithArg: anOrderedCollection receiver: aRecordJumpTargets size: aNumber
	self sendSize: aNumber
	! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 4/26/2004 22:54'!
emitter
	^ self! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 7/6/2003 20:17'!
finish
! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:18'!
generate: firstMed add: secondMed 
	self binaryOperation.
	! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:18'!
generate: aRecordJumpTargets bitAnd: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:18'!
generate: aRecordJumpTargets bitOr: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets bitShift: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets div: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets divide: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aJumpTargetRecorder equivilent: aJumpTargetRecorder2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets makePoint: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets mod: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: firstMed multiply: secondMed 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: firstMed subtract: secondMed 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 6/6/2004 17:10'!
generateBinarySelector: anObject receiver: aRecordJumpTargets argument: aNumber 
	self sendSize: 2
	! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:22'!
generateClass: aJumpTargetRecorder 
	self sendSize: 1
! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:23'!
generateNew: aRecordJumpTargets 

	self sendSize: 1
! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:23'!
generateUnarySelector: aSmallInteger receiver: aRecordJumpTargets 
	self sendSize: 1
! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 6/14/2004 21:37'!
initialize
	targets := OrderedCollection new.
	stackTrace := OrderedCollection new.! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 6/14/2004 21:37'!
jumpIfFalse: aBoolean to: aTarget 
	self addJumpTo: aTarget! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 6/14/2004 21:37'!
jumpIfTrue: aRecordJumpTargets to: aTarget 
	self addJumpTo: aTarget! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 2/13/2005 12:46'!
jumpTo: aTarget 
	self addJumpTo: aTarget! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 2/13/2005 12:44'!
moveFrom: aJumpTargetRecorder to: anUndefinedObject 
	! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 7/4/2003 12:28'!
numberOfTemporaries: aSmallInteger 
	! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:37'!
pop! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:19'!
popIntoTemp: aMed slot: anInteger
	self pop! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
popStack: aRecordJumpTargets 
	self pop! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed equals: secondMed		
	self binaryOperation! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed greaterThan: secondMed	
	self binaryOperation
	! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed greaterThanEqual: secondMed	
	self binaryOperation
! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed lessThan: secondMed
		
	self binaryOperation! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed lessThanEquals: secondMed 	
	self binaryOperation
	! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed notEquals: secondMed	
	self binaryOperation
! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:37'!
push! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
pushConstant: aLiteral slot: aNumber
	self push.! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
pushFalse
	self push.! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
pushInstanceVariable: aSmallInteger 
	self push.
	! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
pushLiteralVariable: aReadOnlyVariableBinding slot: aSmallInteger 
	self push.! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
pushNil
	self push.! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:21'!
pushSelf
	self push.! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:21'!
pushTempAt: anInteger
	self push.! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:21'!
pushTrue
	self push.! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:38'!
return! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnFalse
	self return
	! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnNil
	
	self return! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnSelf
	self return
! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnTop: aMed
	self return! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnTrue
	self return
	! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:23'!
sendAtPutTo: aRecordJumpTargets location: aRecordJumpTargets2 value: aRecordJumpTargets22 
	self sendSize: 3
! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:24'!
sendAtTo: aRecordJumpTargets with: aRecordJumpTargets2  
	self sendSize: 2
! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 7/6/2003 17:34'!
sendRentryWithStack: anOrderedCollection atPC: aSmallInteger 
	! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:25'!
sendSelector: aSymbol inSlot: aSmallInteger arguments: anObject 
	self sendSize: anObject size
	! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:38'!
sendSize: aSmallInteger ! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 4/26/2004 22:55'!
stackRegister: aSmallInteger 
	^ nil! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:02'!
stackTrace
	^ stackTrace! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 6/14/2004 21:09'!
state: anExuperyStack 
 	stack := anExuperyStack
	! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 12/5/2004 23:16'!
storeAndPopReceiverVariableIndex: aSmallInteger value: aSymbol 
	self pop.! !

!JumpTargetRecorder methodsFor: 'misc' stamp: 'wbk 10/15/2002 14:05'!
targets
	^ targets! !

Object subclass: #Lattice
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!Lattice class methodsFor: 'instance creation' stamp: 'wbk 10/21/2002 21:39'!
new
	^ super new initializeValue: (Set new)! !

!Lattice class methodsFor: 'instance creation' stamp: 'wbk 10/21/2002 21:34'!
value: aSet
	^ super new initializeValue: aSet! !

!Lattice class methodsFor: 'instance creation' stamp: 'wbk 10/21/2002 19:57'!
with: firstRegister
	^ super new initializeValue: (Set with: firstRegister)! !

!Lattice class methodsFor: 'instance creation' stamp: 'wbk 10/21/2002 19:55'!
with: firstRegister with: secondRegister
	^ super new initializeValue: (Set
			with: firstRegister
			with: secondRegister)! !

!Lattice class methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 21:00'!
with: anUndefinedObject with: anUndefinedObject2 with: aMedTemporaryRegister 
	^ (Lattice
		with: anUndefinedObject
		with: anUndefinedObject2) +
		(Lattice with: aMedTemporaryRegister)! !

!Lattice methodsFor: 'Operations' stamp: 'wbk 3/17/2003 18:14'!
+ aLattice
	| newSet |
	newSet := value copy.
	newSet addAll: aLattice value.
	^ self class value: newSet! !

!Lattice methodsFor: 'Operations' stamp: 'wbk 3/17/2003 18:14'!
- aLattice
	| newSet |
	newSet := value copy.
	newSet addAll: aLattice value. "Add the values so that removing them will not cause an error"
	newSet removeAll: aLattice value.
	^ self class value: newSet! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/23/2002 14:10'!
do: aBlock
	value do: aBlock! !

!Lattice methodsFor: 'Unit Testing' stamp: 'wbk 11/1/2002 19:54'!
includesAllOf: anArray
	|registerNames|
	registerNames := value collect: [:each| each name].
	anArray do: [:each| (registerNames includes: each) ifFalse: [^ false]].
	^ true! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/21/2002 19:56'!
initializeValue: aSet
	value := aSet.
	^ self! !

!Lattice methodsFor: 'as yet unclassified' stamp: 'wbk 6/24/2003 10:35'!
isEmpty
	^ value isEmpty! !

!Lattice methodsFor: 'Unit Testing' stamp: 'wbk 10/21/2002 21:31'!
matchesArray: anArray
	|registerNames|
	anArray size = value size ifFalse: [^ false].
	registerNames := value collect: [:each| each name].
	anArray do: [:each| (registerNames includes: each) ifFalse: [^ false]].
	^ true! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/23/2002 14:29'!
register
	value size ~= 1 ifTrue: [Error signal].
	value do: [:each| ^ each].
	! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/24/2002 19:05'!
size
	^ value size! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/21/2002 21:40'!
value
	^ value! !

Object subclass: #LivenessAnalyser
	instanceVariableNames: 'source hasUpdated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!LivenessAnalyser class methodsFor: 'instance creation' stamp: 'wbk 10/20/2002 22:39'!
on: aMethod
	| analyser |
	analyser := self new initializeOn: aMethod.
	analyser run.
	^ analyser! !

!LivenessAnalyser methodsFor: 'Analysis' stamp: 'wbk 11/3/2002 20:31'!
analyse
	| origional updated |
	hasUpdated := true.
	[hasUpdated] whileTrue:
		[hasUpdated := false.
		source blocksDo: 
			[:eachBlock| eachBlock numberOfExpressions
				to: 1
				by: -1
				do: 
					[:each| each ~= eachBlock numberOfExpressions ifTrue:
						[origional := (eachBlock expressionAt: each) out.
						updated := (eachBlock expressionAt: each + 1) in.
						(eachBlock expressionAt: each) setOut: updated.
						updated size > origional size ifTrue: [hasUpdated := true]].
					(eachBlock expressionAt: each) visitWith: self]]].! !

!LivenessAnalyser methodsFor: 'Misc' stamp: 'wbk 10/21/2002 19:52'!
initializeGraph
	source instructionsDo:
		[:each| each setIn: Lattice new.
		each setOut: Lattice new].! !

!LivenessAnalyser methodsFor: 'Misc' stamp: 'wbk 10/20/2002 22:38'!
initializeOn: aMethod
	source := aMethod.
	^ self! !

!LivenessAnalyser methodsFor: 'Unit Testing' stamp: 'wbk 10/22/2002 14:04'!
isLive: anArray at: anInteger
	^ (source 
		blockAt: 1
		instructionAt: anInteger) in matchesArray: anArray! !

!LivenessAnalyser methodsFor: 'Unit Testing' stamp: 'wbk 10/24/2002 22:27'!
isLive: anArray block: blockInteger at: anInteger
	^ (source 
		blockAt: blockInteger
		instructionAt: anInteger) in matchesArray: anArray! !

!LivenessAnalyser methodsFor: 'Analysis' stamp: 'wbk 10/21/2002 12:25'!
run
	self initializeGraph.
	self analyse.
	! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 4/11/2003 11:05'!
visitAssembly: anAssembly
	|newLattice|
	newLattice := (anAssembly registersUsed + (
		anAssembly out - anAssembly registersDefined)).
	newLattice value size ~= anAssembly in value size ifTrue: [hasUpdated := true].
	anAssembly setIn: newLattice! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 7/5/2003 15:12'!
visitCall: aMedCall 
	"It might be nessisary to do something more with calls. They could kill registers, I'm not sure"
	self visitAssembly: aMedCall! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 1/29/2004 20:20'!
visitDivide: aMedX86Divide 
	self visitAssembly: aMedX86Divide! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 2/4/2005 23:37'!
visitJump: aJump
	|newLattice|
	aJump target isMedBlock
		ifTrue:
			[aJump setOut: (aJump out + aJump target in).
			newLattice := aJump out.
			newLattice value size ~= aJump in value size ifTrue: [hasUpdated := true].
			aJump setIn: newLattice]
		ifFalse:
			[self visitAssembly: aJump]! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 11/4/2002 13:54'!
visitMov: anAssembly
	^ self visitAssembly: anAssembly! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 2/9/2004 20:10'!
visitNegate: aMedNegate 
	self visitAssembly: aMedNegate! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 2/25/2005 23:20'!
visitPic: aMedPic 
	self visitAssembly: aMedPic! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 3/4/2005 16:05'!
visitPop: aMedPop 
	
	^ self visitAssembly: aMedPop	! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 6/23/2003 11:47'!
visitPush: aMedPush 
	^ self visitAssembly: aMedPush	! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 3/4/2005 16:38'!
visitRet: anAssembly
	self visitAssembly: anAssembly! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 2/1/2004 22:04'!
visitX86Cdq: aMedX86CDQ 
	self visitAssembly: aMedX86CDQ! !

Object subclass: #MachineX86
	instanceVariableNames: 'machineRegisters nextRegister registerFile spillSlots nextSpillSlot temporaryRegisters currentContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!MachineX86 class methodsFor: 'instance creation' stamp: 'WBK 8/28/2002 20:00'!
new
	^ super new initialize! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 1/29/2005 21:57'!
activeContextAddress
	<primitive: 'activeContextAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 2/18/2005 21:54'!
addressOf: aMedLiteral 
	aMedLiteral literal = #trueObj ifTrue: [^ self trueObjAddress * 2].
	aMedLiteral literal = #falseObj ifTrue: [^ self falseObjAddress * 2].
	aMedLiteral literal = #exuperySetupMessageSend ifTrue: [^ MedLiteral literal: self setupMessageSendAddress * 2].
	aMedLiteral literal = #specialObjectsOop ifTrue: [^ self specialObjectsOopAddress * 2].
	aMedLiteral literal = #atCache ifTrue: [^ self atCacheAddress * 2].
	aMedLiteral literal = #nilObj ifTrue: [^ self nilObjAddress *2].
	aMedLiteral literal = #youngStart ifTrue: [^ self youngStartAddress * 2].
	aMedLiteral literal = #rootTableCount ifTrue: [^ self rootTableCountAddress * 2].
	aMedLiteral literal = #rootTable ifTrue: [^ self rootTableAddress * 2].
	aMedLiteral literal = #activeContext ifTrue: [^ self activeContextAddress * 2].
	aMedLiteral literal = #reclaimableContextCount ifTrue: [^ self reclaimableContextCount * 2].
	aMedLiteral literal = #freeContexts ifTrue: [^ self freeContexts * 2].
	aMedLiteral literal = #exuperyCreateContext ifTrue: [^ MedLiteral literal: self exuperyCreateContext * 2].

	self error: 'Address of Unknown Literal'.! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 8/9/2003 12:11'!
atCacheAddress
	<primitive: 'atCacheAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/8/2004 23:58'!
createTemporaryRegister
	| name register |
	name := 't' , nextRegister asString asSymbol.
	nextRegister := nextRegister + 1.
	register := self makeTemporaryRegister: name.
	temporaryRegisters 
		at: name
		put: register.
	^register! !

!MachineX86 methodsFor: 'Intermediate Generation' stamp: 'wbk 7/24/2004 11:14'!
currentContext
	^ currentContext! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 2/18/2005 21:30'!
exuperyCreateContext
	<primitive: 'exuperyCreateContext' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 4/18/2003 15:51'!
falseObjAddress
	<primitive: 'falseObjAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 1/30/2005 19:20'!
freeContexts
	<primitive: 'freeContexts' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/24/2004 15:00'!
initialize
	|registerNames reg|
	machineRegisters := Dictionary new.
	registerFile := OrderedCollection new.
	temporaryRegisters := Dictionary new.
	spillSlots := Dictionary new.
	nextRegister := 1.
	nextSpillSlot := -16.
	registerNames := #(eax ebx ecx edx esi edi).
	registerNames do: [:each| 
		reg := self machineRegister: each.
		registerFile add: reg].
	currentContext := self makeTemporaryRegister: #currentContext.
	^ self! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 11/1/2002 12:52'!
isSpecialRegister: aRegister 
	| name |
	name := aRegister name.
	^self isSpecialRegisterName: name! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 11/2/2002 16:14'!
isSpecialRegisterName: name 
	^ name = #ebp | (name = #esp)! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 00:02'!
machineRegister: aSymbol 
	^machineRegisters 
		at: aSymbol
		ifAbsentPut: 
			[self makeMachineRegister: aSymbol]! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 1/21/2005 23:36'!
machineWordIn: aSmallInteger at: aSmallInteger2 put: aSmallInteger3 
	<primitive: 'machineWordInAtPut' module: 'ExuperyPlugin'>
	TestFailure signal.! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 20:37'!
makeMachineRegister: name 
	| register |
	register := MedMachineRegister name: name.
	^register! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 20:37'!
makeTemporaryRegister: name 
	| register |
	register := MedTemporaryRegister name: name.
	^register! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 9/12/2002 16:44'!
newSpillSlot
	|answer|
	answer := nextSpillSlot.
	nextSpillSlot := nextSpillSlot -4.
	^ answer! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 12/18/2004 00:04'!
newTemporaryNamed: aSymbol
	|number register|
	register := self makeTemporaryRegister: aSymbol.
	aSymbol first = $t ifTrue:
		[number := (aSymbol copyFrom: 2 to: aSymbol size) asNumber.
		number >= nextRegister ifTrue: [nextRegister := number + 1]].
	temporaryRegisters
		at: aSymbol
		put: register.
	^ register! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 10/4/2003 21:12'!
nilObjAddress
	<primitive: 'nilObjAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Register Allocation' stamp: 'wbk 10/23/2002 17:21'!
numberOfColours
	^ 6! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 1/30/2005 19:20'!
reclaimableContextCount
	<primitive: 'reclaimableContextCount' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 6/28/2004 22:47'!
registerAt: aSmallInteger 
	machineRegisters do: [:each| each index = aSmallInteger ifTrue: [^ each]].
	temporaryRegisters do: [:each| each index = aSmallInteger ifTrue: [^ each]].
	Error signal: 'Register not found'! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 11/1/2002 12:53'!
registerNamed: aSymbol
	^ machineRegisters
		at: aSymbol
		ifAbsent:
			[
				(self isSpecialRegisterName: aSymbol) ifTrue:
					[^ self machineRegister: aSymbol].
				^ self temporaryNamed: aSymbol]! !

!MachineX86 methodsFor: 'Register Allocation' stamp: 'wbk 11/4/2002 16:07'!
reloadRegister: aReg usingMap: aDictionary into: aMedBlock
	|slot instruction |
	slot := spillSlots
		at: aReg
		ifAbsent: [^ self].
	instruction := MedMov
		from: (MedAddressingMode
			offset: slot
			base: (self machineRegister: #ebp))
		to: (aDictionary at: aReg).
	aMedBlock add: instruction! !

!MachineX86 methodsFor: 'Primitives - Memory Testing' stamp: 'wbk 11/21/2003 22:36'!
rootTableAddress
	<primitive: 'rootTableAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Memory Testing' stamp: 'wbk 11/21/2003 22:32'!
rootTableCountAddress
	<primitive: 'rootTableCountAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Register Allocation' stamp: 'wbk 11/4/2002 16:08'!
saveRegister: aReg usingMap: aDictionary into: aMedBlock
	|instruction aNumber |
	aNumber := (self spillSlotFor: aReg).
	instruction := MedMov
		 	from: (aDictionary at: aReg)
			to: (MedAddressingMode
				offset: aNumber
				base: (self machineRegister: #ebp)).
	aMedBlock add: instruction! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 6/30/2003 18:31'!
setupMessageSendAddress
	<primitive: 'setupMessageSendAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 7/17/2003 12:44'!
specialObjectsOopAddress
	<primitive: 'specialObjectsOopAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Register Allocation' stamp: 'wbk 9/17/2002 13:34'!
spillSlotFor: aRegister
	^ spillSlots
		at: aRegister
		ifAbsentPut: [self newSpillSlot]! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 00:04'!
stackRegister:  aSmallInteger 
	 | registerName register |
	registerName := (#s, aSmallInteger printString) asSymbol.
	^ temporaryRegisters
		at: registerName
		ifAbsent:
			[register := self makeTemporaryRegister: registerName.
			temporaryRegisters
				at: registerName
				put: register.
			^ register]! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 4/29/2004 21:24'!
temporaryNamed: aSymbol
	^ temporaryRegisters
		at: aSymbol
		ifAbsent: [self newTemporaryNamed: aSymbol]! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 4/18/2003 15:51'!
trueObjAddress
	<primitive: 'trueObjAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'WBK 8/28/2002 22:50'!
useableRegisters
	^ registerFile! !

!MachineX86 methodsFor: 'Primitives - Memory Testing' stamp: 'wbk 11/21/2003 20:01'!
youngStartAddress
	<primitive: 'youngStartAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

MachineX86 subclass: #MockExuperyPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!MockExuperyPlugin methodsFor: 'as yet unclassified' stamp: 'wbk 2/18/2005 21:08'!
addressOf: aMedLiteral 
	aMedLiteral literal = #trueObj ifTrue: [^ self trueObjAddress].
	aMedLiteral literal = #falseObj ifTrue: [^ self falseObjAddress].
	(#(exuperySetupMessageSend exuperyCreateContext) includes: aMedLiteral literal) ifTrue: [^ aMedLiteral].

	Error signal. "Unrecognised Constant"! !

!MockExuperyPlugin methodsFor: 'as yet unclassified' stamp: 'wbk 4/11/2003 16:16'!
falseObjAddress
	^ 16r41133557! !

!MockExuperyPlugin methodsFor: 'as yet unclassified' stamp: 'wbk 4/10/2003 14:21'!
trueObjAddress
	^ 16r40123456! !

Object subclass: #MedLanguage
	instanceVariableNames: 'in out'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

MedLanguage subclass: #MedAddressingMode
	instanceVariableNames: 'base offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedAddressingMode class methodsFor: 'instance creation' stamp: 'wbk 9/11/2002 17:23'!
address: aSimpleMed
	^ self indirectRegister: aSimpleMed! !

!MedAddressingMode class methodsFor: 'instance creation' stamp: 'wbk 9/11/2002 13:53'!
indirectRegister: aRegister
	^ self new initializeIndirectRegister: aRegister! !

!MedAddressingMode class methodsFor: 'instance creation' stamp: 'wbk 9/12/2002 17:01'!
offset: aNumber base: aRegister
	^ self new 
		initializeOffset: aNumber
		base: aRegister! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 9/12/2002 16:59'!
address
	^ base! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 3/14/2003 14:33'!
base
	^ base! !

!MedAddressingMode methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:46'!
expressionsDo: aBlockContext ! !

!MedAddressingMode methodsFor: 'as yet unclassified' stamp: 'wbk 4/11/2003 14:00'!
hasOffset
	^ offset isNil not! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 9/12/2002 17:13'!
initialize
	base := nil.! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 9/12/2002 17:02'!
initializeIndirectRegister: aRegister
	self initialize.
	base := aRegister.
	^ self! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 9/12/2002 17:02'!
initializeOffset: aNumber base: aRegister
	self initialize.
	offset := aNumber.
	base := aRegister.
	^ self! !

!MedAddressingMode methodsFor: 'Unit Testing' stamp: 'wbk 9/12/2002 17:13'!
intermediateForm
	|answer|
	answer := OrderedCollection new.
	offset ~= nil ifTrue: [answer add: offset].
	answer add: base intermediateForm.
	^ answer asArray! !

!MedAddressingMode methodsFor: 'testing' stamp: 'wbk 9/11/2002 23:20'!
isAddressingMode
	^ true! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 3/14/2003 14:33'!
offset
	^ offset! !

!MedAddressingMode methodsFor: 'printing' stamp: 'wbk 10/18/2002 17:39'!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."

	| title |
	title _ self class name.
	aStream
		nextPutAll: (title first isVowel ifTrue: ['an '] ifFalse: ['a ']);
		nextPutAll: title! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 11/1/2002 16:34'!
registersDo: aBlock
	aBlock value: base ! !

!MedAddressingMode methodsFor: 'Dataflow Analysis' stamp: 'wbk 4/11/2003 12:53'!
registersUsed
	^ Lattice with: base! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 10/5/2002 21:44'!
visitWith: anObject
	^ anObject visitAddressingMode: self! !

MedLanguage subclass: #MedArithmatic
	instanceVariableNames: 'operator arg1 arg2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedArithmatic class methodsFor: 'instance creation' stamp: 'wbk 3/6/2004 19:55'!
operator: aSymbol arg1: firstMed arg2: secondMed
	^ self new 
		initializeOperator: aSymbol
		arg1: firstMed
		arg2: secondMed! !

!MedArithmatic methodsFor: 'Accessing' stamp: 'WBK 8/28/2002 09:46'!
arg1
	^ arg1! !

!MedArithmatic methodsFor: 'Accessing' stamp: 'WBK 8/28/2002 09:46'!
arg2
	^ arg2! !

!MedArithmatic methodsFor: 'Misc' stamp: 'wbk 8/7/2004 22:21'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	arg1 expressionsDo: aBlockContext.
	arg2 expressionsDo: aBlockContext.! !

!MedArithmatic methodsFor: 'Initialization' stamp: 'WBK 8/27/2002 12:47'!
initializeOperator: aSymbol arg1: firstMed arg2: secondMed
	operator := aSymbol.
	arg1 := firstMed.
	arg2 := secondMed.
	^ self! !

!MedArithmatic methodsFor: 'Unit testing' stamp: 'wbk 3/6/2004 20:12'!
intermediateForm
	^ {operator. arg1 intermediateForm. arg2 intermediateForm}! !

!MedArithmatic methodsFor: 'Testing' stamp: 'wbk 11/8/2002 14:20'!
isAdd
	^ operator = #add! !

!MedArithmatic methodsFor: 'Misc' stamp: 'wbk 3/4/2005 23:52'!
isArithmatic
	^ true! !

!MedArithmatic methodsFor: 'Accessing' stamp: 'WBK 8/28/2002 15:01'!
operator
	^ operator! !

!MedArithmatic methodsFor: 'Misc' stamp: 'wbk 10/6/2002 11:30'!
visitWith: aVisitor
	^ aVisitor visitArithmatic: self! !

MedLanguage subclass: #MedAssembly
	instanceVariableNames: 'name arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedAssembly class methodsFor: 'instance creation' stamp: 'wbk 11/5/2002 14:42'!
name: aSymbol arguments: aCollection
"aSymbol = #mov ifTrue: [self halt]."
	^ self new
		initializeName: aSymbol
		arguments: aCollection! !

!MedAssembly methodsFor: 'misc' stamp: 'wbk 3/17/2003 18:28'!
arg1
	^arguments first! !

!MedAssembly methodsFor: 'misc' stamp: 'wbk 3/14/2003 17:48'!
arg2
	^ arguments at: 2! !

!MedAssembly methodsFor: 'misc' stamp: 'WBK 8/28/2002 21:23'!
argumentsDo: aBlock
	arguments do: aBlock! !

!MedAssembly methodsFor: 'Register Allocation' stamp: 'wbk 1/31/2004 14:51'!
buildInterferenceWith: anAllocator
	| defined |
	(arguments at: 2) isAddressingMode ifTrue: [^ self].
	defined := self registersDefined register.
	out do: 
		[:each | anAllocator 
			addInterferenceEdge: defined 
			to: each]! !

!MedAssembly methodsFor: 'misc' stamp: 'WBK 8/27/2002 20:13'!
initializeName: aSymbol arguments: aCollection
	name := aSymbol.
	arguments := aCollection.
	^ self! !

!MedAssembly methodsFor: 'Unit Testing' stamp: 'WBK 8/28/2002 15:42'!
intermediateForm
	|args answer|
	answer := OrderedCollection with: name.
	args := arguments collect: [:each| each intermediateForm].
	answer addAll: args.
	^ answer asArray! !

!MedAssembly methodsFor: 'Testing' stamp: 'wbk 8/1/2004 14:52'!
isRegisterRead: aMedTemporaryRegister 
	arguments do: [:each| each = aMedTemporaryRegister ifTrue: [^ true]].
	arguments do: 
		[:each| each isAddressingMode ifTrue: 
			[each registersDo: 
				[:eachRegister| eachRegister = aMedTemporaryRegister ifTrue: 
					[^true]]]].
	^ false! !

!MedAssembly methodsFor: 'Testing' stamp: 'wbk 7/31/2004 11:50'!
isRegisterWritten: aMedTemporaryRegister 
	^ (arguments at: 2) = aMedTemporaryRegister! !

!MedAssembly methodsFor: 'misc' stamp: 'WBK 8/28/2002 21:22'!
name
	^ name! !

!MedAssembly methodsFor: 'Dataflow Analysis' stamp: 'wbk 11/4/2002 16:00'!
registersDefined
	(arguments at: 2) isAddressingMode ifTrue: [^ Lattice new].
	^ Lattice with: (arguments at: 2)! !

!MedAssembly methodsFor: 'misc' stamp: 'wbk 11/4/2002 16:52'!
registersDo: aBlock
	arguments do: [:each| each registersDo: aBlock]! !

!MedAssembly methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/17/2003 18:28'!
registersUsed
	^(arguments first) registersUsed + (arguments at: 2) registersUsed! !

!MedAssembly methodsFor: 'misc' stamp: 'wbk 10/5/2002 22:30'!
visitWith: aVisitor
	^ aVisitor visitAssembly: self! !

MedLanguage subclass: #MedAtElementAddress
	instanceVariableNames: 'object index failureBlock cacheOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedAtElementAddress class methodsFor: 'instance creation' stamp: 'wbk 12/12/2004 22:10'!
for: objectMed index: indexMed failTo: aMedBlock cacheOffset: anObject
	^ self new initialiseFor: objectMed
		index: indexMed
		failTo: aMedBlock
		cacheOffset: anObject! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:26'!
cacheOffset
	^ cacheOffset! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:30'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	object expressionsDo: aBlockContext.
	index expressionsDo: aBlockContext.
	failureBlock expressionsDo: aBlockContext.! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:25'!
failureBlock
	^ failureBlock! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:25'!
index
	^ index! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:11'!
initialiseFor: objectMed index: indexMed failTo: aMedBlock cacheOffset: anObject
	object := objectMed.
	index := indexMed.
	failureBlock := aMedBlock.
	cacheOffset := anObject.! !

!MedAtElementAddress methodsFor: 'Unit Testing' stamp: 'wbk 12/12/2004 22:15'!
intermediateForm
	^ {#atElementAddress. object. index intermediateForm. failureBlock. cacheOffset}! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:25'!
object
	^ object! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:20'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitAtElementAddress: self! !

MedLanguage subclass: #MedAtPut
	instanceVariableNames: 'receiver index value failureBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedAtPut class methodsFor: 'instance creation' stamp: 'wbk 12/13/2004 21:00'!
receiver: receiverMed index: indexMed value: valueMed failTo: failureBlock
	^ self new 
		initialiseReceiver: receiverMed 
		index: indexMed 
		value: valueMed 
		failTo: failureBlock! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:31'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	receiver expressionsDo: aBlockContext.
	index expressionsDo: aBlockContext.
	value expressionsDo: aBlockContext.
	failureBlock expressionsDo: aBlockContext.! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:21'!
failureBlock
	^ failureBlock! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:21'!
index
	^ index! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:02'!
initialiseReceiver: receiverMed  index: indexMed value: valueMed failTo: failureBlockMed
	receiver := receiverMed.
	index := indexMed.
	value := valueMed.
	failureBlock := failureBlockMed.! !

!MedAtPut methodsFor: 'Unit Testing' stamp: 'wbk 12/13/2004 22:21'!
intermediateForm
	^ {#atPut. receiver. index. value. failureBlock blockName}! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:10'!
object
	^ receiver! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:12'!
value
	^ value! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:07'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitAtPut: self.! !

MedLanguage subclass: #MedBitShift
	instanceVariableNames: 'firstArgument secondArgument failureBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedBitShift class methodsFor: 'instance creation' stamp: 'wbk 12/22/2004 21:43'!
new: firstMed with: secondMed failingTo: aMedBlock 
	^self new 
		initializeNew: firstMed
		shiftedBy: secondMed
		failTo: aMedBlock! !

!MedBitShift methodsFor: 'Misc' stamp: 'wbk 12/12/2004 17:00'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	firstArgument expressionsDo: aBlockContext.
	secondArgument expressionsDo: aBlockContext.
	failureBlock expressionsDo: aBlockContext.! !

!MedBitShift methodsFor: 'Misc' stamp: 'wbk 12/12/2004 16:59'!
failureBlock
	^ failureBlock! !

!MedBitShift methodsFor: 'Misc' stamp: 'wbk 12/12/2004 16:58'!
firstArgument
	^ firstArgument! !

!MedBitShift methodsFor: 'Misc' stamp: 'wbk 12/12/2004 16:38'!
initializeNew: firstMed shiftedBy: secondMed failTo: aMedBlock
	firstArgument := firstMed.
	secondArgument := secondMed.
	failureBlock := aMedBlock.! !

!MedBitShift methodsFor: 'Unit Testing' stamp: 'wbk 12/12/2004 16:40'!
intermediateForm
	^ {#bitShift. firstArgument intermediateForm. secondArgument intermediateForm. failureBlock blockName}! !

!MedBitShift methodsFor: 'Misc' stamp: 'wbk 12/12/2004 16:59'!
secondArgument
	^ secondArgument! !

!MedBitShift methodsFor: 'Misc' stamp: 'wbk 12/12/2004 16:55'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitBitShift: self! !

MedBitShift subclass: #MedMidDiv
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMidDiv methodsFor: 'Misc' stamp: 'wbk 12/12/2004 17:59'!
intermediateForm
	^ {#midDiv. firstArgument intermediateForm. secondArgument intermediateForm. failureBlock blockName}! !

!MedMidDiv methodsFor: 'Misc' stamp: 'wbk 12/12/2004 18:02'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitMidDiv: self! !

MedBitShift subclass: #MedMidDivide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMidDivide methodsFor: 'Misc' stamp: 'wbk 12/12/2004 19:12'!
intermediateForm
	^ {#midDivide. firstArgument intermediateForm. secondArgument intermediateForm. failureBlock blockName}! !

!MedMidDivide methodsFor: 'Misc' stamp: 'wbk 12/12/2004 19:31'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitMidDivide: self! !

MedBitShift subclass: #MedMidMod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMidMod methodsFor: 'Unit Testing' stamp: 'wbk 12/17/2004 22:55'!
intermediateForm
	^ {#midMod. firstArgument intermediateForm. secondArgument intermediateForm. failureBlock blockName}! !

!MedMidMod methodsFor: 'Misc' stamp: 'wbk 12/17/2004 23:09'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitMidMod: self! !

MedLanguage subclass: #MedBlock
	instanceVariableNames: 'expressions blockNumber isAligned'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedBlock class methodsFor: 'instance creation' stamp: 'wbk 10/3/2002 22:46'!
number: anInteger
	^ super new initializeNumber: anInteger.! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 10/31/2002 18:23'!
add: aMed
	aMed isNil ifTrue: [^ self]. "Nil means there wasn't really an instruction"
	expressions add: aMed! !

!MedBlock methodsFor: 'Unit Testing' stamp: 'wbk 10/2/2002 17:34'!
blockName
	^ 'block', blockNumber asString! !

!MedBlock methodsFor: 'Misc' stamp: 'WBK 8/27/2002 19:32'!
blockNumber
	^ blockNumber! !

!MedBlock methodsFor: 'Misc' stamp: 'WBK 8/27/2002 19:31'!
do: aBlock
	^ expressions do: aBlock! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 9/15/2002 21:59'!
expressionAt: aNumber
	^ expressions at: aNumber! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:22'!
expressionsDo: aBlockContext 
	expressions do: [:each| each expressionsDo: aBlockContext].! !

!MedBlock methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/17/2003 18:28'!
in
	expressions isEmpty ifTrue: [^ Lattice new].
	^ (expressions at: 1) in! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 1/14/2005 22:46'!
initializeNumber: anInteger
	blockNumber := anInteger.
	expressions := OrderedCollection new.
	isAligned := false.
	^ self! !

!MedBlock methodsFor: 'Unit Testing' stamp: 'wbk 10/21/2002 21:25'!
instructionAt: anInteger
	^ expressions at: anInteger! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:19'!
instructionsDo: aBlock 
	expressions do: aBlock! !

!MedBlock methodsFor: 'Unit Testing' stamp: 'WBK 8/27/2002 15:16'!
intermediateForm
	|expr|
	expr := OrderedCollection with: #block with: blockNumber.

     expr addAll: (expressions collect: [:each| each intermediateForm]).
	^ expr asArray ! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 1/14/2005 22:46'!
isAligned
	^ isAligned! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 2/4/2005 20:52'!
isMedBlock
	^ true! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 1/14/2005 22:45'!
makeAligned
	isAligned := true.! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 10/22/2002 10:52'!
numberOfExpressions
	^ expressions size! !

!MedBlock methodsFor: 'Unit Testing' stamp: 'wbk 1/23/2005 11:33'!
printOn: aStream
	aStream nextPutAll: '('.
	self blockName printOn: aStream.
	aStream cr.
	self instructionsDo: 
			[:each | 
			aStream nextPutAll: each printString.
			aStream cr].! !

!MedBlock methodsFor: 'Misc' stamp: 'WBK 8/29/2002 17:30'!
registersDo: aBlock
	expressions do: [:each| each registersDo: aBlock]! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 10/5/2002 23:01'!
visitWith: aVisitor
	^ aVisitor visitBlock: self.! !

MedLanguage subclass: #MedCall
	instanceVariableNames: 'function eax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedCall class methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2005 22:36'!
function: aSymbol machine: anObject 
	^ self new 
		initializeFunction: aSymbol	"Really an address"
		machine: anObject! !

!MedCall methodsFor: 'Register Allocation' stamp: 'wbk 6/24/2003 11:36'!
buildInterferenceWith: anAllocator 
	! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 8/7/2004 23:04'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	function expressionsDo: aBlockContext.! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/21/2003 17:18'!
function
	^ function
! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 2/9/2005 22:37'!
initializeFunction: aSymbol machine: aMachine
	function := aSymbol.
	eax := aMachine registerNamed: #eax.
	^ self! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/21/2003 17:24'!
intermediateForm
	^ {#call. function intermediateForm}! !

!MedCall methodsFor: 'Dataflow Analysis' stamp: 'wbk 2/9/2005 22:43'!
registersDefined
	^ Lattice with: eax! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/24/2003 11:35'!
registersDo: aBlockContext 
	function registersDo: aBlockContext! !

!MedCall methodsFor: 'Dataflow Analysis' stamp: 'wbk 7/5/2003 15:12'!
registersUsed
	^ function registersUsed! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/21/2003 23:15'!
visitWith: aVisitor 
	^aVisitor visitCall: self! !

MedLanguage subclass: #MedConvertBoolean
	instanceVariableNames: 'jumpType expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedConvertBoolean class methodsFor: 'instance creation' stamp: 'wbk 8/30/2004 16:49'!
jumpType: aSymbol expression: aMedLiteral 
	^ self new
		initialiseJumpType: aSymbol
		expression: aMedLiteral! !

!MedConvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/30/2004 17:19'!
expression
	^ expression! !

!MedConvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:56'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	expression expressionsDo: aBlockContext.! !

!MedConvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:50'!
initialiseJumpType: aSymbol expression: aMedLiteral 
	jumpType := aSymbol.
	expression := aMedLiteral.! !

!MedConvertBoolean methodsFor: 'Unit Testing' stamp: 'wbk 8/30/2004 18:28'!
intermediateForm
	^ {#convertBoolean. jumpType. expression intermediateForm}.! !

!MedConvertBoolean methodsFor: 'Testing' stamp: 'wbk 12/24/2004 15:18'!
isConvertBoolean
	^ true! !

!MedConvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/30/2004 17:20'!
jumpType
	^ jumpType! !

!MedConvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/30/2004 17:32'!
visitWith: aMedSimplifier 
	^ aMedSimplifier visitConvertBoolean: self.! !

MedLanguage subclass: #MedDeconvertBoolean
	instanceVariableNames: 'target boolean desiredBoolean pc stackHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedDeconvertBoolean class methodsFor: 'as yet unclassified' stamp: 'wbk 8/27/2004 21:45'!
jumpTo: aMedBlock if: aMedLiteral is: aSymbol 
self removeMe.
	^ self new
		initialiseJumpTo: aMedBlock
		if: aMedLiteral
		is: aSymbol! !

!MedDeconvertBoolean class methodsFor: 'as yet unclassified' stamp: 'wbk 8/28/2004 22:57'!
jumpTo: aMedBlock if: aMedLiteral is: aSymbol pc: pcInteger stackHeight: stackInteger
	^ self new
		initialiseJumpTo: aMedBlock
		if: aMedLiteral
		is: aSymbol
		pc: pcInteger
		stackHeight: stackInteger! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/8/2004 20:53'!
boolean
	^ boolean! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/8/2004 20:53'!
desiredBoolean
	^ desiredBoolean! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/29/2004 22:58'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	target expressionsDo: aBlockContext.
	boolean expressionsDo: aBlockContext.! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/27/2004 21:48'!
initialiseJumpTo: aMedBlock if: aMedLiteral is: aSymbol 
self removeMe.
	target := aMedBlock.
	boolean := aMedLiteral.
	desiredBoolean := aSymbol.! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/27/2004 21:47'!
initialiseJumpTo: aMedBlock if: aMedLiteral is: aSymbol pc: pcInteger stackHeight: stackInteger
	target := aMedBlock.
	boolean := aMedLiteral.
	desiredBoolean := aSymbol.
	pc := pcInteger.
	stackHeight := stackInteger.! !

!MedDeconvertBoolean methodsFor: 'Unit Testing' stamp: 'wbk 8/27/2004 21:50'!
intermediateForm
	^ {#deconvertBoolean. desiredBoolean. boolean intermediateForm. target blockName.
	pc. stackHeight}.! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/28/2004 17:46'!
pc
	^ pc! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/28/2004 17:46'!
stackHeight
	^ stackHeight! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/8/2004 20:53'!
target
	^ target! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/8/2004 20:50'!
visitWith: aMedSimplifier 
	^ aMedSimplifier visitDeconvertBoolean: self! !

MedLanguage subclass: #MedDivide
	instanceVariableNames: 'arg1 arg2 remander'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedDivide class methodsFor: 'as yet unclassified' stamp: 'wbk 8/8/2004 19:27'!
emit: firstMed divide: secondMed remander: remanderMed 
	^self new 
		initialiseArg1: firstMed
		arg2: secondMed
		remainder: remanderMed! !

!MedDivide class methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:02'!
register: aMedTemporaryRegister 
	^ self
		emit: nil
		divide: nil
		remander: aMedTemporaryRegister! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:25'!
arg1
	^ arg1! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:01'!
arg2
	^ arg2! !

!MedDivide methodsFor: 'Misc' stamp: 'wbk 8/8/2004 19:33'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	arg1 expressionsDo: aBlockContext.
	arg2 expressionsDo: aBlockContext.
	remander expressionsDo: aBlockContext.! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/24/2004 12:45'!
initialiseArg1: aMedLiteral arg2: aMedLiteral2 remainder: aMedTemporaryRegister 
	arg1 := aMedLiteral.
	arg2 := aMedLiteral2.
	remander := aMedTemporaryRegister! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 8/8/2004 19:32'!
intermediateForm
	^ {#div. arg1 intermediateForm. arg2 intermediateForm. remander intermediateForm}! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:27'!
remainder
	^ remander! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/26/2004 22:53'!
visitWith: aVisitor
	^ aVisitor visitDivide: self! !

MedLanguage subclass: #MedIntegerValueOf
	instanceVariableNames: 'argument failureBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedIntegerValueOf class methodsFor: 'instance creation' stamp: 'wbk 10/17/2004 21:02'!
argument: aMed failureBlock: aBlock
	^ self new
		initializeArgument: aMed
		failureBlock: aBlock! !

!MedIntegerValueOf methodsFor: 'Misc' stamp: 'wbk 10/17/2004 22:28'!
argument
	^ argument ! !

!MedIntegerValueOf methodsFor: 'Misc' stamp: 'wbk 10/17/2004 22:32'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	argument expressionsDo: aBlockContext.
	failureBlock expressionsDo: aBlockContext.! !

!MedIntegerValueOf methodsFor: 'Misc' stamp: 'wbk 10/17/2004 22:29'!
failureBlock
	^ failureBlock! !

!MedIntegerValueOf methodsFor: 'Misc' stamp: 'wbk 10/17/2004 21:04'!
initializeArgument: aMed failureBlock: aBlock
	argument := aMed.
	failureBlock := aBlock.! !

!MedIntegerValueOf methodsFor: 'Unit Testing' stamp: 'wbk 10/17/2004 21:10'!
intermediateForm
	^ {#integerValueOf. argument intermediateForm. failureBlock blockName}! !

!MedIntegerValueOf methodsFor: 'Misc' stamp: 'wbk 10/17/2004 21:42'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitIntegerValueOf: self! !

MedLanguage subclass: #MedJump
	instanceVariableNames: 'type target instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedJump class methodsFor: 'instance creation' stamp: 'wbk 10/2/2004 22:03'!
type: aSymbol target: aMedBlock
	^ self new
		initializeType:  aSymbol 
		block: aMedBlock 
		instruction: nil! !

!MedJump class methodsFor: 'instance creation' stamp: 'wbk 10/2/2004 22:02'!
type: aSymbol target: aMedBlock instruction: aMed 
	^self new 
		initializeType: aSymbol
		block: aMedBlock
		instruction: aMed! !

!MedJump methodsFor: 'Register Allocation' stamp: 'wbk 11/4/2002 16:35'!
buildInterferenceWith: anAllocator! !

!MedJump methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:44'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	instruction ifNil: [^ self].
	instruction expressionsDo: aBlockContext.
	! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/2/2002 17:31'!
initializeType:  aSymbol block: aMedBlock instruction: aMed
	type := aSymbol.
	target := aMedBlock.
	instruction := aMed.
	^ self! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/3/2002 17:16'!
instruction
	^ instruction! !

!MedJump methodsFor: 'Unit Testing' stamp: 'wbk 2/4/2005 20:56'!
intermediateForm
	|answer|
	answer := OrderedCollection 
		with: type 
		with: ( target class = MedBlock 
			ifTrue: [target blockName asSymbol]
			ifFalse: [target intermediateForm]).
	instruction isNil ifFalse: [answer addLast: instruction intermediateForm].
	^ answer asArray! !

!MedJump methodsFor: 'Testing' stamp: 'wbk 7/10/2004 18:30'!
isJump
	^ true! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/24/2002 11:13'!
name
	"Used in ColouringRegisterAllocator>>buildInstruction"
	^ type! !

!MedJump methodsFor: 'Register Allocation' stamp: 'wbk 2/4/2005 23:37'!
registersDefined
	^ Lattice new.! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/3/2002 21:15'!
registersDo: aBlock! !

!MedJump methodsFor: 'Register Allocation' stamp: 'wbk 2/4/2005 23:39'!
registersUsed
	^ Lattice with: target ! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/3/2002 17:18'!
target
	^ target! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/3/2002 17:17'!
type
	^ type! !

!MedJump methodsFor: 'misc' stamp: 'wbk 10/5/2002 22:41'!
visitWith: aVisitor
	^ aVisitor visitJump: self! !

MedLanguage subclass: #MedLabel
	instanceVariableNames: 'code failureCode failureBlock arguments argumentRegisters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedLabel class methodsFor: 'instance creation' stamp: 'wbk 12/12/2004 21:59'!
arguments: argumentsMed registers: someRegisters around: aMedArithmatic failingTo: aMedTemporaryRegister failureBlock: aMedBlock 
	^ self new
		initialiseArguments: argumentsMed
		registerst: someRegisters
		around: aMedArithmatic
		failingTo: aMedTemporaryRegister
		failureBlock: aMedBlock! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 12/11/2004 19:47'!
argumentRegisters
	^ argumentRegisters! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 12/11/2004 19:46'!
arguments
	^ arguments! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 9/18/2004 21:47'!
code
	^ code! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 9/18/2004 22:04'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	code expressionsDo: aBlockContext.
	failureBlock expressionsDo: aBlockContext.! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 9/18/2004 21:45'!
failureBlock
	^ failureBlock! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 9/18/2004 21:57'!
failureCode
	^ failureCode! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 12/11/2004 19:32'!
initialiseArguments: argumentsMed registerst: someRegisters around: aMedArithmatic failingTo: aMedTemporaryRegister failureBlock: aMedBlock 
	arguments := argumentsMed.
	argumentRegisters := someRegisters.
	code := aMedArithmatic.
	failureCode := aMedTemporaryRegister.
	failureBlock := aMedBlock.! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 12/11/2004 19:33'!
initialiseAround: aMedArithmatic failingTo: aMedTemporaryRegister failureBlock: aMedBlock
self removeMe. 
	code := aMedArithmatic.
	failureCode := aMedTemporaryRegister.
	failureBlock := aMedBlock.! !

!MedLabel methodsFor: 'Unit Testing' stamp: 'wbk 9/18/2004 13:11'!
intermediateForm
	^ {#label. code. failureCode. failureBlock}! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 12/24/2004 15:17'!
isLabel
	^ true! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 10/3/2004 12:39'!
isStackable
	^ true! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 9/18/2004 21:30'!
visitWith: aMedSimplifier 
	^ aMedSimplifier visitLabel: self.! !

!MedLanguage methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/21/2002 21:27'!
in 
	^ in! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 11/8/2002 14:19'!
isAdd
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 9/11/2002 23:19'!
isAddressingMode
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 3/4/2005 23:53'!
isArithmatic
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 12/24/2004 15:18'!
isConvertBoolean
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 7/10/2004 18:30'!
isJump
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 12/24/2004 15:17'!
isLabel
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'WBK 8/28/2002 14:49'!
isLiteral	
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 11/8/2002 14:39'!
isMachineInteger
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 9/11/2002 23:08'!
isMachineRegister
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 2/4/2005 20:52'!
isMedBlock
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 9/3/2002 16:51'!
isMem
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'WBK 8/27/2002 20:16'!
isMov
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'WBK 8/27/2002 20:42'!
isRegister
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 7/11/2004 21:51'!
isReturn
	^ false! !

!MedLanguage methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/21/2002 18:22'!
out
	^ out! !

!MedLanguage methodsFor: 'Unit Testing' stamp: 'wbk 10/18/2002 17:39'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedLanguage methodsFor: 'Misc' stamp: 'wbk 11/4/2002 14:26'!
registersIn: aCollection
	|answer|
	answer := OrderedCollection new.
	self registersDo: [:each| (aCollection includes: each) ifTrue: [answer add: each]].
	^ answer! !

!MedLanguage methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/21/2002 11:55'!
setIn: aLattice
	in := aLattice! !

!MedLanguage methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/21/2002 11:55'!
setOut: aLattice
	out := aLattice! !

MedLanguage subclass: #MedLiteral
	instanceVariableNames: 'literal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

MedLiteral subclass: #MedAddress
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedAddress class methodsFor: 'instance creation' stamp: 'wbk 1/19/2005 21:20'!
addressOf: aBlock
	^ self new initializeBlock: aBlock! !

!MedAddress methodsFor: 'Misc' stamp: 'wbk 1/19/2005 21:21'!
initializeBlock: aBlock
	block := aBlock! !

!MedAddress methodsFor: 'Unit Testing' stamp: 'wbk 1/19/2005 21:22'!
intermediateForm
	^ {#addressOf. block blockName}! !

!MedAddress methodsFor: 'Misc' stamp: 'wbk 1/20/2005 23:17'!
literal
	^ self error: 'Accidental superclass behaviour'.! !

!MedAddress methodsFor: 'Unit Testing' stamp: 'wbk 1/20/2005 21:49'!
printOn: aStream
	aStream nextPutAll: 'address ['.
	literal printOn: aStream.
	aStream nextPut: $].! !

!MedAddress methodsFor: 'Misc' stamp: 'wbk 1/21/2005 22:06'!
valueUsing: anEncoder
	anEncoder addRelocationFor: block.
	^ 0! !

!MedAddress methodsFor: 'Misc' stamp: 'wbk 1/20/2005 21:29'!
visitWith: anInstructionSelector 
	anInstructionSelector visitAddress: self! !

!MedLiteral class methodsFor: 'instance creation' stamp: 'wbk 9/3/2002 14:09'!
literal: anInteger
	^ self new initialize: anInteger! !

!MedLiteral class methodsFor: 'instance creation' stamp: 'wbk 9/18/2002 16:57'!
smallInteger: aNumber
	^ self literal: aNumber * 2 + 1! !

!MedLiteral methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:45'!
expressionsDo: aBlockContext ! !

!MedLiteral methodsFor: 'Initialization' stamp: 'WBK 8/27/2002 12:26'!
initialize: anInteger
	literal := anInteger! !

!MedLiteral methodsFor: 'Unit Testing' stamp: 'WBK 8/27/2002 15:03'!
intermediateForm
	^ literal! !

!MedLiteral methodsFor: 'Testing' stamp: 'WBK 8/28/2002 14:49'!
isLiteral
	^ true! !

!MedLiteral methodsFor: 'Testing' stamp: 'wbk 11/8/2002 14:34'!
isMachineInteger
	^ literal isInteger! !

!MedLiteral methodsFor: 'Misc' stamp: 'wbk 10/3/2004 12:39'!
isStackable
	^ true! !

!MedLiteral methodsFor: 'Misc' stamp: 'wbk 11/8/2002 14:37'!
literal
	^ literal! !

!MedLiteral methodsFor: 'Unit Testing' stamp: 'wbk 10/18/2002 17:56'!
printOn: aStream
	aStream nextPutAll: 'literal ['.
	literal printOn: aStream.
	aStream nextPut: $].! !

!MedLiteral methodsFor: 'Misc' stamp: 'wbk 8/2/2004 21:25'!
registersDo: aBlock! !

!MedLiteral methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/23/2002 12:29'!
registersUsed
	^ Lattice new! !

!MedLiteral methodsFor: 'Misc' stamp: 'wbk 1/21/2005 21:59'!
valueUsing: anEncoder
	^ literal isSymbol
		ifTrue: [
			anEncoder addressOfLiteral: self]
		ifFalse: [literal].! !

!MedLiteral methodsFor: 'Misc' stamp: 'wbk 10/5/2002 21:56'!
visitWith: aVisitor
	^ aVisitor visitLiteral: self! !

MedLiteral subclass: #MedPicEntry
	instanceVariableNames: 'picMethodLocation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedPicEntry methodsFor: 'Misc' stamp: 'wbk 2/27/2005 10:45'!
initialize
	literal := (Exupery loadCode: (ByteArray new: 12)) * 2! !

!MedPicEntry methodsFor: 'Misc' stamp: 'wbk 2/27/2005 14:42'!
picMethodLocation
	^ picMethodLocation! !

!MedPicEntry methodsFor: 'Misc' stamp: 'wbk 2/27/2005 14:45'!
picMethodLocation: aSmallInteger 
	picMethodLocation := aSmallInteger! !

!MedPicEntry methodsFor: 'Unit Testing' stamp: 'wbk 2/27/2005 10:26'!
printOn: aStream
	aStream nextPutAll: 'picEntry ['.
	literal printOn: aStream.
	aStream nextPut: $].! !

!MedPicEntry methodsFor: 'Misc' stamp: 'wbk 3/3/2005 23:23'!
relocateInMethodAt: aSmallInteger 
	self 
		setupPicEntryAt: literal / 2
		forPic: picMethodLocation
		inMethod: aSmallInteger
! !

!MedPicEntry methodsFor: 'Misc' stamp: 'wbk 3/3/2005 23:22'!
setupPicEntryAt: entryInteger forPic:picInteger inMethod: methodInteger
	<primitive: 'setupPicEntryAtforPicinMethod' module: 'ExuperyPlugin'>
	Error signal.
! !

MedLanguage subclass: #MedMachineRegister
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMachineRegister class methodsFor: 'instance creation' stamp: 'wbk 7/9/2004 20:06'!
name: aSymbol 
	^ self new 
		initializeName: aSymbol! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:46'!
expressionsDo: aBlockContext ! !

!MedMachineRegister methodsFor: 'Testing' stamp: 'wbk 4/11/2003 14:00'!
hasOffset
	^ false! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'wbk 7/9/2004 20:06'!
initializeName: aSymbol
	name := aSymbol.
	^ self! !

!MedMachineRegister methodsFor: 'Unit testing' stamp: 'WBK 8/27/2002 15:00'!
intermediateForm
	^ name! !

!MedMachineRegister methodsFor: 'Testing' stamp: 'WBK 8/28/2002 21:25'!
isMachineRegister
	^ true! !

!MedMachineRegister methodsFor: 'Testing' stamp: 'WBK 8/27/2002 20:42'!
isRegister
	^ true! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'WBK 8/28/2002 23:24'!
name
	^ name! !

!MedMachineRegister methodsFor: 'Unit testing' stamp: 'wbk 9/13/2002 22:55'!
printOn: aStream
	self printRegTypeOn: aStream.
	aStream nextPutAll: ' ['.
	aStream nextPutAll: name.
	aStream nextPutAll: ']'.! !

!MedMachineRegister methodsFor: 'Unit testing' stamp: 'wbk 9/13/2002 22:56'!
printRegTypeOn: aStream
	aStream nextPutAll: 'reg'.! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'wbk 11/4/2002 13:40'!
registersDo: aBlock
	aBlock value: self! !

!MedMachineRegister methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/23/2002 12:09'!
registersUsed
	^ Lattice with: self! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'wbk 10/5/2002 21:49'!
visitWith: anObject
	^ anObject visitMachineRegister: self! !

MedMachineRegister subclass: #MedTemporaryRegister
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedTemporaryRegister methodsFor: 'testing' stamp: 'WBK 8/28/2002 21:26'!
isMachineRegister
	^ false! !

!MedTemporaryRegister methodsFor: 'testing' stamp: 'wbk 9/13/2002 22:55'!
printRegTypeOn: aStream
	aStream nextPutAll: 'temp'.! !

!MedTemporaryRegister methodsFor: 'misc' stamp: 'wbk 10/5/2002 21:54'!
visitWith: anObject
	^ anObject visitTemporaryRegister: self! !

MedLanguage subclass: #MedMem
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMem class methodsFor: 'instance creation' stamp: 'wbk 12/8/2004 22:02'!
address: aMed
	^ self new initializeAddress: aMed! !

!MedMem methodsFor: 'Misc' stamp: 'wbk 9/11/2002 13:51'!
address
	^ address! !

!MedMem methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:57'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	address expressionsDo: aBlockContext.! !

!MedMem methodsFor: 'Misc' stamp: 'wbk 9/3/2002 14:18'!
initializeAddress: aMed
	address := aMed.
	^ self! !

!MedMem methodsFor: 'Unit Testing' stamp: 'wbk 9/3/2002 15:04'!
intermediateForm
	^ {#mem. address intermediateForm}! !

!MedMem methodsFor: 'Testing' stamp: 'wbk 9/3/2002 16:51'!
isMem
	^ true! !

!MedMem methodsFor: 'Misc' stamp: 'wbk 10/4/2004 21:51'!
isStackable
	^ true! !

!MedMem methodsFor: 'Misc' stamp: 'wbk 10/6/2002 11:24'!
visitWith: aVisitor
	^ aVisitor visitMem: self! !

MedLanguage subclass: #MedMov
	instanceVariableNames: 'to from'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMov class methodsFor: 'instance creation' stamp: 'wbk 12/25/2004 10:03'!
from: fromMed to: toMed 
	^ self new 
		initializeTo: toMed 
		from: fromMed! !

!MedMov methodsFor: 'Register Allocation' stamp: 'wbk 7/5/2003 15:28'!
buildInterferenceWith: anAllocator
	| defined |
	to isAddressingMode ifTrue: [^ self].
	defined := self registersDefined register.
	^ out do: 
		[:eachRegister | 
		eachRegister = from ifFalse: 
			[anAllocator 
				addInterferenceEdge: defined 
				to: eachRegister]]! !

!MedMov methodsFor: 'misc' stamp: 'wbk 8/7/2004 21:24'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	to expressionsDo: aBlockContext.
	from expressionsDo: aBlockContext.! !

!MedMov methodsFor: 'accessing' stamp: 'WBK 8/27/2002 20:17'!
from
	^ from! !

!MedMov methodsFor: 'misc' stamp: 'wbk 10/28/2004 21:38'!
initializeTo: toMed from: fromMed
	to := toMed.
	from := fromMed.
	^ self! !

!MedMov methodsFor: 'unit testing' stamp: 'WBK 8/30/2002 15:32'!
intermediateForm
	^ {#mov. from intermediateForm. to intermediateForm}! !

!MedMov methodsFor: 'testing' stamp: 'WBK 8/27/2002 20:16'!
isMov
	^ true! !

!MedMov methodsFor: 'Testing' stamp: 'wbk 8/1/2004 14:58'!
isRegisterRead: aMedTemporaryRegister 
	from = aMedTemporaryRegister ifTrue: [^true].
	from isAddressingMode ifTrue:
		[from registersDo: [:each| each = aMedTemporaryRegister ifTrue: [^ true]]].
	to isAddressingMode ifTrue:
		[to registersDo: [:each| each = aMedTemporaryRegister ifTrue: [^ true]]].
	^ false! !

!MedMov methodsFor: 'Testing' stamp: 'wbk 7/31/2004 11:40'!
isRegisterWritten: aMedTemporaryRegister 
	^ to = aMedTemporaryRegister! !

!MedMov methodsFor: 'misc' stamp: 'wbk 11/4/2002 14:29'!
name
	"Used for a type test"
	^ #mov! !

!MedMov methodsFor: 'Dataflow Analysis' stamp: 'wbk 11/4/2002 13:59'!
registersDefined
	to isAddressingMode ifTrue: [^ Lattice new].
	^ Lattice with: to! !

!MedMov methodsFor: 'misc' stamp: 'wbk 11/4/2002 13:38'!
registersDo: aBlock
	from registersDo: aBlock.
	to registersDo: aBlock! !

!MedMov methodsFor: 'Dataflow Analysis' stamp: 'wbk 11/4/2002 13:58'!
registersUsed
	to isAddressingMode ifTrue:
		[^ to registersUsed + from registersUsed].
	^ from registersUsed! !

!MedMov methodsFor: 'accessing' stamp: 'WBK 8/27/2002 20:17'!
to
	^ to! !

!MedMov methodsFor: 'misc' stamp: 'wbk 10/6/2002 11:32'!
visitWith: aVisitor
	^ aVisitor visitMov: self! !

MedLanguage subclass: #MedNegate
	instanceVariableNames: 'argument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedNegate class methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 19:11'!
argument: aMedLiteral 
	^ self new initialiseArgument: aMedLiteral! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 19:54'!
argument
	^ argument! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:19'!
buildInterferenceWith: aColouringRegisterAllocator 	
	out do:
		[:each| aColouringRegisterAllocator
			addInterferenceEdge: argument
			to: each]! !

!MedNegate methodsFor: 'Misc' stamp: 'wbk 8/8/2004 20:34'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	argument expressionsDo: aBlockContext! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 19:10'!
initialiseArgument: aMedLiteral 
	argument := aMedLiteral! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 19:12'!
intermediateForm
	^{#neg. argument intermediateForm}! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:11'!
registersDefined
	^ Lattice with: argument! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:17'!
registersDo: aBlockContext 
	aBlockContext value: argument! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:10'!
registersUsed
	^ Lattice with: argument! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:43'!
visitWith: anInstructionSelector 
	^ anInstructionSelector visitNegate: self! !

MedLanguage subclass: #MedPic
	instanceVariableNames: 'selectionRegister picEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedPic class methodsFor: 'instance creation' stamp: 'wbk 2/27/2005 13:36'!
selectionRegister: aMed picEntry: anObject 
	^ self new 
		selectionRegister: aMed
		picEntry: anObject! !

!MedPic methodsFor: 'Register Allocation' stamp: 'wbk 2/26/2005 18:14'!
buildInterferenceWith: aColouringRegisterAllocator 
! !

!MedPic methodsFor: 'Unit Testing' stamp: 'wbk 2/26/2005 21:57'!
intermediateForm
	^ ({ 
		#pic.
		selectionRegister intermediateForm})! !

!MedPic methodsFor: 'Misc' stamp: 'wbk 2/26/2005 21:57'!
location
	^ selectionRegister! !

!MedPic methodsFor: 'Misc' stamp: 'wbk 2/27/2005 13:58'!
picEntry
	^ picEntry! !

!MedPic methodsFor: 'Register Allocation' stamp: 'wbk 2/26/2005 21:56'!
registersDefined
	^ Lattice new! !

!MedPic methodsFor: 'Misc' stamp: 'wbk 2/26/2005 21:57'!
registersDo: aBlockContext 
	selectionRegister registersDo: aBlockContext! !

!MedPic methodsFor: 'Register Allocation' stamp: 'wbk 2/26/2005 21:57'!
registersUsed
	^ Lattice with: selectionRegister! !

!MedPic methodsFor: 'Misc' stamp: 'wbk 2/27/2005 14:02'!
selectionRegister: aMed picEntry: aPicEntry
	selectionRegister := aMed.
	picEntry := aPicEntry! !

!MedPic methodsFor: 'Misc' stamp: 'wbk 2/25/2005 23:00'!
visitWith: aLivenessAnalyser 
	aLivenessAnalyser visitPic: self! !

MedLanguage subclass: #MedPush
	instanceVariableNames: 'argument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

MedPush subclass: #MedPop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedPop methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/4/2005 16:06'!
buildInterferenceWith: anAllocator

	out do:
		[:each| anAllocator
			addInterferenceEdge: argument
			to: each]! !

!MedPop methodsFor: 'Unit Testing' stamp: 'wbk 3/4/2005 15:24'!
intermediateForm
	^ {#pop. argument intermediateForm}! !

!MedPop methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/4/2005 16:05'!
registersDefined
	^ argument registersUsed! !

!MedPop methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/4/2005 16:05'!
registersUsed
	^ Lattice new! !

!MedPop methodsFor: 'Misc' stamp: 'wbk 3/4/2005 15:26'!
visitWith: aVisitor
	aVisitor visitPop: self! !

!MedPush class methodsFor: 'as yet unclassified' stamp: 'wbk 6/21/2003 19:12'!
argument: aSmallInteger 
	^ self new initializeArgument: aSmallInteger! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/21/2003 16:13'!
argument
	^ argument! !

!MedPush methodsFor: 'Register Allocation' stamp: 'wbk 7/5/2003 15:26'!
buildInterferenceWith: anAllocator ! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 8/7/2004 22:39'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	argument expressionsDo: aBlockContext! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/20/2003 20:41'!
initializeArgument: aSmallInteger 
	argument := aSmallInteger.
	^ self! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/21/2003 17:30'!
intermediateForm
	^ {#push. argument intermediateForm}! !

!MedPush methodsFor: 'Dataflow Analysis' stamp: 'wbk 6/23/2003 11:55'!
registersDefined
	^ Lattice new! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/24/2003 10:30'!
registersDo: aBlockContext 
	argument registersDo: aBlockContext! !

!MedPush methodsFor: 'Dataflow Analysis' stamp: 'wbk 6/23/2003 11:54'!
registersUsed
	^ argument registersUsed! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/21/2003 15:47'!
visitWith: anInstructionSelector 
	^ anInstructionSelector visitPush: self! !

MedLanguage subclass: #MedRet
	instanceVariableNames: 'resultRegister'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedRet class methodsFor: 'instance creation' stamp: 'wbk 3/4/2005 16:30'!
resultRegister: aRegister
	^ self new initialisResultRegister: aRegister! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 11/4/2002 15:20'!
argumentsDo: aBlock! !

!MedRet methodsFor: 'Register Allocation' stamp: 'wbk 11/4/2002 16:35'!
buildInterferenceWith: anAllocator! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:47'!
expressionsDo: aBlockContext 
	aBlockContext value: self.! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 3/4/2005 16:31'!
initialisResultRegister: aRegister
	resultRegister := aRegister! !

!MedRet methodsFor: 'Unit testing' stamp: 'wbk 3/4/2005 15:08'!
intermediateForm
	^ #(#ret)! !

!MedRet methodsFor: 'Testing' stamp: 'wbk 7/11/2004 21:51'!
isReturn
	^ true! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 3/4/2005 13:49'!
name
	^ #returnSequence! !

!MedRet methodsFor: 'Register Allocation' stamp: 'wbk 3/4/2005 16:39'!
registersDefined
	^ Lattice new! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 11/4/2002 15:17'!
registersDo: aBlock! !

!MedRet methodsFor: 'Register Allocation' stamp: 'wbk 3/4/2005 16:39'!
registersUsed
	^ Lattice with: resultRegister! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 3/4/2005 17:40'!
resultRegister
	^ resultRegister! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 10/6/2002 11:26'!
visitWith: aVisitor
	^ aVisitor visitRet: self! !

MedLanguage subclass: #MedReturn
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedReturn class methodsFor: 'object creation' stamp: 'wbk 10/2/2004 10:06'!
value: aMed
	^ self new initializeValue: aMed! !

!MedReturn methodsFor: 'Misc' stamp: 'wbk 10/2/2004 10:43'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	value expressionsDo: aBlockContext.! !

!MedReturn methodsFor: 'Misc' stamp: 'wbk 10/2/2004 10:06'!
initializeValue: aMed
	value := aMed! !

!MedReturn methodsFor: 'Unit Testing' stamp: 'wbk 10/2/2004 10:09'!
intermediateForm
	^ {#return. value intermediateForm}! !

!MedReturn methodsFor: 'Misc' stamp: 'wbk 10/2/2004 10:37'!
value
	^ value! !

!MedReturn methodsFor: 'Visiting' stamp: 'wbk 10/2/2004 10:30'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitReturn: self.! !

MedLanguage subclass: #MedSend
	instanceVariableNames: 'selector arguments pc stackHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedSend class methodsFor: 'instance creation' stamp: 'wbk 9/16/2004 21:33'!
selector: aMedMem arguments: anArray programCounter: aSmallInteger stackHeight: aSmallInteger4 
	^ self new
		initialiseSelector: aMedMem 
		arguments: anArray 
		programCounter: aSmallInteger 
		stackHeight: aSmallInteger4 ! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 9/19/2004 12:14'!
arguments
	^ arguments! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 9/19/2004 13:00'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	selector expressionsDo: aBlockContext.
	arguments do: [:each| each expressionsDo: aBlockContext].! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 9/16/2004 21:34'!
initialiseSelector: aMedMem arguments: anArray programCounter: aSmallInteger stackHeight: aSmallInteger4 
	selector := aMedMem.
	arguments := anArray.
	pc := aSmallInteger.
	stackHeight := aSmallInteger4! !

!MedSend methodsFor: 'Unit Testing' stamp: 'wbk 9/18/2004 13:10'!
intermediateForm
	^ {#send. selector. arguments. pc. stackHeight}! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 9/19/2004 12:14'!
programCounter
	^ pc! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 9/19/2004 12:13'!
selector
	^ selector! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 9/19/2004 12:18'!
stackHeight
	^ stackHeight! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 9/19/2004 12:58'!
visitWith: aMedSimplifier 
	^ aMedSimplifier visitSend: self.! !

MedLanguage subclass: #MedStoreInReceiver
	instanceVariableNames: 'slot value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedStoreInReceiver class methodsFor: 'instance creation' stamp: 'wbk 11/1/2004 21:14'!
slot: aSmallInteger value: aMedLiteral 
	^ self new
		initializeSlot: aSmallInteger 
		value: aMedLiteral! !

!MedStoreInReceiver methodsFor: 'Misc' stamp: 'wbk 11/3/2004 22:27'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	value expressionsDo: aBlockContext.
	! !

!MedStoreInReceiver methodsFor: 'Misc' stamp: 'wbk 11/1/2004 21:16'!
initializeSlot: anInteger value: aMed 
	slot := anInteger.
	value := aMed! !

!MedStoreInReceiver methodsFor: 'Misc' stamp: 'wbk 11/1/2004 22:27'!
slot
	^ slot! !

!MedStoreInReceiver methodsFor: 'Misc' stamp: 'wbk 11/1/2004 22:15'!
value
	^ value! !

!MedStoreInReceiver methodsFor: 'Misc' stamp: 'wbk 11/1/2004 21:46'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitStoreInReceiver: self! !

MedLanguage subclass: #MedStoreInTemp
	instanceVariableNames: 'slot valueStored'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedStoreInTemp class methodsFor: 'instance creation' stamp: 'wbk 10/23/2004 18:37'!
slot: anInteger value: aMed
	^ self new
		initializeSlot: anInteger
		value: aMed! !

!MedStoreInTemp methodsFor: 'Misc' stamp: 'wbk 10/24/2004 10:41'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	valueStored expressionsDo: aBlockContext! !

!MedStoreInTemp methodsFor: 'Misc' stamp: 'wbk 10/24/2004 22:02'!
initializeSlot: anInteger value: aMed
	slot := anInteger.
	valueStored := aMed.! !

!MedStoreInTemp methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2004 18:58'!
intermediateForm
	^{#storeInTemp. slot. valueStored intermediateForm}! !

!MedStoreInTemp methodsFor: 'Misc' stamp: 'wbk 10/24/2004 19:10'!
isRegister
	^ false! !

!MedStoreInTemp methodsFor: 'Misc' stamp: 'wbk 10/24/2004 10:39'!
slot
	^ slot! !

!MedStoreInTemp methodsFor: 'Misc' stamp: 'wbk 10/24/2004 18:00'!
value
	^ valueStored! !

!MedStoreInTemp methodsFor: 'Misc' stamp: 'wbk 10/24/2004 17:35'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitStoreInTemp: self! !

MedLanguage subclass: #MedX86CDQ
	instanceVariableNames: 'eax edx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedX86CDQ class methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:18'!
eax: eaxRegister edx: edxRegister
	^ self new						"WBK, change super back to self after the old call has
										been removed"
		initialiseEax: eaxRegister
		edx: edxRegister! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/2/2004 20:41'!
buildInterferenceWith: aColouringRegisterAllocator 
	out do:
		[:each| aColouringRegisterAllocator
			addInterferenceEdge: edx
			to: each]
	! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:18'!
initialiseEax: aMedMachineRegister edx: aMedMachineRegister2 
	eax := aMedMachineRegister.
	edx := aMedMachineRegister2.! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 20:07'!
intermediateForm
	^ #(cdq)! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:23'!
registersDefined
	^ Lattice with: edx! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/2/2004 19:31'!
registersDo: aBlockContext 
	aBlockContext value: eax.
	aBlockContext value: edx.! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:19'!
registersUsed
	^ Lattice with: eax! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:03'!
visitWith: anAnalyser 
	anAnalyser visitX86Cdq: self
! !

MedLanguage subclass: #MedX86Divide
	instanceVariableNames: 'argument eax edx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedX86Divide class methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 21:35'!
register: argumentRegister eax: eaxRegister edx: edxRegister
	^ self new
		initializeArgument: argumentRegister
		eax: eaxRegister
		edx: edxRegister! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 15:49'!
argument
	^ argument! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 15:08'!
buildInterferenceWith: anAllocator 
	{eax. edx} do:
		[:eachDefine| out do:
			[:eachUse| anAllocator
				addInterferenceEdge: eachDefine
				to: eachUse]]
	! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 21:41'!
initializeArgument: aMedTemporaryRegister eax: eaxRegister edx: edxRegister
	argument := aMedTemporaryRegister.
	eax := eaxRegister.
	edx := edxRegister.
	^ self! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:31'!
intermediateForm
	^ {#div. argument name}! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 15:32'!
register
	^ argument! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 22:05'!
registersDefined
	^ Lattice
		with: eax
		with: edx! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 12:42'!
registersDo: aBlockContext 
	aBlockContext value: argument.
	aBlockContext value: eax.
	aBlockContext value: edx! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 20:59'!
registersUsed
	^ Lattice
		with: eax
		with: edx
		with: argument! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 15:11'!
visitWith: anAnalyser 
	^ anAnalyser visitDivide: self! !

Object subclass: #MedMethod
	instanceVariableNames: 'blocks nextBlockNumber prolog entryPoints numberOfTemporaries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMethod class methodsFor: 'Unit Testing' stamp: 'wbk 10/5/2002 18:38'!
createAssembly: anArray for: aMachine
	^ IntermediateCreator
		createAssembly: anArray
		for: aMachine! !

!MedMethod class methodsFor: 'Unit Testing' stamp: 'wbk 10/5/2002 13:37'!
createIntermediate: anArray for: aMachine
	^ IntermediateCreator
		createIntermediate: anArray
		for: aMachine! !

!MedMethod class methodsFor: 'instance creation' stamp: 'wbk 10/3/2002 20:10'!
from: aMedMethod
	^ super new initializeFrom: aMedMethod! !

!MedMethod class methodsFor: 'instance creation' stamp: 'wbk 10/14/2002 13:38'!
new
	^ super new initialize! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/5/2002 21:15'!
addBlock: aMedBlock
	blocks add: aMedBlock! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 7/11/2004 18:43'!
blockAt: aNumber
	^ blocks at: aNumber! !

!MedMethod methodsFor: 'Unit Testing' stamp: 'wbk 10/21/2002 21:26'!
blockAt: blockInteger instructionAt: instructionInteger
	^ (blocks at: blockInteger) instructionAt: instructionInteger! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/3/2002 16:51'!
blockNumbered: anInteger
	^blocks
		detect:  [:each| each blockNumber = anInteger]
		ifNone: 
			[|newBlock|
			newBlock := MedBlock number: anInteger.
			self addBlock: newBlock.
			^ newBlock]! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 7/6/2003 20:49'!
blocksCollect: aBlock
	^ blocks collect: aBlock! !

!MedMethod methodsFor: 'Misc' stamp: 'WBK 8/28/2002 16:13'!
blocksDo: aBlock
	blocks do: aBlock! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 9/19/2004 16:18'!
entryPoints
	^ entryPoints! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:21'!
expressionsDo: aBlockContext 
	blocks do: [:each| each expressionsDo: aBlockContext].! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 9/22/2004 20:12'!
initialize
	blocks := OrderedCollection new.
	nextBlockNumber := 2.
	entryPoints := OrderedCollection new.
	numberOfTemporaries := 0.
	^ self! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 7/6/2003 20:48'!
initializeFrom: aMedMethod
	self initialize.
	blocks := aMedMethod blocksCollect: [:each| MedBlock number: each blockNumber].
	nextBlockNumber := aMedMethod numberOfBlocks + 1.! !

!MedMethod methodsFor: 'Debugging' stamp: 'wbk 7/11/2004 18:23'!
inspect
	ExuperyMethodInspector inspect: self.! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:19'!
instructionsDo: aBlock 
	self blocksDo: [:each | each instructionsDo: aBlock]! !

!MedMethod methodsFor: 'Unit Testing' stamp: 'wbk 7/6/2003 19:01'!
intermediateForm
	|answer|
	answer := blocks collect: [:each| each intermediateForm].
	^ answer asArray! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/3/2002 20:17'!
newBlock
	| number newBlock |
	number := nextBlockNumber.
	nextBlockNumber := nextBlockNumber + 1.
	newBlock := MedBlock number: number.
	self addBlock: newBlock.
	^ newBlock! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/3/2002 20:26'!
newBlockFor: aMedBlock
	^ self blockNumbered: aMedBlock blockNumber! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 8/30/2004 15:52'!
nextBlockNumber: aSmallInteger 
	nextBlockNumber := aSmallInteger! !

!MedMethod methodsFor: 'Unit Testing' stamp: 'wbk 10/2/2002 17:59'!
numberOfBlocks
	^ blocks size.! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 9/22/2004 20:12'!
numberOfTemporaries
	^ numberOfTemporaries! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 9/22/2004 20:15'!
numberOfTemporaries: aSmallInteger 
	numberOfTemporaries := aSmallInteger! !

!MedMethod methodsFor: 'Unit Testing' stamp: 'wbk 1/23/2005 11:42'!
printOn: aStream
	aStream nextPutAll: '(MedMethod '.
	blocks do: 
		[:each| aStream cr.
		each printOn: aStream].
	aStream nextPutAll: ')'.
! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 7/6/2003 19:02'!
prolog
	| number |
	prolog ifNotNil: [^ prolog].
	number := nextBlockNumber.
	nextBlockNumber := nextBlockNumber + 1.
	prolog := MedBlock number: number.
	blocks addFirst: prolog.
	^ prolog
	! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 9/19/2004 16:14'!
registerEntryPointWithPC: aSmallInteger label: anIntermediateEmitter 
	entryPoints add: (MethodEntryPoint 
				address: aSmallInteger
				label: anIntermediateEmitter)! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/23/2002 22:10'!
registersDo: aBlock
	self instructionsDo: [:each| each registersDo: aBlock].! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 3/10/2003 10:48'!
visitWith: aVisitor
	^ aVisitor visitMethod: self! !

Object subclass: #MethodEntryPoint
	instanceVariableNames: 'address label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!MethodEntryPoint class methodsFor: 'as yet unclassified' stamp: 'wbk 7/6/2003 18:27'!
address: aSmallInteger label: aSymbol 
	^ self new 
		initializeAddress: aSmallInteger 
		label: aSymbol ! !

!MethodEntryPoint methodsFor: 'as yet unclassified' stamp: 'wbk 7/6/2003 18:47'!
address
	^ address! !

!MethodEntryPoint methodsFor: 'as yet unclassified' stamp: 'wbk 7/6/2003 18:28'!
initializeAddress: aSmallInteger label: aSymbol 
	address := aSmallInteger.
	label := aSymbol.! !

!MethodEntryPoint methodsFor: 'as yet unclassified' stamp: 'wbk 7/6/2003 18:47'!
label
	^ label! !

Object subclass: #MockIntermediateEmitter
	instanceVariableNames: 'callPosition callList expectedRegisteredPC expectedRegisteredBlock registeredPC registeredBlock hasCreatedProlog isAnyOrder expressionsExpected state currentBlock blockList storedExpressions currentExpression realEmitter machine stackSetValue result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!MockIntermediateEmitter class methodsFor: 'instance creation' stamp: 'wbk 10/14/2002 13:50'!
new
	^ super new initialize! !

!MockIntermediateEmitter class methodsFor: 'as yet unclassified' stamp: 'wbk 11/17/2003 21:58'!
newWith: aMockExuperyPlugin 
	^ self new initialiseMachine: aMockExuperyPlugin! !

!MockIntermediateEmitter methodsFor: 'Set Up' stamp: 'wbk 8/5/2003 20:35'!
addExpectedEmission: anArray 
	self createCall: anArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 12/13/2004 22:55'!
addExpression: aMed
	| correct |
	"Verifies that aMed has been added to the current block. If this fails then check if
	a top level expression is not being added"
	storedExpressions ifNil: [^ self].
	aMed ifNil: [^ self].
	(aMed isKindOf: MedLanguage) ifTrue: [^ self].
	"Registers may be returned by 											
	expressions but they are not part of the
	intermediate generated."
	(aMed isKindOf: MedMachineRegister) ifTrue: [^ self]. 
	correct := (storedExpressions at: currentExpression).
	self 
		assert: (self asMed: aMed) = correct
		message: 'Wrong expression added to the current block'.
	currentExpression := currentExpression + 1.! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 1/19/2005 19:40'!
addressOf: aMedBlock 
	^ self check: {#address. aMedBlock blockName}! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/13/2005 12:49'!
alignedLabel
	^ self check: #(#alignedLabel)! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/13/2005 12:49'!
alignedLabel: aMedBlock 
	^ self checkAndAdd: #(#alignedLabel)! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 7/15/2003 20:20'!
anyOrder
	isAnyOrder := true.! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/13/2005 12:52'!
arithmaticOperator: aSymbol arg1: aMedLiteral arg2: aMedLiteral3 
	^ self check: ({ 
				aSymbol.
				self asMed: aMedLiteral.
				self asMed: aMedLiteral3})! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 2/27/2005 13:29'!
asMed: aMed 
	(aMed isKindOf: MedPicEntry) ifTrue: [^ #picEntry].
	(aMed isKindOf: MedBlock) ifTrue: [^ aMed blockName].
	^ (aMed isKindOf: MedLanguage) 
		ifTrue: [aMed intermediateForm]
		ifFalse: [aMed]! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 11/17/2003 23:31'!
assert: aBoolean 
	self
		assert: aBoolean
		message: 'Assertion failed'! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 11/17/2003 23:30'!
assert: aBoolean message: aString
	aBoolean ifFalse: [self signalFailure: aString]! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:26'!
atCacheEntryEntry: aSymbol index: aSymbol2 
	^ self check: ({ 
				#emitAtCacheEntry.
				aSymbol.
				aSymbol2 intermediateForm})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:26'!
atElementAddressFor: aSmallInteger with: aSmallInteger2 failTo: aMedBlock cacheOffset: anObject 
	^ self check: ({ 
				#emitAtElementAddress.
				self asMed: aSmallInteger.
				self asMed: aSmallInteger2.
				aMedBlock blockName.
				anObject})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 12/13/2004 21:52'!
atPutReceiver: aSymbol index: aSymbol2 value: aSymbol3 failTo: aMedBlock 
	^ self check: {#atPut. self asMed: aSymbol. self asMed: aSymbol2. self asMed: aSymbol3.
					aMedBlock blockName}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 2/13/2005 12:44'!
basicMoveFrom: aMedTemporaryRegister to: aMedLiteral 
	^ self check: ({ 
				#mov.
				self asMed: aMedTemporaryRegister.
				self asMed: aMedLiteral})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:27'!
beRoot: anArray ifNeededBy: aSymbol 
	self checkAndAdd: ({ 
				#emitBeRootIfNeeded.
				self asMed: anArray.
				self asMed: aSymbol})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:27'!
beRootIfNessisary: anArray exitingTo: aMedBlock 
	self checkAndAdd: ({ 
				#beRootIfNessisary.
				anArray.
				aMedBlock blockName})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/17/2005 21:51'!
callFunctionNamed: aSymbol with: someMeds 
	| answer |
	answer _ ({ 
				#callFunction.
				aSymbol}) asOrderedCollection.
	answer addAll: (someMeds collect: [:each | self asMed: each]).
	^ self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/5/2003 21:24'!
check: answer 
	|correct remainingExpressions |
	currentBlock ifNotNil: [self assert: (blockList at: callPosition) = currentBlock].
	callList isEmpty ifTrue: [^ self]. "A crude way to avoid this check when there isn't a call	
									list."
  	correct := self nextCallValue.
	isAnyOrder
		ifTrue: 
			[remainingExpressions := expressionsExpected
				at: answer
				put: (expressionsExpected at: answer) - 1.
			self assert: remainingExpressions >= 0.]
		ifFalse: [self assert: correct = answer].
	^ answer! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 2/8/2005 23:22'!
checkAndAdd: anArray 
	self addExpression: anArray.
	self check: anArray.
	^ anArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:19'!
checkIsInteger: aSymbol failTo: aSymbol2 
	| blockName |
	blockName _ (aSymbol2 isKindOf: MedLanguage) 
				ifTrue: [aSymbol2 blockName]
				ifFalse: [aSymbol2].
	^ self checkAndAdd: ({ 
				#emitCheckIsInteger.
				aSymbol intermediateForm.
				blockName})! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 6/21/2003 20:36'!
checkIsMed: anObject
	^ self assert: (anObject isKindOf: MedLanguage)! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:20'!
checkIsNotInteger: aSymbol failTo: aSymbol2 
	^ self checkAndAdd: ({ 
				#emitCheckIsNotInteger.
				aSymbol.
				self asMed: aSymbol2})! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 10/13/2003 23:08'!
checkMed: firstMed 
	self assert: (firstMed isKindOf: Array) | firstMed isString | (firstMed isKindOf: MedLanguage).
	^self asMed: firstMed! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:27'!
classOf: aSymbol 
	^ self check: ({ 
				#emitClass.
				aSymbol})! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/13/2005 12:49'!
conditionalBytecodeArg1: aMedLiteral arg2: aMedLiteral2 withJump: aSymbol failureSelector: aSmallInteger 
	^ self check: ({ 
				#emitConditionalBytecode.
				self asMed: aMedLiteral.
				self asMed: aMedLiteral2.
				aSymbol.
				aSmallInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/13/2005 12:49'!
conditionalJumpTo: aMedBlock onBoolean: aMedLiteral ifBooleanIs: aSymbol pc: aSmallInteger stackHeight: aSmallInteger5 
	^ self checkAndAdd: ({ 
				#conditionalJumpTo.
				aMedBlock blockName.
				aSymbol.
				self asMed: aMedLiteral.
				aSmallInteger.
				aSmallInteger5})! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:20'!
convertComparisionToBoolean: aMed jumpType: anObject 
	^ self check: ({ 
				#emitConvertComparisionToBoolean.
				anObject.
				self asMed: aMed})! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:20'!
convertToSmallInteger: aMed failTo: aLabel 
	^ self check: ({ 
				#emitConvertToSmallInteger.
				aLabel blockName.
				aMed})! !

!MockIntermediateEmitter methodsFor: 'Set Up' stamp: 'wbk 8/5/2003 21:18'!
createCall: anArray
	2
		to: anArray size
		do: 
			[:each| 
				((anArray at: each) isString | (anArray at: each) isNumber) not
					ifTrue: [self createCall: (anArray at: each)]].
	callList add: anArray.
	blockList add: currentBlock.
	expressionsExpected
		at: anArray
		put: (expressionsExpected
			at: anArray
			ifAbsent: [0]) + 1.! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/6/2003 20:12'!
createProlog
	self assert: hasCreatedProlog not.
	hasCreatedProlog := true.! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 11/17/2003 21:56'!
createTemporaryRegister
	^ machine createTemporaryRegister! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/10/2003 11:48'!
currentBlock
	^ currentBlock! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 9/13/2004 22:08'!
currentBlock: aMedBlock 
	currentBlock := aMedBlock blockName! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 1/2/2005 16:25'!
currentContextAddress
	^ self check: #(currentContextAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/13/2005 12:21'!
deconvertBooleanJumpingTo: aMedBlock if: aMedLiteral is: aSymbol pc: aSmallInteger stackHeight: aSmallInteger5 
	^ self check: ({ 
				#deconvertBoolean.
				aSymbol.
				self asMed: aMedLiteral.
				aMedBlock blockName.
				aSmallInteger.
				aSmallInteger5})! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 8/10/2003 16:07'!
emit: aSymbol add: anArray 
	^ self check: {#add. self checkMed: aSymbol. self checkMed: anArray}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/21/2003 00:07'!
emit: aMedTemporaryRegister and: aLargePositiveInteger 
	^ self check: {#and. self checkMed: aMedTemporaryRegister. self checkMed: aLargePositiveInteger}! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 12/22/2004 21:26'!
emit: firstMed bitShift: secondMed failingTo: aBlock
	^ self check: {#bitShift. aBlock blockName. self asMed: firstMed. self asMed: secondMed}! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 12/22/2004 21:45'!
emit: anArray div: anArray2 failingTo: aMedBlock 
	^self check: { 
				#emitDiv.
				aMedBlock blockName.
				self asMed: anArray.
				self asMed: anArray2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 12/22/2004 21:46'!
emit: anArray divide: anArray2 failingTo: aMedBlock 
	^self check: { 
				#emitDivide.
				aMedBlock blockName.
				self asMed: anArray.
				self asMed: anArray2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/16/2003 19:17'!
emit: firstMed minus: secondMed 
	| arg2 arg1 |
	arg1 := self checkMed: firstMed.
	arg2 := self checkMed: secondMed.
	^self check: { 
				#sub.
				arg1.
				arg2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 12/22/2004 21:47'!
emit: anArray mod: anArray2 failingTo: aMedBlock 
	^self check: { 
				#emitMod.
				aMedBlock blockName.
				self asMed: anArray.
				self asMed: anArray2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 12/22/2004 21:44'!
emit: firstMed multiply: secondMed failingTo: aLabel 
	^self check: { 
				#emitMultiply.
				aLabel blockName.
				firstMed.
				secondMed}! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 11/21/2003 19:11'!
emit: aLargePositiveInteger or: aMedTemporaryRegister 
	^ self check: {#or. self checkMed: aLargePositiveInteger. self checkMed: aMedTemporaryRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/21/2003 19:08'!
emit: aSmallInteger sal: aMedTemporaryRegister 
	^ self check: {#sal. self checkMed: aSmallInteger. self checkMed: aMedTemporaryRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 3/7/2004 23:33'!
emit: aMedLiteral sar: aMedLiteral2 
	^self check: { 
				#sar.
				self checkMed: aMedLiteral.
				self checkMed: aMedLiteral2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 5/30/2004 21:52'!
emitJumpTarget: anInteger stackHeight: secondInteger
	stackSetValue := secondInteger.
	^ self check: {#emitJumpTarget. anInteger. secondInteger}.! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/13/2005 12:51'!
expanded: aMedLiteral div: aMedLiteral2 failingTo: aMedBlock 
	^ self check: ({ 
				#emitExpandedDiv.
				self asMed: aMedLiteral.
				self asMed: aMedLiteral2.
				aMedBlock blockName})! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/13/2005 12:52'!
expanded: aMedLiteral divide: aMedLiteral2 failingTo: aMedBlock 
	^ self check: ({ 
				#emitExpandedDivide.
				self asMed: aMedLiteral.
				self asMed: aMedLiteral2.
				aMedBlock blockName})! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/13/2005 12:52'!
expanded: aMedLiteral mod: aMedLiteral2 failingTo: aMedBlock 
	^ self check: ({ 
				#emitExpandedMod.
				self asMed: aMedLiteral.
				self asMed: aMedLiteral2.
				aMedBlock blockName})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:28'!
expandedAtElementAddressFor: aMedLiteral with: aMedLiteral2 failTo: aMedLiteral3 cacheOffset: aMedLiteral4 
	^ self check: ({ 
				#emitExpandedAtElementAddress.
				self asMed: aMedLiteral.
				self asMed: aMedLiteral2.
				aMedLiteral3 blockName.
				aMedLiteral4})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:22'!
expandedIntegerValueOf: aMedLiteral failTo: aMedBlock 
	^ self check: ({ 
				#emitExpandedIntegerValueOf.
				aMedBlock blockName.
				self asMed: aMedLiteral})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:02'!
expandedReturnValue: aMedMov 
	^ self check: ({ 
				#expandedReturn.
				self asMed: aMedMov})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:03'!
expandedSendSelector: selectorMed arguments: aCollection pc: pcInteger stackHeight: stackInteger 
	| answer |
	answer _ ({ 
				#emitExpandedSend.
				self asMed: selectorMed}) asOrderedCollection.
	answer addAll: (aCollection collect: 
					[:each | 
					(each isKindOf: MedLanguage) 
						ifTrue: [each intermediateForm]
						ifFalse: [each]]).
	self checkAndAdd: answer asArray.
	^ nil	"This doesn't get added to the tree"! !

!MockIntermediateEmitter methodsFor: 'Set Up' stamp: 'wbk 12/21/2004 13:36'!
expectEmission: anArray 
	| blockName |
	storedExpressions := OrderedCollection new.
	anArray do: 
			[:each | 
			blockName := each at: 1.
			currentBlock := blockName.
			2 
				to: each size
				do: 
					[:eachLocation | 
					self addExpectedEmission: (each at: eachLocation).
					"Don't expect sends because they are already fully added. They may
				occur in expression trees (they return a register)."
					
					storedExpressions addLast: (each at: eachLocation)]].
	currentBlock := #block1! !

!MockIntermediateEmitter methodsFor: 'Set Up' stamp: 'wbk 7/6/2003 15:59'!
expectRegisterEntryPointPC: aSmallInteger blockNumbered: aSmallInteger2 
	expectedRegisteredPC := aSmallInteger.
	expectedRegisteredBlock := aSmallInteger2.! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:53'!
falseAddress
	^ self check: #(#falseAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:28'!
fetchAddress: aSmallInteger ofObject: anArray 
	| index |
	index _ (aSmallInteger isKindOf: MedLanguage) 
				ifTrue: [aSmallInteger literal]
				ifFalse: [aSmallInteger].
	^ self check: ({ 
				#emitFetchAddress.
				index.
				self asMed: anArray})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:29'!
fetchVariableAddress: anArray ofObject: aSymbol 
	^ self check: ({ 
				#emitFetchVariableAddress.
				anArray.
				aSymbol})! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/6/2003 20:10'!
hasCreatedProlog
	^ hasCreatedProlog! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:29'!
incrementStackPtrFor: aMockIntermediateEmitter 
	self removeMe! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 11/17/2003 21:59'!
initialiseMachine: aMockExuperyPlugin 
	machine := aMockExuperyPlugin.
	^ self! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:13'!
initialize
	callPosition := 1.
	callList := OrderedCollection new.
	hasCreatedProlog := false.
	isAnyOrder := false.
	result := MedMethod new.
	result blockNumbered: 1.	"Simulate creation of the first block"
	expressionsExpected := Dictionary new.
	blockList := OrderedCollection new.
	currentExpression := 1.
	^self! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 11/3/2004 22:04'!
instanceVariableAddress: aSmallInteger 
	^ self check: {#instanceVariableAddress. aSmallInteger}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:22'!
integerValueOf: aFirstObject failTo: overflowBlock 
	^ self check: ({ 
				#emitIntegerValueOf.
				overflowBlock blockName.
				self asMed: aFirstObject})! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:48'!
jumpIfFalseTo: aLabel onBoolean: anExpression 
	^ self check: ({ 
				#emitJumpIfFalse.
				aLabel.
				anExpression})! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/13/2005 12:48'!
jumpIfTrueTo: anArray onBoolean: aSymbol 
	^ self check: ({ 
				#emitJumpIfTrue.
				anArray.
				aSymbol})! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 2/13/2005 12:48'!
jumpTarget: anInteger 
	^ self check: ({ 
				#emitJumpTarget.
				anInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:46'!
jumpTo: aLabel 
	| label |
	label _ aLabel class ~= MedBlock 
				ifTrue: [self asMed: aLabel]
				ifFalse: [aLabel blockName].
	^ self checkAndAdd: ({ 
				#jmp.
				label})! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 8/30/2004 18:02'!
jumpType: aSymbol to: aSymbol2 dependingOn: anArray 
	| blockName |
	blockName := aSymbol2 isString
		ifTrue: [aSymbol2]
		ifFalse: [aSymbol2 blockName].
	^ self check: {aSymbol. blockName. self asMed: anArray}! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/13/2005 12:47'!
label
	^ self check: #(#label)! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/13/2005 12:52'!
labelArguments: someArguments registers: someRegisters around: anArray failingTo: anArray3 failureBlock: anObject 
	| answer |
	answer _ OrderedCollection new.
	answer add: #label1.
	answer add: anObject blockName.
	answer addAll: (someArguments collect: [:each | self asMed: each]).
	answer addAll: (someRegisters collect: [:each | self asMed: each]).
	answer add: anArray.
	answer add: anArray3.
	^ self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/13/2005 12:53'!
labelAround: anArray failingTo: anArray3 failureBlock: anObject 
	self removeMe.
	^ self check: ({ 
				#label1.
				anObject blockName.
				anArray.
				anArray3})! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:47'!
labelForByteCode: anInteger 
	^ self check: ({ 
				#emitLabelForByteCode.
				anInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:54'!
literalAddress: aSmallInteger 
	^ self check: ({ 
				#emitLiteralAddress.
				aSmallInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 12/11/2004 19:55'!
machine
	machine isNil ifFalse: [^ machine].
	^ MockExuperyPlugin new! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 10/2/2004 23:21'!
materialiseStack
	^ self check: #(materialiseStack)! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 2/13/2005 12:03'!
mem: aMedLiteral 
	^ self check: ({ 
				#mem.
				self checkMed: aMedLiteral})! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:13'!
method
	^result! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 2/13/2005 12:44'!
moveFrom: fromMed to: toMed 
	^ self checkAndAdd: ({ 
				#mov.
				self checkMed: fromMed.
				self checkMed: toMed})! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 2/13/2005 12:45'!
moveToEax: aMed 
	self assert: (aMed isKindOf: MedLanguage).
	self checkAndAdd: ({ 
				#emitMoveToEax.
				aMed literal})! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 2/13/2005 12:43'!
moveToTemp: anArray 
	^ self check: ({ 
				#emitMoveToTemp.
				self checkMed: anArray})! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 8/30/2004 16:13'!
newBlock
	^result newBlock! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 7/15/2003 21:48'!
nextCallValue
	| answer |
	self assert: callPosition <= callList size.
	answer := callList at: callPosition.
	callPosition := callPosition + 1.
	^ answer! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:54'!
nilAddress
	^ self check: #(#nilAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/6/2003 20:07'!
numberOfTemporaries: aSmallInteger 
	! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/27/2005 13:37'!
picLocatedAt: aMedTemporaryRegister picEntry: anObject 
	self checkAndAdd: ({ 
				#pic.
				self asMed: aMedTemporaryRegister})! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 3/4/2005 14:21'!
pop: aMedMachineRegister 
	^ self checkAndAdd: {#pop. self asMed: aMedMachineRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:29'!
popIntoReceiver: aSymbol slot: aSmallInteger 
	^ self check: ({ 
				#storeInReceiver.
				aSmallInteger.
				self asMed: aSymbol})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:29'!
popIntoTemp: aMedLiteral slot: aSmallInteger 
	^ self check: ({ 
				#storeInTemp.
				aSmallInteger.
				self asMed: aMedLiteral})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:04'!
preamble
	self checkAndAdd: #(#preamble)! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/18/2005 21:14'!
push: aMedMachineRegister 
	^ self checkAndAdd: {#push. self asMed: aMedMachineRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:58'!
receiver
	^ self check: #(#receiver)! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:58'!
receiverAddress
	^ self check: #(#receiverAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 1/30/2005 14:44'!
recycleContextIfPossible: aMedTemporaryRegister 
	self checkAndAdd: {#recycleContextIfPossible. self asMed: aMedTemporaryRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:10'!
registerEntryPointWithPC: aLiteral label: aMedBlock 
	expectedRegisteredPC ifNil: [^self].
	registeredPC := aLiteral.
	registeredBlock := aMedBlock isMedBlock
		ifTrue: [aMedBlock blockName]
		ifFalse: [aMedBlock].
	self assert: registeredPC literal = expectedRegisteredPC.
	self assert: registeredBlock = expectedRegisteredBlock.
	self assert: (aLiteral isKindOf: MedLanguage)! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:04'!
reloadStack: anArray 
	| answer |
	answer _ #(#emitReloadStack) asOrderedCollection.
	answer addAll: (anArray collect: [:each | self checkMed: each]).
	self checkAndAdd: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:04'!
restoreContextWithPC: aSmallInteger stack: anObject 
	| answer |
	answer _ ({ 
				#emitRestoreContext.
				aSmallInteger}) asOrderedCollection.
	answer addAll: (anObject collect: 
					[:each | 
					each isSymbol | each isNumber 
						ifTrue: [each]
						ifFalse: [each name]]).
	self checkAndAdd: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 3/4/2005 20:26'!
restoreSendersFrame
	^ self checkAndAdd: #(restoreSendersFrame)! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:13'!
result
	^result! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:17'!
result: aMedMethod 
	result := aMedMethod! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 3/4/2005 14:10'!
ret
	self checkAndAdd: #(ret)! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 3/4/2005 13:49'!
returnSequence
	self checkAndAdd: ({ 
				#returnSequence})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/12/2005 23:08'!
returnToCompiledMethod: anArray 
	self checkAndAdd: {#returnToCompiledMethod. self asMed: anArray}! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 10:21'!
returnToInterpreter
	^ self checkAndAdd: #(returnToInterpreter)! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:15'!
returnValue: anArray 
	| answer |
	answer _ ({ 
				#emitReturnValue.
				anArray}).
	self addExpression: answer.
	^ self check: answer! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:30'!
rootTableAddress
	^ self check: #(#rootTableAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:30'!
rootTableCountAddress
	^ self check: #(#rootTableCountAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:16'!
sendSelector: anEmitter arguments: aCollection 
	| answer |
	answer _ ({ 
				#emitSend.
				anEmitter}) asOrderedCollection.
	answer addAll: (aCollection collect: 
					[:each | 
					(each isKindOf: MedLanguage) 
						ifTrue: [each intermediateForm]
						ifFalse: [each]]).
	^ self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:16'!
sendSelector: anEmitter arguments: aCollection pc: pcInteger stackHeight: stackInteger 
	| answer |
	answer _ ({ 
				#emitSend.
				anEmitter intermediateForm.
				pcInteger.
				stackInteger}) asOrderedCollection.
	answer addAll: (aCollection collect: 
					[:each | 
					(each isKindOf: MedLanguage) 
						ifTrue: [each intermediateForm]
						ifFalse: [each]]).
	^ self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:58'!
sendersContext
	self removeMe! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:25'!
setProgramCounter: aMedLiteral 
	self check: ({ 
				#emitSetProgramCounter.
				aMedLiteral literal})! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/17/2003 17:00'!
signalFailure: anObject 
	TestResult failure sunitSignalWith: anObject! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:18'!
specialObject: aSmallInteger 
	^ self check: ({ 
				#emitSpecialObject.
				aSmallInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:18'!
specialSelector: aSmallInteger 
	^ self check: ({ 
				#emitSpecialSelector.
				aSmallInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:30'!
stackFor: aMockIntermediateEmitter at: aMockIntermediateEmitter2 put: aMedTemporaryRegister 
	self removeMe! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 6/27/2004 22:47'!
stackRegister: aSmallInteger 
	^ machine registerNamed: ('s', aSmallInteger printString) asSymbol! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 5/30/2004 21:36'!
stackSetValue
	^ stackSetValue! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/28/2003 13:32'!
state: anExuperyStack 
	! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:59'!
temporaryAddress: anInteger 
	^ self check: ({ 
				#emitTemporaryAddress.
				anInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:59'!
trueAddress
	^ self check: #(#trueAddress)! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/17/2003 17:00'!
verify
	callPosition = (callList size + 1) ifFalse: [self signalFailure: 'Wrong Number of Calls'].
	expectedRegisteredPC ifNotNil: [self assert: registeredPC isNil not].
	storedExpressions ifNotNil: [self assert: currentExpression = (storedExpressions size + 1)].! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:53'!
withFailTo: aBlockContext failureSpecialSelector: aSmallInteger arguments: anArray 
	| answer registers |
	answer _ OrderedCollection new.
	answer add: #emitWithFailTo.
	answer addAll: (anArray collect: [:each | self asMed: each]).
	registers _ anArray size = 2 
				ifTrue: [#(#t1 #t2)]
				ifFalse: [#(#t1 #t2 #t3)].
	answer addAll: registers.
	answer add: (aBlockContext 
				value: registers
				value: result newBlock).
	answer add: aSmallInteger.
	^ self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:30'!
youngStartAddress
	^ self check: #(#youngStartAddress)! !

Object subclass: #MockIntermediateGenerator
	instanceVariableNames: 'byteCodes primitive stackString doEmitAddresses callList callPosition expectedTemporaries isTemporariesSet isCheckingSendRentry sendPosition rentryStack reentryPC stackSizeOnSend state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!MockIntermediateGenerator class methodsFor: 'instance creation' stamp: 'WBK 8/26/2002 18:19'!
new
	^ super new initialize! !

!MockIntermediateGenerator methodsFor: 'Misc Mocked Methods' stamp: 'wbk 10/23/2004 22:23'!
addExpression: aMockIntermediateGenerator 
! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 7/11/2003 22:36'!
addUnknownByteCode
	self error: 'Unknown bytecode'.! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 7/4/2003 12:17'!
assert: aBoolean
	aBoolean ifFalse: [TestResult failure sunitSignalWith: 'Assertion Failed']! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/15/2002 14:38'!
byteCodeAddress: anInteger
	doEmitAddresses ifTrue: [byteCodes add: {#byteCode. anInteger}]! !

!MockIntermediateGenerator methodsFor: 'accessing' stamp: 'WBK 8/26/2002 20:12'!
byteCodeString
	|answer|
	answer := ''.
	byteCodes do: [:each| each isString 
		ifTrue: [answer := answer , ' ', each]
		ifFalse: [answer := answer, ' ', (each at: 1), ' ', (each at: 2) asString]].
	^ answer 
		copyFrom: 2 
		to: answer size! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/4/2003 19:42'!
check: anArray 
	| rightAnswer |
	callList isNil ifTrue: [^anArray].
	rightAnswer := self nextCall.
	rightAnswer = anArray ifFalse: [self failure].
	^anArray! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 7/15/2003 13:09'!
checkStackSizeOnSend: aSmallInteger 
	stackSizeOnSend := aSmallInteger! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/20/2002 16:19'!
createExpectedCall: anArray
	2
		to: anArray size
		do:
			[:each| ((anArray at: each) isString | (anArray at: each) isNumber) not ifTrue: 
				[self createExpectedCall: (anArray at: each)]].
	callList addLast: anArray! !

!MockIntermediateGenerator methodsFor: 'Mocked Stack Registers' stamp: 'wbk 6/27/2004 22:56'!
emitter
	^ MockIntermediateEmitter newWith: MachineX86 new.! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/20/2002 16:34'!
failure
	TestResult failure sunitSignalWith: 'Assertion Failed'! !

!MockIntermediateGenerator methodsFor: 'Misc Mocked Methods' stamp: 'wbk 7/6/2003 20:17'!
finish
! !

!MockIntermediateGenerator methodsFor: 'Arithmatic' stamp: 'wbk 10/24/2004 22:48'!
generate: firstObject add: secondObject 
	byteCodes add: 'sendPlus'.
	^self check: { 
				#sendAdd.
				firstObject.
				secondObject}! !

!MockIntermediateGenerator methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
generate: anArray bitAnd: anArray2 
	^self check: { 
				#bitAnd.
				anArray.
				anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/5/2004 20:44'!
generate: anArray bitOr: anArray2 
	^ self check: {#bitOr. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/8/2004 19:09'!
generate: anArray bitShift: anArray2 
	^ self check: {#bitShift. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/5/2004 22:06'!
generate: anArray div: anArray2 
	^ self check: {#div. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:18'!
generate: anArray divide: anArray2 
	^self check: { 
				#divide.
				anArray.
				anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/27/2004 21:25'!
generate: anArray equivilent: anArray2 
	^ self check: {#equivilent. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Common Sends' stamp: 'wbk 2/13/2004 20:30'!
generate: anArray makePoint: anArray2 
	^ self check: {#makePoint. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/7/2004 20:36'!
generate: anArray mod: anArray2 
	^ self check: {#mod.  anArray.  anArray2}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 2/8/2004 16:19'!
generate: firstObject multiply: secondObject 
	byteCodes add: 'sendMultiply'.
	^self check: { 
				#sendMultiply.
				firstObject.
				secondObject}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 2/8/2004 16:20'!
generate: firstObject subtract: secondObject 
	byteCodes add: 'sendMultiply'.
	^self check: { 
				#sendMinus.
				firstObject.
				secondObject}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 2/22/2004 16:36'!
generateBinarySelector: anObject receiver: receiverMed argument: argumentMed 
	stackSizeOnSend ifNotNil: [self assert: state stackSize = stackSizeOnSend].
	^self check: { 
				#binarySendWithSpecialSelector.
				anObject.
				receiverMed.
				argumentMed}! !

!MockIntermediateGenerator methodsFor: 'Mocked Common Sends' stamp: 'wbk 3/1/2004 19:48'!
generateClass: anArray 
	^ self check: {#class. anArray}! !

!MockIntermediateGenerator methodsFor: 'Mocked Common Sends' stamp: 'wbk 2/14/2004 15:21'!
generateNew: anArray 
	^ self check: {#sendNew. anArray}! !

!MockIntermediateGenerator methodsFor: 'Mocked Common Sends' stamp: 'wbk 2/22/2004 13:28'!
generateUnarySelector: aSmallInteger receiver: anArray 
	^ self check: {#sendUnarySelector. aSmallInteger. anArray}! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 7/6/2003 17:13'!
initialize
	byteCodes := OrderedCollection new.
	stackString := ''.
	doEmitAddresses := false.
	primitive := 0.
	isTemporariesSet := false.
	isCheckingSendRentry := false.! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 2/28/2004 15:35'!
jumpIfFalse: aMed to: anInteger 
	byteCodes add: { 
				#jumpFalse.
				anInteger}.
	^self check: { 
				#jumpFalse.
				aMed.
				anInteger}! !

!MockIntermediateGenerator methodsFor: 'Mocked Jumps' stamp: 'wbk 2/14/2004 11:54'!
jumpIfTrue: anArray to: aSmallInteger 
	^ self check: {#jumpIfTrue. anArray. aSmallInteger}! !

!MockIntermediateGenerator methodsFor: 'Mocked Jumps' stamp: 'wbk 2/13/2005 12:46'!
jumpTo: anInteger 
	byteCodes add: ({ 
				#jumpTo.
				anInteger}).
	^ self check: ({ 
				#jumpTo.
				anInteger})! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/20/2002 16:17'!
nextCall
	| answer |
	answer := callList at: callPosition.
	callPosition := callPosition + 1.
	^ answer! !

!MockIntermediateGenerator methodsFor: 'accessing' stamp: 'WBK 8/26/2002 18:23'!
numberOfBytecodes
	^ byteCodes size! !

!MockIntermediateGenerator methodsFor: 'Misc Mocked Methods' stamp: 'wbk 7/4/2003 12:20'!
numberOfTemporaries: anInteger
	expectedTemporaries ifNil: [^ self].
	self assert: anInteger = expectedTemporaries.
	isTemporariesSet := true.! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/24/2004 22:48'!
popIntoTemp: aValue slot: anInteger 
	byteCodes add: { 
				#popIntoTemp.
				anInteger}.
	^ self check: { 
				#popIntoTemp.
				anInteger.
				aValue}! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 19:42'!
popStack: aMed 
	^self check: { 
				#popStack.
				aMed}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/14/2004 21:36'!
prim: anArray equals: anArray2 
	^ self check: {#equals. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/12/2004 21:50'!
prim: anArray greaterThan: anArray2 
	^ self check: {#greaterThan. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/14/2004 21:19'!
prim: anArray greaterThanEqual: anArray2 
	^ self check: {#greaterThanEqual. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/6/2004 23:21'!
prim: anArray lessThan: anArray2 
	^ self check: {#lessThan. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/17/2004 22:13'!
prim: firstObject lessThanEquals: secondObject 
	byteCodes add: 'sendLessThanEquals'.
	^self check: { 
				#sendLessThanEquals.
				firstObject.
				secondObject}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/17/2004 19:04'!
prim: anArray notEquals: anArray2 
	^ self check: {#notEquals. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'accessing' stamp: 'WBK 8/26/2002 18:40'!
primitiveNumber
	^ primitive! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
pushConstant: aLiteral slot: aNumber 
	byteCodes add: { 
				'pushConstant'.
				aLiteral}.
	^self check: { 
				#pushConstant.
				aLiteral}! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 6/13/2004 16:00'!
pushFalse
	byteCodes add: 'pushFalse'.
	^self check: #(#pushFalse)! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 19:42'!
pushInstanceVariable: aSmallInteger 
	^self check: { 
				#pushInstanceVariable.
				aSmallInteger}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
pushLiteralVariable: aReadOnlyVariableBinding slot: aSmallInteger 
	byteCodes add: { 
				'pushLiteralVariable'.
				aSmallInteger}.
	^self check: { 
				#pushLiteralVariable.
				aSmallInteger}! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 2/28/2004 16:09'!
pushNil
	byteCodes add: #pushNil.
	^self check: #(#pushNil)! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
pushSelf
	byteCodes add: { 
				#pushSelf}.
	^self check: { 
				#pushSelf}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
pushTempAt: anInteger 
	byteCodes add: { 
				#pushTemp.
				anInteger}.
	^self check: { 
				#pushTemp.
				anInteger}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 6/13/2004 15:59'!
pushTrue
	byteCodes add: 'pushTrue'.
	^self check: { 
				#pushTrue}! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 10/15/2002 14:41'!
recordByteCodeNumbers
	doEmitAddresses := true.! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 11/27/2003 21:20'!
returnFalse
	self check: #(returnFalse)! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 10/18/2003 12:54'!
returnNil
	^ self check: #(returnNil)! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 10/4/2003 19:42'!
returnSelf
	byteCodes add: 'returnSelf'.
	self check: { 
				#returnSelf}! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 10/4/2003 19:42'!
returnTop: anObject 
	byteCodes add: 'returnTop'.
	^self check: { 
				#returnTop.
				anObject}! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 11/27/2003 19:49'!
returnTrue
	^ self check: #(returnTrue)! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 19:42'!
sendAtPutTo: anArray location: anArray2 value: anArray22 
	^self check: { 
				#sendAtPut.
				anArray.
				anArray2.
				anArray22}! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 19:42'!
sendAtTo: anArray with: anArray2 
	^self check: { 
				'sendAt'.
				anArray.
				anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
sendSelector: aSymbol inSlot: selectorInteger arguments: someArguments 
	| answer |
	stackSizeOnSend ifNotNil: [self assert: state stackSize = stackSizeOnSend].
	answer := { 
				#send.
				aSymbol} asOrderedCollection.
	"aStack size - argumentInteger to: aStack size
		do: [:each | answer addLast: (aStack at: each)]."
	someArguments do: [:each | answer addLast: each].
	byteCodes add: answer.
	isCheckingSendRentry ifTrue: [sendPosition := callPosition].
	^self check: answer asArray! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/20/2002 16:25'!
setExpectedBytecodes: anArray
	callPosition := 1.
	callList := OrderedCollection new.
	anArray do: [:each| self createExpectedCall: each].! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 7/4/2003 12:11'!
setExpectedTemporaries: aSmallInteger 
	expectedTemporaries := aSmallInteger! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'WBK 8/26/2002 18:39'!
setPrimitive: anInteger
	primitive := anInteger! !

!MockIntermediateGenerator methodsFor: 'accessing' stamp: 'WBK 8/26/2002 21:57'!
stackString
	^ stackString
! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 7/29/2003 12:10'!
state: anExuperyStack 
	state := anExuperyStack
	! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 6/13/2004 16:05'!
storeAndPopReceiverVariableIndex: aSymbol value: aSymbol2 
	byteCodes add: {#storeIntoReceiver. aSymbol}.
	self check: { 
				#storeAndPopReceiverVariable.
				aSymbol.
				aSymbol2}! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 10/18/2003 13:48'!
verify
	expectedTemporaries ifNotNil: [self assert: isTemporariesSet].
	isCheckingSendRentry ifTrue: [self assert: sendPosition isNil].
	callList ifNotNil: [self assert: callList size + 1 = callPosition]! !

Object subclass: #MockRelocator
	instanceVariableNames: 'relocations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!MockRelocator methodsFor: 'Mocked' stamp: 'wbk 1/21/2005 22:04'!
addRelocationAt: aSmallInteger 
self removeMe.
	relocations remove: aSmallInteger! !

!MockRelocator methodsFor: 'Mocked' stamp: 'wbk 1/21/2005 22:06'!
addRelocationAt: aSmallInteger for: aMedBlock 
	relocations remove: aSmallInteger -> aMedBlock blockName.! !

!MockRelocator methodsFor: 'Misc' stamp: 'wbk 1/2/2005 11:46'!
expectRelocationAt: anInteger
	relocations add: anInteger! !

!MockRelocator methodsFor: 'Misc' stamp: 'wbk 1/21/2005 20:56'!
expectRelocationAt: aSmallInteger to: aSymbol 
	relocations add: aSmallInteger -> aSymbol.! !

!MockRelocator methodsFor: 'Misc' stamp: 'wbk 1/21/2005 20:56'!
initialize
	relocations := Set new.! !

!MockRelocator methodsFor: 'Misc' stamp: 'wbk 1/2/2005 11:47'!
verify
	self assert: relocations isEmpty! !

Object subclass: #MoveNode
	instanceVariableNames: 'to from maxColours'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!MoveNode class methodsFor: 'creation' stamp: 'wbk 6/20/2004 10:49'!
move: aMedMov withGraph: anInterferenceGraph maxColours: aNumber
	^ self new 
		initialiseMove: aMedMov
		withGraph: anInterferenceGraph
		maxColours: aNumber! !

!MoveNode methodsFor: 'Move Coalescing' stamp: 'wbk 6/20/2004 10:22'!
doesInterfere
	^ (from interferesWith: to) ! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 8/2/2004 22:22'!
freezeWeight
	| weight |
	weight := 0.
	from currentSize < maxColours ifTrue:
		[weight := weight + (from currentSize / from currentMoves)].
	to currentSize < maxColours ifTrue:
		[weight := weight + (to currentSize / to currentMoves)].
	^ weight! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/21/2004 22:07'!
fromCurrentNode
	^ from currentVersion! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/19/2004 23:41'!
fromNode
	^ from ! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/21/2004 22:18'!
initialiseMove: aMedMov withGraph: anInteferenceGraph maxColours: aNumber
	maxColours := aNumber.
	self 
		markAsMoveRelated: aMedMov to
		withGraph: anInteferenceGraph.
	self markAsMoveRelated: aMedMov from
		withGraph: anInteferenceGraph.
	from := anInteferenceGraph at: aMedMov from.
	to := anInteferenceGraph at: aMedMov to.
	^ self! !

!MoveNode methodsFor: 'Move Coalescing' stamp: 'wbk 3/5/2005 22:58'!
isCoalescable
	| edges |
	"A quick fast check for the easy common cases"
	from currentEdges size > maxColours | (to currentEdges size > maxColours) ifTrue: [^ false].
	from currentEdges size + to currentEdges size < maxColours ifTrue: [^ true].
	"The actual check"
	edges := from currentEdges copy asSet.
	edges addAll: to currentEdges.
	^ edges size < maxColours.! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/19/2004 23:32'!
markAsMoveRelated: aRegister withGraph: anInterferenceGraph
	| node |
	node := (anInterferenceGraph at: aRegister).
	node markAsMoveRelated.
	node incrementCurrentMoves.! !

!MoveNode methodsFor: 'Unit Testing' stamp: 'wbk 3/5/2005 00:59'!
printOn: aStream
	aStream nextPutAll: 'MoveNode ['.
	aStream nextPutAll: from register name.
	aStream nextPut: $ .
	aStream nextPutAll: to register name.
	aStream nextPutAll: ']'.! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/21/2004 22:08'!
toCurrentNode
	^ to currentVersion! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/19/2004 23:42'!
toNode
	^ to! !

Object subclass: #NodeLattice
	instanceVariableNames: 'set'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!NodeLattice class methodsFor: 'instance creation' stamp: 'wbk 6/25/2004 23:16'!
value: aSet
	^ self new initialiseSet: aSet! !

!NodeLattice methodsFor: 'Operations' stamp: 'wbk 6/25/2004 23:36'!
+ aNodeLattice
	| newSet |
	newSet := set copy.
	newSet addAll: aNodeLattice set.
	^ self class value: newSet! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/27/2004 19:05'!
addNode: anInterferenceNode 
	set add: anInterferenceNode! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/23/2004 22:17'!
asSet
	^ set copy! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/26/2004 00:31'!
includesNode: anInterferenceNode 
	^ set includes: anInterferenceNode! !

!NodeLattice methodsFor: 'Misc' stamp: 'wbk 6/27/2004 23:13'!
initialiseSet: aSet
	set := aSet.! !

!NodeLattice methodsFor: 'Misc' stamp: 'wbk 6/27/2004 23:18'!
initialize
	set := Set new! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/26/2004 00:25'!
nodesDo: aBlockContext 
	^ set do: aBlockContext! !

!NodeLattice methodsFor: 'Misc' stamp: 'wbk 6/25/2004 23:37'!
set
	^ set! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/23/2004 22:16'!
size
	^ set size! !

!Object methodsFor: '*Exupery-Additions' stamp: 'wbk 9/25/2004 08:33'!
isStackable
	^ false! !

Object subclass: #OffsetPatcher
	instanceVariableNames: 'target location assembler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!OffsetPatcher class methodsFor: 'as yet unclassified' stamp: 'wbk 4/3/2003 20:30'!
target: aMedBlock location: aSmallInteger assembler: anAssemblerExupery 
	^ self new
		initializeTarget: aMedBlock 
		location: aSmallInteger 
		assembler: anAssemblerExupery! !

!OffsetPatcher methodsFor: 'as yet unclassified' stamp: 'wbk 4/3/2003 20:29'!
initializeTarget: aMedBlock location: anInteger assembler: anAssembler
	target := aMedBlock.
	location := anInteger.
	assembler := anAssembler.
	^ self! !

!OffsetPatcher methodsFor: 'as yet unclassified' stamp: 'wbk 2/26/2005 20:37'!
patch
	|targetAddress offset |
	targetAddress := assembler addressFor: target.
	offset := targetAddress - location.
	assembler
		patchByteAt: location - 3
		with: (offset bitAnd: 255).
	assembler
		patchByteAt: location - 2
		with: ((offset bitShift: -8) bitAnd: 255).
	assembler
		patchByteAt: location - 1
		with: ((offset bitShift: -16) bitAnd: 255).
	assembler
		patchByteAt: location
		with: ((offset bitShift: -24) bitAnd: 255).
! !

!OffsetPatcher methodsFor: 'as yet unclassified' stamp: 'wbk 2/26/2005 20:39'!
patchLiteral
	| offset |
	offset :=  target.
	assembler
		patchByteAt: location - 3
		with: (offset bitAnd: 255).
	assembler
		patchByteAt: location - 2
		with: ((offset bitShift: -8) bitAnd: 255).
	assembler
		patchByteAt: location - 1
		with: ((offset bitShift: -16) bitAnd: 255).
	assembler
		patchByteAt: location
		with: ((offset bitShift: -24) bitAnd: 255).
! !

Object subclass: #SystemInvestigation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Plugin'!

!SystemInvestigation methodsFor: 'Image Experiments' stamp: 'wbk 4/12/2003 22:07'!
countBytecodes
	|bytecodes methods classes|
	" This method doesn't handle methods with no bytecodes, they count as -1 bytes.
	It looks like I'm averaging 70 bytecodes/method, I don't know how reasonable this
	is but the ballpark seems tolerable."
	bytecodes := 0.
	methods := 0.
	classes := 0.
	Smalltalk allClassesDo: 
		[:eachClass| classes := classes + 1.
		eachClass methodsDo:
			[:eachMethod| methods := methods + 1.
			bytecodes := bytecodes + eachMethod endPC + eachMethod initialPC + 1]].
	^ {bytecodes. methods. classes}! !

Object subclass: #WBKToys
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!WBKToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/22/2004 19:46'!
forBytecodes

| weakRef |
weakRef := WeakValueAssociation new.
Smalltalk garbageCollect. "make it old"
weakRef value: Object new.
Smalltalk garbageCollectMost. "incr. GC"
weakRef value. "and it's still there"! !

!WBKToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/22/2004 19:13'!
gcTest: weakRef
weakRef value: Object new.! !

!WBKToys methodsFor: 'Refactoring Toys' stamp: 'wbk 7/28/2003 15:29'!
aTest
	| x4 |
	x4 := 10.
	x4 + x4.
	1 + 2 + 3 
		abc: 55
		def: 66
		ghi: 77.
	1 
		abc: 2
		def: 3.
	1 abc: 2! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 7/31/2003 20:23'!
arithmaticLoop
	| acc |
	acc := 0.
	1
		to: 2000000
		do: [:each| acc := acc + 1].
	^ 5! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 11/2/2004 21:20'!
javaLoop
 | x |
    x := 0.
    1
	to: 100000000
	do: [:each| x := x + 1].
x! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 4/7/2003 18:43'!
returnFalse
	^ false! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 4/7/2003 18:42'!
returnTrue
	^ true! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 4/20/2003 21:31'!
senders
	^ self sent! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 4/20/2003 21:32'!
sent
	|a|
	a := thisContext.
	self halt.
	^ 42! !

InterpreterPlugin subclass: #ExuperyPlugin
	instanceVariableNames: 'codeCache nextMethodAddress methods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Plugin'!

!ExuperyPlugin class methodsFor: 'Hacky Hacks' stamp: 'ar 12/18/2004 18:21'!
declareCVarsIn: codeGenerator
	"Only methodCache is really a bad hack"
	"Method cache should be removed, it's not used"
	"codeGenerator 
		var: 'methodCache'
		declareC: 'extern int * methodCache'."
	codeGenerator
		var: #codeCache
		declareC: 'unsigned char * codeCache'.
	codeGenerator
		var: #nextMethodAddress
		declareC: 'unsigned char * nextMethodAddress'.
"
	codeGenerator addHeaderFile: '<unistd.h>'.
	codeGenerator addHeaderFile: '<sys/mman.h>'.
"! !

!ExuperyPlugin class methodsFor: 'Hacky Hacks' stamp: 'ar 12/18/2004 18:21'!
hasHeaderFile
	^true! !

!ExuperyPlugin class methodsFor: 'Hacky Hacks' stamp: 'ar 12/18/2004 18:47'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^true! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/29/2005 21:59'!
activeContextAddress
	| address |
	self export: true.
	address := self exuperyActiveContextAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 4/18/2004 20:56'!
atCacheAddress
	| address |
	self export: true.
	address := self exuperyAtCacheAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Test Primitives' stamp: 'wbk 11/22/2003 17:25'!
checkIsRootObject
	| object objectPtr |
	self export: true.
	objectPtr := interpreterProxy stackValue: 0.
	object := interpreterProxy longAt: objectPtr. "The header"
	"Check object is in the cache"
	"First check the header is tagged"
	(object bitAnd: 16r40000000) = 0 ifTrue: 
		[interpreterProxy primitiveFail.
		^ 0].
	"Then check there is an entry in the remembered set"
	(self exuperyCheckRootTableFor: objectPtr) ifFalse: 
		[interpreterProxy primitiveFail.
		^ 0].

	interpreterProxy pop: 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 7/18/2004 14:15'!
codeCacheSize
	^ 100000! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 2/18/2005 21:31'!
exuperyCreateContext
	|address|
	self export: true.

	address := self exuperyCreateContextAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 4/18/2004 20:57'!
falseObjAddress
	| address |
	self export: true.
	address := self exuperyFalseObjAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/30/2005 19:21'!
freeContexts
	| address |
	self export: true.
	address := self exuperyFreeContexts.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 4/18/2004 20:58'!
initialiseExupery
	self export: true.
	self exuperyRegisterLookupMethod: (self cCode: 'lookupMethod').
	self exuperyRegisterRemapObjects: (self cCode: 'remapObjects').
	self exuperyRegisterMarkObjects: (self cCode: 'markObjects').
	self exuperyRegisterReturnMethod: (self cCode: '(int) lookupReturnMethod').
	nextMethodAddress := codeCache.
	methods := interpreterProxy stackValue: 0.
	interpreterProxy pop: 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'ar 12/18/2004 18:23'!
initialiseModule
	| cacheSize |
	self export: true.
	cacheSize := self codeCacheSize.
	codeCache := self ioMapCodeCache: cacheSize.
	"codeCache := self cCode: 'mmap(0, cacheSize,
                PROT_READ|PROT_WRITE|PROT_EXEC,
                MAP_PRIVATE|MAP_ANONYMOUS, -1, 0)'."
	nextMethodAddress := 0.
	^ true! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 7/18/2004 14:17'!
loadCode
	| array arraySize byteValue bytes i methodAddress|
	self export: true.

	self
		var: #bytes
		declareC: 'unsigned char * bytes'.

	array := interpreterProxy stackValue: 0.

	(interpreterProxy isBytes: array) & (nextMethodAddress ~= 0) ifFalse: 
		[^self primitiveFail].
	
	arraySize := interpreterProxy stSizeOf: array.
	
	nextMethodAddress + arraySize > (codeCache + self codeCacheSize) ifTrue:
		[^self primitiveFail].


	bytes := interpreterProxy firstIndexableField: array.
	
	i := 0.
	[i < arraySize] whileTrue:
		[byteValue := bytes at: i.
		nextMethodAddress
			at: i
			put: byteValue.
		i := i + 1.].

	methodAddress := nextMethodAddress.
	nextMethodAddress := nextMethodAddress + arraySize.
	
	"Make sure nextMethodAddress is word aligned"
	nextMethodAddress := (((self cCode: '(int) nextMethodAddress') - 1) bitOr: 3) + 1.

	self 
		pop: 2
		thenPush: (self cCode: '(int) methodAddress + 1').! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 4/17/2004 20:52'!
lookupMethod: aMethod
	"This method lookup tolerates integers as Dictionary keys to support
	execution of images in which Symbols have been compacted out"
 	| length index mask wrapAround nextSelector methodArray selectorStart answer hashBits |
	selectorStart := 2.
	length _ self fetchWordLengthOf: methods.
	mask _ length - selectorStart - 1.
	hashBits := ((self cCode: '*(int *)aMethod') >> 17) bitAnd: 16rFFF.
	index _ (mask bitAnd: hashBits) + selectorStart.
	"It is assumed that there are some nils in this dictionary, and search will
	stop when one is encountered.  However, if there are no nils, then wrapAround
	will be detected the second time the loop gets to the end of the table."
	wrapAround _ false.
	[true] whileTrue:
		[nextSelector _ self 
			fetchPointer: index
			ofObject: methods.
		nextSelector= interpreterProxy nilObject ifTrue: [^ nil].
		nextSelector=aMethod ifTrue: [
			methodArray _ self 
				fetchPointer: 1 "MethodArrayIndex"
				ofObject: methods.
			answer _ self 
				fetchPointer:  index - selectorStart
				ofObject: methodArray.
			^ answer - 1 "Subtract one to detag the integer"
		].
		index _ index + 1.
		index = length ifTrue: 
			[wrapAround ifTrue: [^ nil].
			wrapAround _ true.
			index _ selectorStart]]! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 1/2/2005 20:09'!
lookupReturnMethod: aContext
	| methodLocal compiledReturn |
	self
		var: #aContext
		declareC: 'int *aContext'.
	methodLocal := (aContext at: 4).
	(methodLocal bitAnd: 1) = 1 ifTrue: [^ nil]. "It's a BlockContext which isn't currently handled."
	compiledReturn := aContext at: 5.
	(compiledReturn bitAnd: 1) = 0 ifTrue: [^ nil]. "It's not a compiledMethod, just let the interpreter deal wiht it"
	^ compiledReturn - 1. "return the detagged return address, which must be aligned to a 2 byte boundary	
							because of tagging"	! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/22/2005 11:09'!
machineWordInAtPut
	| method location value |
	self export: true.
	method := self stackValue: 2.
	location := self stackValue: 1.
	value := self stackValue: 0.
	self pop: 3.
	self cCode: '*(int *)(method - 1 + location / 2) = method + (value / 2)'! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 4/17/2004 23:23'!
markObjects
	self markAndTrace: methods.! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 20:51'!
nilObjAddress
	|address|
	self export: true.

	address := self exuperyNilObjAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 12/27/2002 23:00'!
nullFunction! !

!ExuperyPlugin methodsFor: 'Unit Tests' stamp: 'wbk 1/30/2003 19:57'!
pointerToReturn42
	self export: true.
	interpreterProxy 
		pop: 1
		thenPush: (self cCode: '((int) return42Context + 1)')! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/30/2005 19:21'!
reclaimableContextCount
	| address |
	self export: true.
	address := self exuperyReclaimableContextCount.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 4/17/2004 23:23'!
remapObjects
	methods := self remap: methods.! !

!ExuperyPlugin methodsFor: 'Unit Tests' stamp: 'wbk 3/2/2003 13:52'!
return42Context: aContext
	|sender oldStackPtr newStackPtr |
	self export: true.
	sender := self cCode: '((int *) aContext) [1]'.
	oldStackPtr := self cCode: '*(int *) (sender + 12)' .
	newStackPtr := oldStackPtr + 2.
	self cCode: '*(int *) (sender + 12) = newStackPtr'.
	self cCode: '((int *) sender) [ 6 + (newStackPtr >> 1)] = 83'. ! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 11/21/2003 22:37'!
rootTableAddress
	| address |
	self export: true.
	address := self exuperyRootTableAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 11/21/2003 22:33'!
rootTableCountAddress
	| address |
	self export: true.
	address := self exuperyRootTableCountAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 6/30/2003 17:43'!
setupMessageSendAddress
	|address|
	self export: true.

	address := self exuperySetupMessageSendAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 3/4/2005 11:56'!
setupPicEntryAtforPicinMethod
	| picEntry picLocation method|
	self export: true.
	picEntry := self stackValue: 2.
	picLocation := self stackValue: 1.
	method := self stackValue: 0.
	self pop: 3.
	self cCode: '*(int *)(picEntry - 1 ) = method - 1 + (picLocation / 2)'! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 7/18/2003 10:14'!
specialObjectsOopAddress
	|address|
	self export: true.

	address := self exuperySpecialObjectsOopAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 4/18/2004 20:59'!
trueObjAddress
	| address |
	self export: true.
	address := self exuperyTrueObjAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 11/21/2003 20:02'!
youngStartAddress
	|address|
	self export: true.

	address := self exuperyYoungStartAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

Exception subclass: #ExuperyTestException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

TestCase subclass: #AssemblerTests
	instanceVariableNames: 'machine intermediate code relocator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!AssemblerTests methodsFor: 'Misc' stamp: 'wbk 4/8/2003 12:43'!
basicAssemble: anArray 
	^ self
		basicAssemble: anArray
		withPlugin: TestExuperyPlugin! !

!AssemblerTests methodsFor: 'Misc' stamp: 'wbk 1/21/2005 22:40'!
basicAssemble: anArray withPlugin: aPlugin
	intermediate := MedMethod 
		createAssembly: anArray 
		for: machine.
	code := (AssemblerExupery 
		basicAssemble: intermediate
		withPlugin: aPlugin
		relocator: relocator) byteCodes.! !

!AssemblerTests methodsFor: 'Misc' stamp: 'wbk 1/2/2005 11:48'!
setUp
	machine := MachineX86 new.
	relocator := MockRelocator new.! !

!AssemblerTests methodsFor: 'Tests - Add' stamp: 'wbk 8/23/2003 15:30'!
testAddFromConstant
	self basicAssemble: #(#(#block 1 #(#add 42 #eax))).
	self should: [code = #(129 192 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Add' stamp: 'wbk 3/21/2003 08:58'!
testAddFromIndirection
	self basicAssemble: #(#(#block 1 #(#add #(8 #ebx) #eax))).
	self should: [code = #(3 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Add' stamp: 'wbk 3/21/2003 08:58'!
testAddToIndirection
	self basicAssemble: #(#(#block 1 #(#add #eax #(4 #ebx)))).
	self should: [code = #(1 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Alignment' stamp: 'wbk 1/21/2005 22:40'!
testAlignBlocks
	intermediate := MedMethod 
		createAssembly: #(#(#block 1 #(#add #(8 #ebx) #eax)) #(#block 2 #(#add #(8 #ebx) #eax)))
		for: machine.
	(intermediate blockAt: 2) makeAligned.
	code := (AssemblerExupery 
		basicAssemble: intermediate
		withPlugin: TestExuperyPlugin
		relocator: relocator) byteCodes.
	self should: [code = #(3 67 8 0 3 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - And' stamp: 'wbk 4/4/2003 15:53'!
testAndFromConstant
	self basicAssemble: #(#(#block 1 #(#and 42 #eax))).
	self should: [code = #(16r81 16rE0 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - And' stamp: 'wbk 4/4/2003 14:43'!
testAndFromIndirection
	self basicAssemble: #(#(#block 1 #(#and #(8 #ebx) #eax))).
	self should: [code = #(16r23 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - And' stamp: 'wbk 4/4/2003 14:55'!
testAndToIndirection
	self basicAssemble: #(#(#block 1 #(#and #eax #(4 #ebx)))).
	self should: [code = #(16r21 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 6/25/2003 16:33'!
testCall
	self basicAssemble: #(#(#block 1 (call 16r12345678))).
	self assert: code = #(16rFF 16r15 16r78 16r56 16r34 16r12) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 6/30/2003 20:21'!
testCallRegister
	self basicAssemble: #(#(#block 1 (call eax))).
	self assert: code = #(16rFF 16rD0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Cdq' stamp: 'wbk 2/2/2004 21:25'!
testCdq
	self basicAssemble: #(#(#block 1 (cdq) )).
	self should: [code = #(16r99) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Div' stamp: 'wbk 1/31/2004 18:31'!
testDivide
	self basicAssemble: #(#(#block 1 (div ebx) )).
	self should: [code = #(16rF7 16rFB) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Div' stamp: 'wbk 1/31/2004 18:31'!
testDivide2
	self basicAssemble: #(#(#block 1 (div ecx) )).
	self should: [code = #(16rF7 16rF9) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Pic' stamp: 'wbk 2/27/2005 10:46'!
testDoublePicEntry
	| picEntry picEntry2 |
	picEntry := (Exupery loadCode: ByteArray new) * 2.
	picEntry2 := picEntry + 12.
	self basicAssemble: #(#(#block 1 #(#mov (picEntry) #ebx) #(#mov (picEntry) #ebx))).
	self assert: (code at: 1) = 187.
	self assert: (code at: 2) = (picEntry bitAnd: 255).
	self assert: (code at: 3) = ((picEntry bitShift: -8) bitAnd: 255).
	self assert: (code at: 4) = ((picEntry bitShift: -16) bitAnd: 255).
	self assert: (code at: 5) = ((picEntry bitShift: -24) bitAnd: 255).

	self assert: (code at: 6) = 187.
	self assert: (code at: 7) = (picEntry2 bitAnd: 255).
	self assert: (code at: 8) = ((picEntry2 bitShift: -8) bitAnd: 255).
	self assert: (code at: 9) = ((picEntry2 bitShift: -16) bitAnd: 255).
	self assert: (code at: 10) = ((picEntry2 bitShift: -24) bitAnd: 255).! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/3/2003 23:20'!
testEcx
	self basicAssemble: #(#(#block 1 #(#mov #eax #ecx))).
	self should: [code = #(137 16rC1) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/17/2003 11:01'!
testEdi
	self basicAssemble: #(#(#block 1 #(#mov #eax #edi)) ).
	self should: [code = #(137 16rC7 ) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/3/2003 23:22'!
testEdx
	self basicAssemble: #(#(#block 1 #(#mov #eax #edx))).
	self should: [code = #(137 16rC2) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - True and False Objects' stamp: 'wbk 4/11/2003 16:12'!
testEncodeFalse
	self 
		basicAssemble: #(#(#block 1 #(mov falseObj ebx)))
		withPlugin: MockExuperyPlugin new.
	self should: [code = #(187 16r57 16r35 16r13 16r41) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - True and False Objects' stamp: 'wbk 4/9/2003 22:44'!
testEncodeTrue
	self 
		basicAssemble: #(#(#block 1 #(mov trueObj ebx)))
		withPlugin: MockExuperyPlugin new.
	self should: [code = #(187 16r56 16r34 16r12 16r40) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/4/2003 11:19'!
testEsi
	self basicAssemble: #((block 1 (mov eax esi))).
	self should: [code = #(137 16rC6) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/4/2003 11:22'!
testEsp
	self basicAssemble: #(#(#block 1 #(#mov #eax #esp))).
	self should: [code = #(137 16rC4) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testForwardJump
	self basicAssemble: #(#(#block 1 #(#jz #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r84 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:17'!
testForwardJumpFurther
	self basicAssemble: #((block 1 (jz block2) (mov eax ebx)) (block 2) ).
	self assert: code = #(16r0F 16r84 2 0 0 0 137 195 ) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testJumpAlways
	self basicAssemble: #(#(#block 1 #(#jmp #block2)) #(#block 2) ).
	self assert: code = #(16rE9 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 2/6/2005 19:07'!
testJumpAlwaysComputed
	self basicAssemble: #(#(#block 1 #(#jmp #eax)) #(#block 2) ).
	self assert: code = #(16rFF 16rE0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 2/6/2005 19:08'!
testJumpAlwaysComputed2
	self basicAssemble: #(#(#block 1 #(#jmp #ebx)) #(#block 2) ).
	self assert: code = #(16rFF 16rE3) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testJumpEqual
	self basicAssemble: #(#(#block 1 #(#je #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r84 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:17'!
testJumpGreater
	self basicAssemble: #((block 1 (jg block2) (mov eax ebx)) (block 2) ).
	self assert: code = #(16r0F 16r8F 2 0 0 0 137 195 ) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 11/21/2003 21:05'!
testJumpGreaterEquals
	self basicAssemble: #(#(#block 1 #(#jge #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r8D 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:21'!
testJumpLess
	self basicAssemble: #(#(#block 1 #(#jl #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r8C 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 11:19'!
testJumpLessThanEquals
	self basicAssemble: #(#(#block 1 #(#jle #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r8E 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 1/14/2004 21:50'!
testJumpNotEquals
	self basicAssemble: #(#(#block 1 #(#jne #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r85 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testJumpNotZero
	self basicAssemble: #(#(#block 1 #(#jnz #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r85 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testJumpOverflow
	self basicAssemble: #(#(#block 1 #(#jo #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r80 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 1/21/2005 20:54'!
testMoveFromBlockAddress
	relocator 
		expectRelocationAt: 1
		to: #block2.
	self basicAssemble: #(#(#block 1 #(#mov (addressOf block2) #eax))).
	self should: [code = #(184 0 0 0 0) asByteArray].
	relocator verify! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveFromConstant
	self basicAssemble: #(#(#block 1 #(#mov 1 #eax))).
	self should: [code = #(184 1 0 0 0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveFromConstantToEBX
	self basicAssemble: #(#(#block 1 #(#mov 1 #ebx))).
	self should: [code = #(187 1 0 0 0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveFromConstantToIndirect
	self basicAssemble: #(#(#block 1 #(#mov 87 #(28 #eax)))).
	self should: [code = #(199 64 28 87 0 0 0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveFromIndirectAddress
	self basicAssemble: #(#(#block 1 #(#mov #(8 #ebx) #eax))).
	self should: [code = #(139 67 8) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 7/18/2003 12:25'!
testMoveLargeOffsetIndirectAddress
	self basicAssemble: #(#(#block 1 #(#mov #eax #(16rEE #ebx)))).
	self should: [code = #(137 16r83 16rEE 0 0 0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 4/11/2003 13:57'!
testMoveToBasicIndirectAddress
	self basicAssemble: #((block 1 (mov eax (ebx)))).
	self should: [code = #(137 16r03) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveToIndirectAddress
	self basicAssemble: #(#(#block 1 #(#mov #eax #(4 #ebx)))).
	self should: [code = #(137 67 4) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 6/2/2004 22:00'!
testMoveToNegative128Offset
	self basicAssemble: #(#(#block 1 #(#mov #eax #(-128 #ebx)))).
	self should: [code = #(137 67 16r80) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 6/2/2004 21:58'!
testMoveToNegativeOffset
	self basicAssemble: #(#(#block 1 #(#mov #eax #(-1 #ebx)))).
	self should: [code = #(137 67 255) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Mul' stamp: 'wbk 4/11/2003 17:52'!
testMulFromIndirection
	self basicAssemble: #(#(#block 1 #(#mul #(8 #ebx) #eax))).
	self should: [code = #(16r0F 16rAF 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Negate' stamp: 'wbk 2/9/2004 21:13'!
testNegate
	self basicAssemble: #(#(#block 1 #(#neg #(8 #ebx)))).
	self should: [code = #(16rF7 16r5B 8) asByteArray ].! !

!AssemblerTests methodsFor: 'Tests - Or' stamp: 'wbk 11/21/2003 22:52'!
testOrFromConstant
	self basicAssemble: #(#(#block 1 #(#or 42 #eax))).
	self should: [code = #(16r81 16rC8 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Or' stamp: 'wbk 11/21/2003 22:56'!
testOrFromIndirection
	self basicAssemble: #(#(#block 1 #(#or #(8 #ebx) #eax))).
	self should: [code = #(16r0B 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Or' stamp: 'wbk 11/21/2003 22:53'!
testOrToIndirection
	self basicAssemble: #(#(#block 1 #(#or #eax #(4 #ebx)))).
	self should: [code = #(16r09 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Pic' stamp: 'wbk 2/27/2005 15:01'!
testPic
	| pic picEntry assembler |
	intermediate := MedMethod 
				createAssembly: #(#(#block 1 #(#pic 1233)))
				for: machine.
	pic := (intermediate blockAt: 1) expressionAt: 1.
	picEntry := pic picEntry.
	assembler := AssemblerExupery 
				basicAssemble: intermediate
				withPlugin: TestExuperyPlugin
				relocator: relocator.
	code := assembler byteCodes.
	self assert: code = #(144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144) asByteArray.
	self assert: picEntry picMethodLocation isInteger.
	self assert: assembler picEntries size = 1.
	self assert: assembler picEntries first = picEntry.! !

!AssemblerTests methodsFor: 'Tests - Pic' stamp: 'wbk 2/27/2005 10:46'!
testPicEntry
	| picEntry |
	picEntry := (Exupery loadCode: ByteArray new) * 2.
	self basicAssemble: #(#(#block 1 #(#mov (picEntry) #ebx))).
	self assert: (code at: 1) = 187.
	self assert: (code at: 2) = (picEntry bitAnd: 255).
	self assert: (code at: 3) = ((picEntry bitShift: -8) bitAnd: 255).
	self assert: (code at: 4) = ((picEntry bitShift: -16) bitAnd: 255).
	self assert: (code at: 5) = ((picEntry bitShift: -24) bitAnd: 255).! !

!AssemblerTests methodsFor: 'Tests - Pic' stamp: 'wbk 2/27/2005 10:36'!
testPicEntry2
	| picEntry afterPicEntry |
	picEntry := Exupery loadCode: ByteArray new.
	self basicAssemble: #(#(#block 1 #(#mov (picEntry) #ebx) )).
	afterPicEntry := Exupery loadCode: ByteArray new.
	self assert: afterPicEntry - picEntry = 6 "We count in double bytes because of tagging"
	! !

!AssemblerTests methodsFor: 'Tests - Pop' stamp: 'wbk 3/4/2005 16:19'!
testPopEbx
	self basicAssemble: #(#(#block 1 #(#pop ebx))).
	self should: [code = #(16r5B) asByteArray ].! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 1/21/2005 22:26'!
testPreamble
	intermediate := MedMethod 
		createAssembly: #(#(#block 1 (mov eax ebx))) 
		for: machine.
	code := (AssemblerExupery 
		assemble: intermediate
		withPlugin: MockExuperyPlugin
		relocator: MockRelocator new) byteCodes.
	self should: [code = #( 137 195 ) asByteArray]
! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 6/25/2003 16:16'!
testPush
	self basicAssemble: #(#(#block 1 (push eax))).
	self assert: code = #(16r50) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 6/25/2003 16:23'!
testPushEbx
	self basicAssemble: #(#(#block 1 (push ebx))).
	self assert: code = #(16r53) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 3/4/2005 15:12'!
testRet
	self basicAssemble: #(#(#block 1 #(#ret))).
	self should: [code = #("131 196 64 95 94 91 137 236 93" 195) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sal' stamp: 'wbk 3/17/2003 14:35'!
testSalWithConstant
	self basicAssemble: #(#(#block 1 #(#sal 2 #eax))).
	self should: [code = #(193 224 2) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sal' stamp: 'wbk 2/8/2004 21:22'!
testSalWithRegister
	self basicAssemble: #(#(#block 1 #(#sal #ecx #eax))).
	self should: [code = #(16rD3 16rE0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sal' stamp: 'wbk 2/8/2004 21:54'!
testSalWithRegisterAndIndirection
	self basicAssemble: #(#(#block 1 #(#sal #ecx (8 ebx)))).
	self should: [code = #(16rD3 16r63 8) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sar' stamp: 'wbk 4/4/2003 15:59'!
testSarWithConstant
	self basicAssemble: #(#(#block 1 #(#sar 2 #eax))).
	self should: [code = #(16rC1 16rF8 2) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sar' stamp: 'wbk 2/8/2004 22:10'!
testSarWithRegister
	self basicAssemble: #(#(#block 1 #(#sar #ecx #eax))).
	self should: [code = #(16rD3 16rF8) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sar' stamp: 'wbk 3/4/2004 20:52'!
testSarWithRegisterAndIndirection
	self basicAssemble: #(#(#block 1 #(#sar #ecx (8 ebx)))).
	self should: [code = #(16rD3 16r7B 8) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testSingleMoveAssembling
	self basicAssemble: #(#(#block 1 #(#mov #eax #ebx))).
	self should: [code = #(137 195) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testSingleMoveDifferentFirstRegisterAssembling
	self basicAssemble: #(#(#block 1 #(#mov #ebx #ebx))).
	self should: [code = #(137 219) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sub' stamp: 'wbk 4/7/2003 21:12'!
testSubFromConstant
	self basicAssemble: #(#(#block 1 #(#sub 42 #eax))).
	self should: [code = #(16r81 16rE8 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Sub' stamp: 'wbk 4/7/2003 20:55'!
testSubFromIndirection
	self basicAssemble: #(#(#block 1 #(sub (8 ebx) eax))).
	self should: [code = #(16r2B 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Sub' stamp: 'wbk 4/7/2003 20:59'!
testSubToIndirection
	self basicAssemble: #(#(#block 1 #(#sub #eax #(4 #ebx)))).
	self should: [code = #(16r29 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 3/17/2003 14:35'!
testTrivialAssembling
	self basicAssemble: #(#(#block 1)).
	self should: [code = #() asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testUsingRegisterEbp
	self basicAssemble: #(#(#block 1 #(#mov #eax #ebp))).
	self should: [code = #(137 197) asByteArray]! !

TestCase subclass: #ExuperyTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

ExuperyTests subclass: #ByteCodeReaderTests
	instanceVariableNames: 'generator method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 7/31/2003 15:34'!
atPutSend
	^ 1 
		at: 2
		put: 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 7/29/2003 11:41'!
atSend
	^ 1 at: 2! !

!ByteCodeReaderTests methodsFor: 'Tests - Sends' stamp: 'wbk 4/18/2003 22:05'!
basicSend
	^ self basicTarget! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/4/2004 20:16'!
bitAnd
	^ 6 bitAnd: 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/5/2004 20:39'!
bitOr
	^ 6 bitOr: 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 18:55'!
bitShift
	^ 6 bitShift: 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 7/14/2003 07:21'!
bytecodePrimSendWithArg
	^ 4 new: 5! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/5/2004 22:03'!
div
	^ 6 // 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 1/18/2004 17:21'!
divide
	^ 6 / 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:33'!
equals
	^ 2 = 3! !

!ByteCodeReaderTests methodsFor: 'Misc' stamp: 'wbk 4/26/2004 23:43'!
execute
	ByteCodeReader 
		newMethod: method
		using: generator
		stack: (TestExuperyStack 
			newPC: method initialPC
			emitter: nil)! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/10/2004 15:56'!
greaterThan
	^ 2 > 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:16'!
greaterThanEqual
	^ 2 >= 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 3/13/2003 13:48'!
ifTrueIfFalse
	1 <= 2
		ifTrue: [^1]
		ifFalse: [^2].! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/9/2004 20:51'!
iterativeFactorial: n
	|acc|
	acc := 1.
	1
		to: n
		do: [:each| acc := acc * each].
	^ acc! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/6/2004 22:39'!
lessThan
	^ 2 < 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 3/13/2003 13:48'!
lessThanEquals
	^ 1 <= 2! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/13/2004 23:45'!
longJumpIfTrue
	true ifFalse:
		[^ 1+2.].
	^ 42! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/13/2004 19:07'!
makePoint
	^ 6 @ 3! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/4/2003 12:27'!
methodWithTemporaries
	| a b | 
	^ a + b! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/7/2004 20:31'!
mod
	^ 6 \\ 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/29/2004 23:54'!
nestedIfTrueIfFalse
	^ 1 <= 2
		ifTrue: [10]
		ifFalse: [20].! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 18:57'!
notEquals
	^ 2 ~= 3! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/31/2003 16:37'!
popStack
	1 add.! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/19/2003 21:11'!
pushConstantTrue
	| a |
	a:=  true.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/11/2003 11:57'!
pushConstantZero
	" The shuffle through a temporary is so we actually use the push constant zero bytecode
	rather than the fast return 0 primitive"
	|a|
	a := 0.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/4/2003 19:29'!
pushFalse
	| a |
	a := false.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/11/2003 22:26'!
pushLiteralVariable
	^ Array! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/4/2003 19:15'!
pushMinusOne
	| a |
	a:= -1.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/4/2003 19:29'!
pushNil
	| a |
	a := nil.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 3/13/2003 13:49'!
pushTemp
	|a|
	a := 1! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 3/13/2003 13:49'!
pushTemporary
	|a|
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 6/11/2004 21:50'!
recursivefTrueIfFalse
	^ false 
		ifTrue: [5] 
		ifFalse: [false 
			ifTrue: [10]
			ifFalse: [15]]! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 3/13/2003 13:49'!
return4
	^ 4! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/9/2004 20:52'!
returnAddSmallInt
	^ 1 + 2! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 11/27/2003 21:16'!
returnFalse
	'Avoid a quick return primitive'.
	^ false! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/18/2003 12:51'!
returnNil
	'Avoid a quick return primitive'.
	^ nil! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 4/18/2003 22:45'!
returnString
	^ 'Test String'! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 11/27/2003 19:36'!
returnTrue
	'Avoid a quick return primitive'.
	^ true! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 19:32'!
sendAtEnd
	^ #abcd atEnd! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 3/1/2004 19:05'!
sendClass
	^ 10 class! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/27/2004 21:22'!
sendEquivilent
	^ #abcd == #efgh! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/14/2004 15:10'!
sendNew
	^ Array new! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 15:05'!
sendNext
	^ #abcd next! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 16:34'!
sendNextPut
	^ #abcd nextPut: #efgh! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 13:14'!
sendSize
	^ #abcd size! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/28/2004 17:39'!
sendX
	^ #abcd x! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/28/2004 17:43'!
sendY
	^ #abcd y! !

!ByteCodeReaderTests methodsFor: 'Misc' stamp: 'wbk 7/4/2003 12:05'!
setUp
	generator := MockIntermediateGenerator new.! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/28/2004 15:24'!
shortUnconditionalJump
	^ #bool ifFalse: [^ #success].! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/9/2004 20:45'!
simpleMinus
	^ 2 - 1! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/9/2004 20:48'!
simpleMultiply
	^ 2 * 3! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/3/2003 23:01'!
storeAndPopReceiverVariable
	"This method is just a test. It should never be called."
	generator := 10! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/24/2004 23:36'!
storeTemp
 	|a|
	a := 1.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/24/2004 22:39'!
storeTempExtended
 	|a|
	^ (a := 1) + 5! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/2/2003 11:25'!
stringConcatenate
	^ 'abc', 'def'! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:47'!
testAtEnd
	method := ByteCodeReaderTests compiledMethodAt: #sendAtEnd.
	generator setExpectedBytecodes: #(#(#returnTop #(#sendUnarySelector 21 #(#pushConstant #abcd)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:37'!
testAtPutSend
	method := ByteCodeReaderTests compiledMethodAt: #atPutSend.
	generator checkStackSizeOnSend: 0.
	generator 
		setExpectedBytecodes: #(#(#returnTop #(#sendAtPut (pushConstant 1) #(pushConstant 2) (pushConstant 3)))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:37'!
testAtSend
	method := ByteCodeReaderTests compiledMethodAt: #atSend.
	generator checkStackSizeOnSend: 0.
	generator 
		setExpectedBytecodes: #(#(#returnTop #(#sendAt (pushConstant 1) #(pushConstant 2) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/26/2004 23:47'!
testBitAnd
	method := ByteCodeReaderTests compiledMethodAt: #bitOr.
	generator 
		setExpectedBytecodes: 
			#((returnTop (bitOr (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/26/2004 23:47'!
testBitShift
	method := ByteCodeReaderTests compiledMethodAt: #bitShift.
	generator 
		setExpectedBytecodes: 
			#((returnTop (bitShift (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testBytecodePrimSendWithArg
	method := ByteCodeReaderTests compiledMethodAt: #bytecodePrimSendWithArg.
	generator checkStackSizeOnSend: 0.
	generator setExpectedBytecodes: 
		#(#(#returnTop 
			#(#binarySendWithSpecialSelector 29 
			#(#pushConstant 4) 
			#(#pushConstant 5)))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testClass
	method := ByteCodeReaderTests compiledMethodAt: #sendClass.
	generator 
		setExpectedBytecodes: 
			#((returnTop (class (pushConstant 10 )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/26/2004 23:47'!
testDiv
	method := ByteCodeReaderTests compiledMethodAt: #div.
	generator 
		setExpectedBytecodes: 
			#((returnTop (div (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/26/2004 23:47'!
testDivide
	method := ByteCodeReaderTests compiledMethodAt: #divide.
	generator 
		setExpectedBytecodes: 
			#((returnTop (divide (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/26/2004 23:39'!
testEquals
	method := ByteCodeReaderTests compiledMethodAt: #equals.
	generator 
		setExpectedBytecodes: 
			#(#(#returnTop #(#equals 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testEquivilent
	method := ByteCodeReaderTests compiledMethodAt: #sendEquivilent.
	generator 
		setExpectedBytecodes: 
			#((returnTop (equivilent (pushConstant abcd ) (pushConstant efgh) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 6/14/2004 21:19'!
testExtendedStoreStackTracing
	| compiler reader |
	compiler := Exupery new 
		initializeMethod: (ExuperyInstanceVariables  compiledMethodAt: #storeInstanceExtended2)
		functionName: #tstoreInstanceExtended2.
	reader := compiler generateIntermediate.
	self assert: reader stackHeights asArray = #(0 1).
	self assert: compiler generator jumpTargets asArray = #(15 16).! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/26/2004 23:39'!
testGreaterThan
	method := ByteCodeReaderTests compiledMethodAt: #greaterThan.
	generator 
		setExpectedBytecodes: 
			#(#(#returnTop #(#greaterThan 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/26/2004 23:39'!
testGreaterThanEqual
	method := ByteCodeReaderTests compiledMethodAt: #greaterThanEqual.
	generator 
		setExpectedBytecodes: 
			#(#(#returnTop #(#greaterThanEqual 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 4/26/2004 23:50'!
testIfTrueIfFalse
	method := ByteCodeReaderTests compiledMethodAt: #ifTrueIfFalse.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(jumpFalse (sendLessThanEquals (pushConstant 1) (pushConstant 2)) 11) 
		(returnTop (pushConstant 1)) 
		(returnTop (pushConstant 2))).
	self execute.
	self should: [generator byteCodeString = 'pushConstant 1 pushConstant 2 sendLessThanEquals jumpFalse 11 pushConstant 1 returnTop pushConstant 2 returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/26/2004 23:39'!
testLessThan
	method := ByteCodeReaderTests compiledMethodAt: #lessThan.
	generator 
		setExpectedBytecodes:
			#((returnTop (lessThan 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/26/2004 23:45'!
testLessThanEquals
	method := ByteCodeReaderTests compiledMethodAt: #lessThanEquals.
	generator setExpectedBytecodes: 
		#((returnTop
			(sendLessThanEquals
				(pushConstant 1)
				(pushConstant 2)))).
	self execute.
	self should: 
		[generator byteCodeString = 'pushConstant 1 pushConstant 2 sendLessThanEquals returnTop']
	! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/24/2004 22:49'!
testLoadLargeReceiver
	method := ExuperyInstanceVariables compiledMethodAt: #i17.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendAdd (pushInstanceVariable 16) (pushConstant 0)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/13/2004 12:37'!
testLoadLargeTemporary
	method := ExuperyInstanceVariables compiledMethodAt: #loadExtendedTemp.
	generator 
		setExpectedBytecodes: 
			#((returnTop (pushTemp 16))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 10/24/2004 22:49'!
testLongJumpIfTrue
	method := ByteCodeReaderTests compiledMethodAt: #longJumpIfTrue.
	generator 
		setExpectedBytecodes: 
			#((jumpIfTrue (pushTrue) 16)
			   (returnTop (sendAdd (pushConstant 1) (pushConstant 2)))
				(returnTop (pushConstant 42))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testMakePoint
	method := ByteCodeReaderTests compiledMethodAt: #makePoint.
	generator 
		setExpectedBytecodes: 
			#((returnTop (makePoint (pushConstant 6) (pushConstant 3)))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/26/2004 23:47'!
testMod
	method := ByteCodeReaderTests compiledMethodAt: #mod.
	generator 
		setExpectedBytecodes: 
			#((returnTop (mod (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testNew
	method := ByteCodeReaderTests compiledMethodAt: #sendNew.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendUnarySelector 28 (pushLiteralVariable 0 )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testNext
	method := ByteCodeReaderTests compiledMethodAt: #sendNext.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendUnarySelector 19 (pushConstant abcd )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testNextPut
	method := ByteCodeReaderTests compiledMethodAt: #sendNextPut.
	generator 
		setExpectedBytecodes: 
			#((returnTop (binarySendWithSpecialSelector 20 (pushConstant abcd ) (pushConstant efgh) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/26/2004 23:39'!
testNotEquals
	method := ByteCodeReaderTests compiledMethodAt: #notEquals.
	generator 
		setExpectedBytecodes: 
			#(#(#returnTop #(#notEquals 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testPointX
	method := ByteCodeReaderTests compiledMethodAt: #sendX.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendUnarySelector 30 (pushConstant abcd )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testPointY
	method := ByteCodeReaderTests compiledMethodAt: #sendY.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendUnarySelector 31 (pushConstant abcd )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:48'!
testPopStack
	method := ByteCodeReaderTests compiledMethodAt: #popStack.
	generator 
		setExpectedBytecodes: #( (popStack (send add (pushConstant 1))) #(#returnSelf)).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:48'!
testPushConstantMinusOne
	method := ByteCodeReaderTests compiledMethodAt: #pushMinusOne.
	generator 
		setExpectedBytecodes: #( (popIntoTemp 0 (pushConstant -1)) #(#returnTop (pushTemp 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:48'!
testPushConstantTrue
	method := ByteCodeReaderTests compiledMethodAt: #pushConstantTrue.
	generator 
		setExpectedBytecodes: #((popIntoTemp 0 (pushTrue)) #(#returnTop (pushTemp 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:48'!
testPushConstantZero
	method := ByteCodeReaderTests compiledMethodAt: #pushConstantZero.
	generator 
		setExpectedBytecodes: #( (popIntoTemp 0 (pushConstant 0)) #(#returnTop (pushTemp 0))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:48'!
testPushFalse
	method := ByteCodeReaderTests compiledMethodAt: #pushFalse.
	generator 
		setExpectedBytecodes: #((popIntoTemp 0 (pushFalse)) #(#returnTop (pushTemp 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:48'!
testPushLiteralVariable
	method := ByteCodeReaderTests compiledMethodAt: #pushLiteralVariable.
	generator 
		setExpectedBytecodes: #( (returnTop (pushLiteralVariable 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testPushNil
	method := ByteCodeReaderTests compiledMethodAt: #pushNil.
	generator 
		setExpectedBytecodes: #((popIntoTemp 0 (pushNil)) #(#returnTop (pushTemp 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/24/2004 22:50'!
testPushReceiverVariables
	method := ExuperyInstanceVariables compiledMethodAt: #a.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendAdd
				(pushInstanceVariable 0) (pushConstant 0) ))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/23/2004 19:47'!
testPushTemp
	method := ByteCodeReaderTests compiledMethodAt: #pushTemp.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(popIntoTemp 0
			(pushConstant 1))
		(returnSelf)).
	self execute.
	self should: [generator byteCodeString = 'pushConstant 1 popIntoTemp 0 returnSelf']
	! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 2/13/2005 12:58'!
testPushTempAddsStoreToIntermediate
	"Checks that the popIntoTemp instruction is actually being added. 
	This is ugly."

	| emitter |
	method _ ByteCodeReaderTests compiledMethodAt: #pushTemp.
	generator _ IntermediateGenerator 
				for: MachineX86 new
				jumpTargets: #().
	emitter _ MockIntermediateEmitter new.
	emitter expectEmission: #(#(#block1 #(#storeInTemp 0 3) #(#emitReturnValue #(#receiverAddress)))).
	generator emitter: emitter.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	"self should: [generator result intermediateForm =  
		#(block 1 (popIntoTemp 0
			(pushConstant 1)))]"
	emitter verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testPushTemporaryVariable
	method := ByteCodeReaderTests compiledMethodAt: #pushTemporary.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(returnTop
			(pushTemp 0))).
	self execute.
	self should: [generator byteCodeString = 'pushTemp 0 returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 4/26/2004 23:45'!
testReadByteCodeNumbers
	method := CompilerToys compiledMethodAt: #simpleMethod2.
	generator := MockIntermediateGenerator new.
	generator recordByteCodeNumbers.
	self execute.
	self should: [generator byteCodeString = 'byteCode 5 pushConstant 1 byteCode 6 pushConstant 2 byteCode 7 sendPlus byteCode 8 returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 4/18/2004 22:20'!
testRegisterJumpTargets
	| compiler |
	compiler := Exupery new 
		initializeMethod: (ByteCodeReaderTests compiledMethodAt: #ifTrueIfFalse)
		functionName: #ifTrueIfFalse.
	compiler generateIntermediate.
	self should: [compiler generator jumpTargets asArray = #(11)].! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 5/30/2004 23:08'!
testRegisterNestedStackTracing
	| compiler reader |
	compiler := Exupery new 
		initializeMethod: (ByteCodeReaderTests compiledMethodAt: #nestedIfTrueIfFalse)
		functionName: #ifTrueIfFalse.
	reader := compiler generateIntermediate.
	self should: [reader stackHeights asArray = #(0 1)].! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 5/30/2004 23:01'!
testRegisterStackTracing
	| compiler reader |
	compiler := Exupery new 
		initializeMethod: (ByteCodeReaderTests compiledMethodAt: #ifTrueIfFalse)
		functionName: #ifTrueIfFalse.
	reader := compiler generateIntermediate.
	self should: [reader stackHeights asArray = #(0)].! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testReturnFalse
	method := ByteCodeReaderTests compiledMethodAt: #returnFalse.
	generator 
		setExpectedBytecodes: #((returnFalse )).
	self execute.
	self verify.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testReturnNil
	method := ByteCodeReaderTests compiledMethodAt: #returnNil.
	generator 
		setExpectedBytecodes: #((returnNil )).
	self execute.
	self verify.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testReturnTrue
	method := ByteCodeReaderTests compiledMethodAt: #returnTrue.
	generator 
		setExpectedBytecodes: #((returnTrue )).
	self execute.
	self verify.! !

!ByteCodeReaderTests methodsFor: 'Tests - Sends' stamp: 'wbk 4/26/2004 23:50'!
testSendBasic
	method := ByteCodeReaderTests compiledMethodAt: #basicSend.
	generator checkStackSizeOnSend: 0.
	generator 
		setExpectedBytecodes: #(#(#returnTop #(#send #basicTarget #(#pushSelf) ))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Sends' stamp: 'wbk 6/16/2004 22:31'!
testSendExtended
	method := TestExuperyPlugin compiledMethodAt: #extendedSend.
	generator checkStackSizeOnSend: 0.
	generator 
		setExpectedBytecodes: #(#
			(#popStack #(#send #method1 #(#pushSelf)))
			(#popStack #(#send #method2 #(#pushSelf)))
			(#popStack #(#send #method3 #(#pushSelf)))
			(#popStack #(#send #method4 #(#pushSelf)))
			(#popStack #(#send #method5 #(#pushSelf)))
			(#popStack #(#send #method6 #(#pushSelf)))
			(#popStack #(#send #method7 #(#pushSelf)))
			(#popStack #(#send #method8 #(#pushSelf)))
			(#popStack #(#send #method9 #(#pushSelf)))
			(#popStack #(#send #method10 #(#pushSelf)))
			(#popStack #(#send #method11 #(#pushSelf)))
			(#popStack #(#send #method12 #(#pushSelf)))
			(#popStack #(#send #method13 #(#pushSelf)))
			(#popStack #(#send #method14 #(#pushSelf)))
			(#popStack (#send #method15 #(#pushSelf)))
			(#popStack #(#send #method16 #(#pushSelf)))
			(#returnTop #(#send #method17 #(#pushSelf) ))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Sends' stamp: 'wbk 4/26/2004 23:51'!
testSendStringConcatenate
	method := ByteCodeReaderTests compiledMethodAt: #stringConcatenate.
	generator 
		setExpectedBytecodes: #(#(#returnTop #(#send #, (pushConstant #abc) (pushConstant #def) ))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 4/26/2004 23:46'!
testSetNumberOfTemporaries
	method := ByteCodeReaderTests compiledMethodAt: #methodWithTemporaries.
	generator setExpectedTemporaries: 2.
	self execute.
	self verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 4/26/2004 23:50'!
testShortUnconditionalJump
	method := ByteCodeReaderTests compiledMethodAt: #shortUnconditionalJump.
	"The following is commented out because this method does not follow stack discipline strictly
	enough for the mock based tester"
	"generator 
		setExpectedBytecodes: 
			#((jumpFalse (pushConstant bool) 17)
			  (pushNil)
				(jumpTo 19)
			   (returnTop (pushConstant #success))
				(returnTop (pushNil) ))."
	self execute.
	self assert: generator byteCodeString = 'pushConstant bool jumpFalse 17 pushNil jumpTo 19 pushConstant success returnTop returnTop'
! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 4/26/2004 23:56'!
testSimpleMethod
	method := CompilerToys compiledMethodAt: #simpleMethod.
	generator := MockIntermediateGenerator new.
	self execute.
	self should: [generator numberOfBytecodes = 0].
	self should: [generator primitiveNumber = 262].
	! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 10/24/2004 22:50'!
testSimpleMethod2
	method := CompilerToys compiledMethodAt: #simpleMethod2.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(returnTop
			(sendAdd
				(pushConstant 1)
				(pushConstant 2)))).
	self execute.
	self should: [generator numberOfBytecodes = 4].
	self should: [generator primitiveNumber = 0].
	self should: [generator byteCodeString = 'pushConstant 1 pushConstant 2 sendPlus returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 7/9/2004 20:45'!
testSimpleMinus
	method := ByteCodeReaderTests compiledMethodAt: #simpleMinus.
	generator := MockIntermediateGenerator new.
	generator 
		setExpectedBytecodes: #(#(#returnTop #(#sendMinus #(#pushConstant 2) #(#pushConstant 1)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 7/9/2004 20:49'!
testSimpleMultiply
	method := ByteCodeReaderTests compiledMethodAt: #simpleMultiply.
	generator := MockIntermediateGenerator new.
	generator 
		setExpectedBytecodes: #(#(#returnTop #(#sendMultiply #(#pushConstant 2) #(#pushConstant 3)))).
	self execute.
	"self should: [generator stackString = '(returnTop (sendMultiply (literal 2) (literal 3)))' ]."! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/26/2004 23:38'!
testSize
	method := ByteCodeReaderTests compiledMethodAt: #sendSize.
	generator 
		setExpectedBytecodes: 
			#((returnTop (sendUnarySelector 18 (pushConstant abcd )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 10/24/2004 22:50'!
testStackTracking
	method := CompilerToys compiledMethodAt: #simpleMethod2.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(returnTop
			(sendAdd
				(pushConstant 1)
				(pushConstant 2)))).
	self execute.
	self should: [generator primitiveNumber = 0].
	self should: [generator byteCodeString = 'pushConstant 1 pushConstant 2 sendPlus returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 5/31/2004 20:40'!
testStackUpdating
	| reader |
	reader := ByteCodeReader
		newMethod: (ByteCodeReaderTests compiledMethodAt: #return4)
		using: generator
		jumpTargets: #(5)
		stackHeights: #(10).
		
	reader byteCodeAddressing: 5.
	self assert: reader stackHeight = 10.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 5/31/2004 20:44'!
testStackUpdating2
	| reader |
	reader := ByteCodeReader
		newMethod: (ByteCodeReaderTests compiledMethodAt: #return4)
		using: generator
		jumpTargets: #(2 4 6)
		stackHeights: #(20 40 30).
		
	reader byteCodeAddressing: 2.
	self assert: reader stackHeight = 20.
	
	reader byteCodeAddressing: 3.
	self assert: reader stackHeight = 20.
	
	reader byteCodeAddressing: 4.
	self assert: reader stackHeight = 40.
	
	reader byteCodeAddressing: 6.
	self assert: reader stackHeight = 30! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 2/13/2005 12:58'!
testStoreAndPopExtendedReceiverAddsStoreToIntermediate
	"Checks that the popIntoTemp instruction is actually being added. 
	This is ugly."

	| emitter machine |
	method _ ExuperyInstanceVariables compiledMethodAt: #i16:.
	machine _ MachineX86 new.
	generator _ IntermediateGenerator 
				for: machine
				jumpTargets: #().
	emitter _ MockIntermediateEmitter new.
	emitter initialiseMachine: machine.
	emitter expectEmission: #(#(#block1 #(#mov #(#emitTemporaryAddress 0) #s1) #(#storeInReceiver 15 #s1) #(#emitReturnValue #(#receiverAddress)))).
	generator emitter: emitter.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	"self should: [generator result intermediateForm =  
		#(block 1 (popIntoTemp 0
			(pushConstant 1)))]"
	emitter verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 2/13/2005 12:58'!
testStoreAndPopReceiverAddsStoreToIntermediate
	"Checks that the popIntoTemp instruction is actually being added. 
	This is ugly."

	| emitter |
	method _ ByteCodeReaderTests compiledMethodAt: #storeAndPopReceiverVariable.
	generator _ IntermediateGenerator 
				for: MachineX86 new
				jumpTargets: #().
	emitter _ MockIntermediateEmitter new.
	emitter expectEmission: #(#(#block1 #(#storeInReceiver 1 21) #(#emitReturnValue #(#receiverAddress)))).
	generator emitter: emitter.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	"self should: [generator result intermediateForm =  
		#(block 1 (popIntoTemp 0
			(pushConstant 1)))]"
	emitter verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/26/2004 23:49'!
testStoreAndPopReceiverVariables
	method := ExuperyInstanceVariables compiledMethodAt: #a:.
	generator 
		setExpectedBytecodes: 
			#(	(storeAndPopReceiverVariable 0 (pushTemp 0))
				(returnSelf)  ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/14/2004 22:35'!
testStoreInstanceExtendedWithoutPopping
	method := ExuperyInstanceVariables compiledMethodAt: #storeInstanceExtended.
	self execute.
	self assert: generator byteCodeString = 'pushTrue jumpFalse 15 pushConstant 10 storeIntoReceiver 15 jumpTo 16 pushNil returnTop'! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/13/2004 10:55'!
testStoreLargeReceiver
	method := ExuperyInstanceVariables compiledMethodAt: #i16:.
	generator 
		setExpectedBytecodes: 
			#((storeAndPopReceiverVariable 15 (pushTemp 0)) (returnSelf)).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/13/2004 12:39'!
testStoreLargeTemporary
	method := ExuperyInstanceVariables compiledMethodAt: #storeExtendedTemp.
	generator 
		setExpectedBytecodes: 
			#((popIntoTemp 16 (pushConstant 17)) (returnSelf)).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/24/2004 23:37'!
testStoreTemp
	method := ByteCodeReaderTests compiledMethodAt: #storeTemp.
	generator setExpectedBytecodes: 
		#(	(popIntoTemp 0 (pushConstant 1))
			(returnSelf)).
	self execute.
	self verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/14/2004 22:43'!
testStoreTempExtendedWithoutPopping
	method := ExuperyInstanceVariables compiledMethodAt: #storeTempExtended2.
	self execute.
	self assert: generator byteCodeString = 'pushTrue jumpFalse 15 pushConstant 15 popIntoTemp 15 jumpTo 16 pushNil returnTop'! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/24/2004 22:43'!
testStoreTempExtendedWithoutPopping2
	method := ByteCodeReaderTests compiledMethodAt: #storeTempExtended.
	generator setExpectedBytecodes: 
		#((returnTop (sendAdd (popIntoTemp 0 (pushConstant 1)) (pushConstant 5)))).
	self execute.
	self verify! !

!ByteCodeReaderTests methodsFor: 'Misc' stamp: 'wbk 7/4/2003 12:14'!
verify
	generator verify! !

ExuperyTests subclass: #ColouringRegisterAllocatorTests
	instanceVariableNames: 'machine allocator selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 11/9/2002 15:27'!
createAllocator: med 
	| source |
	machine := MachineX86 new.
	source := MedMethod 
		createAssembly: med 
		for: machine.
	^ allocator := ColouringRegisterAllocator new 
		initialiseSource: source 
		machine: machine! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 8/2/2004 21:14'!
createAndPrepareAllocator: anArray
	allocator := self createAllocator: anArray.
	allocator setUp.
	^ allocator! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 6/2/2004 22:50'!
createAssignments: anArray
	| assignments |
	assignments := Dictionary new.
	anArray do: 
		[:each| assignments
			at: (machine registerNamed: each first)
			put: (machine registerNamed: each last)].
	^ assignments

! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 8/2/2004 20:59'!
nodeNamed: aSymbol 
	^ allocator interferenceGraph at: (machine registerNamed: aSymbol)! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 11/9/2002 15:47'!
testAllocateBasicCoalesce
	self createAllocator: #(#(#block 1 #(#mov #t1 #t2) #(#add #t1 #t2))).
	allocator run.
	self should: [allocator intermediateForm = #(#(#block 1 #(#add #eax #eax)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 3/4/2005 15:14'!
testAllocateReturn42
	self createAllocator: 
		#(#(#block 1 
			#(#mov 8 #t3) 
			#(#add #ebp #t3) 
			#(#mov #(#t3) #t4) 
			#(#mov #(#t4) #t5) 
			#(#mov #t5 #t1) 
			#(#mov 8 #t6) 
			#(#add #t1 #t6) 
			#(#mov #(#t6) #t7) 
			#(#mov 1 #t8) 
			#(#add #t7 #t8) 
			#(#mov #t8 #t2) 
			#(#mov 8 #t9) 
			#(#add #t1 #t9) 
			#(#mov #t2 #(#t9)) 
			#(#mov 4 #t10) 
			#(#mul #t2 #t10) 
			#(#mov #t10 #t11) 
			#(#add #t1 #t11) 
			#(#mov 24 #t12) 
			#(#add #t11 #t12) 
			#(#mov 85 #(#t12)) 
			#(#ret))).
	allocator run.
	self should: [allocator hasNoTemporaries].
	self should: [(allocator result blockNumbered: 1) numberOfExpressions = 19].
	self verifyAllocator! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 11/9/2002 15:48'!
testAllocateWithSpills
	allocator := self createAllocator: #(#	(#block 1 #(#add #t1 #t2) #(#add #t3 #t4) #(#add #t5 #t6) #(#add #t6 #t7) 
					(#add #t3 #t5) #(#add #t5 #t1) #(#jmp #block1)) 
				(#block 2 #(#add #t8 #t5))).

	allocator run.

	self should: [allocator hasNoTemporaries].
	self should: [self usesAllAvailibleRegisters: allocator].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 1/20/2005 21:47'!
testAssignAddress
	self createAllocator: #((block 1 (mov (addressOf block1) t1) )).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov (addressOf block1) eax)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:44'!
testAssignAddressingMode
	self createAllocator: #((block 1 (mov (ebp) t1) (mov 2 t2) (add t1 t2))).

 	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov (ebp) eax) (mov 2 ebx) (add eax ebx)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 2/2/2004 21:16'!
testAssignCdq
	self createAllocator: #((block 1 (cdq) )).
	self createAssignments: #((t1 ebx) (t2 ebx)).

 	allocator assignRegisters.

	self should: 
			[allocator intermediateForm 
				= #((block 1 (cdq) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:45'!
testAssignCoalescedMove
	self createAllocator: #((block 1 (mov t1 t2) (add t1 t2))).
	
	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 eax))).

	self should: 
			[allocator intermediateForm 
				= #(#(#block 1  #(#add #eax #eax)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 1/16/2005 19:54'!
testAssignCopyAlignedFlag
	
	self createAllocator: #((block 1) (block 2)).

	(allocator source blockAt: 2) makeAligned.

 	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 ) (block 2))].
	self assert: (allocator  result blockAt: 1) isAligned not.
	self assert: (allocator result blockAt: 2) isAligned.
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:44'!
testAssignDivide
	self createAllocator: #((block 1 (div t1) )).

 	allocator assignRegisters: (self createAssignments: #((t1 ebx) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (div ebx) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:46'!
testAssignJump
	self createAllocator: #((block 1 (mov 1 t1) (jz block2) (jo block2) (jmp block2)) 
							(block 2)).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov 1 eax) (jz block2) (jo block2) (jmp block2)) 
					(block 2))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 2/4/2005 23:42'!
testAssignJumpCalculated
	self createAllocator: #((block 1 (jmp t1) ) 
							(block 2)).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1  (jmp eax) ) 
					(block 2))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 7/6/2003 21:31'!
testAssignKeepsBlocksInOrder
	self createAllocator: #((block 4 (jz block2) ) (block 1 ) (block 2 (jmp block3) ) (block 3)).
	self createAssignments: #((t1 eax) (t2 ebx)).
	allocator assignRegisters.

	self should: 
			[allocator intermediateForm 
				= #((block 4 (jz block2) ) (block 1 ) (block 2 (jmp block3) ) (block 3))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:47'!
testAssignMachineRegister
	self createAllocator: #((block 1 (mov ebp t1) (mov 2 t2) (add t1 t2))).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov ebp eax) (mov 2 ebx) (add eax ebx)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:47'!
testAssignNeg
	self createAllocator: #((block 1 (neg t1) )).

 	allocator assignRegisters: (self createAssignments: #((t1 ebx) (t2 ecx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (neg ebx) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 3/4/2005 15:11'!
testAssignRet
	self createAllocator: #(#(#block 1 #(#ret))).
	self createAssignments: #(#(#t1 #eax) #(#t2 #ebx)).
	allocator assignRegisters.
	self should: [allocator intermediateForm = #(#(#block 1 #(#ret)))].
	self verifyAllocator! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:48'!
testAssignSimple
	self createAllocator: #((block 1 (mov 1 t1) (mov 2 t2) (add t1 t2))).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov 1 eax) (mov 2 ebx) (add eax ebx)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:49'!
testAssignSpillCode
	self createAllocator: #((block 1 (mov (-16 ebp) t1) (add 1 t1) 
									(mov t1 (-16 ebp)))).

	allocator assignRegisters: (self createAssignments: #((t1 eax))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov (-16 ebp) eax) (add 1 eax) (mov eax (-16 ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:50'!
testCall
	self createAllocator: #((block 1 (call t1))).

	allocator assignRegisters: (self createAssignments: #((t1 eax))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (call eax) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 21:04'!
testCoalesceAfterSimplifyInterferes
	self createAndPrepareAllocator: #(#	(#block 1 (mov 1 t2) (add t1 t2) (mov t2 t3) (mov 1 t4)  (add t4 t3) )).
	allocator simplify.
	allocator coalesce.

	self 
		verifyInterferes: #t1
		with: #t3.
	self 
		verifyInterferes: #t3
		with: #t1.
	self should: [(self nodeNamed: #t2) currentSize = 0].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:29'!
testCoalesceBuildMovWorklistIndirectAddressing
	self createAndPrepareAllocator: #(#(#block 1 #(#mov (t1) #t2) (mov t1 (t2)) )).

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist isEmpty].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:30'!
testCoalesceBuildMovWorklistInterferes
	" A single add does not produce an interference edge, add %eax, %eax is the same assuming
	t1 and t2 are never used again later."
	self createAndPrepareAllocator: #(#(#block 1 #(#mov t1 #t2) (add t1 t2) (add t1 t2) )). 

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist isEmpty].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:30'!
testCoalesceBuildMovWorklistSimple
	self createAndPrepareAllocator: #(#(#block 1 #(#mov t1 #t2) )).

	self should: [allocator moveWorklist size = 1].
	self should: [allocator simplifyWorklist isEmpty].
	self should: [allocator spillWorklist isEmpty].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 21:04'!
testCoalesceBuildWorklistsMoveCountsSimple
	self createAndPrepareAllocator: #(#(#block 1 #(#mov t1 #t2) )).

	self should: [(self nodeNamed: #t1) currentMoves = 1].
	self should: [(self nodeNamed: #t2) currentMoves = 1].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 21:05'!
testCoalesceBuildWorklistsMoveCountsTwoMoves
	self createAndPrepareAllocator: #(#(#block 1 #(#mov t1 #t2) (mov t2 t3) )).

	self should: [(self nodeNamed: #t1) currentMoves = 1].
	self should: [(self nodeNamed: #t2) currentMoves = 2].
	self should: [(self nodeNamed: #t3) currentMoves = 1].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 4/24/2004 13:12'!
testCoalesceConstrainsNextMov
	self createAndPrepareAllocator: #((block 1 (mov t1 t2) (mov t2 t3) (mov 1 t1) (mov 2 t3) (add t1 t3))).
	self should: [allocator coalesce].

	self should: [allocator coalescedMoves size = 1].
	self should: [allocator moveWorklist size = 0].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist size = 0].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:01'!
testCoalesceDecrementsIndirectCounts
	"When a move is decremented."
	|  movet3t4 movet2t3 movet1t3 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t3) 
			(mov 1 t2) "Avoiding pollution with t1"
			(mov t2 t3) 
			(mov t3 t4)   )).

	
	movet3t4 := allocator 
		getMoveFrom: #t3 
		to: #t4.
	movet2t3 := allocator 
		getMoveFrom: #t2 
		to: #t3.
	movet1t3 := allocator 
		getMoveFrom: #t1 
		to: #t3.

	allocator coalesceNode: movet3t4.
	self assert: (self nodeNamed: #t4) currentMoves = 2.
	
	allocator coalesceNode: movet2t3.
	self assert: (self nodeNamed: #t4) currentMoves = 1.
	
	allocator coalesceNode: movet1t3.
	self assert: (self nodeNamed: #t4) currentMoves = 0.
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:02'!
testCoalesceDecrementsIndirectCounts2
	"Trying to catch the case in live where a move count isn't properly	 	incremented/decremented.."
	|  movet2t3 movet1t2 movet21t22 movet22t2 movet23t22 |
	self createAndPrepareAllocator: 
		#(#	(#block 1
			(mov t21 t22)
			(mov 0 t23) "Avoiding interference"
			(mov t23 t22)
			(mov t22 t2)
			 
			(mov 0 t1) "Just to avoid interference"
			(mov t1 t2) 
			(mov t2 t3) 
			"(mov t3 t4)"   )).

	
	movet1t2 := allocator 
		getMoveFrom: #t1
		to: #t2.
	movet2t3 := allocator 
		getMoveFrom: #t2 
		to: #t3.
	movet21t22 := allocator 
		getMoveFrom: #t21 
		to: #t22.
	movet22t2 := allocator 
		getMoveFrom: #t22 
		to: #t2.
	movet23t22 := allocator 
		getMoveFrom: #t23 
		to: #t22.

	allocator coalesceNode: movet22t2.
	self assert: (self nodeNamed: #t3) currentMoves = 1.

	allocator coalesceNode: movet2t3.
	self assert: (self nodeNamed: #t3) currentMoves = 3.
	
	allocator coalesceNode: movet1t2.
	self assert: (self nodeNamed: #t3) currentMoves = 2.

	allocator coalesceNode: movet21t22.
	self assert: (self nodeNamed: #t3) currentMoves = 1.
	
	allocator coalesceNode: movet23t22.
	self assert: (self nodeNamed: #t3) currentMoves = 0.
	self verifyAllocator.
	
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:32'!
testCoalesceFreezeOneHighDegree
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2)  (add t3 t4) (add t4 t5) (add t6 t7) (add t7 t8) )).

	self should: [allocator freeze].

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 7].
	self should: [allocator spillWorklist size = 1].
	self should: [(allocator spillWorklist at: 1) register intermediateForm = #t2].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 22:50'!
testCoalesceFreezeRegistersUsedInOtherMoves
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (mov t2 t3) )).

	self should: [allocator freeze].

	self should: [(self nodeNamed: #t2) currentMoves = 1].
	self should: [(self nodeNamed: #t3) currentMoves = 0].
	self should: [allocator moveWorklist size = 1].
	self should: [allocator simplifyWorklist size = 1].
	self should: [allocator spillWorklist isEmpty].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:33'!
testCoalesceFreezeSimple
	allocator := self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (add t1 t2) )).

	self should: [allocator freeze].

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist isEmpty].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:33'!
testCoalesceFreezeTwoHighDegrees
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (add t2 t1) (add t3 t4) (add t4 t5) (add t6 t7) (add t7 t8) )).

	self shouldnt: [allocator freeze].

	self should: [allocator moveWorklist size = 1].
	self should: [allocator simplifyWorklist size = 4].
	self should: [allocator spillWorklist size = 2].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 7/25/2004 16:05'!
testCoalesceFromPhysicalRegister
	"Tests that when we merge a move with a precoloured node the new merged node is
	also precoloured."
	|  move |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov eax t1)  )).
			
	move := allocator 
		getMoveFrom: #eax
		to: #t1.
		
	allocator coalesceNode: move.
	self verifyAllocator. "Check everything is OK"
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:02'!
testCoalesceInterferingMove
	"This test is an attempt to isolate a bug that's effecting the bitShift"| movet2t3 |
.
	self createAndPrepareAllocator: 
		#(#	(#block 1 (mov 1 t1)  
					(mov t1 t2) (mov t2 t3) (add 2 t3) (mov t1 t4)  (add t4 t4) )).

	movet2t3 := allocator 
		getMoveFrom: #t2 
		to: #t3.
		
	allocator coalesceNode: movet2t3.
	self 
		verifyInterferes: #t1 
		with: #t2.
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:00'!
testCoalesceLoop
	"Tests that we handle coalsecing a move to a register that has already been
	coalesced away."
	|  movet1t2 movet2t1 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t2) 
			(mov t2 t1) )).

	
	movet1t2 := allocator 
		getMoveFrom: #t1
		to: #t2.
	movet2t1 := allocator 
		getMoveFrom: #t2
		to: #t1.
		
	allocator coalesceNode: movet1t2.
	self verifyAllocator. "Check everything is OK"
	allocator coalesceNode: movet2t1.
	self verifyAllocator.	"Check that cloaing the loop didn't corrupt us"
	
	self assert: (self nodeNamed: #t1) currentVersion register name = #t2.
	self assert: (self nodeNamed: #t1) currentVersion currentMoves = 0.

	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:03'!
testCoalesceMoveCounts
	"Tests that we handle coalsecing a move to a register that has already been
	coalesced away."
	|  movet3t4 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t3) 
			(mov 1 t2) "Avoiding pollution with t1"
			(mov t2 t3) 
			(mov t3 t4)   )).

	
	movet3t4 := allocator 
		getMoveFrom: #t3 
		to: #t4.
		
	allocator coalesceNode: movet3t4.
	
	self assert: (self nodeNamed: #t4) currentMoves = 2.
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 5/22/2004 22:11'!
testCoalesceMultipleMoves
	"Tests that we handle coalsecing a move to a register that has already been
	coalesced away."
	| movet2t3 movet1t2 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov 1 t1)  "Create an interference edge for t1"
			(add t5 t6)
			(mov t1 t2)
			(mov t2 t3)   )).

	
	movet2t3 := allocator 
		getMoveFrom: #t2 
		to: #t3.
	movet1t2 := allocator
		getMoveFrom: #t1
		to: #t2.
	allocator coalesceNode: movet2t3.
	allocator coalesceNode: movet1t2.	
	self verifyAllocator.
		
	"The check is that it didn't raise an error. If it fails then it will try and add to
	an empty array."
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 7/25/2004 17:09'!
testCoalesceSelfMove
	"Tests that moving a node onto itself is correctly handled. This does not remove a register,
	it just removes the move. It was a no-op move before we started processing."
	|  move |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t1) 
			(mov t1 t3) )).
	move := allocator 
		getMoveFrom: #t1
		to: #t1.
		
	allocator coalesceNode: move.
	self verifyAllocator. "Check everything is OK"
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:33'!
testCoalesceSimple
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (add t1 t2) )).

	allocator coalesce.

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 1].
	self should: [allocator spillWorklist isEmpty].
	self should: [allocator coalescedMoves size = 1].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 21:06'!
testCoalesceSimpleInterferes
	self createAndPrepareAllocator: #(#	(#block 1 (mov 1 t2) (add t1 t2) (mov t2 t3) (mov 1 t4)  (add t4 t3) )).
	allocator coalesce.

	self 
		verifyInterferes: #t1
		with: #t3.
	self 
		verifyInterferes: #t3
		with: #t1.
	self should: [(self nodeNamed: #t2) currentSize = 0].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 11/9/2002 15:34'!
testCoalesceSpillMove
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (add t1 t2) )).

	allocator spillMove.

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist isEmpty].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 7/25/2004 16:06'!
testCoalesceToPhysicalRegister
	"Tests that when we merge a move with a precoloured node the new merged node is
	also precoloured."
	|  move |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 eax)  )).
			
	move := allocator 
		getMoveFrom: #t1
		to: #eax.
		
	allocator coalesceNode: move.
	self verifyAllocator. "Check everything is OK"
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:34'!
testCoalesceTooManyHighDegreeNodes
	self createAndPrepareAllocator: #(	(#block 1 (mov t1 t8) (add t1 t2) (add t3 t4) (add t5 t6) (add t1 t7) )).

	allocator coalesce.

	self should: [allocator moveWorklist size = 1].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 4/24/2004 13:14'!
testCoalesceTwoInstructions
	self createAndPrepareAllocator: #(#	(#block 1 (mov t3 t1) (mov t1 t2) (add t1 t2) )).

	allocator coalesce.
	allocator coalesce.

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 1].
	self should: [allocator spillWorklist isEmpty].
	self should: [allocator coalescedMoves size = 2].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:03'!
testFreezeMoveWatchingCounts
	"Tests that we handle coalsecing a move to a register that has already been
	coalesced away."
	|  movet1t2 movet2t3 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t2)
			(mov t2 t3) )).

	
	movet1t2 := allocator 
		getMoveFrom: #t1 
		to: #t2.
	movet2t3 := allocator 
		getMoveFrom: #t2
		to: #t3.
		
	allocator coalesceNode: movet2t3.
	self assert: (self nodeNamed: #t3) currentMoves = 1.
	
	allocator freezeMove: movet1t2.
	self assert: (self nodeNamed: #t3) currentMoves = 0.
	self verifyAllocator.
	
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 6/24/2003 12:36'!
testFromSpecialRegister
	self createAllocator: #(#(#block 1 #(mov ebp t1) )).
	allocator run.
	self should: [allocator intermediateForm = #(#(#block 1 #(mov ebp #eax) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:50'!
testPush
	self createAllocator: #((block 1 (push t1))).

	allocator assignRegisters: (self createAssignments: #((t1 eax))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (push eax) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Create Statistics' stamp: 'wbk 8/2/2004 20:58'!
testRegisterCountsBasic
	self createAndPrepareAllocator: #((block 1 (mov 1 t1))).
	
	self assert: (self nodeNamed: #t1) registerCount = 1.
	
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Create Statistics' stamp: 'wbk 8/2/2004 21:06'!
testRegisterCountsBasic2
	self createAndPrepareAllocator: #((block 1 (mov t1 t1))).
	
	self assert: (self nodeNamed: #t1) registerCount = 2.
	
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 3/4/2005 15:16'!
testSelectDoNotSpill
	self createAllocator: 
		#(#(#block 1 
			#(#mov 8 #t3) 
			#(#add #ebp #t3) 
			#(#mov #(#t3) #t4) 
			#(#mov #(#t4) #t5) 
			#(#mov #t5 #t1) 
			#(#mov 8 #t6) 
			#(#add #t1 #t6) 
			#(#mov #(#t6) #t7) 
			#(#mov 1 #t8) 
			#(#add #t7 #t8) 
			#(#mov #t8 #t2) 
			#(#mov 8 #t9) 
			#(#add #t1 #t9) 
			#(#mov #t2 #(#t9)) 
			#(#mov 4 #t10) 
			#(#mul #t2 #t10) 
			#(#mov #t10 #t11) 
			#(#add #t1 #t11) 
			#(#mov 24 #t12) 
			#(#add #t11 #t12) 
			#(#mov 85 #(#t12)) 
			#(#ret))).
	allocator analyseLiveness.
	allocator buildInterferenceGraph.
	allocator registerStack: #(#t9 #t12 #t11 #t6 #t3 #t10 #t7 #t4 #t2 #t1 #t5 #t8).
	allocator select.
	self should: [allocator spiltRegisters size = 0].
	self verifyAllocator! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 3/4/2005 15:16'!
testSelectDoesntMarkAsSpilled
	self createAllocator: #(#(#block 1 #(#mov 8 #t3) #(#add #ebp #t3) #(#mov #(#t3) #t4) #(#mov #(#t4) #t5) #(#mov #t5 #t1) #(#mov 8 #t6) #(#add #t1 #t6) #(#mov #(#t6) #t7) #(#mov 1 #t8) #(#add #t7 #t8) #(#mov #t8 #t2) #(#mov 8 #t9) #(#add #t1 #t9) #(#mov #t2 #(#t9)) #(#mov 4 #t10) #(#mul #t2 #t10) #(#mov #t10 #t11) #(#add #t1 #t11) #(#mov 24 #t12) #(#add #t11 #t12) #(#mov 85 #(#t12)) #(#ret))).
	allocator analyseLiveness.
	allocator buildInterferenceGraph.
	allocator registerStack: #(#t9 #t4 #t6 #t8 #t7 #t2 #t11 #t12 #t1 #t10 #t3 #t5).
	allocator select.
	self verifyNoSpiltRegisters: allocator.
	self verifyAllocator! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 11/9/2002 15:51'!
testSelectSimple
	| assignments t1 t2 |
	self createAndPrepareAllocator: #(#(#block 1 #(#mov 1 #t1) #(#mov 2 #t2) #(#add #t1 #t2))).

	allocator simplify.
	allocator select.

	assignments := allocator registerAssignments.
	t1 := assignments at: (machine registerNamed: #t1).
	t2 := assignments at: (machine registerNamed: #t2).
	self should: [t1 isMachineRegister].
	self should: [t2 isMachineRegister].
	self should: [t1 ~= t2].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 5/2/2004 18:11'!
testSelectWithPrecolouredRegisters
	| assignments t1 eax t2 |
	self createAndPrepareAllocator: #(#(#block 1 (mov 1 t2) #(#mov 2 #eax) #(#mov 1 #t1)    #(#add #eax #t1 ) (add t2 eax) )).

	allocator simplify.
	allocator registerStack: #(t2 eax t1). "Just to make the test deterministic"
	allocator select.

	assignments := allocator registerAssignments.
	t1 := assignments at: (machine registerNamed: #t1).
	t2 := assignments at: (machine registerNamed: #t2).
	eax := assignments at: (machine registerNamed: #eax).
	self assert: eax name = #eax. "eax must be assigned to eax otherwise after register reallocation
									we will have clashes"
	self assert: t1 ~= eax.
	self assert: t2 ~= eax.
	self assert: t1 ~= t2.
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 11/9/2002 15:51'!
testSelectWithSpilling
	self createAllocator: #((block 1
									(add t1 t2) (add t3 t4) (add t5 t6) (add t6 t7) 
									(add t3 t5) (add t5 t1)  (jmp block1) )
						(block 2 (add t8 t5) )).

	allocator analyseLiveness.
	allocator buildInterferenceGraph.
	allocator registerStack: #(  t1 t2 t3 t4 t5 t6 t7 t8).
	(allocator registerStack at: 1) markAsSpilled.

	allocator select.

	self should: [(allocator spiltRegisters at: 1) name = #t1].
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 8/2/2004 21:18'!
testSelectWithSpills
	self createAndPrepareAllocator: #((block 1
									(add t1 t2) (add t3 t4) (add t5 t6) (add t6 t7) 
									(add t3 t5) (add t5 t1)  (jmp block1) )
						(block 2 (add t8 t5) )).

	allocator simplifyAndSpill.
	allocator select.

	self should: [allocator spiltRegisters size = 1].
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 11/7/2002 13:57'!
testSimpleColouringRegisterAllocation
	| source assignments t1 t2 |
	machine := MachineX86 new.
	source := MedMethod 
		createAssembly: #((block 1 (mov 1 t1) (mov 2 t2) (add t1 t2)))
		for: machine.
	allocator := ColouringRegisterAllocator
		on: source 
		for: machine.

	assignments := allocator registerAssignments.

	t1 := (assignments at: (machine registerNamed: #t1)).
	t2 := (assignments at: (machine registerNamed: #t2)).
	self should: [t1 isMachineRegister].
	self should: [t2 isMachineRegister].
	self should: [t1 ~= t2].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 8/2/2004 21:17'!
testSimplifyAndSpill
	self createAndPrepareAllocator: #((block 1
										(add t1 t2) (add t3 t4) (add t5 t6) (add t6 t7) 
										(add t3 t5) (add t5 t1)  (jmp block1) )
									(block 2 (add t8 t5) )).

	allocator simplifyAndSpill.

	self should: [allocator stackSize = 8].
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 11/9/2002 15:36'!
testSimplifyForSpill
	self createAndPrepareAllocator: #((block 1
									(add t1 t2) (add t3 t4) (add t5 t6) (add t6 t7) 
									(add t3 t5) (add t5 t1)  (jmp block1) )
						(block 2 (add t8 t5) )).

	allocator simplify.

	self should: [allocator unallocated size = 7].
	self should: [allocator stackIncludes: (machine registerNamed: #t8)].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 11/9/2002 15:36'!
testSimplifyPickRegisterToSpill
	self createAndPrepareAllocator:  
		#(	#(#block 1 #(#add #t1 #t2) #(#add #t3 #t4) #(#add #t5 #t6) #(#add #t6 #t7) #(#add #t3 #t5) 
						#(#add #t5 #t1) #(#jmp #block1)) 
			#(#block 2 #(#add #t8 #t5))).

	allocator simplify.

	self should: [allocator stackSize = 1].
	allocator spillRegister.
	self should: [allocator stackSize = 2].
	self should: [(allocator registerStack at: 2) isSpilled].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 3/5/2005 22:37'!
testSimplifyPrecolouredNode
	self createAndPrepareAllocator: #(#(#block 1 #(#mov 1 #eax) #(#mov 2 #t2) #(#add #eax #t2))).

	(self nodeNamed: #eax) simplify.

	self assert: (self nodeNamed: #t2) currentEdges size = 1.
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 11/9/2002 15:52'!
testSimplifySimple
	self createAndPrepareAllocator: #(#(#block 1 #(#mov 1 #t1) #(#mov 2 #t2) #(#add #t1 #t2))).

	allocator simplify.

	self should: [allocator stackIncludes: (machine registerNamed: #t1)].
	self should: [allocator stackIncludes: (machine registerNamed: #t2)].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 12/18/2004 00:05'!
testSpillCurrentContext
	self createAllocator: #(#(#block 1 #(#mov #currentContext 1))).
	allocator spiltRegisters: {machine registerNamed: #currentContext}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1  #(#mov (-16 ebp) currentContextv1) #(#mov currentContextv1 1)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:03'!
testSpillKeepsBlocksInOrder
	self createAllocator: #((block 4 (jz block2) ) (block 1 ) (block 2 (jmp block3) ) (block 3)).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 4 (jz block2) ) (block 1 ) (block 2 (jmp block3) ) (block 3))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:03'!
testSpillMultipleRanges
	self createAllocator: #(#(#block 1 #(#mov 1 #t1) #(#mov 2 #t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 1  (mov 1 t1v1) (mov t1v1 (-16 ebp)) 
							(mov 2 t1v2) (mov t1v2 (-16 ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:04'!
testSpillMultipleSpilling
	self createAllocator: #(#(#block 1 #(#mov #t1 #t2))).
	allocator spiltRegisters:
		{machine registerNamed: #t1.
		machine registerNamed: #t2}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 #(#mov #(-16 #ebp) #t1v1)  #(#mov #t1v1 #t2v1)
							  #(#mov #t2v1 #(-20 #ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:03'!
testSpillReadArithmatic
	self createAllocator: #(#(#block 1 #(#add t1 1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 #(#mov #(-16 #ebp) #t1v1) #(#add  #t1v1 1) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:03'!
testSpillSimple
	self createAllocator: #(#(#block 1 #(#mov 1 #t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1  #(#mov 1 #t1v1) #(#mov #t1v1 #(-16 #ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:05'!
testSpillWithJump
	self createAllocator: #(#(#block 1 #(#jmp #block2)) #(#block 2)).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[(allocator source blockAt: 1 instructionAt: 1) target =
				(allocator source blockNumbered: 2)].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:02'!
testSpillWriteArithmatic
	self createAllocator: #(#(#block 1 #(#add 1 t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 
						#(#mov #(-16 #ebp) #t1v1) 
						#(#add  1 #t1v1) 
						(mov t1v1 (-16 ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:02'!
testSpillWriteIndirectArithmatic
	self createAllocator: #(#(#block 1 #(#add 1 (t1)))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 
						#(#mov #(-16 #ebp) #t1v1) 
						#(#add  1 (#t1v1)) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:06'!
testSpillWriteIndirectArithmatic2
	self createAllocator: #(#(#block 1 #(#add (t1) 1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 
						#(#mov #(-16 #ebp) #t1v1) 
						#(#add (#t1v1) 1) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:02'!
testSpillWriteIndirectMove
	self createAllocator: #(#(#block 1 #(#mov 1 (t1)))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 1 
						(mov (-16 ebp) t1v1) 
						(mov 1 (t1v1)) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:02'!
testSpillWriteIndirectMove2
	self createAllocator: #(#(#block 1  #(#mov (t1) 1 ))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 1 
						(mov (-16 ebp) t1v1) 
						(mov (t1v1) 1 ) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:02'!
testSpilledVariablesNotSpillable
	self createAllocator: #(#(#block 1 #(#mov 1 #t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self assert: (allocator hasSpill:  (machine registerNamed: #t1v1)).
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 6/24/2003 13:28'!
testToSpecialRegister
	self createAllocator: #((block 1 (mov t1 ebp) )).
	allocator run.
	self should: [allocator intermediateForm = #((block 1 (mov eax ebp) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 11/3/2002 19:14'!
usesAllAvailibleRegisters: anAllocator
	| used |
	used := Set new.
	anAllocator result registersDo: 
		[:each| (machine isSpecialRegister: each) ifFalse: [used add: each]].
	^ used size = 6	! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 7/25/2004 15:51'!
verifyAllocator
	allocator verify.! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 5/22/2004 21:52'!
verifyAllocatorMoveCounts
	allocator verify.! !

!ColouringRegisterAllocatorTests methodsFor: 'Interference Graph' stamp: 'wbk 3/13/2003 14:40'!
verifyInterferes: firstString with: secondString
	self should:
		[allocator
			interferes: (machine registerNamed: firstString)
			with: (machine registerNamed: secondString)].! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 11/3/2002 19:14'!
verifyNoSpiltRegisters: allocator
	allocator registerStack do: [:each| self shouldnt: [each isSpilled]]! !

!ExuperyTests methodsFor: 'Checking Methods' stamp: 'wbk 3/13/2003 13:47'!
stringShould: aString contain: aSubString
	self should: 
		[(aString 
			indexOfSubCollection: aSubString
			startingAt: 1) ~= 0]! !

ExuperyTests subclass: #InstructionSelectionTests
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!InstructionSelectionTests methodsFor: 'Support' stamp: 'wbk 3/13/2003 14:15'!
selectInstructions: anArray
	| med machine| 
	machine := MachineX86 new.
	med := MedMethod
		createIntermediate: anArray
		for: machine.
	selector := InstructionSelector 
		on: med
		for: machine.
	^ selector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 1/20/2005 21:37'!
testAddressOf
	selector := self selectInstructions: #((block 1 (mov (addressOf block2) t1) )).
	self should: [selector writtenResult = #((block 1 (mov (addressOf block2) t1) ) (block 2))].
	self should: 
		[(selector result 
			blockAt: 1
			instructionAt: 1) class = MedMov].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 20:59'!
testArithmaticSelection
	selector := self selectInstructions: #((block 1 (add 1 2) )).
	self should: [selector writtenResult = #((block 1  (mov 2 t1) (mov t1 t2) (add 1 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 20:59'!
testCall
	selector := self selectInstructions: #(#(#block 1 #(call 1234) )).
	self should: 
		[selector writtenResult = #(#(#block 1 #(call 1234) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 1/15/2005 13:06'!
testCopyAlignedFlag
	| med machine| 
	machine := MachineX86 new.
	med := MedMethod
		createIntermediate: #((block 1) (block 2))
		for: machine.
	(med blockAt: 2) makeAligned.
	selector := InstructionSelector 
		on: med
		for: machine.
	self assert: (selector result blockAt: 1) isAligned not.
	self assert: (selector result blockAt: 2) isAligned.
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:00'!
testDivide
	selector := self 
				selectInstructions: #(#(#block 1 (mov #(div t1 t2 t3) t4) )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 
						(mov t1 eax) 
						(cdq)    "Sign extends EAX into EDX:EAX"
						(div t2) "This is an X86 division, the rest of the arguments are in EAX:EDX"
						(mov eax t5) 
						(mov edx t3) 
						(mov t5 t4) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:00'!
testDivide2
	selector := self 
				selectInstructions: #(#(#block 1 (mov #(div (add 1 t1) (add 2 t2) t3) t4) )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 
						(mov t1 t6)
						(add 1 t6)
						(mov t2 t7)
						(add 2 t7)
						(mov t6 eax) 
						(cdq) 
						(div t7) "This is an X86 division, the rest of the arguments are in EAX:EDX"
						(mov eax t5) 
						(mov edx t3) 
						(mov t5 t4) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:00'!
testIPush
	selector := self selectInstructions: #(#(#block 1 #(push eax) )).
	self should: 
		[selector writtenResult = #(#(#block 1 #(push eax) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:00'!
testIndirectConstant
	selector := self 
				selectInstructions: #(#(#block 1 #(#mov #(#mem #falseObj) 't1') )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 (mov falseObj t2) #(#mov (t2) t1) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:01'!
testInstructionArithmaticWithLeftAddressing
	selector := self 
				selectInstructions: #(#(#block 1 #(#add #(#mem #(#add #ebp 8)) #eax))).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 #(#mov #eax #t1) #(#add #(8 #ebp) #t1)))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:01'!
testInstructionArithmaticWithRightAddressing
	selector := self 
				selectInstructions: #(#(#block 1 #(#add #eax #(#mem #(#add #ebp 8)) ))).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 #(#mov (8 ebp) #t1) (mov t1 t2) #(#add #eax t2) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:01'!
testInstructionMemWithAddressing
	selector := self selectInstructions: #((block 1 (mem (add ebp 8) ) )).
	self should: [selector writtenResult = #((block 1 (mov (8 ebp) t1) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:01'!
testInstructionMoveWithBothAddressing
	selector := self 
				selectInstructions: #(#(#block 1 (mov (mem eax) (mem (add ebp 8))) )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 (mov (eax) t1) #(#mov t1 (8 ebp)) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionMoveWithLeftAddressing
	selector := self selectInstructions: #(#(#block 1 #(#mov #(#mem #(#add #ebp 8)) #eax))).
	self should: [selector writtenResult = #(#(#block 1 #(#mov #(8 #ebp) #eax)))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionMoveWithRightAddressing
	selector := self 
				selectInstructions: #(#(#block 1 (mov eax (mem (add ebp 8))) )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 #(#mov eax (8 ebp)) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:18'!
testInstructionSelection
	selector := self selectInstructions: #(#(#block 1 #(#mov #(#add 1 2) #eax) #(#ret))).
	self should: 
		[selector writtenResult = 
			#(#(#block 1 
				#(#mov 2 #t1) 
				#(#mov #t1 #t2) 
				#(#add 1 #t2) 
				#(#mov #t2 #eax) 
				#(#ret)))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionSelectionForBasicMem
	selector := self selectInstructions: #((block 1 (mov (mem ebp) eax))).
	self should: [selector writtenResult = #((block 1 (mov (ebp) eax) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionSelectionForMemTarget
	selector := self selectInstructions: #((block 1 (mov eax (mem t1)))).
	self should: [selector writtenResult = #((block 1 (mov eax (t1)) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/4/2005 21:32'!
testJumpComputed
	selector := self selectInstructions: #((block 1 (jmp (sub t1 1)) )).
	self should: [selector writtenResult = #((block 1 (mov t1 t2) (sub 1 t2) (jmp t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:03'!
testJumpInsideEpressionSelection
	selector := self selectInstructions: #((block 1 (mov (jo block2 (add 1 2)) t2) ) (block 2 (mov 2 t2) )).
	self should: 
		[selector writtenResult = 
		#((block 1  (mov 2 t3) (mov t3 t4) (add 1 t4) (jo block2) (mov t4 t2)) 
			(block 2 (mov 2 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:03'!
testJumpInstructionSelection
	selector := self selectInstructions: #((block 1 (jo block2 (mov 1 t1)) ) (block 2 (mov 2 t2) )).
	self should: [selector writtenResult = #((block 1 (mov 1 t1) (jo block2) ) (block 2 (mov 2 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:03'!
testJumpJmpInstructionSelection
	"Tests that we can generate a simple nonconditional jump (jmp)"
	selector := self selectInstructions: #((block 1 (jmp block2 ) ) (block 2  )).
	self should: [selector writtenResult = #((block 1 (jmp block2) ) (block 2 ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:03'!
testJumpSelectsJumpClass
	selector := self selectInstructions: #((block 1 (jmp block1) )).
	self should: [selector writtenResult = #((block 1 (jmp block1) ))].
	self should: 
		[(selector result 
			blockAt: 1
			instructionAt: 1) class = MedJump].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:04'!
testMovSelectsMovClass
	selector := self selectInstructions: #((block 1 (mov 1 t1) )).
	self should: [selector writtenResult = #((block 1 (mov 1 t1) ))].
	self should: 
		[(selector result 
			blockAt: 1
			instructionAt: 1) class = MedMov].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:04'!
testMovToMemSelectsMovClass
	selector := self selectInstructions: #((block 1 (mov 1 (mem t1)) )).
	self should: [selector writtenResult = #((block 1 (mov 1 (t1)) ))].
	self should: 
		[(selector result 
			blockAt: 1
			instructionAt: 1) class = MedMov].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 12/25/2004 22:49'!
testMultiplyLiteral
	selector := self selectInstructions: #((block 1 (mul 42 t1) )).
	self should: [selector writtenResult = #((block 1  (mov 42 t2) (mov t1 t3) (mul t2 t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:04'!
testNegRegister
	selector := self selectInstructions: #((block 1 (neg t1) )).
	self should: [selector writtenResult = #((block 1 (mov t1 t2) (neg t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:04'!
testNegRegister2
	selector := self selectInstructions: #((block 1 (mov (neg t1) t2) )).
	self should: [selector writtenResult = #((block 1 (mov t1 t3) (neg t3) (mov t3 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/26/2005 10:18'!
testPic
	selector := self selectInstructions: #(#(#block 1 #(pic ecx) )).
	self should: 
		[selector writtenResult = #(#(#block 1 #(pic ecx) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:56'!
testPop
	selector := self selectInstructions: #(#(#block 1 #(pop eax) )).
	self should: 
		[selector writtenResult = #(#(#block 1 #(pop eax) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:05'!
testPrologBlock
	selector := self selectInstructions: #((block 3) (block 1 ) (block 2) ).
	self should: [selector writtenResult = #((block 3) (block 1 ) (block 2) )].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:05'!
testPushExpression
	selector := self selectInstructions: #(#(#block 1 #(push (add 1 2)) )).
	self should: 
		[selector writtenResult = #(#(#block 1 (mov 2 t1) (mov t1 t2) (add 1 t2) #(push t2) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:10'!
testReturnSelectsRetClass
	selector := self selectInstructions: #(#(#block 1 #(#ret))).
	self should: [selector writtenResult = #(#(#block 1 #(#ret)))].
	self should: 
			[(selector result 
				blockAt: 1
				instructionAt: 1) class = MedRet].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2004 21:36'!
testSalConstant
	selector := self selectInstructions: #((block 1 (sal  t2 1) )).
	self should: [selector writtenResult = #((block 1 (mov t2 t3)  (sal 1 t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2004 21:36'!
testSalRegister
	selector := self selectInstructions: #((block 1 (sal t2 t1 ) )).
	self should: [selector writtenResult = #((block 1 (mov t1 ecx) (mov t2 t3)  (sal ecx t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2004 20:53'!
testSarConstant
	selector := self selectInstructions: #((block 1 (sar t2 1) )).
	self should: [selector writtenResult = #((block 1 (mov t2 t3)  (sar 1 t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2004 20:54'!
testSarRegister
	selector := self selectInstructions: #((block 1 (sar t2  t1 ) )).
	self should: [selector writtenResult = #((block 1 (mov t1 ecx) (mov t2 t3)  (sar ecx t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2005 23:23'!
testSideEffectingAdd
	selector := self selectInstructions: #((block 1 (mov (add t1 20) t1) )).
	self should: [selector writtenResult = #((block 1 (add 20 t1) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/6/2004 20:16'!
testSub
	"This test is here because subtracts  need their arguments reversed for x86 assembly, this is
	because med uses normal ordering and the assembly is in AT&T order with two arguments"
	
	selector := self selectInstructions: #((block 1 (sub 10 2) )).
	self should: [selector writtenResult = #((block 1  (mov 10 t1) (mov t1 t2) (sub 2 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Support' stamp: 'wbk 3/13/2003 14:15'!
verifySelector
	selector result instructionsDo:
		[:each| each name = #mov ifTrue: [self should: [each class = MedMov]]]! !

ExuperyTests subclass: #InterferenceGraphGenerationTests
	instanceVariableNames: 'allocator machine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!InterferenceGraphGenerationTests methodsFor: 'Misc' stamp: 'wbk 6/23/2003 13:22'!
prepare: anArray
	|source |
	machine := MachineX86 new.
	source := MedMethod 
		createAssembly: anArray
		for: machine.	
	allocator := ColouringRegisterAllocator new
		initialiseSource: source 
		machine: machine.
	allocator analyseLiveness.! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 7/5/2003 15:49'!
testAddDoesntInterfereWithSelf
	"A register add shouldn't interfer with itself,"
	self prepare: #((block 1 (add 1 t1) (mov (t1) t2))).
	allocator buildInterferenceGraph.

	"Test the registers are allocated"
	(allocator interferenceNode: (machine registerNamed: #t1)).
	(allocator interferenceNode: (machine registerNamed: #t2)).
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 2/2/2004 21:02'!
testCDQ

	self prepare: #((block 1 
				(cdq)
				(add t1 t2)
				(add t3 t4))).
	allocator buildInterferenceGraph.
	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #edx)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #edx)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t3)
			with: (machine registerNamed: #edx)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/24/2003 11:34'!
testCall
	self prepare: #((block 1 (call 12345) )).
	allocator buildInterferenceGraph.
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 7/5/2003 14:39'!
testCallInterference
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (call t1) (call t2) )).
	allocator buildInterferenceGraph.

	self assert: (allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2))! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 1/31/2004 14:41'!
testDivide
	"This test checks that when building the interference graph we add edges from all
	live variables in live-out to both eax and edx Eax and edx are the two registers set in 
	the divide instruction."
	self prepare: #((block 1 
				(div t1)
				(mov eax t2)
				(mov edx t3)
				(add t1 t1))).
	allocator buildInterferenceGraph.
	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #eax)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #edx)].
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #eax)
			with: (machine registerNamed: #t2)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/28/2004 22:42'!
testDoubleRegisterInterferance
	self prepare: #((block 1 (mov 1 t2) (add 1 t2) (mov t2 1)  (mov 1 t4) (mov 1 t3) 
							(add t2 t4) (add t3 t4) (mov t4 1) )).
	allocator buildInterferenceGraph.

	self assert:
		(allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t3)).
	self assert:
		(allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t4)).
	self assert:
		(allocator
			interferes: (machine registerNamed: #t3)
			with: (machine registerNamed: #t4)).! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:23'!
testJumpInterferance
	self prepare: #((block 1 (mov 1 t3) (mov 1 t1) (mov 2 t2) (add t1 t2) (jmp block2) ) 
			(block 2 (add t3 t2) ) ).
	allocator buildInterferenceGraph.

	self should:
		[allocator
			interferes: (machine registerNamed: #t3)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:24'!
testMachineRegisterInterferance
	"Reproduces a bug, ebp wasn't being placed in the the interference graph
	throwing it into the debugger"
	"Interestingly it is only created if ebp is an indirect argument"
	self prepare: #((block 1 (mov t1 t2) (mov (ebp) t6) )).
	allocator buildInterferenceGraph.! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:24'!
testMovFromIndirectRegisterInterferance
	"This test has no register interference but it still needs to allocate registers"
	self prepare: #((block 1 (mov 1 t1) (mov (t1) t2))).
	allocator buildInterferenceGraph.

	"Test the registers are allocated"
	(allocator interferenceNode: (machine registerNamed: #t1)).
	(allocator interferenceNode: (machine registerNamed: #t2)).
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:25'!
testMovRegisterInterferance
	self prepare: #((block 1 (mov 1 t1) (mov t1 t2) (add t1 t1))).
	allocator buildInterferenceGraph.

	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:25'!
testMovToIndirectRegisterInterferance
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (mov t1 (t2)))).
	allocator buildInterferenceGraph.

	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 20:17'!
testNegate

	self prepare: #((block 1
					(add t1 t1) 
					(neg t2)
					(mov t3 t4) )).
	allocator buildInterferenceGraph.
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t3)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 2/26/2005 18:09'!
testPic
	self prepare: #((block 1 (pic eax) )).
	allocator buildInterferenceGraph.
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 16:09'!
testPop

	self prepare: #((block 1
					(add t1 t1) 
					(pop t2)
					(mov t3 t4) )).
	allocator buildInterferenceGraph.
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t3)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/24/2003 10:28'!
testPush
	self prepare: #((block 1 (push 1) )).
	allocator buildInterferenceGraph.
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 7/5/2003 14:38'!
testPushInterference
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (push t1)  (push t2) )).
	allocator buildInterferenceGraph.

	self assert: (allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2))
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 16:27'!
testRet
	self prepare: #(#(#block 1 #(#mov 1 #eax) (mov 1 t1) #(#add #t1 #t1) #(#ret))).
	allocator buildInterferenceGraph.
	self should: 
			[allocator 
				interferes: (machine registerNamed: #t1)
				with: (machine registerNamed: #eax)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:18'!
testRetInterferance
	self prepare: #(#(#block 1 #(#mov 1 #t1) #(#mov 2 #t2) #(#add #t1 #t2) #(#ret))).
	allocator buildInterferenceGraph.
	self should: 
			[allocator 
				interferes: (machine registerNamed: #t1)
				with: (machine registerNamed: #t2)].
	self should: 
			[allocator 
				interferes: (machine registerNamed: #t2)
				with: (machine registerNamed: #t1)]! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:18'!
testReturn42Interferance
	self prepare: #(#(#block 1 #(#mov 8 't3') #(#add #ebp 't3') #(#mov #('t3') 't4') #(#mov #('t4') 't5') #(#mov 't5' 't1') #(#mov 8 't6') #(#add 't1' 't6') #(#mov #('t6') 't7') #(#mov 1 't8') #(#add 't7' 't8') #(#mov 't8' 't2') #(#mov 8 't9') #(#add 't1' 't9') #(#mov 't2' #('t9')) #(#mov 4 't10') #(#mul 't2' 't10') #(#mov 't10' 't11') #(#add 't1' 't11') #(#mov 24 't12') #(#add 't11' 't12') #(#mov 85 #('t12')) #(#ret))).
	allocator buildInterferenceGraph.
	self verifyInterferenceGraph.
	self 
		verifyDoesntInterfere: #t3
		with: #t4! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:27'!
testSimpleJumpRegisterInterferance
	self prepare: #((block 1 (jz block2) (jo block2) (jmp block2) (jg block2) (je block2) ) (block 2) ).
	allocator buildInterferenceGraph.
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:29'!
testSingleRegisterInterferance
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (add t1 t2))).
	allocator buildInterferenceGraph.

	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:29'!
testSpecialRegisterInterferance
	self prepare: #((block 1 (add ebp t1) )).
	allocator buildInterferenceGraph.

	self shouldnt:
		[allocator interferenceGraph includesKey: (machine registerNamed: #ebp)].! !

!InterferenceGraphGenerationTests methodsFor: 'Verification Methods' stamp: 'wbk 3/13/2003 14:26'!
verifyDoesntInterfere: firstString with: secondString
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: firstString)
			with: (machine registerNamed: secondString)].! !

!InterferenceGraphGenerationTests methodsFor: 'Verification Methods' stamp: 'wbk 3/13/2003 14:26'!
verifyInterferenceGraph
	allocator interferenceGraph do: 
		[:each| self should: [ each register isRegister]].! !

!InterferenceGraphGenerationTests methodsFor: 'Verification Methods' stamp: 'wbk 3/13/2003 14:26'!
verifyInterferes: firstString with: secondString
	self should:
		[allocator
			interferes: (machine registerNamed: firstString)
			with: (machine registerNamed: secondString)].! !

ExuperyTests subclass: #IntermediateCopierTests
	instanceVariableNames: 'machine source result emitter mockEmitter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!IntermediateCopierTests methodsFor: 'Misc' stamp: 'wbk 12/21/2004 12:39'!
setUp
	mockEmitter := MockIntermediateEmitter new.
	machine := MachineX86 new.! !

!IntermediateCopierTests methodsFor: 'Misc' stamp: 'wbk 12/21/2004 12:44'!
simplifyFullyMocked
	| simplifier |
	machine := MachineX86 new.
	simplifier := self operationClass
				from: source
				emitter: mockEmitter.
	result := simplifier runBasic! !

!IntermediateCopierTests methodsFor: 'Misc' stamp: 'wbk 12/21/2004 13:36'!
verify
	| expressions |
	"Verify that the new result is not accidentally sharing nodes from the source. This
	can be a very fertile source of bugs."
	self assert: source ~= result.
	expressions := Set new.
	source expressionsDo: [:each| expressions add: each].
	result expressionsDo: [:each| self assert: (expressions includes: each) not]! !

IntermediateCopierTests subclass: #IntermediateSimplifierTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 12/21/2004 12:43'!
operationClass
	^ IntermediateSimplifier! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 9/19/2004 17:46'!
simplify
	| simplifer |
	emitter := IntermediateEmitter 
		machine: machine
		jumpTargets: #()
		result: (MedMethod from: source).
	simplifer := IntermediateSimplifier 
		from: source
		emitter: emitter.
	result := simplifer runBasic! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 9/19/2004 17:46'!
simplifyMocked
	| simplifier |
	machine := MachineX86 new.
	emitter := IntermediateEmitter 
				machine: machine
				jumpTargets: #().
	emitter emitter: mockEmitter.
	simplifier := IntermediateSimplifier 
				from: source
				emitter: emitter.
	result := simplifier runBasic.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:31'!
testAdd
	source := MedMethod 
				createIntermediate: #(#(#block 1 #(#add #(#mov 1 1) #(#mov 2 2))))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 #(#add #(#mov 1 1) #(#mov 2 2)))).
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 22:31'!
testAtElementAddress
	source := MedMethod 
				createIntermediate: 
					#((block 1  (atElementAddress 42 1 block2 0 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedAtElementAddress 42 1 block2 0 )) 
			).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 22:33'!
testAtElementAddressNested
	source := MedMethod 
				createIntermediate: 
					#((block 1  (atElementAddress (add 42 42) (add 1 1) block2 0 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedAtElementAddress (add 42 42) (add 1 1) block2 0 )) 
			).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/13/2004 22:36'!
testAtPut
	source := MedMethod 
				createIntermediate: 
					#((block 1  (atPut receiver location value block2 0) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitBeRootIfNeeded receiver value)
				(mov value (emitExpandedAtElementAddress receiver location block2 32)) ) 
			).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/13/2004 22:32'!
testAtPutNested
	source := MedMethod 
				createIntermediate: 
					#((block 1  (atPut (add 1 1) (add 2 2) (add 3 3) block2 0) ))
				for: machine.			
	
	self simplify.
	

	self verify. 
! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 17:11'!
testBitShift
	source := MedMethod 
				createIntermediate: #(#(#block 1 (bitShift 13 5 block2)))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(	(block 1 
				(mov 13 t2)
				(mov 5 t3)
				(jl block3 (sub t3 0)) 
				(jl block2 (sub 31 t3))
				(mov (sal t2 t3) t1) 
				(jnz block2 (sub t2 (sar t1 t3))) 
				(jmp block4))
			(block 2) "The failure block"
			(block 3 
				(jl block2 (sub t3 -31))
				(mov (sar  t2  (neg t3)) t1) 
				(jmp block4)) 
			#(#block 4)).	"t2 is the remander".
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 17:14'!
testBitShiftNested
	source := MedMethod 
				createIntermediate: #(#(#block 1 (bitShift (add 13 13) (sub 5 5) block2)))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(	(block 1 
				(mov (add 13 13) t2)
				(mov (sub 5 5) t3)
				(jl block3 (sub t3 0)) 
				(jl block2 (sub 31 t3))
				(mov (sal t2 t3) t1) 
				(jnz block2 (sub t2 (sar t1 t3))) 
				(jmp block4))
			(block 2) "The failure block"
			(block 3 
				(jl block2 (sub t3 -31))
				(mov (sar  t2  (neg t3)) t1) 
				(jmp block4)) 
			#(#block 4)).	"t2 is the remander".
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:31'!
testCall
	source := MedMethod 
				createIntermediate: #(#(#block 1 (call (add 1 1))))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 (call (add 1 1)))).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:59'!
testConvertBoolean
	source _ MedMethod 
				createIntermediate: #(#(#block 1 #(#convertBoolean #jg #anExpression)))
				for: machine.
	mockEmitter expectEmission: #(#(#block1 #(#jg #block2 #anExpression) #(#mov #(#trueAddress) #t1) #(#jmp #block3)) #(#block2 #(#mov #(#falseAddress) #t1) #(#jmp #block3)) #(#block3)).
	self simplifyMocked.
	self verify.
	mockEmitter verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 9/22/2004 20:17'!
testCopyNumberOfTemporaries
	source := MedMethod new.
	source numberOfTemporaries: 42.
	
	self simplify.
	
	self assert: result numberOfTemporaries = 42.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 9/19/2004 18:07'!
testDeconvertBoolean
	source := MedMethod 
				createIntermediate: 
					#((block 1  (deconvertBoolean falseObj anExpression block2 1 0) )
						(block 2 ))
				for: machine.
	mockEmitter expectEmission:
		#( 	(block1			
				(je block2 (sub anExpression (mem falseObj) ))
				(jne block3 (sub anExpression (mem trueObj)))
				(jmp block4))
			(block2) 
			(block3 
				(emitExpandedSend (emitSpecialObject 25) anExpression)
				(jmp block4))
			(block4) ).
	
	self simplifyMocked.

	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:31'!
testDivide
	source := MedMethod 
		createIntermediate: 
			#(#(#block 1 #(#div#(#mov 1 1) #(#mov 2 2) (mov 3 3))))
		for: machine.
		
	self simplify.
	
	self assert: result intermediateForm = 
		#(#(#block 1 #(#div #(#mov 1 1) #(#mov 2 2) (mov 3 3)))).
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 9/19/2004 16:24'!
testEntryPointsCopying
	source := MedMethod 
				createAssembly: #(#(#block 1 ))
				for: machine.
	source 
		registerEntryPointWithPC: 10
		label: source newBlock.
	source 
		registerEntryPointWithPC: 20
		label: source newBlock.
				
	self simplify.
	
	self assert: result entryPoints size = 2.
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 9/19/2004 17:47'!
testGenerateProlog
	| simplifier |
	source := MedMethod 
				createAssembly: #(#(#block 1 ))
				for: machine.
	
	machine := MachineX86 new.
	simplifier := IntermediateSimplifier 
				from: source
				emitter: mockEmitter.
	result := simplifier run.
	
	self assert: mockEmitter hasCreatedProlog.
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 10/17/2004 22:37'!
testIntegerValueOf
	source := MedMethod 
				createIntermediate: 
					#((block 1  (integerValueOf 42 block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedIntegerValueOf block2 42)) 
			(block2) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:31'!
testJump
	source := MedMethod 
				createAssembly: #(#(#block 1 #(jmp block2)) (block 2))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 #(jmp block2)) (block 2)).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 2/4/2005 20:42'!
testJumpComputed
	source := MedMethod 
				createAssembly: #(#(#block 1 #(jmp (add 10 20))) (block 2))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 #(jmp (add 10 20))) (block 2)).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:31'!
testJumpNested
	source := MedMethod 
				createAssembly: #(#(#block 1 #(jz block2 (mov 10 20))) (block 2))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 #(jz block2 (mov 10 20))) (block 2)).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/11/2004 19:56'!
testLabel
	source := MedMethod 
				createIntermediate: 
					#((block 1  (label () () codeExpression failureExpression block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(mov codeExpression t1)
				(jmp block3))
			(block2 
				(mov failureExpression t1)
				(jmp block3)) 
			(block3)).
			
	self simplifyFullyMocked.
	
	"The label should return t1"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/11/2004 19:54'!
testLabelWithArguments
	source := MedMethod 
				createIntermediate: 
					#((block 1  (label (arg1 arg2) (t1 t2) 
						(add t1 t2) 
						(sub t1 t2) 
						block2 ) ))
				for: machine.	
	mockEmitter initialiseMachine: machine.		
	mockEmitter expectEmission:
		#(	(block1 
				(mov arg1 t1)
				(mov arg2 t2)
				(mov (add t1 t2) t3)
				(jmp block3))
			(block2 
				(mov (sub t1 t2) t3)
				(jmp block3)) 
			(block3)).
			
	self simplifyFullyMocked.
	
	"The label should return t3"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 23:35'!
testLabelWithArgumentsNested
	source := MedMethod 
				createIntermediate: 
					#((block 1  (label ((add 1 1) arg2) (t1 t2) 
						(add t1 t2) 
						(sub t1 t2) 
						block2 ) ))
				for: machine.	
	mockEmitter initialiseMachine: machine.		
	mockEmitter expectEmission:
		#(	(block1 
				(mov (add 1 1) t1)
				(mov arg2 t2)
				(mov (add t1 t2) t3)
				(jmp block3))
			(block2 
				(mov (sub t1 t2) t3)
				(jmp block3)) 
			(block3)).
			
	self simplifyFullyMocked.
	
	"The label should return t3"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/25/2004 10:15'!
testLabelWithBooleanDeconversion
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(label () () codeExpression (deconvertBoolean falseObj failureExpression block2 1 0)  block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(mov codeExpression t1)
				(jmp block3))
			(block2 
				(conditionalJumpTo block2 falseObj failureExpression 1 0 )
				(jmp block3)) 
			(block3)).
			
	self simplifyFullyMocked.
	
	"The label should return t1"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 10/2/2004 10:26'!
testMachineRegister
	source := MedMethod 
				createIntermediate: #((block 1  (add eax ebx)))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #((block 1 (add eax ebx))).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 18:05'!
testMidDiv
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midDiv 13 5 block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedDiv 13 5 block2)) 
			(block2) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 18:14'!
testMidDivNested
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midDiv (add 13 13) (sub 5 5) block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedDiv (add 13 13) (sub 5 5) block2)) 
			(block2) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 19:29'!
testMidDivide
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midDivide 13 5 block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedDivide 13 5 block2)) 
			(block2) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 19:29'!
testMidDivideNested
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midDivide (add 13 13) (sub 5 5) block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedDivide (add 13 13) (sub 5 5) block2)) 
			(block2) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/17/2004 23:03'!
testMidMod
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midMod 13 5 block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedMod 13 5 block2)) 
			(block2) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 10/2/2004 10:26'!
testMove
	source := MedMethod 
				createAssembly: #((block 1 (mov 1 t1)))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #((block 1 (mov 1 t1))).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:32'!
testMoveIndirect
	source := MedMethod 
				createAssembly: #(#(#block 1 #(#mov 1 (mem #t1))))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 #(#mov 1 (mem #t1)))).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:29'!
testMoveNested
	source := MedMethod 
				createAssembly: #(#(#block 1 #(#mov (mov 1 1) (mov 2 2))))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 #(#mov (mov 1 1) (mov 2 2)))).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:34'!
testMultipleBlocks
	source := MedMethod 
		createIntermediate: #(#(#block 1 (add 10 10)) (block 2 (add 20 20)) (block 3 (add 30 30)))
		for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 (add 10 10)) (block 2 (add 20 20)) (block 3 (add 30 30))).
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:35'!
testNeg
	source := MedMethod 
		createIntermediate: #((block 1 (neg (mov 1 1)) ))
		for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #((block 1 (neg (mov 1 1)) )).
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:35'!
testPush
	source := MedMethod 
		createIntermediate: #(#(#block 1 (push (add 1 1))))
		for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 (push (add 1 1)))).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:19'!
testRet
	source := MedMethod 
				createAssembly: #(#(#block 1 #(#ret)))
				for: machine.
	self simplify.
	self assert: result intermediateForm = #(#(#block 1 #(#ret))).
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 10/2/2004 10:42'!
testReturn
	source := MedMethod 
		createIntermediate: #((block 1 (return (add 1 1)) ))
		for: machine.
	mockEmitter expectEmission:
		#((block1 
			(expandedReturn (add 1 1)))).
				
	self simplifyFullyMocked.
	
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 9/19/2004 12:50'!
testSend
	source := MedMethod 
				createIntermediate: 
					#((block 1  (send selector pc stackHeight arg1 arg2) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				#(#emitExpandedSend selector arg1 arg2)). 
			).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 9/25/2004 09:48'!
testSendWithComplexArguments
	source := MedMethod 
				createIntermediate: 
					#((block 1  (send selector pc stackHeight (add 1 1) (add 2 2)) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				#(#emitExpandedSend selector (add 1 1) (add 2 2))). 
			).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:58'!
testStoreInReceiver
	"Just a hack to get this working."

	mockEmitter initialiseMachine: machine.
	source _ MedMethod 
				createIntermediate: #(#(#block 1 #(#mov #(#storeInReceiver 5 #theValue) #answer)))
				for: machine.
	mockEmitter expectEmission: #(#(#block1 #(#mov #theValue #t1) #(#emitBeRootIfNeeded #(#receiverAddress) #t1) #(#mov #t1 #(#instanceVariableAddress 5)) #(#mov #t1 #answer))).
	self simplifyFullyMocked.
	self verify.
	mockEmitter verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:58'!
testStoreInReceiverNested
	"Just a hack to get this working."

	mockEmitter initialiseMachine: machine.
	source _ MedMethod 
				createIntermediate: #(#(#block 1 #(#storeInReceiver 5 #(#mov 1 1))))
				for: machine.
	mockEmitter expectEmission: #(#(#block1 #(#mov #(#mov 1 1) #t1) #(#emitBeRootIfNeeded #(#receiverAddress) #t1) #(#mov #t1 #(#instanceVariableAddress 5)))).
	self simplifyFullyMocked.
	self verify.
	mockEmitter verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 11/1/2004 20:36'!
testStoreInTemp
	"Just a hack to get this working."
	mockEmitter initialiseMachine: machine.
	
	source := MedMethod 
				createIntermediate: 
					#((block 1  (storeInTemp 42 anExpression ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(mov anExpression t1)
				(mov t1 (emitTemporaryAddress 42)) )).
			
	self simplifyMocked.
	
	self verify. 
	mockEmitter verify.! !

IntermediateCopierTests subclass: #LowLevelOptimiserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 1/22/2005 15:26'!
testAddress
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1  (mov (addressOf block1) t1) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (mov (addressOf block1) t1) )).! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 1/22/2005 15:49'!
testCopyAlignedFlag
	| optimiser | 
	machine := MachineX86 new.
	source := MedMethod
		createIntermediate: #((block 1) (block 2))
		for: machine.
	(source blockAt: 2) makeAligned.
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: (result blockAt: 1) isAligned not.
	self assert: (result blockAt: 2) isAligned.! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 1/22/2005 16:07'!
testDontRemoveAfterConditionalJumps
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1 (jz block1 (sub 1 1) ) (jmp block2) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (jz block1 (sub 1 1) ) (jmp block2) ) (block 2)).! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 2/26/2005 09:57'!
testPic
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1 (pic t1) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (pic t1) )).! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:36'!
testPop
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1 (pop eax) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (pop eax) )).! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 1/22/2005 16:08'!
testRemoveRedundantJumps
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1 (jmp block1) (jmp block2) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (jmp block1) ) (block 2)).! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:11'!
testRemoveRedundantJumpsAfterRet
	| optimiser |
	source := MedMethod 
				createIntermediate: #(#(#block 1 #(#ret) #(#jmp #block2)))
				for: machine.
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.
	self assert: result intermediateForm = #(#(#block 1 #(#ret)) #(#block 2))! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 1/22/2005 16:18'!
testResetJumpRemovalOnNextBlock
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1 (jmp block1)) (block 2 (jmp block2) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (jmp block1) ) (block 2 (jmp block2))).! !

IntermediateCopierTests subclass: #TreeOptimiserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!TreeOptimiserTests methodsFor: 'Misc' stamp: 'wbk 12/21/2004 12:43'!
operationClass
	^ TreeOptimiser! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/27/2004 10:46'!
testAtElementAddress
	source := MedMethod 
				createIntermediate: 
					#((block 1  (atElementAddress 42 1 block2 0 ) ))
				for: machine.				
	mockEmitter expectEmission:
		#((block1 
		 	(emitAtElementAddress 42 1 block2 0 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/27/2004 10:47'!
testAtPut
	source := MedMethod 
				createIntermediate: 
					#((block 1  (atPut receiver location value block2 0) ))
				for: machine.				
	mockEmitter expectEmission:
		#((block1 
		 	(atPut receiver location value block2) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/22/2004 21:24'!
testBitShift
	source := MedMethod 
				createIntermediate: #(#(#block 1 (bitShift 13 5 block2)))
				for: machine.					
	mockEmitter expectEmission:
		#((block1 
		 	(bitShift block2 13 5 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/21/2004 17:11'!
testConvertBoolean
	source := MedMethod 
				createIntermediate: 
					#((block 1  (convertBoolean jg anExpression ) ))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(emitConvertComparisionToBoolean jg anExpression ))).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/21/2004 14:54'!
testDeconvertBoolean
	source := MedMethod 
				createIntermediate: 
					#((block 1  (deconvertBoolean falseObj anExpression block2 1 0) )
						(block 2 ))
				for: machine.
	mockEmitter expectEmission:
		#((block1 
			(deconvertBoolean falseObj anExpression block2 1 0) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/25/2004 17:34'!
testIntegerValueOf
	source := MedMethod 
				createIntermediate: 
					#((block 1  (integerValueOf arg block2 ) ))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(emitIntegerValueOf block2 arg))).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/21/2004 15:40'!
testLabelWithArguments
	source := MedMethod 
				createIntermediate: 
					#((block 1  (label (arg1 arg2) (t1 t2) 
						(add t1 t2) 
						(sub t1 t2) 
						block2 ) ))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(label1 block2 arg1 arg2 t1 t2 
						(add t1 t2) 
						(sub t1 t2) 
						 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/22/2004 21:33'!
testMidDiv
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midDiv 13 5 block2 ) ))
				for: machine.							
	mockEmitter expectEmission:
		#((block1 (emitDiv block2 13 5  ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/22/2004 21:35'!
testMidDivide
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midDivide 13 5 block2 ) ))
				for: machine.									
	mockEmitter expectEmission:
		#((block1 (emitDivide block2 13 5  ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/22/2004 21:38'!
testMidMod
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midMod 13 5 block2 ) ))
				for: machine.									
	mockEmitter expectEmission:
		#((block1 (emitMod block2 13 5  ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/24/2004 21:54'!
testOptimiseBooleanConversion
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(deconvertBoolean falseObj
							(label (arg1 arg2) (t1 t2) 
								(convertBoolean jg (add t1 t2))
								(sub t1 t2) 
								block2 )
							block3 1 0) 
							)
					(block 2)
					(block 3))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(label1 block2 arg1 arg2 t1 t2 
						(jg block3 (add t1 t2) )
						(deconvertBoolean falseObj (sub t1 t2) block3 1 0)
						 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/25/2004 11:08'!
testOptimiseBooleanConversion2
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(deconvertBoolean trueObj
							(label (arg1 arg2) (t1 t2) 
								(convertBoolean jg (add t1 t2))
								(sub t1 t2) 
								block2 )
							block3 1 0) 
							)
					(block 2)
					(block 3))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(label1 block2 arg1 arg2 t1 t2 
						(jle block3 (add t1 t2) )
						(deconvertBoolean trueObj (sub t1 t2) block3 1 0)
						 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/25/2004 11:26'!
testOptimiseBooleanConversion3
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(deconvertBoolean trueObj
							(label (arg1 arg2) (t1 t2) 
								(convertBoolean jne (add t1 t2))
								(sub t1 t2) 
								block2 )
							block3 1 0) 
							)
					(block 2)
					(block 3))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(label1 block2 arg1 arg2 t1 t2 
						(je block3 (add t1 t2) )
						(deconvertBoolean trueObj (sub t1 t2) block3 1 0)
						 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/25/2004 17:35'!
testOptimiseConstantIntegerValueOf
	source := MedMethod 
				createIntermediate: 
					#((block 1  (mov (integerValueOf 11 block2 ) t1)))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(mov 5 t1))).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/25/2004 12:47'!
testOptimiseConstantLabel
	source := MedMethod 
				createIntermediate: 
					#((block 1  (label (11 arg2) (t1 t2) 
						(add t1 t2) 
						(sub t1 t2) 
						block2 ) ))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(label1 block2  arg2 t2 
						(add 11 t2) 
						(sub 11 t2) 
						 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/21/2004 13:52'!
testReturn
	source := MedMethod 
		createIntermediate: #((block 1 (return (add 1 1)) ))
		for: machine.
	mockEmitter expectEmission:
		#((block1 
			(emitReturnValue (add 1 1)))).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/21/2004 13:32'!
testSend
	source := MedMethod  
				createIntermediate: 
					#((block 1  (send selector pc stackHeight arg1 arg2) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitSend selector pc stackHeight arg1 arg2)). 
			).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/22/2004 20:56'!
testStoreInReceiver
	source := MedMethod 
				createIntermediate: 
					#((block 1  (mov (storeInReceiver 5 theValue ) answer) ))
				for: machine.						
	mockEmitter expectEmission:
		#((block1 
		 	(mov (storeInReceiver 5 theValue ) answer) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/22/2004 20:19'!
testStoreInTemp
	source := MedMethod 
				createIntermediate: 
					#((block 1  (storeInTemp 42 anExpression ) ))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(storeInTemp 42 anExpression ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

ExuperyTests subclass: #IntermediateEmissionTests
	instanceVariableNames: 'machine generator emitter result mockEmitter state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!IntermediateEmissionTests methodsFor: 'Misc' stamp: 'wbk 8/8/2004 13:02'!
result
	^ generator result intermediateForm! !

!IntermediateEmissionTests methodsFor: 'Misc' stamp: 'wbk 4/26/2004 22:31'!
setUp
	machine := MockExuperyPlugin new.
	generator := IntermediateGenerator for: machine.
	emitter := IntermediateEmitter 
		machine: machine 
		jumpTargets: #().
	state := ExuperyStack 
		newPC: 10
		emitter: emitter.
	emitter state: state.
	generator emitter: emitter.! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 10/2/2004 12:09'!
testAddLiteralToCurrentBlock
	emitter addExpression: (MedLiteral literal: 42).
	self assert: self result = #((block 1))! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 10/2/2004 11:54'!
testAddRegisterToCurrentBlock
	emitter addExpression: emitter createTemporaryRegister.
	self assert: self result = #((block 1))! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 12/13/2004 22:22'!
testAtPut
		
	result := emitter
				atPutReceiver: #receiver
				index: #index
				value: #value
				failTo: emitter newBlock.
	self assert: result intermediateForm = #(atPut receiver index value block2)

! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/27/2004 23:04'!
testBasicStack
	| stack |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1
				(mov firstValue s1)
				(mov secondValue s2))).
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: #secondValue.

	self assert: stack pop name = #s2.
	self assert: stack pop name = #s1.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 3/6/2005 11:12'!
testBytecodePrimNewWithArg
	| answer |
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
			#(#emitRestoreContext 2 4 5) 
			#(#mov #(#address #block3) 
			#(#mem #(#add #(#currentContextAddress) 20))) 

			#(mov (emitClass 4) eax)
			(mov picEntry ecx)

			(mov literalAddress edx)
			(restoreSendersFrame)
			(pic eax)

			#(#mov #(callFunction #exuperySetupMessageSend edx 1 ecx) eax) 
			#(#jz #block2 #(#sub eax 0)) 
			#(jmp eax))			"Call compiled method"
		 #(#block2 
			#(mov 1 eax)	
			(ret) 				"Return to Interpreter"
			#(#alignedLabel) 
			#(#preamble) 
			#(#emitReloadStack #t1))).
	"A real block begins here"
	mockEmitter 
		expectRegisterEntryPointPC: 5
		blockNumbered: #block3.	"An encoded SmallInteger"
	state pc: 1.
	answer := emitter 
				expandedSendSelector: (MedLiteral literal: #literalAddress)
				arguments: #(4 5).
	self assert: (answer isKindOf: MedLanguage).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 2/13/2005 12:27'!
testClass
	mockEmitter _ MockIntermediateEmitter newWith: emitter machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: #(#(#block1 #(#emitCheckIsInteger #theReceiver #block2) #(#mov #(#emitSpecialObject 5) #t1) #(#jmp #block4)) #(#block2 #(#mov #(#and 31 #(#sar #(#mem #theReceiver) 12)) #t2) #(#je #block3 #(#sub 0 #t2)) #(#mov #(#emitFetchVariableAddress #(#sub #t2 1) #(#emitSpecialObject 28)) #t1) #(#jmp #block4)) #(#block3 #(#mov #(#and 4294967292 #(#mem #(#sub #theReceiver 4))) #t1) #(#jmp #block4)) #(#block4)).
	result _ emitter classOf: (MedLiteral literal: #theReceiver).
	self verify.
	self assert: result name = #t1.
	self assert: mockEmitter currentBlock = #block4! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:49'!
testConditionalByteCode
	mockEmitter _ MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter addExpectedEmission: #(#emitWithFailTo 3 5 #t1 #t2 #(#emitConvertComparisionToBoolean #jge #(#sub #(#emitIntegerValueOf #block2 #t1) #(#emitIntegerValueOf #block2 #t2))) 2).
	result _ emitter 
				conditionalBytecodeArg1: (MedLiteral smallInteger: 1)
				arg2: (MedLiteral smallInteger: 2)
				withJump: #jge
				failureSelector: 2.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 8/8/2003 20:35'!
testEmitAdd
	result := emitter 
		emit: (MedLiteral literal: 10)
		add: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(add 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 1/19/2005 21:19'!
testEmitAddressOf
	result := emitter addressOf: emitter newBlock.
	self should: [result intermediateForm = #(addressOf block2)]! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:49'!
testEmitAlignedLabel
	| oldBlock answer |
	oldBlock _ emitter currentBlock.
	answer _ emitter alignedLabel.
	self assert: (emitter result blockAt: 2) isAligned.
	self assert: oldBlock ~= emitter currentBlock.
	self assert: self result = #(#(#block 1 #(#jmp #block2)) #(#block 2)).
	self assert: (answer isKindOf: MedLanguage)! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/4/2004 23:38'!
testEmitAnd
	result := emitter 
		emit: (MedLiteral literal: 10)
		and: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(and 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:26'!
testEmitAtCacheEntry
	result _ emitter 
				atCacheEntryEntry: 10
				index: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(#mem #(#add #atCache #(#sal #(#add 10 20) 2)))! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:26'!
testEmitAtElementAddress
	| answer |
	mockEmitter _ MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	answer _ emitter 
				atElementAddressFor: #receiver
				with: (MedLiteral literal: #elementNumber)
				failTo: #failureBlock
				cacheOffset: 0.
	self verify.
	self assert: answer intermediateForm = #(#atElementAddress #receiver #elementNumber #failureBlock 0)! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:30'!
testEmitBeRootIfNessisary
	mockEmitter _ MockIntermediateEmitter newWith: emitter machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: #(#(#block1 #(#emitCheckIsNotInteger #pointedTo #block2) #(#jl #block2 #(#sub #pointedTo #(#mem #(#youngStartAddress)))) #(#jge #block2 #(#sub #root #(#mem #(#youngStartAddress)))) #(#mov #(#mem #root) #t1) #(#jnz #block2 #(#and #t1 1073741824)) #(#mov #(#add 1 #(#mem #(#rootTableCountAddress))) #t2) #(#mov #t2 #(#mem #(#rootTableCountAddress))) #(#mov #root #(#mem #(#add #(#rootTableAddress) #(#sal #t2 2)))) #(#mov #(#or #t1 1073741824) #(#mem #root)) #(#jmp #block2))).
	"An old object is receiving a pointer to a young object"
	" Now record the object as a new root"
	result _ emitter 
				beRoot: #root
				ifNeededBy: #pointedTo.
	self assert: mockEmitter currentBlock = #block2.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 12/12/2004 16:41'!
testEmitBitShift
	result := emitter 
				emit: (MedLiteral literal: 13)
				bitShift: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = 
		#(	(block 1)
			(block 2) "The failure block").
	self assert: result intermediateForm = #(bitShift 13 5 block2).
	self assert: emitter currentBlock blockName = #block1! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:20'!
testEmitCheckIsNotInteger
	| failureBlock |
	failureBlock _ emitter result newBlock.
	result _ emitter 
				checkIsNotInteger: (MedLiteral literal: 10)
				failTo: failureBlock.
	self assert: generator result intermediateForm = #(#(#block 1 #(#jnz #block2 #(#and 1 10))) #(#block 2))! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:20'!
testEmitConvertComparisionToBoolean
	result _ emitter 
				convertComparisionToBoolean: (MedArithmatic 
						operator: #sub
						arg1: (MedLiteral literal: 2)
						arg2: (MedLiteral literal: 1))
				jumpType: #jg.
	self should: [result intermediateForm = #(#convertBoolean #jg #(#sub 2 1))].
	self should: [emitter currentBlock blockName = #block1]! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:20'!
testEmitConvertToSmallInteger
	result _ emitter 
				convertToSmallInteger: (MedLiteral literal: 42)
				failTo: emitter newBlock.
	self should: [generator result intermediateForm = #(#(#block 1) #(#block 2))].
	self should: [result intermediateForm = #(#add 1 #(#jo #block2 #(#sal 42 1)))].
	self should: [emitter currentBlock blockName = #block1]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 12/22/2004 21:45'!
testEmitDiv
	result := emitter 
				emit: (MedLiteral literal: 13)
				div: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = #(#(#block 1) #(#block 2)).
	self assert: result intermediateForm = #(#midDiv 13 5 #block2).
	self assert: emitter currentBlock blockName = #block1! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 12/22/2004 21:46'!
testEmitDivide
	result := emitter 
				emit: (MedLiteral literal: 13)
				divide: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = #(#(#block 1) #(#block 2)).
	self assert: result intermediateForm = #(#midDivide 13 5 #block2)! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/13/2005 12:52'!
testEmitExpandedBitShift
	result _ emitter 
				expanded: (MedLiteral literal: 13)
				bitShift: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = #(#(#block 1 #(#mov 13 #t2) #(#mov 5 #t3) #(#jl #block3 #(#sub #t3 0)) #(#jl #block2 #(#sub 31 #t3)) #(#mov #(#sal #t2 #t3) #t1) #(#jnz #block2 #(#sub #t2 #(#sar #t1 #t3))) #(#jmp #block4)) #(#block 2) #(#block 3 #(#jl #block2 #(#sub #t3 -31)) #(#mov #(#sar #t2 #(#neg #t3)) #t1) #(#jmp #block4)) #(#block 4)).	"The failure block"	"t2 is the remander"
	self assert: result intermediateForm = #t1.
	self assert: emitter currentBlock blockName = #block4! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/13/2005 12:51'!
testEmitExpandedDiv
	result _ emitter 
				expanded: (MedLiteral literal: 13)
				div: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = #(#(#block 1 #(#je #block2 #(#sub 0 5)) #(#mov #(#div 13 5 #t2) #t1) #(#jge #block3 #(#sub #t1 0)) #(#je #block3 #(#sub 0 #t2)) #(#mov #(#sub #t1 1) #t1) #(#jmp #block3)) #(#block 2) #(#block 3)).	"t2 is the remander"
	self assert: result intermediateForm = #t1.
	self assert: emitter currentBlock blockName = #block3! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/13/2005 12:52'!
testEmitExpandedDivide
	result _ emitter 
				expanded: (MedLiteral literal: 13)
				divide: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = #(#(#block 1 #(#je #block2 #(#sub 0 5)) #(#mov #(#div 13 5 #t2) #t1) #(#jne #block2 #(#sub 0 #t2))) #(#block 2)).	"t2 is the remander"
	self assert: result intermediateForm = #t1! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:22'!
testEmitExpandedIntegerValueOf
	result _ emitter 
				expandedIntegerValueOf: (MedLiteral literal: 42)
				failTo: emitter newBlock.
	self should: 
			[self result = #(#(#block 1 #(#mov 42 #t1) #(#jz #block2 #(#and 1 #t1))) #(#block 2))].
	self should: [result intermediateForm = #(#sar #t1 1)].
	self should: [emitter currentBlock blockName = #block1]! !

!IntermediateEmissionTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/13/2005 12:48'!
testEmitExpandedJumpIfFalseTo
	| target |
	mockEmitter _ MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: #(#(#block1 #(#je #block2 #(#sub #anExpression #(#mem #falseObj))) #(#jne #block3 #(#sub #anExpression #(#mem #trueObj))) #(#jmp #block4)) #(#block2) #(#block3 #(#emitExpandedSend #(#emitSpecialObject 25) #anExpression) #(#jmp #block4)) #(#block4)).
	target _ mockEmitter newBlock.
	emitter 
		expandedJumpIfFalseTo: target
		onBoolean: (MedLiteral literal: #anExpression).
	self verify.
	self assert: mockEmitter currentBlock = #block4! !

!IntermediateEmissionTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/13/2005 12:48'!
testEmitExpandedJumpIfTrueTo
	| target |
	mockEmitter _ MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter result: emitter result.
	mockEmitter expectEmission: #(#(#block1 #(#je #block2 #(#sub #anExpression #(#mem #trueObj))) #(#jne #block3 #(#sub #anExpression #(#mem #falseObj))) #(#jmp #block4)) #(#block2) #(#block3 #(#emitExpandedSend #(#emitSpecialObject 25) #anExpression) #(#jmp #block4)) #(#block4)).
	target _ mockEmitter newBlock.
	emitter 
		expandedJumpIfTrueTo: target
		onBoolean: (MedLiteral literal: #anExpression).
	self verify.
	self assert: mockEmitter currentBlock = #block4! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:28'!
testEmitExtendedAtElementAddress
	| answer |
	mockEmitter _ MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: #(#(#block1 #(#emitCheckIsNotInteger #receiver #failureBlock) #(#emitCheckIsInteger #elementNumber #failureBlock) #(#mov #(#add #(#and #receiver 28) 0) #t1) #(#jnz #failureBlock #(#sub #receiver #(#emitAtCacheEntry 1 #t1))) #(#jl #failureBlock #(#sub #(#emitAtCacheEntry 2 #t1) #(#sar #elementNumber 1))) #(#jg #failureBlock #(#sub #(#emitAtCacheEntry 3 #t1) 4)))).
	mockEmitter addExpectedEmission: #(#emitFetchVariableAddress #(#sub #(#add #(#sar #elementNumber 1) #(#emitAtCacheEntry 4 #t1)) 1) #receiver).
	answer _ emitter 
				expandedAtElementAddressFor: #receiver
				with: (MedLiteral literal: #elementNumber)
				failTo: #failureBlock
				cacheOffset: 0.
	self verify.
	self assert: answer = #(#emitFetchVariableAddress #(#sub #(#add #(#sar #elementNumber 1) #(#emitAtCacheEntry 4 #t1)) 1) #receiver)! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:28'!
testEmitExtendedAtElementAddressWithOffset
	| answer |
	mockEmitter _ MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: #(#(#block1 #(#emitCheckIsNotInteger #receiver #failureBlock) #(#emitCheckIsInteger #elementNumber #failureBlock) #(#mov #(#add #(#and #receiver 28) 32) #t1) #(#jnz #failureBlock #(#sub #receiver #(#emitAtCacheEntry 1 #t1))) #(#jl #failureBlock #(#sub #(#emitAtCacheEntry 2 #t1) #(#sar #elementNumber 1))) #(#jg #failureBlock #(#sub #(#emitAtCacheEntry 3 #t1) 4)))).
	mockEmitter addExpectedEmission: #(#emitFetchVariableAddress #(#sub #(#add #(#sar #elementNumber 1) #(#emitAtCacheEntry 4 #t1)) 1) #receiver).
	answer _ emitter 
				expandedAtElementAddressFor: #receiver
				with: (MedLiteral literal: #elementNumber)
				failTo: #failureBlock
				cacheOffset: 32.
	self verify.
	self assert: answer = #(#emitFetchVariableAddress #(#sub #(#add #(#sar #elementNumber 1) #(#emitAtCacheEntry 4 #t1)) 1) #receiver)! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/13/2005 12:52'!
testEmitExtendedMod
	result _ emitter 
				expanded: (MedLiteral literal: 13)
				mod: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: self result = #(#(#block 1 #(#je #block2 #(#sub 0 5)) #(#mov #(#div 13 5 #t2) #t1) #(#jge #block3 #(#sub #t1 0)) #(#je #block3 #(#sub 0 #t2)) #(#mov #(#add #t2 5) #t2) #(#jmp #block3)) #(#block 2) #(#block 3)).	"t2 is the remander"
	self assert: result intermediateForm = #t2.
	self assert: emitter currentBlock blockName = #block3! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:53'!
testEmitFalseAddress
	result _ emitter falseAddress.
	self should: [result intermediateForm = #(#mem #falseObj)]! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:22'!
testEmitIntegerValueOf
	result _ emitter 
				integerValueOf: (MedLiteral literal: 42)
				failTo: emitter newBlock.
	self should: [self result = #(#(#block 1) #(#block 2))].
	self should: [result intermediateForm = #(#integerValueOf 42 #block2)].
	self should: [emitter currentBlock blockName = #block1]! !

!IntermediateEmissionTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/13/2005 12:48'!
testEmitJumpIfFalseTo
	| target |
	target _ emitter newBlock.
	emitter exuperyStack pc: 10.
	emitter exuperyStack heightTo: 2.
	result _ emitter 
				jumpIfFalseTo: target
				onBoolean: (MedLiteral literal: #anExpression).
	self assert: self result = #(#(#block 1 #(#deconvertBoolean #falseObj #anExpression #block2 10 2)) #(#block 2)).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/13/2005 12:48'!
testEmitJumpIfTrueTo
	| target |
	target _ emitter newBlock.
	emitter exuperyStack pc: 10.
	emitter exuperyStack heightTo: 2.
	result _ emitter 
				jumpIfTrueTo: target
				onBoolean: (MedLiteral literal: #anExpression).
	self assert: self result = #(#(#block 1 #(#deconvertBoolean #trueObj #anExpression #block2 10 2)) #(#block 2)).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/13/2005 12:46'!
testEmitJumpTarget
	| targetBlock |
	targetBlock _ emitter newBlock.
	emitter jumpTo: targetBlock.
	self should: [self result = #(#(#block 1 #(#jmp #block2)) #(#block 2))]! !

!IntermediateEmissionTests methodsFor: 'Tests - Jumps' stamp: 'wbk 8/8/2004 13:17'!
testEmitJumpTo
	| failureBlock |
	failureBlock := emitter result newBlock.
	result := emitter 
		jumpType: #jumpType
		to: failureBlock
		dependingOn: (MedLiteral literal: #instruction).
	self assert: result intermediateForm = #(jumpType block2 instruction) ! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:47'!
testEmitLabel
	| oldBlock answer |
	oldBlock _ emitter currentBlock.
	answer _ emitter label.
	self assert: oldBlock ~= emitter currentBlock.
	self assert: self result = #(#(#block 1 #(#jmp #block2)) #(#block 2)).
	self assert: (answer isKindOf: MedLanguage)! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:47'!
testEmitLabelForByteCode
	emitter _ IntermediateEmitter 
				machine: machine
				jumpTargets: #(5 10).
	generator emitter: emitter.
	result _ emitter labelForByteCode: 10.
	self should: [result class = MedBlock].
	self should: [result blockName = #block3]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/13/2005 12:03'!
testEmitMem
	result _ emitter mem: (MedLiteral literal: #address).
	self assert: result intermediateForm = #(#mem #address)! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 12/22/2004 21:47'!
testEmitMod
	result := emitter 
				emit: (MedLiteral literal: 13)
				mod: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = #(#(#block 1) #(#block 2)).
	self assert: result intermediateForm = #(#midMod 13 5 #block2).
	self assert: emitter currentBlock blockName = #block1! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/13/2005 12:44'!
testEmitMove
	result _ emitter 
				moveFrom: (MedLiteral literal: 1)
				to: (MedLiteral literal: 2).
	self assert: self result = #(#(#block 1 #(#mov 1 2)))! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/13/2005 12:43'!
testEmitMoveToTemp
	result _ emitter moveToTemp: (MedLiteral literal: 10).
	self assert: self result = #(#(#block 1 #(#mov 10 #t1))).
	self assert: result intermediateForm = #t1! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 12/22/2004 21:44'!
testEmitMultiply
	result := emitter 
				emit: (MedLiteral literal: 1)
				multiply: (MedLiteral literal: 2)
				failingTo: emitter newBlock.
	self assert: result intermediateForm = #(#jo #block2 #(#mul 1 2))! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:54'!
testEmitNilAddress
	result _ emitter nilAddress.
	self should: [result intermediateForm = #(#mem #nilObj)]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 11/21/2003 00:02'!
testEmitOr
	result := emitter 
		emit: (MedLiteral literal: 10)
		or: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(or 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 2/13/2005 12:28'!
testEmitPopIntoTemp
	result _ emitter 
				expandedPopIntoTemp: (MedLiteral smallInteger: 1)
				slot: 0.
	self should: 
			[emitter result intermediateForm = #(#(#block 1 #(#mov 3 #t1) #(#mov #t1 #(#mem #(#add #currentContext 28)))))].
	self should: [generator result numberOfBlocks = 1].
	self assert: result name = #t1.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 2/13/2005 12:28'!
testEmitPopIntoTemp2
	result _ emitter 
				expandedPopIntoTemp: (MedLiteral smallInteger: 1)
				slot: 2.
	self should: 
			[emitter result intermediateForm = #(#(#block 1 #(#mov 3 #t1) #(#mov #t1 #(#mem #(#add #currentContext 36)))))].
	self should: [generator result numberOfBlocks = 1].
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:30'!
testEmitRootTableAddress
	result _ emitter rootTableAddress.
	self should: [result intermediateForm = #rootTable]! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:30'!
testEmitRootTableCountAddress
	result _ emitter rootTableCountAddress.
	self should: [result intermediateForm = #rootTableCount]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 11/21/2003 00:00'!
testEmitSal
	result := emitter 
		emit: (MedLiteral literal: 10)
		sal: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(sal 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 3/7/2004 23:33'!
testEmitSar
	result := emitter 
				emit: (MedLiteral literal: 10)
				sar: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(#sar 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:58'!
testEmitSelfAddress
	result _ emitter receiverAddress.
	self assert: result intermediateForm = #(#mem #(#add #currentContext 24))! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 2/13/2005 12:18'!
testEmitSpecialSelector
	mockEmitter _ MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter addExpectedEmission: #(#emitFetchAddress 10 #(#emitFetchAddress 23 #(#mem #specialObjectsOop))).
	result _ emitter specialSelector: 5.
	self assert: result = #(#emitFetchAddress 10 #(#emitFetchAddress 23 #(#mem #specialObjectsOop))).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/7/2004 19:27'!
testEmitSubtract
	result := emitter 
		emit: (MedLiteral literal: 1)
		minus: (MedLiteral literal: 2).
	self should: [result intermediateForm = #(#sub 1 2)]! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:59'!
testEmitTrueAddress
	result _ emitter trueAddress.
	self should: [result intermediateForm = #(#mem #trueObj)]! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:53'!
testEmitWithFailTo
	mockEmitter _ MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: #(#(#block1 #(#label1 #block2 #arg1 #arg2 #t1 #t2 #(#aMethod #block2) #(#emitSend #(#emitSpecialSelector 100) #t1 #t2))) #(#block2)).
	result _ emitter 
				withFailTo: 
					[:arguments :failureBlock | 
					self assert: (arguments collect: [:each | each intermediateForm]) = #(#t1 #t2).
					mockEmitter check: ({ 
								#aMethod.
								failureBlock blockName})]
				failureSpecialSelector: 100
				arguments: #(#arg1 #arg2).
	self should: 
			[result = #(#label1 #block2 #arg1 #arg2 #t1 #t2 #(#aMethod #block2) #(#emitSend #(#emitSpecialSelector 100) #t1 #t2))].
	self should: [mockEmitter currentBlock = #block1]! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:30'!
testEmitYoungStartAddress
	result _ emitter youngStartAddress.
	self should: [result intermediateForm = #youngStart]! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 3/4/2005 14:04'!
testExtendedReturn
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	"emitter newBlock. "	"Use the first block"
	mockEmitter expectEmission: 
		#(#(#block1 
			#(#mov #(#mem #(#add #currentContext 4)) #t1) 
			#(#mov #(#add #(#mem #(#add #t1 12)) 2) #t2) 
			#(#mov #t2 #(#mem #(#add #t1 12))) 
			#(#mov #theValue #(#mem #(#add #(#add #t1 #(#sal #t2 1)) 22))) 
			#(#recycleContextIfPossible #currentContext) 
			#(#mov #t1 #(#currentContextAddress)) 
			#(#mov #(#nilAddress) #(#mem #(#add #currentContext 20))) 
			#(#beRootIfNessisary #(#currentContextAddress) #block2)) 
		#(#block2 
			#(#emitCheckIsNotInteger #(#mem #(#add #(#currentContextAddress) 20)) #block3) 
			#(#mov #(#mem #(#add #(#currentContextAddress) 20)) #t3) 
			#(#emitCheckIsInteger #t3 #block3) 
			#(#returnToCompiledMethod #(#sub #t3 1))) 
		#(#block3 
			#(#emitMoveToEax 1) 
			#(#returnSequence))).	"Senders Context"	"New Stack Ptr"	"Save Stack Ptr"	"Place theValue on callers stack"	"Change the context"	"Nil out the compiled PC"	"Check it's a Method Context"	"Return to the interpreter"
	result := emitter expandedReturnValue: (MedLiteral literal: #theValue).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:29'!
testFetchVariableAddress
	result _ emitter 
				fetchVariableAddress: (MedLiteral literal: #index)
				ofObject: (MedLiteral literal: #object).
	self assert: result intermediateForm = #(#mem #(#add #object #(#add #(#sal #index 2) 4)))! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 9/28/2004 22:50'!
testHeightToStack
	| stack answer |
	stack := ExuperyStack 
		newPC: 1
		emitter: emitter.
	stack heightTo: 3.
	answer := stack pop: 3.
	self assert: (answer at: 1) intermediateForm = #s1.
	self assert: (answer at: 2) intermediateForm = #s2.
	self assert: (answer at: 3) intermediateForm = #s3.! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 2/13/2005 12:58'!
testInstanceVariableAddress
	mockEmitter _ MockIntermediateEmitter newWith: emitter machine.
	emitter emitter: mockEmitter.
	mockEmitter addExpectedEmission: #(#emitFetchAddress 5 #(#receiverAddress)).
	result _ emitter instanceVariableAddress: 5.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 9/23/2004 22:48'!
testLabelsAreStackable
	| stack |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1 (mov firstValue s1))).
		
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: MedLabel new.

	self assert: stack pop class = MedLabel.
	self assert: stack pop name = #s1.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 9/25/2004 08:39'!
testLabelsAreStackableMultiplePop
	| stack answer |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1 (mov firstValue s1))).
		
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: MedLabel new.
	
	answer := stack pop: 2.

	self assert: (answer at: 1) name = #s1.
	self assert: (answer at: 2) class = MedLabel.
	
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/4/2004 21:42'!
testLabelsAreStackablePeek
	| stack |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1 )).
		
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: MedLabel new.

	self assert: stack peek class = MedLabel.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/27/2004 23:04'!
testMultiplePop
	| stack answer |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1
				(mov firstValue s1)
				(mov secondValue s2))).
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: #secondValue.

	answer := stack pop: 2.
	self assert: (answer at: 1) name = #s1.
	self assert: (answer at: 2) name = #s2.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 2/27/2005 13:37'!
testPic
	result _ emitter 
				picLocatedAt: (MedLiteral literal: 20)
				picEntry: 'nil'.
	self assert: emitter result intermediateForm = #(#(#block 1 #(#pic 20)))! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 3/4/2005 15:07'!
testPop
	result := emitter pop: (machine registerNamed: #eax).
	self assert: emitter result intermediateForm = #((block 1 (pop eax))).! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 2/13/2005 12:30'!
testRecycleContextIfPossible
	mockEmitter _ MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: #(#(#block1 #(#jle #block2 #(#sub #(#mem #reclaimableContextCount) 0)) #(#mov #(#sub #(#mem #reclaimableContextCount) 1) #(#mem #reclaimableContextCount)) #(#jl #block2 #(#sub #theContext #(#mem #(#youngStartAddress)))) #(#mov #(#mem #freeContexts) #(#emitFetchAddress 0 #theContext)) #(#mov #theContext #(#mem #freeContexts)) #(#jmp #block2))).	"Check there is a context to recycle"	"Decrement count"	"Check the context is young"
	"We're only dealing with small method context headers for now. The compiler doesn't
			deal with blocks. Large emthod contexts should be identical except the large list is used"
	result _ emitter recycleContextIfPossible: (MedLiteral literal: #theContext).
	self assert: emitter currentBlock blockName = #block2.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 2/18/2005 21:28'!
testRegisterEntryPoint
	| block |

	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission:  
		#((block1
						"The call preamble, this used to be done using a preassembled prolog"
						(push ebp)
						(mov esp ebp)
						(push ebx)
						(push esi)
						(push edi)
						(mov (sub esp 16r40) esp) 
						(callFunction exuperyCreateContext)
						"Load current context into a register"
						(mov (currentContextAddress) currentContext)
						(jmp block1) ) ).

	block := emitter newBlock.
	emitter 
		registerEntryPointWithPC: (MedLiteral literal: 5)
		label: block.
	emitter createProlog.
	
	self verify.! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 2/13/2005 12:04'!
testReloadStack
	emitter reloadStack: ({ 
				machine registerNamed: #t1}).
	self should: 
			[self result = #(#(#block 1 #(#mov #currentContext #t2) #(#mov #(#mem #(#add #t2 28)) #t1)))]! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 2/13/2005 12:04'!
testReloadStack2
	emitter reloadStack: ({ 
				machine registerNamed: #t1.
				machine registerNamed: #t2.
				machine registerNamed: #t3}).
	self should: 
			[self result = #(#(#block 1 #(#mov #currentContext #t4) #(#mov #(#mem #(#add #t4 28)) #t1) #(#mov #(#mem #(#add #t4 32)) #t2) #(#mov #(#mem #(#add #t4 36)) #t3)))]! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 2/13/2005 12:04'!
testRestoreContext
	result _ emitter 
				restoreContextWithPC: 1
				stack: #().
	self should: 
			[self result = #(#(#block 1 #(#mov 3 #(#mem #(#add #currentContext 8))) #(#mov 1 #(#mem #(#add #currentContext 12))) #(#mov #currentContext #t1)))	"not needed for this test but all sends will need
															to save at least the receiver so it should 															always be needed in practice"]! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 2/13/2005 12:04'!
testRestoreContextWithStack
	result _ emitter 
				restoreContextWithPC: 0
				stack: ({ 
						MedLiteral literal: #abc}).
	self should: 
			[self result = #(#(#block 1 #(#mov 1 #(#mem #(#add #currentContext 8))) #(#mov 3 #(#mem #(#add #currentContext 12))) #(#mov #currentContext #t1) #(#mov #abc #(#mem #(#add #t1 28)))))]! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 2/13/2005 12:04'!
testRestoreContextWithStack2
	result _ emitter 
				restoreContextWithPC: 0
				stack: ({ 
						MedLiteral literal: #abc.
						MedLiteral literal: #def}).
	self should: 
			[self result = #(#(#block 1 #(#mov 1 #(#mem #(#add #currentContext 8))) #(#mov 5 #(#mem #(#add #currentContext 12))) #(#mov #currentContext #t1) #(#mov #abc #(#mem #(#add #t1 28))) #(#mov #def #(#mem #(#add #t1 32)))))]! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 2/13/2005 12:04'!
testRestoreContextWithTemporaries
	emitter numberOfTemporaries: 1.
	result _ emitter 
				restoreContextWithPC: 0
				stack: ({ 
						MedLiteral literal: #abc}).
	self should: 
			[self result = #(#(#block 1 #(#mov 1 #(#mem #(#add #currentContext 8))) #(#mov 5 #(#mem #(#add #currentContext 12))) #(#mov #currentContext #t1) #(#mov #abc #(#mem #(#add #t1 32)))))]! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 3/5/2005 00:03'!
testRestoreSendersFrame
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
			(mov (add esp 64) esp)
			(pop edi)
			(pop esi)
			(pop ebx)
			(mov ebp esp)
			(pop ebp) )).
	result := emitter restoreSendersFrame.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 3/4/2005 15:05'!
testReturn
	result := emitter ret.
	self assert: emitter result intermediateForm = #((block 1 (ret))).! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 3/4/2005 20:28'!
testReturnSequence
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
			(restoreSendersFrame)
			(ret) )).
	result := emitter returnSequence.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 3/4/2005 20:18'!
testReturnToCompiledMethod

	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	"emitter newBlock. ""Use the first block"
	mockEmitter expectEmission: 
		#((block1 

			(restoreSendersFrame)
			(jmp theValue))).

	result := emitter returnToCompiledMethod: (MedLiteral literal: #theValue).

	self verify			! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 3/6/2005 11:16'!
testSendMessage
	| answer |
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#((block1 
			(emitRestoreContext 13 receiver arg1 arg2) 
			(mov (address block3) 
			(mem (add (currentContextAddress) 20))) 

			(mov (emitClass receiver) eax)
			(mov #picEntry ecx)

			(mov literalAddress edx)
			(restoreSendersFrame)
			(pic eax)
			(mov (callFunction exuperySetupMessageSend edx 2 ecx) eax) 
			(jz block2 (sub eax 0)) 
			(jmp eax))						"Call compiled method"
		(block2 
			(mov 1 eax)
			(ret) 							"Return to interpreter"
			(alignedLabel) 
			(preamble) 
			(emitReloadStack t1))).
	mockEmitter 
		expectRegisterEntryPointPC: 27
		blockNumbered: #block3.	
	state pc: 12.
	answer := emitter 
				expandedSendSelector: (MedLiteral literal: #literalAddress)
				arguments: #(#receiver #arg1 #arg2).
	self assert: (answer isKindOf: MedMachineRegister).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 3/6/2005 10:57'!
testSendMessageCheckingPicEntry
	| picEntry |
	state pc: 12.
	emitter 
		expandedSendSelector: (MedLiteral literal: #literalAddress)
		arguments: #(#receiver #arg1 #arg2).
	picEntry := ((emitter result blockAt: 6) expressionAt: 10) picEntry class.
	self assert: picEntry = MedPicEntry.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 3/6/2005 11:17'!
testSendWithStack
	| answer |
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
			(#emitRestoreContext 11 #s1 #s2 #arg4 #arg5) 
			(#mov #(#address #block3) 
			(#mem #(#add #(#currentContextAddress) 20))) 

			(mov (emitClass arg4) eax)
			(mov picEntry ecx)

			(mov literalAddress edx)
			(restoreSendersFrame)
			(pic eax)

			(#mov #(#callFunction #exuperySetupMessageSend edx 1 ecx) eax) 
			(#jz #block2 #(#sub eax 0)) 
			(jmp eax)) 
		(block2 
			(mov 1 eax)
			(ret) 
			(alignedLabel) 
			(preamble) 
			(emitReloadStack s1 s2 t1))).
	"A real block begins here"
	mockEmitter 
		expectRegisterEntryPointPC: 23
		blockNumbered: #block3.	"An encoded SmallInteger"
	state heightTo: 2.
	answer := emitter 
				expandedSendSelector: (MedLiteral literal: #literalAddress)
				arguments: #(#arg4 #arg5).
	self assert: (answer isKindOf: MedLanguage).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 3/6/2005 11:20'!
testSendWithStack2
	| answer |
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#((block1 
			(emitRestoreContext 11 #s1 #s2 #s3 #arg4 #arg5 #arg6) 
			(mov #(#address #block3) 
			(mem #(#add #(#currentContextAddress) 20))) 

			(mov (emitClass arg4) eax)
			(mov picEntry ecx)

			(mov literalAddress edx)
			(restoreSendersFrame)
			(pic eax)

			(mov #(callFunction #exuperySetupMessageSend edx 2 ecx) eax) 
			(jz #block2 #(#sub eax 0)) 
			(jmp eax)) 
		#(#block2 
			(mov 1 eax)
			(ret)
			(alignedLabel) 
			(preamble) 
			(emitReloadStack #s1 #s2 #s3 #t1))).
	"A real block begins here"
	mockEmitter 
		expectRegisterEntryPointPC: 23
		blockNumbered: #block3.	"An encoded SmallInteger"
	state heightTo: 3.
	answer := emitter 
				expandedSendSelector: (MedLiteral literal: #literalAddress)
				arguments: #(#arg4 #arg5 #arg6).
	self assert: (answer isKindOf: MedLanguage).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 8/8/2004 13:17'!
testSetCurrentBlock
	| block |
	block := emitter result newBlock.
	emitter currentBlock: block.
	self assert: emitter currentBlock = block.
	self assert: self result = #((block 1) (block 2))! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 2/17/2005 21:48'!
testSetUpMessageSend
	result _ emitter 
				callFunctionNamed: #exuperySetupMessageSend
				with: ({ 
						MedLiteral literal: #receiver.
						MedLiteral literal: 1}).
	self assert: emitter result intermediateForm = #(#(#block 1 #(#push 1) #(#push #receiver) #(#mov #exuperySetupMessageSend #t1) #(#call #t1) #(#mov #eax #t2) #(#mov #(#add 8 #esp) #esp))).
	self assert: result intermediateForm = #t2! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/2/2004 21:24'!
testStackMaterialise
	| stack |
	stack :=  emitter exuperyStack.
		
	stack push: (MedLiteral literal: 'value1').
	stack push: (MedLiteral literal: 'value2').
	
	emitter materialiseStack.
	
	self assert: (self result = 
		#( (block 1
			(mov value1 s1)
			(mov value2 s2)))).
			
	self assert: stack pop name = #s2.
	self assert: stack pop name = #s1.
	
	self verify.! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/27/2004 23:05'!
testStackPeek
	| stack |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1
				(mov firstValue s1)
				(mov secondValue s2))).
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: #secondValue.

	self assert: stack peek name = #s2.
	self assert: stack peek name = #s2.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/29/2004 20:11'!
testStackRegister
	| variable |
	variable := emitter stackRegister: 1.
	self assert: variable name = #s1.
	self assert: (variable isKindOf: MedTemporaryRegister).
	variable := emitter stackRegister: 2.
	self assert: variable name = #s2.! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 5/3/2004 15:06'!
testStackRegisterSameSlot
	| s1a s1b |
	s1a := emitter stackRegister: 1.
	s1b := emitter stackRegister: 1.
	self assert: s1a = s1b.! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/29/2004 20:40'!
testStackRegisterWithTemps
	| variable |
	variable := emitter stackRegister: 1.
	variable := emitter stackRegister: 2.
	self assert: emitter createTemporaryRegister name = #t1.! !

!IntermediateEmissionTests methodsFor: 'Misc' stamp: 'wbk 7/16/2003 15:26'!
verify
	mockEmitter ifNotNil: [mockEmitter verify].! !

ExuperyTests subclass: #IntermediateGenerationTests
	instanceVariableNames: 'machine generator emitter result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!IntermediateGenerationTests methodsFor: 'Misc' stamp: 'wbk 3/1/2004 20:30'!
checkIsMed: anObject
	(anObject isKindOf: MedLanguage) ifTrue: [^ true].
	anObject isSequenceable ifTrue:
		[^ self assert: (#(emitSend emitWithFailTo emitConvertComparisionToBoolean emitClass) includes: (anObject at: 1))].
	self assert: (anObject isKindOf: MedLanguage).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"! !

!IntermediateGenerationTests methodsFor: 'Misc' stamp: 'wbk 10/4/2004 21:56'!
checkIsRegister: anObject 
	anObject isCollection ifTrue: 
		[(anObject at: 1) = #emitConvertLessOrEqualToBoolean ifTrue: [^ self].
		(anObject at: 1) = #emitMoveToTemp ifTrue: [^ self].
		(anObject at: 1) = #emitSend ifTrue: [^ self].
		(anObject at: 1) = #emitWithFailTo ifTrue: [^ self].
		(anObject at: 1) = #emitConditionalBytecode ifTrue: [^ self].
		(anObject at: 1) = #emitClass ifTrue: [^ self].
		(anObject at: 1) = #emitTemporaryAddress ifTrue: [^ self]].
	^ self assert: (anObject isKindOf: MedTemporaryRegister)! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 12/11/2004 21:46'!
expectIntegerWrappedCallTo: aSymbol failingTo: anInteger
	emitter addExpectedEmission: 
		{#emitWithFailTo. 5. 3. #t1. #t2.
			{#emitConvertToSmallInteger. #block2.
				{aSymbol.
					#(emitIntegerValueOf block2 t1).
					#(emitIntegerValueOf block2 t2) }}. anInteger}.! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 12/11/2004 22:43'!
expectWrappedCallWithFailBlockTo: aSymbol failingTo: anInteger
	emitter addExpectedEmission: 
		{#emitWithFailTo. 5. 3. #t1. #t2.
			{#emitConvertToSmallInteger. #block2.
				{aSymbol. #block2.
					#(emitIntegerValueOf block2 t1).
					#(emitIntegerValueOf block2 t2) }}. anInteger}.! !

!IntermediateGenerationTests methodsFor: 'Misc' stamp: 'wbk 3/17/2003 17:59'!
setUp
	emitter := MockIntermediateEmitter new.
	generator := IntermediateGenerator for: MachineX86 new.
	generator emitter: emitter.! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:28'!
testBitAnd
	self
		expectIntegerWrappedCallTo: #and
		failingTo: 14.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				bitAnd: (MedLiteral smallInteger: 1).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:28'!
testBitOr
	self
		expectIntegerWrappedCallTo: #or
		failingTo: 15.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				bitOr: (MedLiteral smallInteger: 1).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:44'!
testBitShifts
	self
		expectWrappedCallWithFailBlockTo: #bitShift
		failingTo: 12.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				bitShift: (MedLiteral smallInteger: 1).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 15:44'!
testBytecodePrimNewWithArg
	| answer |
	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitSpecialSelector 29) 4 5).
	answer := generator 
				generateBinarySelector: 29
				receiver: 4
				argument: 5.
	self checkIsMed: answer.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 3/1/2004 20:22'!
testClass
	emitter addExpectedEmission: #(#emitClass #abc).
	result := generator generateClass: #abc.
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 8/8/2004 13:11'!
testDiv
	self
		expectWrappedCallWithFailBlockTo: #emitDiv
		failingTo: 13.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				div: (MedLiteral smallInteger: 1).
	self should: [generator result numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 8/8/2004 13:11'!
testDivide
	self
		expectWrappedCallWithFailBlockTo: #emitDivide
		failingTo: 9.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				divide: (MedLiteral smallInteger: 1).
	self should: [generator result numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/28/2004 16:56'!
testEquivilent
	| answer |
	emitter addExpectedEmission: #(#emitConvertComparisionToBoolean jne (sub arg1 arg2) ).
	answer := generator 
				generate: #arg1
				equivilent: #arg2.
	self checkIsMed: answer.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 12/11/2004 22:44'!
testGenerateAddByteCode2
	emitter addExpectedEmission: 
		#(#emitWithFailTo 3 5 t1 t2
			#(#emitConvertToSmallInteger #block2 
				#(#add 
					#(#emitIntegerValueOf #block2 t1) 
					#(#emitIntegerValueOf #block2 t2))) 0).
	result := generator 
				generate: (MedLiteral smallInteger: 1)
				add: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:42'!
testGenerateEquals
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #jne 6).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				equals: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/12/2004 20:38'!
testGenerateGreaterThan
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #jle 3).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				greaterThan: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:23'!
testGenerateGreaterThanEqual
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 7 #jl 5).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				greaterThanEqual: (MedLiteral smallInteger: 3).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Jump' stamp: 'wbk 10/2/2004 23:20'!
testGenerateJumpIfFalse
	emitter addExpectedEmission: #(materialiseStack).
	emitter addExpectedEmission: #(#emitJumpIfFalse #(#emitLabelForByteCode 42) #anExpression).
	generator 
		jumpIfFalse: #anExpression
		to: 42.
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Jump' stamp: 'wbk 10/2/2004 23:19'!
testGenerateJumpIfTrue
	emitter addExpectedEmission: #(materialiseStack).
	emitter addExpectedEmission: #(#emitJumpIfTrue #(#emitLabelForByteCode 42) #anExpression).
	generator 
		jumpIfTrue: #anExpression
		to: 42.
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Jump' stamp: 'wbk 10/2/2004 23:19'!
testGenerateJumpTargetLabel
	emitter addExpectedEmission: #(materialiseStack).
	emitter addExpectedEmission: #(#emitJumpTarget 10).
	generator jumpTargets: #(10).
	generator byteCodeAddress: 10.
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 8/8/2004 13:12'!
testGenerateMinusByteCode
	self
		expectIntegerWrappedCallTo: #sub
		failingTo: 1.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				subtract: (MedLiteral smallInteger: 1).
	self should: [generator result numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 19:14'!
testGenerateNotEquals
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #je 7).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				notEquals: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 10/23/2004 18:58'!
testGeneratePopIntoTemp
	generator := IntermediateGenerator for: MachineX86 new.
	result := generator
		popIntoTemp: (MedLiteral smallInteger: 1)
		slot: 0.
	self should: 
		[result intermediateForm = #(storeInTemp 0 3)].
	self should: [generator result numberOfBlocks = 1].
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 10/23/2004 18:59'!
testGeneratePopIntoTemp2
	generator := IntermediateGenerator for: MachineX86 new.
	result := generator
		popIntoTemp: (MedLiteral smallInteger: 10)
		slot: 2.
	self should: 
		[result intermediateForm = #(storeInTemp 2 21)].
	self should: [generator result numberOfBlocks = 1].
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 10/4/2004 21:55'!
testGeneratePushTemp
	emitter addExpectedEmission: #(#emitTemporaryAddress 0).
	result := generator pushTempAt: 0.
	self should: [generator result numberOfBlocks = 1].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 2/13/2005 12:53'!
testGenerateReturnFalse
	emitter addExpectedEmission: #(#emitReturnValue #(#falseAddress)).
	generator returnFalse.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 2/13/2005 12:54'!
testGenerateReturnNil
	emitter addExpectedEmission: #(#emitReturnValue #(#nilAddress)).
	generator returnNil.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 2/13/2005 12:58'!
testGenerateReturnSelf
	emitter addExpectedEmission: #(#emitReturnValue #(#receiverAddress)).
	generator returnSelf.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 10/2/2004 12:14'!
testGenerateReturnTop
	|method |
	method := ByteCodeReaderTests compiledMethodAt: #return4.
	generator := IntermediateGenerator for: MachineX86 new.
	ByteCodeReader
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	self assert: generator intermediateString = 
		#((block 1 
			(return 9))).
	self verify.
	! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 2/13/2005 12:59'!
testGenerateReturnTrue
	emitter addExpectedEmission: #(#emitReturnValue #(#trueAddress)).
	generator returnTrue.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 22:13'!
testGenerateSendLessOrEqual
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #jg 4).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				lessThanEquals: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 20:55'!
testGenerateSendLessThan
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #jge 2).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				lessThan: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 8/8/2004 13:13'!
testGenerateSendMultiply
	self
		expectWrappedCallWithFailBlockTo: #emitMultiply
		failingTo: 8.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				multiply: (MedLiteral smallInteger: 1).
	self should: [generator result numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Jump' stamp: 'wbk 2/13/2005 12:46'!
testGenerateUnconditionalJump
	emitter addExpectedEmission: #(#materialiseStack).
	emitter addExpectedEmission: #(#jmp #(#emitLabelForByteCode 42)).
	generator jumpTo: 42.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Misc' stamp: 'wbk 10/4/2004 21:58'!
testIntermediateForReturnString
	|method|
	"(mem (add (mem (add  (mem (add ebp 8)) 12)) 8)) is all that we want to test, the rest is the return byte code"
	method := ByteCodeReaderTests compiledMethodAt: #returnString.
	generator := IntermediateGenerator for: MachineX86 new.
	ByteCodeReader
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	self should: [generator intermediateString = 
		#((block 1 
			(return (mem (add (mem (add currentContext 16)) 8))) ))].
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/13/2004 20:38'!
testMakePoint
	| answer |
	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitSpecialSelector 11) 4 5).
	answer := generator 
				generate: 4
				makePoint: 5.
	self checkIsMed: answer.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 8/8/2004 13:13'!
testMod
	self
		expectWrappedCallWithFailBlockTo: #emitMod
		failingTo: 10.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				mod: (MedLiteral smallInteger: 1).
	self should: [generator result numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 7/31/2003 17:12'!
testPopStack
	generator popStack: 5.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 12/19/2004 14:45'!
testPopStackMove
	| move |
	"emitter addExpectedEmission: #(mov 10 t2)."
	generator := IntermediateGenerator for: MachineX86 new.
	move := IntermediateCreator 
		createExpression: #(mov 10 t2)
		for: MachineX86 new.
	generator popStack: move.
	self assert: generator result intermediateForm = #((block 1 (mov 10 t2))).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 2/13/2005 12:53'!
testPushFalse
	emitter addExpectedEmission: #(#emitMoveToTemp #(#falseAddress)).
	result _ generator pushFalse.
	self verify.
	self assert: result = #(#emitMoveToTemp #(#falseAddress))! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 11/3/2004 22:57'!
testPushInstanceVariable
	emitter addExpectedEmission: #(#instanceVariableAddress 5 ).
	result := generator pushInstanceVariable: 5.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 1/10/2004 15:14'!
testPushLiteralVariable
	" The address 1 below is counting from zero. It is accessing the value in the 	ReadOnlyValueBinding 	or Association that holds the variable 'Array'."

	emitter addExpectedEmission: #(#mov #(#emitFetchAddress 1 #(#emitLiteralAddress 5)) #t1).	"could use emitMoveToTemp rather than doing it explicitly"	"Fetching the address get's the value from the variable's holder"
	result := generator 
				pushLiteralVariable: #aName
				slot: 5.
	self assert: result intermediateForm = #t1.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 2/13/2005 12:54'!
testPushNil
	emitter addExpectedEmission: #(#emitMoveToTemp #(#nilAddress)).
	result _ generator pushNil.
	self assert: result = #(#emitMoveToTemp #(#nilAddress)).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 2/13/2005 12:58'!
testPushSelf
	emitter addExpectedEmission: #(#emitMoveToTemp #(#receiverAddress)).
	result _ generator pushSelf.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 2/13/2005 12:59'!
testPushTrue
	emitter addExpectedEmission: #(#emitMoveToTemp #(#trueAddress)).
	result _ generator pushTrue.
	self assert: result = #(#emitMoveToTemp #(#trueAddress)).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 12/12/2004 21:29'!
testSendAt
	"Explicit send and inlined operation must use the same register"

	emitter addExpectedEmission: #(#emitWithFailTo arg1 arg2 t1 t2 #(#emitAtElementAddress t1 t2 #block2 0) 16).
	result := generator 
				sendAtTo: #arg1
				with: #arg2.
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 12/13/2004 21:54'!
testSendAtPut
	" The emitMov is really coded as part of the block that is wrapped by emitWithFailTo, but
	the mock system can't yet encode this so I've told the emitter to expect it first.
	The problem is that the mock framework doesn't handle block additions that well, it does handle
	code that is built up as an expression."


	emitter addExpectedEmission: #(#emitWithFailTo receiver index value t1 t2 t3 (atPut t1 t2 t3 block2) 17).
	result := generator 
				sendAtPutTo: #receiver
				location: #index
				value: #value.
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Send Generation' stamp: 'wbk 1/10/2004 15:14'!
testSendMessage
	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitLiteralAddress 3)).
	result := generator 
				sendSelector: #basicTarget
				inSlot: 3
				arguments: #().
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Send Generation' stamp: 'wbk 1/10/2004 15:14'!
testSendMessageWithStackValues
	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitLiteralAddress 3) #abc #def).
	result := generator 
				sendSelector: #basicTarget
				inSlot: 3
				arguments: #(#abc #def).
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Send Generation' stamp: 'wbk 1/10/2004 15:14'!
testSendMessageWithStackValues2
	"Tests real stack values as well as arguments"

	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitLiteralAddress 3) #abc #def).
	result := generator 
				sendSelector: #basicTarget
				inSlot: 3
				arguments: #(#abc #def).
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 11/1/2004 20:53'!
testStoreAndPopInstanceVariable
	emitter addExpectedEmission: #(storeInReceiver 5 theValue).
	generator 
		storeAndPopReceiverVariableIndex: 5
		value: #theValue.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 14:04'!
testUnarySelector
	| answer |
	emitter addExpectedEmission: #(#emitSend #(#emitSpecialSelector 16) 4).
	answer := generator 
		generateUnarySelector: 16
		receiver: 4.
	self checkIsMed: answer.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Misc' stamp: 'wbk 10/22/2004 23:09'!
verify
	emitter verify.
	"Its no longer required that bytecodes return registers, they are supposed
	to return mid level intermediate now"
	"result ifNotNil: [self checkIsRegister: result]"! !

ExuperyTests subclass: #JumpTargetTests
	instanceVariableNames: 'generator method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!JumpTargetTests methodsFor: 'Misc' stamp: 'wbk 5/30/2004 23:37'!
checkNoTargetsForMethod: methodName in: className 
	method := className compiledMethodAt: methodName.
	generator := JumpTargetRecorder new.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	self should: [generator targets size = 0]! !

!JumpTargetTests methodsFor: 'Misc' stamp: 'wbk 5/30/2004 23:45'!
findTargetsFor: aSymbol inClass: aClass
	method := aClass compiledMethodAt: aSymbol.
	generator := JumpTargetRecorder new.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:44'!
testBenchFibStackTracing
	self
		findTargetsFor: #benchFib
		inClass: Integer.
	self should: [generator stackTrace asArray = #(0 1)]! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/4/2004 20:17'!
testBitAnd
	self
		checkNoTargetsForMethod: #bitAnd
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/5/2004 20:40'!
testBitOr
	self
		checkNoTargetsForMethod: #bitOr
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 18:56'!
testBitShift
	self
		checkNoTargetsForMethod: #bitShift
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 3/1/2004 19:06'!
testClass
	self
		checkNoTargetsForMethod: #sendClass
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/5/2004 22:03'!
testDiv
	self
		checkNoTargetsForMethod: #div
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 1/18/2004 17:21'!
testDivide
	self
		checkNoTargetsForMethod: #divide
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:33'!
testEquals
	self
		checkNoTargetsForMethod: #equals
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/27/2004 21:22'!
testEquivilent
	self
		checkNoTargetsForMethod: #sendEquivilent
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:46'!
testFindEmptyStackTracing
	self
		findTargetsFor: #return4
		inClass: ByteCodeReaderTests.
	self should: [generator stackTrace asArray = #()]! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:47'!
testFindJumpTargets
	self
		findTargetsFor: #ifTrueIfFalse
		inClass: ByteCodeReaderTests.
	method := ByteCodeReaderTests compiledMethodAt: #ifTrueIfFalse.
	self should: [generator targets asArray = #(11)]! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 7/9/2004 20:49'!
testFindJumpTargetsFoSimpleMinus
	self
		checkNoTargetsForMethod: #simpleMinus
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Sends' stamp: 'wbk 1/24/2004 15:30'!
testFindJumpTargetsForBytecodePrimSendWithArg
	self
		checkNoTargetsForMethod: #bytecodePrimSendWithArg
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 7/9/2004 20:50'!
testFindJumpTargetsForIterativeFactorial
	self
		findTargetsFor: #iterativeFactorial:
		inClass: ByteCodeReaderTests.
	self should: [generator targets asArray = #(24 9)]! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testFindJumpTargetsForPushFalse
	self
		checkNoTargetsForMethod: #popStack
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testFindJumpTargetsForPushMinusOne
	self
		checkNoTargetsForMethod: #pushMinusOne
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testFindJumpTargetsForPushNil
	self
		checkNoTargetsForMethod: #pushNil
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 7/9/2004 20:52'!
testFindJumpTargetsForReturnAddSmallInt
	self
		checkNoTargetsForMethod: #returnAddSmallInt
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 1/24/2004 15:32'!
testFindJumpTargetsForSendAtPut
	self
		checkNoTargetsForMethod: #atPutSend
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testFindJumpTargetsForStoreAndPopReceiverVariables
	self
		checkNoTargetsForMethod: #storeAndPopReceiverVariable
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:47'!
testFindNestedStackTracing
	self
		findTargetsFor: #nestedIfTrueIfFalse
		inClass: ByteCodeReaderTests.
	self should: [generator stackTrace asArray = #(0 1)]! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 6/11/2004 22:01'!
testFindStackTracing
	self
		findTargetsFor: #recursivefTrueIfFalse
		inClass: ByteCodeReaderTests.
	self assert: generator stackTrace asArray = #(0 1 0 1).
	self assert: generator targets asArray = #(21 26 25 26).! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/12/2004 21:47'!
testGreaterThan
	self
		checkNoTargetsForMethod: #greaterThan
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:15'!
testGreaterThanEqual
	self
		checkNoTargetsForMethod: #greaterThanEqual
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/12/2003 22:31'!
testJumpTargetsInPushInstanceVariable
	self 
		checkNoTargetsForMethod: #a
		in: ExuperyInstanceVariables! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/12/2003 21:52'!
testJumpTargetsInPushLiteralVariable
	self
		checkNoTargetsForMethod: #pushLiteralVariable
		in: TestExuperyPlugin! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/12/2003 21:53'!
testJumpTargetsInPushSelf
	self
		checkNoTargetsForMethod:  #returnSelf
		in: TestExuperyPlugin! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testJumpTargetsInPushTrue
	self
		checkNoTargetsForMethod: #pushConstantTrue
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 1/24/2004 15:32'!
testJumpTargetsInSendAt
	self
		checkNoTargetsForMethod: #atSend
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Sends' stamp: 'wbk 10/12/2003 21:54'!
testJumpTargetsInSendLiteralSelector
	self
		checkNoTargetsForMethod: #basicSend
		in: TestExuperyPlugin! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/6/2004 22:37'!
testLessThan
	self
		checkNoTargetsForMethod: #lessThan
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:48'!
testLongJumpIfTrue
	self
		findTargetsFor: #longJumpIfTrue
		inClass: ByteCodeReaderTests.
	self should: [generator targets asArray = #(16)]! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/14/2004 15:11'!
testMakePoint
	self
		checkNoTargetsForMethod: #makePoint
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/7/2004 20:32'!
testMod
	self
		checkNoTargetsForMethod: #mod
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/14/2004 15:11'!
testNew
	self
		checkNoTargetsForMethod: #sendNew
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 15:06'!
testNext
	self
		checkNoTargetsForMethod: #sendNext
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 18:58'!
testNotEquals
	self
		checkNoTargetsForMethod: #notEquals
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Return' stamp: 'wbk 1/17/2004 22:04'!
testReturnFalse
	self
		checkNoTargetsForMethod: #returnFalse
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Return' stamp: 'wbk 1/17/2004 22:04'!
testReturnNil
	self
		checkNoTargetsForMethod: #returnNil
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Return' stamp: 'wbk 1/17/2004 22:04'!
testReturnTrue
	self
		checkNoTargetsForMethod: #returnTrue
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:49'!
testShortUnconditionalJump
	self
		findTargetsFor: #shortUnconditionalJump
		inClass: ByteCodeReaderTests.
	self should: [generator targets asArray = #(17 19)]! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 13:15'!
testSize
	self
		checkNoTargetsForMethod: #sendSize
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 6/6/2004 16:42'!
testStackTracingForBenchmark
	self
		findTargetsFor: #benchmark
		inClass: Integer.
	self should: [generator stackTrace asArray = #(0 0 0 0 0 0 0)]! !

ExuperyTests subclass: #LatticeTests
	instanceVariableNames: 'machine interferenceGraph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!LatticeTests methodsFor: 'Misc' stamp: 'wbk 7/8/2004 21:50'!
newLattice
	^NodeLattice new! !

!LatticeTests methodsFor: 'Misc' stamp: 'wbk 7/8/2004 19:47'!
newNode: aSymbol 
	| register answer |
	register := machine registerNamed: aSymbol.
	answer := InterferenceNode 
				for: register
				with: machine
				interferenceGraph: #().
	interferenceGraph 
		at: register
		put: answer.
	^answer! !

!LatticeTests methodsFor: 'Misc' stamp: 'wbk 7/1/2004 20:43'!
setUp
	machine := MachineX86 new.
	interferenceGraph := Dictionary new.! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 7/1/2004 21:31'!
testAdd
	| lattice node1 node2 lattice2 answer |
	lattice := self newLattice.
	lattice2 := self newLattice.
	node1 := self newNode: #t1.
	node2 := self newNode: #t2.
	lattice addNode: node1.
	lattice2 addNode: node2.
	
	answer := lattice + lattice2.
		
	self assert: (answer asSet includes: node1).
	self assert: (answer asSet includes: node2).
	self assert: answer asSet size = 2.! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/27/2004 21:51'!
testAddNode
	| lattice node1 |
	lattice := self newLattice.
	node1 := self newNode: #t1.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1)! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/28/2004 23:05'!
testAddNodeTwice
	| lattice node1 |
	lattice := self newLattice.
	node1 := self newNode: #t1.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/27/2004 22:20'!
testAddTwoNode2
	| lattice node1 node2 |
	lattice := self newLattice.
	node1 := self newNode: #t1.
	node2 := self newNode: #t2.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2) not.
	lattice addNode: node2.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2).! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/28/2004 22:22'!
testAsSet
	| lattice |
	lattice := self newLattice.	
	self assert: lattice asSet class = Set.
	self assert: lattice asSet isEmpty.! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/28/2004 23:12'!
testAsSet2
	| lattice node1 node2 |
	lattice := self newLattice.
	node1 := self newNode: #t1.
	node2 := self newNode: #t2.
	lattice addNode: node1.
	lattice addNode: node2.
		
	self assert: (lattice asSet includes: node1).
	self assert: (lattice asSet includes: node2).
	self assert: lattice asSet size = 2.! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/27/2004 22:43'!
testCreatingStackRegisters
	| lattice node1 node2 |
	lattice := self newLattice.
	node1 := machine stackRegister: 1.
	node2 := machine stackRegister: 2.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2) not.
	lattice addNode: node2.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2).! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/27/2004 22:41'!
testCreatingTemporaries
	| lattice node1 node2 |
	lattice := self newLattice.
	node1 := machine createTemporaryRegister.
	node2 := machine createTemporaryRegister.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2) not.
	lattice addNode: node2.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2).! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 7/1/2004 20:48'!
testNodesDo
	| lattice node1 node2 answer |
	lattice := self newLattice.
	node1 := machine createTemporaryRegister.
	node2 := machine createTemporaryRegister.
	interferenceGraph
		at: node1
		put: node1.
	interferenceGraph
		at: node2
		put: node2.
	answer := OrderedCollection new.

	lattice addNode: node1.
	lattice addNode: node2.
	
	lattice nodesDo: [:each| answer add: each].	
	self assert: (answer includes: node1).
	self assert: (answer includes: node2).! !

ExuperyTests subclass: #LivenessAnalysisTests
	instanceVariableNames: 'source analyser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testBasicLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (add esp t1)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(esp t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 10:43'!
testCall
	source := MedMethod 
		createAssembly: #((block 1 (call 1234)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #()
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 2/9/2005 20:38'!
testCallKillsEax
	source := MedMethod 
		createAssembly: #((block 1 (call 1234) (add eax eax) ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #()
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 7/5/2003 14:42'!
testCallRegister
	source := MedMethod 
		createAssembly: #((block 1 (call t1)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 1/31/2004 21:16'!
testCdq
	source := MedMethod 
		createAssembly: 
			#((block 1 
				(cdq)
				(add edx edx)
				))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self assert: 
		(analyser 
			isLive: #(eax)
			at: 1).! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 1/29/2004 22:09'!
testDivide
	source := MedMethod 
		createAssembly: 
			#((block 1 
				(mov 12 eax)
				(mov 0 edx)
				(div t1)
				(mov eax t2)
				(mov edx t3)
				(add t2 t3)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self assert: 
		(analyser 
			isLive: #(t1)
			at: 1).
	self assert:
		(analyser
			isLive: #(eax edx t1)
			at: 3).! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testIndirectAddress2LivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov (t1) (t2))))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t2)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testIndirectAddressLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov t1 (t2))))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t2)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testIndirectAddressWithArithmaticExpressionLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (add (t1) (t2))))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t2)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 2/4/2005 23:21'!
testJumpCalculated
	source := MedMethod 
		createAssembly: #((block 1 (jmp t1)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testJumpLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov 1 t1) (mov 1 t2) (mov 1 t3) (jo block2) (add t1 t3) )
			(block 2 (add t2 t3) ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			at: 4].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testJumpLoopLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (add t1 t3) (add t2 t3) (mov 1 t1) (mov 1 t2) (mov 1 t3) (jo block1)  )
			(block 2 ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			at: 6].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:54'!
testMovInstructionLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov t1 t2)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:55'!
testMultipleStatementLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (add esp t1) (add t2 t3) ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(esp t1 t2 t3)
			at: 1].
	self should: 
		[analyser 
			isLive: #( t2 t3)
			at: 2].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:55'!
testMultipleStatementMovLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov t1 t2) (add t2 t3) ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t3)
			at: 1].
	self should: 
		[analyser 
			isLive: #( t2 t3)
			at: 2].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 20:13'!
testNeg
	source := MedMethod 
		createAssembly: 
			#((block 1
				(add t2 t2) 
				(neg t2)
				(mov t3 t4)
				))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self assert: 
		(analyser 
			isLive: #(t2 t3)
			at: 2).! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:55'!
testNestedLoopLivenessAnalysis
	source := MedMethod 
		createAssembly: #(  (block 1 (mov 1 t6) (add t4 t6) (add t5 t6) (jmp block2) )
							(block 2 (add t1 t3) (add t2 t3) (mov 1 t1) (mov 1 t2) (mov 1 t3) 
								(jo block2)  )
							(block 3 (mov 1 t4)  (mov 1 t5) (jmp block1) ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1 t2 t3 t4 t5)
			block: 1
			at: 1].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			block: 1
			at: 4].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			block: 2
			at: 6].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			block: 2
			at: 1].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			block: 3
			at: 1].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3 t4 t5)
			block: 3
			at: 3].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 2/26/2005 21:55'!
testPic
	source := MedMethod 
		createAssembly: #((block 1 (pic t1) ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:59'!
testPop
	source := MedMethod 
		createAssembly: #((block 1 (pop eax) (add eax eax)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #()
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 11:44'!
testPush
	source := MedMethod 
		createAssembly: #((block 1 (push t1)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 16:34'!
testRet
	source := MedMethod 
		createAssembly: #((block 1 (ret)))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.
	self should: 
		[analyser 
			isLive: #(eax)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 4/11/2003 12:55'!
testSingeBlockLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 
			(mov 5 t1)
			(add 6 t1)
			(mov 7 t2)
			(add t2 t1)
			(mov 10 t3)
			(add 11 t3) ))
		for: MachineX86 new.
	analyser := LivenessAnalyser on: source.

	self should: 
		[analyser 
			isLive: #()
			at: 1].
	self should:
		[analyser
			isLive: #()
			at: 5].! !

!LivenessAnalysisTests methodsFor: 'Support' stamp: 'wbk 4/11/2003 09:47'!
verify
	source instructionsDo: 
		[:each| each in do: [:eachRegister| self assert: eachRegister isRegister ].
		each out do: [:eachRegister| self assert: eachRegister isRegister]]! !

ExuperyTests subclass: #TestEndToEnd
	instanceVariableNames: 'source analyser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!TestEndToEnd methodsFor: 'Sample Methods' stamp: 'wbk 7/2/2003 12:20'!
stringConcatentate
	^ 'abc', 'def'! !

!TestEndToEnd methodsFor: 'Tests' stamp: 'wbk 8/7/2004 00:49'!
testBenchFib
	"This method was causing a register allocator bug. It failed to compile."
	Exupery 
		compileMethod: (Integer compiledMethodAt: #benchFib).! !

!TestEndToEnd methodsFor: 'Tests' stamp: 'wbk 4/18/2004 22:20'!
testStringConcatenate
	"An end to end test to make sure all the compiler stages hang together"
	Exupery 
		compileMethod: (TestEndToEnd compiledMethodAt: #stringConcatentate).! !

TestCase subclass: #TestExuperyPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 10/11/2003 17:19'!
additionOverflow
	^ 1000000000 + 1000000000! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/6/2003 14:29'!
basicSend
	^ self basicTarget + 1! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 9/28/2004 23:01'!
basicTarget
	^ 2 + 3! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 7/19/2003 16:26'!
bytecodePrimSendWithArg
	^ Array new: 5! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 11/22/2003 17:49'!
checkIsNotRootObject: anExuperyInstanceVariables 
	self 
		should: [self checkIsRootObject: anExuperyInstanceVariables]
		raise: Error! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 11/12/2003 21:36'!
checkIsRootObject: anExuperyInstanceVariables 
	<primitive: 'checkIsRootObject' module: 'ExuperyPlugin'>
	Error signal.
! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 10/3/2004 11:23'!
compile: aString 
	self
		compileMethod: aString
		into: #example! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 3/3/2005 22:35'!
compile: sourceMethod into: targetMethod
	Exupery
		compileMethod: sourceMethod
		into: targetMethod
		forClass: self class.! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 3/3/2005 22:36'!
compile: sourceMethod into: targetMethod class: aClass
	
	Exupery
		compileMethod: sourceMethod
		into: targetMethod
		forClass: aClass.! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 10/3/2004 11:36'!
compileExpression: aString 
	self 
		compile: ' ^ ', aString! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 10/3/2004 11:38'!
compileMethod: aString into: aSymbol 
	self class
		compile: aSymbol, ' ', aString
		classified: 'Generated'.
	self
		compile: aSymbol
		into: aSymbol! !

!TestExuperyPlugin methodsFor: 'Generated' stamp: 'wbk 3/7/2005 22:44'!
example |a| a := 1. ^(a:= a +1) + (a := a + 1)! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
extendedSend
	self method1.
	self method2.
	self method3.
	self method4.
	self method5.
	self method6.
	self method7.
	self method8.
	self method9.
	self method10.
	self method11.
	self method12.
	self method13.
	self method14.
	self method15.
	self method16.
	^ self method17.! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 4/11/2003 18:12'!
iterativeFactorial
	|acc n|
	n := 3.
	acc := 1.
	1
		to: n
		do: [:each| acc := acc * each].
	^ acc! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 4/11/2003 16:29'!
lessThanEqualsWhenEquals
	^ 2 <= 2! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 4/11/2003 14:27'!
lessThanEqualsWhenGreater
	^ 3 <= 2! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 4/7/2003 18:46'!
lessThanEqualsWhenLess
	^ 2 <= 3! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:28'!
longJumpIfFalseOnNonInteger
	TestExuperyPlugin new
		ifTrue: [^ 1 + 2].
	^ 42! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/13/2004 23:10'!
longJumpIfTrue
	true ifFalse:
		[^ 1+2.].
	^ 42! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:19'!
longJumpIfTrueOnFalse
	false ifFalse:
		[^ 1+2.].
	^ 42! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:27'!
longJumpIfTrueOnNonInteger
	TestExuperyPlugin new
		ifFalse: [^ 1 + 2].
	^ 42! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method1
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method10
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method11
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method12
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method13
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
method14
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
method15
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
method16
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
method17
	^ 42! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method2
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method3
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method4
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method5
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method6
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method7
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method8
	^ 1! !

!TestExuperyPlugin methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method9
	^ 1! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/15/2004 12:20'!
mustBeBoolean
	ExuperyTestException signal! !

!TestExuperyPlugin methodsFor: 'Primitive Support' stamp: 'wbk 4/18/2003 15:54'!
pointerToReturn42
	<primitive: 'pointerToReturn42' module: 'ExuperyPlugin'>
	TestFailure signal! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 7/31/2003 17:24'!
popStack
	1 printString.
	^ 5! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 10/4/2003 18:47'!
pushConstantMinusOne
	"The variable a is used to avoid a quick return method. This way we use the desired bytecode
	rather than the short-cut primitive"
	| a |
	a := -1.
	^ a! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 10/4/2003 19:19'!
pushConstantNil
	| a |
	a :=  nil.
	^ a! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 10/4/2003 19:19'!
pushConstantTrue
	| a |
	a :=  true.
	^ a! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 7/11/2003 11:25'!
pushConstantZero
	" The shuffle through a temporary is so we actually use the push constant zero bytecode
	rather than the fast return 0 primitive"
	|a|
	a := 0.
	^ a! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 7/30/2003 18:01'!
pushFalse
	| a |
	a := false.
	^ a! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 7/11/2003 22:34'!
pushLiteralVariable
	^ Array! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/9/2004 15:58'!
return4
	^ 4! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 3/30/2003 21:09'!
return43
	^ 43! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/9/2004 15:58'!
return5
	^ 5! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/9/2004 15:58'!
return6
	^ 6! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/9/2004 15:58'!
return7
	^ 7! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/14/2004 21:39'!
return8
	^ 8! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/14/2004 21:39'!
return9
	^ 9! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/11/2003 18:42'!
returnArgument: anInteger
	^ anInteger * 2! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 11/27/2003 19:52'!
returnFalse
	'Forcing a returnNil bytecode rather than a quick return primitive'.
	^ false! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/18/2003 12:27'!
returnNil
	'Forcing a returnNil bytecode rather than a quick return primitive'.
	^ nil! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 12/28/2002 17:05'!
returnNumber
	"This method will be overridden by a compiled method that returns 42"
	^ 5! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/20/2003 17:06'!
returnSelf
	|answer|
	answer := self.
	^ answer! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/16/2003 22:23'!
returnSelfBytecode
	'Just making sure that we really generate a returnReceiver bytecode'.
	^ self! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/7/2003 16:12'!
returnString
	^ 'Hello World'! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 11/24/2003 23:18'!
returnTrue
	'Forcing a returnNil bytecode rather than a quick return primitive'.
	^ true! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/23/2003 23:37'!
sendAt: anInteger Put: anObject to: anArray
	^ anArray 
		at: anInteger
		put: anObject.! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 23:09'!
sendAt: anInteger to: anArray
	^ anArray 
		at: anInteger.! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 8/15/2003 14:04'!
sendAtOutsideTheArray: anArray
	^ anArray at: 4! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 7/31/2003 16:12'!
sendAtPut: anArray
	^ anArray 
		at: 3
		put: 50.! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 7/19/2003 22:31'!
sendPrimAt: anArray
	^ anArray at: 2! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/17/2004 21:20'!
sendReturn4
	^ self return4 + 10! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/17/2004 22:24'!
sendReturn4Hook
	^ self return4 + 20! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/17/2004 21:21'!
sendReturn6
	^ self return6 + 10! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/17/2004 22:25'!
sendReturn6Hook
	^ self return6 + 20! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/2/2003 11:03'!
sendStringConcatenate
	^ 'abc', 'def'! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/4/2003 12:56'!
sendWithArg1: arg1 arg2: arg2
	| a b |
	a := 4.
	b := 5.
	^ self basicTarget + 1 + a + b + arg1 + arg2! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/2/2003 15:52'!
sendWithTemporaries
	| a b |
	a := 4.
	b := 5.
	^ self basicTarget + 1 + a + b! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 9/29/2004 21:31'!
sendWithTemporariesSimple
	| b |
	b := 5.
	^ self basicTarget +  b ! !

!TestExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 4/18/2004 22:20'!
setUp
	Exupery initialiseExupery! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/28/2004 16:11'!
shortUnconditionalJump
^ 20 = 20 ifFalse: [^ 15 + 20].! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/28/2004 16:12'!
shortUnconditionalJump2
^ 20 = 20 ifFalse: [^ #success]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testAddMultipleValues
	self compileExpression: '2 + 3 + 4 + 5'.
	self should: [self example = 14]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:33'!
testAddMultipleValuesWithTemps
	self compile: '|a b| a := 3. b := 4. ^ 2 + a + b'.
	self should: [self example = 9]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 9/19/2004 18:43'!
testAddThreePlusFour
	self 
		compile: #threePlusFour
		into: #returnNumber.
	self should: [self returnNumber = 7]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testAddThreeValues
	self compileExpression: '2 + 3 + 4'.
	self should: [self example = 9]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testAdditionArgumentNotInteger
	self compileExpression: '3 + 4.0'.
	self should: [self example = 7.0]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/11/2003 17:20'!
testAdditionOverflow
	self 
		compile: #additionOverflow
		into: #additionOverflow.
	self should: [self additionOverflow = 2000000000]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testAdditionReceiverNotInteger
	self compileExpression: '3.0 + 2'.
	self should: [self example = 5.0]! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testAnd
	self compileExpression: ' 3 bitAnd: 3'.
	self assert: self example = 3! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testAnd2
	self compileExpression: ' 3 bitAnd: 1'.
	self assert: self example = 1! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testAnd3
	self compileExpression: ' 5 bitAnd: 3'.
	self assert: self example = 1! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testAndArgumentOverflow
	self compileExpression: ' 5 bitAnd: 50000000006'.
	self assert: self example = 4! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testAndReceiverOverflow
	self compileExpression: ' 50000000002 bitAnd: 3'.
	self assert: self example = 2! !

!TestExuperyPlugin methodsFor: 'Test - Assembling Methods' stamp: 'wbk 4/17/2003 10:38'!
testAssembledReturn43
	self 
		compile: #return43
		into: #returnNumber.
	self should: [self returnNumber = 43]! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 23:10'!
testAtAfter
	| array answer |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self 
		compile: #sendAt:to:
		into: #sendAt:to:.
	self
		should:
			[answer := self 
				sendAt: 4
				to: array]
		raise: Error.
	self assert: answer = nil.
	self assert: array = #(10 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 23:10'!
testAtBefore
	| array answer |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self 
		compile: #sendAt:to:
		into: #sendAt:to:.
	self
		should:
			[answer := self 
				sendAt: 0
				to: array]
		raise: Error.
	self assert: answer = nil.
	self assert: array = #(10 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testAtEnd
	self compileExpression: '(ReadStream on: #()) atEnd'.
	self assert: self example = true! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testAtEnd2
	self compileExpression: '(ReadStream on: #(1 2 3 4)) atEnd'.
	self assert: self example = false! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 3/20/2004 14:55'!
testAtFirst
	| array answer |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self 
		compile: #sendAt:to:
		into: #sendAt:to:.
	answer := self 
		sendAt: 1
		to: array.
	self assert: answer = 10.
	self assert: array = #(10 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 3/20/2004 14:55'!
testAtLast
	| array answer |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self 
		compile: #sendAt:to:
		into: #sendAt:to:.
	answer := self 
		sendAt: 3
		to: array.
	self assert: answer = 30.
	self assert: array = #(10 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 22:50'!
testAtPutAfter
	| array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1
		put: 11. "Prime the atCache"
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	self
		should:
			[self 
				sendAt: 4
				Put: 50
				to: array]
		raise: Error.
	self assert: array = #(11 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 22:49'!
testAtPutBefore
	| array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1
		put: 11. "Prime the atCache"
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	self
		should:
			[self 
				sendAt: 0
				Put: 50
				to: array]
		raise: Error.
	self assert: array = #(11 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 20:25'!
testAtPutBothOld
	| newObject array |
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.

	newObject := 'A new string' copy.
	array := Array 
		with: 10
		with: 20
		with: 30.
	Smalltalk garbageCollect.

	array
		at: 1
		put: 11. "Prime the atCache"
	self checkIsNotRootObject: array.
	self
		sendAt: 1
		Put: newObject
		to: array.

	self checkIsNotRootObject: array.
	self assert: array = #( 'A new string' 20 30)! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 20:25'!
testAtPutBothYoung
	| newObject array |
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.

	Smalltalk garbageCollect.
	newObject := 'A new string' copy.
	array := Array 
		with: 10
		with: 20
		with: 30.

	array
		at: 1
		put: 11. "Prime the atCache"
	self checkIsNotRootObject: array.
	self
		sendAt: 1
		Put: newObject
		to: array.

	self checkIsNotRootObject: array.
	self assert: array = #( 'A new string' 20 30)! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 22:48'!
testAtPutFirst
	| answer array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	array
		at: 1
		put: 11. "Prime the atCache"
	answer := self 
		sendAt: 1
		Put: 50
		to: array.
	self assert: answer = #50.
	self assert: array = #(50 20 30).
	! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 00:06'!
testAtPutFromOldToYoung
	| newObject array |
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.

	array := Array 
		with: 10
		with: 20
		with: 30.
	Smalltalk garbageCollect.
	newObject := 'A new string' copy.

	array
		at: 1
		put: 11. "Prime the atCache"
	self checkIsNotRootObject: array.
	self
		sendAt: 1
		Put: newObject
		to: array.

	self checkIsRootObject: array.
	self assert: array = #( 'A new string' 20 30)! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 20:25'!
testAtPutFromYoungToOld
	| newObject array |
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.

	newObject := 'A new string' copy.
	Smalltalk garbageCollect.
	array := Array 
		with: 10
		with: 20
		with: 30.

	array
		at: 1
		put: 11. "Prime the atCache"
	self checkIsNotRootObject: array.
	self
		sendAt: 1
		Put: newObject
		to: array.

	self checkIsNotRootObject: array.
	self assert: array = #( 'A new string' 20 30)! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 12/18/2004 17:15'!
testAtPutSideEffecting
	self compile: '|array| array := Array new: 1. array at: 1 put: 42. ^ array'.
	self assert: (self example at: 1) = 42.
	! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/22/2003 17:10'!
testBasicRememberSets
	| object newObject |
	object := ExuperyInstanceVariables new.
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.

	Smalltalk garbageCollect.
	newObject := 'A new string' copy.

	object
		a: newObject
		b: 20.

	self checkIsRootObject: object.
	self assert: object getA = newObject.
	self assert: object getB = 20.! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/23/2003 21:40'!
testBasicRememberSetsBothOld
	| object newObject |
	object := ExuperyInstanceVariables new.
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.

	newObject := 'A new string' copy.
	Smalltalk garbageCollect.

	object
		a: newObject
		b: 20.

	self checkIsNotRootObject: object.
	self assert: object getA = newObject.
	self assert: object getB = 20.! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 1/31/2005 20:50'!
testBasicRememberSetsBothYoung
	| object newObject |
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.

	Smalltalk garbageCollect.
	object := ExuperyInstanceVariables new.

	newObject := 'A new string' copy.

	object
		a: newObject
		b: 20.

	self checkIsNotRootObject: object.
	self assert: object getA = newObject.
	self assert: object getB = 20.! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 1/24/2004 15:35'!
testBasicRememberSetsFromYoungToOld
	| object newObject |
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.

	newObject := 'A new string' copy.
	Smalltalk garbageCollect.
	object := ExuperyInstanceVariables new.

	object 
		a: newObject
		b: 20.

	self checkIsNotRootObject: object.
	self assert: object getA = newObject.
	self assert: object getB = 20! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/14/2003 15:18'!
testBasicSend
	self 
		compile: #basicSend
		into: #basicSend.
	self assert: self basicSend = 6! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/15/2003 22:38'!
testBasicSend2
	self 
		compile: #sendStringConcatenate
		into: #sendStringConcatenate.
	self assert: self sendStringConcatenate = 'abcdef'! !

!TestExuperyPlugin methodsFor: 'Test - Real Methods' stamp: 'wbk 7/15/2004 23:33'!
testBenchFib
	Exupery 
		compileMethod: #benchFib
		class: Integer.
	self assert: 1 benchFib = 1.
	self assert: 2 benchFib = 3.
	self assert: 3 benchFib = 5! !

!TestExuperyPlugin methodsFor: 'Test - Real Methods' stamp: 'wbk 7/15/2004 23:33'!
testBenchFibLarge
	"A large number of calls to compiled methods used to blow the C stack.
	The problem was caused by some recursion used to handle re-entering compiled
	code from compiled code. This will also occur if a lot of primitives are called from
	a compiled method."

	Exupery 
		compileMethod: #benchFib
		class: Integer.
	self assert: 30 benchFib = 2692537! !

!TestExuperyPlugin methodsFor: 'Test - Real Methods' stamp: 'wbk 3/6/2005 10:59'!
testBenchmark
	Exupery 
		compileMethod: #benchmark
		class: Integer.
	self assert: 0 benchmark = nil.
	self assert: 1 benchmark = 1028.
	self assert: 3 benchmark = 1028! !

!TestExuperyPlugin methodsFor: 'Test - Real Methods' stamp: 'wbk 3/6/2005 11:00'!
testBenchmarkLarge
	Exupery 
		compileMethod: #benchmark
		class: Integer.
	self assert: 10 benchmark = 1028! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift
	self compileExpression: '5 bitShift: 2'.
	self assert: self example = 20! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift2
	self compileExpression: '5 bitShift: 3'.
	self assert: self example = 40! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift3
	self compileExpression: '5 bitShift: 1'.
	self assert: self example = 10! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift4
	"Test a shift of more than one byte. To check some Intel instruction set weirdness"

	self compileExpression: '5 bitShift: 512'.
	self assert: self example class = LargePositiveInteger! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift5
	"Test a shift of more than one byte. To check some Intel instruction set weirdness"

	self compileExpression: '5 bitShift: 32'.
	self assert: self example = 21474836480! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift6
	"Test a shift of more than one byte. To check some Intel instruction set weirdness"

	self compileExpression: '5 bitShift: 33'.
	self assert: self example = 42949672960! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift7
	"Test a shift of more than one byte. To check some Intel instruction set weirdness"

	self compileExpression: '5 bitShift: 256'.
	self assert: self example class = LargePositiveInteger! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftNegative
	self compileExpression: '100 bitShift: -3'.
	self assert: self example = 12! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftNegative2
	self compileExpression: '100 bitShift: -1'.
	self assert: self example = 50! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftNegative3
	self compileExpression: '2 bitShift: -512'.
	self assert: self example = 0! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftNegativeNumber
	self compileExpression: '-1 bitShift: -5'.
	self assert: self example = -1! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftNegativeNumber2
	self compileExpression: '-1 bitShift: 1'.
	self assert: self example = -2! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftOverflows
	self compileExpression: '1000000000 bitShift: 1'.
	self assert: self example = 2000000000! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftOverflows2
	"this makes sure that we handle overflows correctly. It's possible that the generic wrapper
	code will handle overflows by one bit. This overflows by a lot. As a 32 bit number, the
	result should be zero, so unless we resort to the primitive it will fail."

	self compileExpression: '1000000000 bitShift: 15'.
	self assert: self example = 32768000000000! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftOverflows3
	"this makes sure that we handle overflows correctly. It's possible that the generic wrapper
	code will handle overflows by one bit. This overflows by a lot. As a 32 bit number, the
	result should be zero, so unless we resort to the primitive it will fail."

	self compileExpression: '1024 bitShift: 30'.
	self assert: self example = 1099511627776! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftReceiverLarge
	self compileExpression: '5000000000 bitShift: 2'.
	self assert: self example = 20000000000! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftReceiverLarge2
	self compileExpression: '5000000001 bitShift: 2'.
	self assert: self example = 20000000004! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftReceiverLarge3
	self compileExpression: '5000000001 bitShift: 4'.
	self assert: self example = 80000000016! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftZero
	self compileExpression: '5 bitShift: 0'.
	self assert: self example = 5! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 7/19/2003 20:09'!
testBytecodePrimSendWithArg
	| answer |
	self 
		compile: #bytecodePrimSendWithArg
		into: #bytecodePrimSendWithArg.
	answer := self bytecodePrimSendWithArg.
	self should: [answer class = Array].
	self assert: answer size = 5.
	! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testClass
	"There are three cases to concider. First, the class is an integer. Second, the class is
	a compact class. Third, the class has a full class header"

	self compileExpression: '10 class'.
	self assert: self example = SmallInteger! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testClass2
	| answer |
	self compileExpression: 'Array new class'.
	answer := self example.
	self assert: answer = Array! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testClass3
	self compileExpression: 'Set new class'.
	self assert: self example = Set! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testClass4
	self compileExpression: 'TestExuperyPlugin new class'.
	self assert: self example = TestExuperyPlugin! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testClass5
	self compileExpression: '#aSymbol class'.
	self assert: self example = Symbol! !

!TestExuperyPlugin methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 18:53'!
testDeconversionRemoveIfTrue
	self compileExpression: '6 = 5 ifTrue: [10]'.
	self should: [self example = nil]! !

!TestExuperyPlugin methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 18:52'!
testDeconversionRemoveIfTrue2
	self compileExpression: '6 = 6 ifTrue: [10]'.
	self should: [self example = 10]! !

!TestExuperyPlugin methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 20:32'!
testDeconversionRemoveLongJumpIfFalse
	self compile: '6 = 6 ifTrue: [^ 10]. ^ 20'.
	self should: [self example = 10]! !

!TestExuperyPlugin methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 20:32'!
testDeconversionRemoveLongJumpIfFalse2
	self compile: '6 = 5 ifTrue: [^ 10]. ^ 20'.
	self should: [self example = 20]! !

!TestExuperyPlugin methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 20:33'!
testDeconversionRemoveLongJumpIfTrue
	self compile: '6 = 5 ifFalse: [^ 10]. ^ 20'.
	self should: [self example = 10]! !

!TestExuperyPlugin methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 20:34'!
testDeconversionRemoveLongJumpIfTrue2
	self compile: '6 = 6 ifFalse: [^ 10]. ^ 20'.
	self should: [self example = 20]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDiv
	self compileExpression: '7 // 2'.
	self should: [self example = 3]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDiv2
	self compileExpression: '11 // 2'.
	self should: [self example = 5]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDiv3
	self compileExpression: '-11 // 2'.
	self should: [self example = -6]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivArgumentNotInteger
	self compileExpression: '2001 // 7000000000'.
	self should: [self example = 0]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivReceiverNotInteger
	self compileExpression: '11000000001 // 2'.
	self should: [self example = 5500000000]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivReceiverNotInteger2
	self compileExpression: '-21000000001 // 2'.
	self should: [self example = -10500000001]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivide
	self compileExpression: '6 / 2'.
	self should: [self example = 3]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivide2
	self compileExpression: '6 / 3'.
	self should: [self example = 2]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideArgumentNotInteger
	self compileExpression: '6 / 2.0'.
	self should: [self example = 3.0]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideByZero
	self compileExpression: '6 / 0'.
	self 
		should: [self example]
		raise: ZeroDivide! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideCreatingFraction
	self compileExpression: '5 / 2'.
	self should: [self example = (5 / 2)]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideCreatingFraction2
	self compileExpression: '12 / 7'.
	self should: [self example = (12 / 7)]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideNegativeNumber
	"The Intel x86 CPU uses two registers to represent the dividend. The top register
	needs to be the sign extended version of the bottom register. This means that clearing
	the top register (EDX) would work for positive numbers but not negative numbers. Thus
	we need to check negatives for division but not for other arithmatic operations"

	self compileExpression: '-6 / 2'.
	self should: [self example = -3]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideNegativeNumber2
	"The Intel x86 CPU uses two registers to represent the dividend. The top register
	needs to be the sign extended version of the bottom register. This means that clearing
	the top register (EDX) would work for positive numbers but not negative numbers. Thus
	we need to check negatives for division but not for other arithmatic operations"

	self compileExpression: '-6000 / 3000'.
	self should: [self example = -2]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideOverFlow
	| answer |
	self compileExpression: 'SmallInteger minVal / -1'.
	answer := self example.
	self assert: answer = (SmallInteger minVal * -1).
	self assert: (answer isKindOf: LargePositiveInteger)! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideReceiverNotInteger
	self compileExpression: '6.0 / 2'.
	self should: [self example = 3.0]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testEqualsSendingEqual
	self compileExpression: '5.0 = 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testEqualsSendingGreater
	self compileExpression: '6.0 = 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testEqualsSendingLess
	self compileExpression: '4.0 = 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testEqualsWhenEquals
	self compileExpression: '6 = 6'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testEqualsWhenGreater
	self compileExpression: '6 = 5'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testEqualsWhenLess
	self compileExpression: '4 = 5'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testEquivilent
	self compileExpression: '10 == 20 ifFalse: [^ #failed]'.
	self assert: self example = #failed! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testEquivilent2
	self compileExpression: '10 == 20 '.
	self assert: self example = false! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testEquivilent3
	self compileExpression: '20 == 20 '.
	self assert: self example = true! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 6/16/2004 22:39'!
testExtendedSend
	self 
		compile: #extendedSend
		into: #extendedSend.
	self assert: self extendedSend = 42! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 10/4/2004 21:43'!
testExtendedTemporaries
	| variables |
	Exupery 
		compileMethod: #basicTemps
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	self assert: variables basicTemps = 35! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanEqualSendingEqual
	self compileExpression: '5.0 >= 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanEqualSendingGreater
	self compileExpression: '6.0 >= 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanEqualSendingLess
	self compileExpression: '4.0 >= 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanEqualWhenEquals
	self compileExpression: '5 >= 5'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanEqualWhenGreater
	self compileExpression: '6 >= 5'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanEqualWhenLess
	self compileExpression: '4 >= 5'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanSendingEquals
	self compileExpression: '5.0 > 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanSendingGreater
	self compileExpression: '6.0 > 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanSendingLess
	self compileExpression: '4.0 > 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanWhenEquals
	self compileExpression: '5 > 5'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanWhenGreater
	self compileExpression: '7 > 6'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanWhenLess
	self compileExpression: '5 > 6'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 18:53'!
testIfFalseDeconversionRemoval
	self compileExpression: '6 = 5 ifFalse: [10]'.
	self should: [self example = 10]! !

!TestExuperyPlugin methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 18:55'!
testIfFalseDeconversionRemoval2
	self compileExpression: '6 = 6 ifFalse: [10]'.
	self should: [self example = nil]! !

!TestExuperyPlugin methodsFor: 'Test - Assembling Methods' stamp: 'wbk 4/17/2003 10:39'!
testIterativeFactorial
	self
		compile: #iterativeFactorial
		into: #returnNumber.
	self should: [self returnNumber = 6]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanEqualArgumentNotInteger
	self compileExpression: '5 <= 6.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanEqualReceiverNotInteger
	self compileExpression: '5.0 <= 6'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanEqualSendingAndEquals
	self compileExpression: '5 <= 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanEqualSendingAndGreater
	self compileExpression: '5 <= 4.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanEqualSendingAndLess
	self compileExpression: '4 <= 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 4/17/2003 10:39'!
testLessThanEqualsWhenEquals
	self
		compile: #lessThanEqualsWhenEquals
		into: #returnNumber.
	self should: [self returnNumber = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 4/17/2003 10:40'!
testLessThanEqualsWhenGreater
	self
		compile: #lessThanEqualsWhenGreater
		into: #returnNumber.
	self should: [self returnNumber = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 4/17/2003 10:41'!
testLessThanEqualsWhenLess
	self
		compile: #lessThanEqualsWhenLess
		into: #returnNumber.
	self should: [self returnNumber = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanSendingEquals
	self compileExpression: '5.0 < 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanSendingGreater
	self compileExpression: '4 < 3.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanSendingLess
	self compileExpression: '4.0 < 5'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanWhenEquals
	self compileExpression: '5 < 5'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanWhenGreater
	self compileExpression: '4 < 3'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanWhenLess
	self compileExpression: '4 < 5'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Method Registering' stamp: 'wbk 7/17/2004 18:43'!
testLoadOverflow
	self
		should: 
			[[true] whileTrue: [Exupery loadCode: (ByteArray new: 10000)]]
		raise: Exception.
	! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/15/2004 12:20'!
testLongJumpIfFalseOnNonInteger
	self 
		compile: #longJumpIfFalseOnNonInteger
		into: #longJumpIfFalseOnNonInteger.
	self 
		should: [self longJumpIfFalseOnNonInteger]
		raise: ExuperyTestException
! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/13/2004 21:48'!
testLongJumpIfTrue
	self 
		compile: #longJumpIfTrue
		into: #longJumpIfTrue.
	self assert: self longJumpIfTrue = 42
! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:20'!
testLongJumpIfTrueOnFalse
	self 
		compile: #longJumpIfTrueOnFalse
		into: #longJumpIfTrueOnFalse.
	self assert: self longJumpIfTrueOnFalse = 3
! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:40'!
testLongJumpIfTrueOnNonInteger
	self 
		compile: #longJumpIfTrueOnNonInteger
		into: #longJumpIfTrueOnNonInteger.
	self 
		should: [self longJumpIfTrueOnNonInteger]
		raise: ExuperyTestException
! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testMakePoint
	self compileExpression: ' 7 @ 13'.
	self assert: self example = (7 @ 13)! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testMakePointFloat
	self compileExpression: ' 7.5 @ 13'.
	self assert: self example = (7.5 @ 13)! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMod
	self compileExpression: '7 \\ 2'.
	self should: [self example = 1]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMod2
	self compileExpression: '10 \\ 4'.
	self should: [self example = 2]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMod3
	self compileExpression: '-10 \\ 4'.
	self should: [self example = 2]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMod4
	self compileExpression: '-30 \\ 7'.
	self should: [self example = 5]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMod5
	self compileExpression: '-30 \\ -7'.
	self should: [self example = -2]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMod6
	self compileExpression: '30 \\ -7'.
	self should: [self example = -5]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testModArgumentNotInteger
	self compileExpression: '1000 \\ 5000000000'.
	self should: [self example = 1000]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testModReceiverNotInteger
	self compileExpression: '-10000000001 \\ 4'.
	self should: [self example = 3]! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/18/2004 22:19'!
testMultipleMethods
	Exupery
		compileMethod: #return4
		into: #return5
		forClass: TestExuperyPlugin.
	Exupery
		compileMethod: #return6
		into: #return7
		forClass: TestExuperyPlugin.
	Exupery
		compileMethod: #return8
		into: #return9
		forClass: TestExuperyPlugin.
	self assert: self return5 = 4.
	self assert: self return7 = 6.
	self assert: self return9 = 8.! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMultiplicationArgumentNotInteger
	self compileExpression: '2 * 3.0'.
	self should: [self example = 6.0]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMultiplicationOverflow
	self compileExpression: '1000000000 * 2'.
	self should: [self example = 2000000000]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMultiplicationReceiverNotInteger
	self compileExpression: '2.0 * 5'.
	self should: [self example = 10.0]! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testNew
	self compileExpression: ' OrderedCollection new'.
	self assert: self example class = OrderedCollection! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testNew2
	self compileExpression: ' Array new'.
	self assert: self example class = Array! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testNext
	self compileExpression: '(Month month: 2 year: 2000) next'.
	self assert: self example asString = 'March 2000'! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testNext2
	self compileExpression: '(Month month: 6 year: 2000) next'.
	self assert: self example asString = 'July 2000'! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testNextPut
	self compileExpression: '((WriteStream on: Array new) nextPut: #abcd) contents'.
	self assert: self example = #(#abcd)! !

!TestExuperyPlugin methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 20:36'!
testNonIntegerDeconversionRemoval
	self compileExpression: '6.0 = 5 ifFalse: [10]'.
	self should: [self example = 10]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testNotEqualsSendingEqual
	self compileExpression: '5.0 ~= 5.0'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testNotEqualsSendingGreater
	self compileExpression: '6.0 ~= 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testNotEqualsSendingLess
	self compileExpression: '4.0 ~= 5.0'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testNotEqualsWhenEquals
	self compileExpression: '5 ~= 5'.
	self should: [self example = false]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testNotEqualsWhenGreater
	self compileExpression: '6 ~= 5'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testNotEqualsWhenLess
	self compileExpression: '4 ~= 5'.
	self should: [self example = true]! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testOr
	self compileExpression: ' 1 bitOr: 2'.
	self assert: self example = 3! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testOr2
	self compileExpression: ' 8 bitOr: 3'.
	self assert: self example = 11! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testOrArgumentLarge
	self compileExpression: ' 11 bitOr: 5000000000'.
	self assert: self example = 5000000011! !

!TestExuperyPlugin methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testOrReceiverLarge
	self compileExpression: ' 5000000000 bitOr: 3'.
	self assert: self example = 5000000003! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 3/6/2005 12:48'!
testPicSend
	self 
		compile: #trivialSend
		into: #trivialSend.
	self 
		compile: #basicTarget
		into: #basicTarget.
	self assert: self trivialSend = 5.
	self assert: self trivialSend = 5! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testPointX
	self compileExpression: '(10 @ 20) x'.
	self assert: self example = 10! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testPointX2
	self compileExpression: '(15 @ 20) x'.
	self assert: self example = 15! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testPointY
	self compileExpression: '(10 @ 20) y'.
	self assert: self example = 20! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testPointY2
	self compileExpression: '(10 @ 25) y'.
	self assert: self example = 25! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPopReceiverLarge
	| variables |
	Exupery 
		compileMethod: #i16
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i16: 42.
	self assert: variables i16 = 42! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPopReceiverLarge2
	| variables |
	Exupery 
		compileMethod: #i17
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i17: 42.
	self assert: variables i17 = 42! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/31/2003 16:22'!
testPopStack
	self compile: #popStack into: #popStack.
	self assert: self popStack = 5! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 10/4/2003 18:45'!
testPushConstantMinusOne
	self 
		compile: #pushConstantMinusOne
		into: #pushConstantMinusOne.
	self should: [self pushConstantMinusOne = -1]! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 10/4/2003 21:44'!
testPushConstantNill
	self 
		compile: #pushConstantNil
		into: #pushConstantNil.
	self should: [self pushConstantNil = nil]! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/19/2003 20:54'!
testPushConstantTrue
	| answer |
	self 
		compile: #pushConstantTrue
		into: #pushConstantTrue.
	answer := self pushConstantTrue.
	self should: [answer = true].
	! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/11/2003 11:24'!
testPushConstantZero
	self 
		compile: #pushConstantZero
		into: #pushConstantZero.
	self should: [self pushConstantZero = 0]! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/31/2003 16:22'!
testPushFalse
	| answer |
	self 
		compile: #pushFalse
		into: #pushFalse.
	answer := self pushFalse.
	self assert: answer = false.
	! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/31/2003 16:22'!
testPushLiteralVariable
	self 
		compile: #pushLiteralVariable
		into: #pushLiteralVariable.
	self assert: self pushLiteralVariable = Array
	! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPushReceiverLarge
	| variables |
	Exupery 
		compileMethod: #i16:
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i16: 42.
	self assert: variables i16 = 42! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPushReceiverLarge2
	| variables |
	Exupery 
		compileMethod: #i17:
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i17: 42.
	self assert: variables i17 = 42! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPushReceiverLarge3
	"The push bytecode overflows at 8 rather than 16 as with pops. This tests
	the smallest compact bytecodes decoding"

	| variables |
	Exupery 
		compileMethod: #i8:
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i8: 42.
	self assert: variables i8 = 42! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 9/29/2003 21:04'!
testPushReceiverVariables
	| object |
	object := ExuperyInstanceVariables new.
	self 
		compile: #a
		into: #a
		class: ExuperyInstanceVariables.
	object
		a: 10
		b: 20.
	self assert: object a = 10.! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 9/29/2003 21:04'!
testPushReceiverVariables2
	| object |
	object := ExuperyInstanceVariables new.
	self
		compile: #b
		into: #b
		class: ExuperyInstanceVariables.
	object
		a: 10
		b: 20.
	self assert: object b = 20.! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 10/21/2004 20:37'!
testPushReceiverVariablesWithSideEffects
	| object |
	object := ExuperyInstanceVariables new.
	self 
		compile: #sideEffects
		into: #sideEffects
		class: ExuperyInstanceVariables.
	self assert: object sideEffects = 7.! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 10/3/2004 11:34'!
testRecursiveStackTracing
	self compileExpression: 'false 
			ifTrue: [5] 
			ifFalse: [false 
				ifTrue: [10]
				ifFalse: [15]]'.
	self assert: self example = 15! !

!TestExuperyPlugin methodsFor: 'Test - Method Registering' stamp: 'wbk 7/15/2004 23:33'!
testRegisterFunctionTwice
	Exupery 
		compileMethod: #returnNumber
		class: TestExuperyPlugin.
	Exupery 
		compileMethod: #returnNumber
		class: TestExuperyPlugin.
	self should: [self returnNumber = 5]! !

!TestExuperyPlugin methodsFor: 'Test - Real Methods' stamp: 'wbk 12/12/2004 23:37'!
testRegisterPressure
	self compileExpression: '1 + (2 + (3 + (4 + (5 + (6 + (7 + 8))))))'.
	self assert: self example = 36! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/17/2003 10:49'!
testReturnArgument
 	self
		compile: #returnArgument:
		into: #returnArgument:.
	self should: [(self returnArgument: 3) = 6].
	self should: [(self returnArgument: 4) = 8]! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 11/27/2003 19:52'!
testReturnFalse
	self 
		compile: #returnFalse
		into: #returnFalse.
	self assert: self returnFalse = false! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/18/2003 13:39'!
testReturnNil
	self 
		compile: #returnNil
		into: #returnNil.
	self assert: self returnNil = nil! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/16/2003 22:13'!
testReturnSelf
	self 
		compile: #returnSelf
		into: #returnSelf.
	self assert: self returnSelf = self! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/16/2003 22:24'!
testReturnSelfBytecode
	self 
		compile: #returnSelfBytecode
		into: #returnSelfBytecode.
	self assert: self returnSelfBytecode = self! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/17/2003 10:49'!
testReturnString
	self
		compile: #returnString
		into: #returnString.
	self should: [self returnString = 'Hello World']! !

!TestExuperyPlugin methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 11/24/2003 23:14'!
testReturnTrue
	self 
		compile: #returnTrue
		into: #returnTrue.
	self assert: self returnTrue = true! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 8/15/2003 14:06'!
testSendAtOutsideTheArray
	| array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendAtOutsideTheArray:
		into: #sendAtOutsideTheArray:.
	
	self 
		should: [self sendAtOutsideTheArray: array.]
		raise: Error
		description: 'Array out of bounds failing'.
	self 
		should: [self sendAtOutsideTheArray: array.]
		raise: Error
		description: 'Array out of bounds failing'.
	! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 7/31/2003 16:13'!
testSendAtPut
	| answer array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendAtPut:
		into: #sendAtPut:.
	answer := self sendAtPut: array.
	self assert: answer = #50.
	self assert: array = #(10 20 50).
	! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 8/11/2003 22:20'!
testSendAtPutDouble
	"Double because of the atCache, the first time primes the cache"
	| answer array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendAtPut:
		into: #sendAtPut:.
	answer := self sendAtPut: array.
	answer := self sendAtPut: array.
	self assert: answer = #50.
	self assert: array = #(10 20 50).
	! !

!TestExuperyPlugin methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 8/11/2003 22:21'!
testSendPrimAt
	| answer array |
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendPrimAt:
		into: #sendPrimAt:.
	answer := self sendPrimAt: array.
	self should: [answer = 20].
	! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 8/10/2003 18:05'!
testSendPrimAtDouble
	| answer array |
	"Tests that the cache works, the first call will prime the atCache and the second call
	should use the cache"
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendPrimAt:
		into: #sendPrimAt:.
	answer := self sendPrimAt: array.
	self assert: answer = 20.
	answer := self sendPrimAt: array.
	self assert: answer = 20.
	! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 4/12/2004 15:32'!
testSendWithArguments
	" Checks that rematerialising the stack doesn't trash arguments and temporaries. Temporaries
	  occur just before the stack in the frame."
	self 
		compile: #sendWithArg1:arg2:
		into: #sendWithArg1:arg2:.
	self assert: (self 
		sendWithArg1: 100
		arg2: 200) = 315! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 7/7/2003 13:02'!
testSendWithTemporaries
	" Checks that rematerialising the stack doesn't trash temporaries. Temporaries
	  occur just before the stack in the frame."
	self 
		compile: #sendWithTemporaries
		into: #sendWithTemporaries.
	self assert: self sendWithTemporaries = 15! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 9/29/2004 21:28'!
testSendWithTemporariesSimple
	" Checks that rematerialising the stack doesn't trash temporaries. Temporaries
	  occur just before the stack in the frame."
	self 
		compile: #sendWithTemporariesSimple
		into: #sendWithTemporariesSimple.
	self assert: self sendWithTemporariesSimple = 10! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/28/2004 15:12'!
testShortUnconditionalJump
	self 
		compile: #shortUnconditionalJump
		into: #shortUnconditionalJump.
	self assert: self shortUnconditionalJump = nil
! !

!TestExuperyPlugin methodsFor: 'Test - Jumps' stamp: 'wbk 2/28/2004 15:12'!
testShortUnconditionalJump2
	self 
		compile: #shortUnconditionalJump2
		into: #shortUnconditionalJump2.
	self assert: self shortUnconditionalJump2 = nil
! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testSize
	self compileExpression: '#abcd size'.
	self assert: self example = 4! !

!TestExuperyPlugin methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testSize2
	self compileExpression: '''abcde'' size'.
	self assert: self example = 5! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 10/3/2004 11:34'!
testStackTracing
	"The origional stack tracing code did not handle tracing the stack across jumps. These
	tests cover the stack being non empty across jumps."

	self compileExpression: 'true ifTrue: [5] ifFalse: [10]'.
	self assert: self example = 5! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 10/3/2004 11:34'!
testStackTracing2
	self compileExpression: 'false ifTrue: [5] ifFalse: [10]'.
	self assert: self example = 10! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 12/2/2004 22:39'!
testStoreAndPopReceiverVariables
	| object |
	object := ExuperyInstanceVariables new.
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.
	object
		a: 10
		b: 20.
	self assert: object a = 10.
	self assert: object b = 20.! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testStoreInstanceExtended
	| variables |
	Exupery 
		compileMethod: #storeInstanceExtended2
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	self assert: variables storeInstanceExtended2 = 20! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testStoreTempExtended
	| variables |
	Exupery 
		compileMethod: #storeTempExtended
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	self assert: variables storeTempExtended = 30! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testSubtractArgumentNotInteger
	self compileExpression: '5 - 4.0'.
	self should: [self example = 1.0]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testSubtractOverflow
	self compileExpression: '-1000000000 - 1000000000'.
	self should: [self example = -2000000000]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testSubtractReceiverNotInteger
	self compileExpression: '5.0 - 2'.
	self should: [self example = 3.0]! !

!TestExuperyPlugin methodsFor: 'Test - Stack' stamp: 'wbk 10/21/2004 20:26'!
testTemporariesWithSideEffects
	self compile: '|a| a := 1. ^(a:= a +1) + (a := a + 1)'.
	self should: [self example = 5]! !

!TestExuperyPlugin methodsFor: 'Test - Arithmatic' stamp: 'wbk 4/17/2003 10:50'!
testThreeTimesFour
	self 
		compile: #threeTimesFour
		into: #returnNumber.
	self should: [self returnNumber = 12]! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/18/2004 22:19'!
testTwoMethods
	Exupery
		compileMethod: #return4
		into: #return5
		forClass: TestExuperyPlugin.
	Exupery
		compileMethod: #return6
		into: #return7
		forClass: TestExuperyPlugin.
	self assert: self return5 = 4.
	self assert: self return7 = 6.! !

!TestExuperyPlugin methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/18/2004 22:19'!
testTwoReturns
	Exupery
		compileMethod: #sendReturn4
		into: #sendReturn4Hook
		forClass: TestExuperyPlugin.
	Exupery
		compileMethod: #sendReturn6
		into: #sendReturn6Hook
		forClass: TestExuperyPlugin.
	self assert: self sendReturn4Hook = 14.
	self assert: self sendReturn6Hook = 16.! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 3/30/2003 21:09'!
threePlusFour
	^ 3 + 4! !

!TestExuperyPlugin methodsFor: 'Example Methods' stamp: 'wbk 4/11/2003 17:40'!
threeTimesFour
	^ 3 * 4! !

!TestExuperyPlugin methodsFor: 'Test - Sends' stamp: 'wbk 3/3/2005 21:54'!
trivialSend
	^ self basicTarget! !

!Interpreter class methodsFor: '*Exupery-override' stamp: 'wbk 4/12/2004 00:11'!
initializeCompilerHooks
	"Interpreter initializeCompilerHooks"

	"compilerHooks[] indices:
	1	void compilerTranslateMethodHook(void)
	2	void compilerFlushCacheHook(CompiledMethod *oldMethod)
	3	void compilerPreGCHook(int fullGCFlag)
	4	void compilerMapHook(int memStart, int memEnd)
	5	void compilerPostGCHook(void)
	6	void compilerProcessChangeHook(void)
	7	void compilerPreSnapshotHook(void)
	8	void compilerPostSnapshotHook(void)
	9	void compilerMarkHook(void)
	10	void compilerActivateMethodHook(void)
	11	void compilerNewActiveContextHook(int sendFlag)
	12	void compilerGetInstructionPointerHook(void)
	13	void compilerSetInstructionPointerHook(void)
	14	void compilerCreateActualMessageHook(void)"

	"Added a few more compiler hooks for Exupery's use"
	CompilerHooksSize _ 25.! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 3/13/2004 20:13'!
commonReturn
	"Note: Assumed to be inlined into the dispatch loop."

	| nilOop thisCntx contextOfCaller localCntx localVal unwindMarked |
	self inline: true.
	self sharedCodeNamed: 'commonReturn' inCase: 120.

	nilOop _ nilObj. "keep in a register"
	thisCntx _ activeContext.
	localCntx _ localReturnContext.
	localVal _ localReturnValue.

	"make sure we can return to the given context"
	((localCntx = nilOop) or:
	 [(self fetchPointer: InstructionPointerIndex ofObject: localCntx) = nilOop]) ifTrue: [
		"error: sender's instruction pointer or context is nil; cannot return"
		^self internalCannotReturn: localVal].

	"If this return is not to our immediate predecessor (i.e. from a method to its sender, or from a block to its caller), scan the stack for the first unwind marked context and inform this context and let it deal with it. This provides a chance for ensure unwinding to occur."
	thisCntx _ self fetchPointer: SenderIndex ofObject: activeContext.

	"Just possibly a faster test would be to compare the homeContext and activeContext - they are of course different for blocks. Thus we might be able to optimise a touch by having a different returnTo for the blockreteurn (since we know that must return to caller) and then if active ~= home we must be doing a non-local return. I think. Maybe."
	[thisCntx = localCntx] whileFalse: [
		thisCntx = nilOop ifTrue:[
			"error: sender's instruction pointer or context is nil; cannot return"
			^self internalCannotReturn: localVal].
		"Climb up stack towards localCntx. Break out to a send of #aboutToReturn:through: if an unwind marked context is found"
		unwindMarked _ self isUnwindMarked: thisCntx.
		unwindMarked ifTrue:[
			"context is marked; break out"
			^self internalAboutToReturn: localVal through: thisCntx].
		thisCntx _ self fetchPointer: SenderIndex ofObject: thisCntx.
 ].

	"If we get here there is no unwind to worry about. Simply terminate the stack up to the localCntx - often just the sender of the method"
	thisCntx _ activeContext.
	[thisCntx = localCntx]
		whileFalse:
		["climb up stack to localCntx"
		contextOfCaller _ self fetchPointer: SenderIndex ofObject: thisCntx.

		"zap exited contexts so any future attempted use will be caught"
		self storePointerUnchecked: SenderIndex ofObject: thisCntx withValue: nilOop.
		self storePointerUnchecked: InstructionPointerIndex ofObject: thisCntx withValue: nilOop.
		reclaimableContextCount > 0 ifTrue:
			["try to recycle this context"
			reclaimableContextCount _ reclaimableContextCount - 1.
			self recycleContextIfPossible: thisCntx].
		thisCntx _ contextOfCaller].

	activeContext _ thisCntx.
	(thisCntx < youngStart) ifTrue: [ self beRootIfOld: thisCntx ].

	self internalFetchContextRegisters: thisCntx.  "updates local IP and SP"
	self fetchNextBytecode.
	self internalPush: localVal.
	
	"Returns into a compiled method, if the method is compiled"
	self externalizeIPandSP.
	self exuperyReturnHook ifTrue: 
		[self internalizeIPandSP. 
		self fetchNextBytecode.
		self externalizeIPandSP]. 
	self internalizeIPandSP.
! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 1/29/2005 21:58'!
exuperyActiveContextAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^  self addressOf: activeContext! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 12/26/2004 22:05'!
exuperyAtCacheAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self addressOf: atCache! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 3/7/2005 21:58'!
exuperyCallMethod
	"Could move into compiled return sequence.
											It depends on how message sends end up working."

	| answer activeCntxt nativeMethod |
	self inline: false.
	activeCntxt := activeContext.
	nativeMethod := newNativeMethod.
	"Exupery only uses the active context, the rest it will get directly from the MethodContext object."
	self storeContextRegisters: activeContext.
	answer := self cCode: '( (int (*)(int))nativeMethod)(activeCntxt)'.
	self exuperyCompiledReturn: answer.
	^nil! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 2/7/2005 21:39'!
exuperyCallMethodHook
	self inline: true.
	newNativeMethod = nil ifTrue: [^false].
	self exuperyCallMethod.
	^true! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 12/26/2004 22:28'!
exuperyCheckRootTableFor: object
	| flag |
	self inline: false.
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	flag := false.
	1 
		to: rootTableCount
		do:
			[:each| (rootTable at: each) = object ifTrue: [flag := true]].
	^ flag! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 2/19/2005 20:52'!
exuperyCompiledReturn: answer 
	| aFunction ans ctx |
	self 
		var: #aFunction
		declareC: 'int (*aFunction) (int)'.
	ctx := activeContext.
	aFunction := self cCode: ' compilerHooks [18] (ctx)'.
	[self cCode: '(aFunction) !!= 0'] whileTrue: 
		[ctx := activeContext.
		ans := self cCode: 'aFunction (ctx)'.
		ctx := activeContext.
		self cCode: 'aFunction = compilerHooks [18] (ctx)'].
	self fetchContextRegisters: activeContext.! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 3/7/2005 22:40'!
exuperyCreateContext
	| newContext methodHeader tempCount nilOop where tmp |
	self export: true.	"allow lookup from elsewhere, e.g., plugin"
	
	tmp := self quickFetchInteger: StackPointerIndex ofObject: activeContext.
	stackPointer := activeContext + BaseHeaderSize + (TempFrameStart + tmp - 1 * 4). "Because a compiled method may have changed these"
	methodHeader := self headerOf: newMethod.
	newContext := self allocateOrRecycleContext: (methodHeader bitAnd: LargeContextBit).
	"initialIP := (LiteralStart + (self literalCountOfHeader: methodHeader)) * 4 + 1."
	tempCount := methodHeader >> 19 bitAnd: 63.	"Assume: newContext will be recorded as a root if necessary by the
	 call to newActiveContext: below, so we can use unchecked stores."
	where := newContext + BaseHeaderSize.
	self 
		longAt: where + (SenderIndex << 2)
		put: activeContext.
"	self 
		longAt: where + (InstructionPointerIndex << 2)
		put: (self integerObjectOf: initialIP).
	self 
		longAt: where + (StackPointerIndex << 2)
		put: (self integerObjectOf: tempCount)."
	self 
		longAt: where + (MethodIndex << 2)
		put: newMethod.	"Copy the reciever and arguments..."
	0 
		to: argumentCount
		do: 
			[:i | 
			self 
				longAt: where + (ReceiverIndex + i << 2)
				put: (self stackValue: argumentCount - i)].	"clear remaining temps to nil in case it has been recycled"
	nilOop := nilObj.
	argumentCount + 1 + ReceiverIndex 
		to: tempCount + ReceiverIndex
		do: 
			[:i | 
			self 
				longAt: where + (i << 2)
				put: nilOop].
	self pop: argumentCount + 1.
	reclaimableContextCount := reclaimableContextCount + 1.

	"self storeContextRegisters: activeContext."
	self storeWord: StackPointerIndex ofObject: activeContext
		withValue: (self integerObjectOf: (self stackPointerIndex - TempFrameStart + 1)).

	newContext < youngStart ifTrue: [self beRootIfOld: newContext].
	activeContext := newContext.
	"self fetchContextRegisters: newContext"! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 2/18/2005 21:32'!
exuperyCreateContextAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^ self cCode: '& exuperyCreateContext'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:26'!
exuperyFalseObjAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self addressOf: falseObj! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 1/30/2005 19:22'!
exuperyFreeContexts
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self addressOf: freeContexts! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 12/26/2004 22:44'!
exuperyLookupMethod
	| meth |
	meth := newMethod.
	^newNativeMethod := self cCode: 'compilerHooks[15](meth)'! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 2/7/2005 21:21'!
exuperyLookupMethodHook
	self inline: true.
	(self cCode: 'compilerHooks[15] !!= nullCompilerHook') ifTrue: [^self exuperyLookupMethod].
	^ nil! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/12/2004 00:15'!
exuperyMarkAndTrace
	^ self cCode: 'compilerHooks[19]()'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/12/2004 00:15'!
exuperyMarkAndTraceHook
	self inline: true.
	(self cCode: 'compilerHooks[19] !!= nullCompilerHook') ifTrue: [^ self exuperyMarkAndTrace] ! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:27'!
exuperyNilObjAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self addressOf: nilObj! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 3/6/2005 13:38'!
exuperyPopulatePic: picEntry with: compiledMethod receiver: aClass
	| picPosition |
	self inline: false. 
	picPosition := 0. "just so it generates"
	self cCode: 'picPosition = *(int *) picEntry'.
	self cCode: '*(char *) picPosition = 0x3D'.
	self cCode: '*(int *) (picPosition + 1) = aClass'.
	self cCode: '*(char *) (picPosition + 6) = 0x0f'.
	self cCode: '*(char *) (picPosition + 7) = 0x84'.
	self cCode: '*(int *) (picPosition + 8) = compiledMethod - (picPosition + 12)'.! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 1/30/2005 19:22'!
exuperyReclaimableContextCount
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self addressOf: reclaimableContextCount! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:26'!
exuperyRegisterCallMethod: aFunction 
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self cCode: 'compilerHooks[17] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:25'!
exuperyRegisterLookupMethod: aFunction 
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self cCode: 'compilerHooks[15] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:27'!
exuperyRegisterMarkObjects: aFunction
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^  self cCode: 'compilerHooks[19] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:26'!
exuperyRegisterRemapObjects: aFunction 
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self cCode: 'compilerHooks[16] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:26'!
exuperyRegisterReturnMethod: aFunction 
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self cCode: 'compilerHooks[18] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:58'!
exuperyRemapObjects
	^self cCode: 'compilerHooks[16]()'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:58'!
exuperyRemapObjectsHook
	self inline: true.
	(self cCode: 'compilerHooks[16] !!= nullCompilerHook') ifTrue: [^self exuperyRemapObjects]! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 3/8/2004 21:30'!
exuperyReturn: aFunction
	| answer activeCntxt |
	self inline: false.
	self var: #aFunction
		declareC: 'int (*aFunction) (int)'.
	activeCntxt := activeContext.
	answer := self cCode: 'aFunction (activeCntxt)'.
	self exuperyCompiledReturn: answer.
! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 12/27/2004 13:04'!
exuperyReturnHook
	| function ctx |
	self inline: true.

	" Return if active context isn't a compiled method."
	(self cCode: 'compilerHooks[18] !!= nullCompilerHook') ifFalse: [^ false].

	ctx := activeContext.
	(self cCode: '(function = compilerHooks [18] (ctx)) !!= 0') ifTrue: 
		[self exuperyReturn: function.
		^ true].
	^ false! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:27'!
exuperyRootTableAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^  self addressOf: rootTable! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:27'!
exuperyRootTableCountAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^  self addressOf: rootTableCount! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 3/7/2005 20:39'!
exuperySetup: selector Message: argumentsInteger Send: picPosition
	|rcvr|
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	self inline: false. 

	" Reload the context here, the interpreter code below depends on it."
	self fetchContextRegisters: activeContext.

	"The send bytecode"
	messageSelector := selector.
	argumentCount := argumentsInteger.

	"normalSend"
	rcvr := self stackValue: argumentCount.
	lkupClass := self fetchClassOf: rcvr.
	receiverClass := lkupClass.
	self findNewMethodInClass: lkupClass.
	newNativeMethod = nil 
		ifTrue:
			[self executeNewMethod. "executeNewMethod fetches the new context registers"
		 	"Load the stackPointer into the active context, it might have changed, e.g. if a primitive
			has been executed"
			self
				storeWord:  StackPointerIndex	
				ofObject: activeContext
				withValue: (self integerObjectOf: (stackPointer - activeContext) / 4 - TempFrameStart)]
		ifFalse:
			[self 
				exuperyPopulatePic: picPosition
				with: newNativeMethod
				receiver: receiverClass].
	"fetchNextBytecode must be done inside the interpreter loop/function"

	^ newNativeMethod  ! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'ar 12/18/2004 18:26'!
exuperySetupMessageSendAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^ self cCode: '& exuperySetupMessageSend'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:26'!
exuperySpecialObjectsOopAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^  self addressOf: specialObjectsOop! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:26'!
exuperyTrueObjAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self addressOf: trueObj! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:27'!
exuperyYoungStartAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^ self addressOf: youngStart! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 4/18/2004 20:57'!
findNewMethodInClass: class 
	"Find the compiled method to be run when the current messageSelector is sent to the given class, setting the values of 'newMethod' and 'primitiveIndex'."

	| ok |
	self inline: false.
	ok := self 
				lookupInMethodCacheSel: messageSelector
				class: class.
	ok ifFalse: 
			["entry was not found in the cache; look it up the hard way"

			self lookupMethodInClass: class.
			lkupClass := class.
			self exuperyLookupMethodHook.
			self addNewMethodToCache]! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 4/12/2004 00:12'!
initCompilerHooks
	"Initialize hooks for the 'null compiler'"

	self cCode: 'compilerHooks[1]= nullCompilerHook'.
	self cCode: 'compilerHooks[2]= nullCompilerHook'.
	self cCode: 'compilerHooks[3]= nullCompilerHook'.
	self cCode: 'compilerHooks[4]= nullCompilerHook'.
	self cCode: 'compilerHooks[5]= nullCompilerHook'.
	self cCode: 'compilerHooks[6]= nullCompilerHook'.
	self cCode: 'compilerHooks[7]= nullCompilerHook'.
	self cCode: 'compilerHooks[8]= nullCompilerHook'.
	self cCode: 'compilerHooks[9]= nullCompilerHook'.
	self cCode: 'compilerHooks[10]= nullCompilerHook'.
	self cCode: 'compilerHooks[11]= nullCompilerHook'.
	self cCode: 'compilerHooks[12]= nullCompilerHook'.
	self cCode: 'compilerHooks[13]= nullCompilerHook'.
	self cCode: 'compilerHooks[14]= nullCompilerHook'.
	self cCode: 'compilerHooks[15]= nullCompilerHook'.
	self cCode: 'compilerHooks[16]= nullCompilerHook'.
	self cCode: 'compilerHooks[17]= nullCompilerHook'.
	self cCode: 'compilerHooks[18]= nullCompilerHook'.
	self cCode: 'compilerHooks[19]= nullCompilerHook'.

	compilerInitialized _ false! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 2/7/2005 21:28'!
initializeInterpreter: bytesToShift 
	"Initialize Interpreter state before starting execution of a new image."

	interpreterProxy _ self sqGetInterpreterProxy.
	self dummyReferToProxy.
	self initializeObjectMemory: bytesToShift.
	self initCompilerHooks.
	activeContext _ nilObj.
	theHomeContext _ nilObj.
	method _ nilObj.
	receiver _ nilObj.
	messageSelector _ nilObj.
	newMethod _ nilObj.
	methodClass _ nilObj.
	lkupClass _ nilObj.
	receiverClass _ nilObj.
	newNativeMethod _ nil.
	self flushMethodCache.
	self loadInitialContext.
	self initialCleanup.
	interruptCheckCounter _ 0.
	interruptCheckCounterFeedBackReset _ 1000.
	interruptChecksEveryNms _ 1.
	nextPollTick _ 0.
	nextWakeupTick _ 0.
	lastTick _ 0.
	interruptKeycode _ 2094.	"cmd-."
	interruptPending _ false.
	semaphoresUseBufferA _ true.
	semaphoresToSignalCountA _ 0.
	semaphoresToSignalCountB _ 0.
	deferDisplayUpdates _ false.
	pendingFinalizationSignals _ 0! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 2/19/2005 19:42'!
internalExecuteNewMethod
	| localPrimIndex delta nArgs |
	self inline: true.

	" Call a compiled method if it's availible"	
	self externalizeIPandSP.
	self exuperyCallMethodHook ifTrue: 
		[self internalizeIPandSP.
		^ self].

	localPrimIndex := primitiveIndex.
	localPrimIndex > 0
		ifTrue: [(localPrimIndex > 255
					and: [localPrimIndex < 520])
				ifTrue: ["Internal return instvars"
					localPrimIndex >= 264
						ifTrue: [^ self internalPop: 1 thenPush: (self fetchPointer: localPrimIndex - 264 ofObject: self internalStackTop)]
						ifFalse: ["Internal return constants"
							localPrimIndex = 256 ifTrue: [^ nil].
							localPrimIndex = 257 ifTrue: [^ self internalPop: 1 thenPush: trueObj].
							localPrimIndex = 258 ifTrue: [^ self internalPop: 1 thenPush: falseObj].
							localPrimIndex = 259 ifTrue: [^ self internalPop: 1 thenPush: nilObj].
							^ self internalPop: 1 thenPush: (self integerObjectOf: localPrimIndex - 261)]]
				ifFalse: [self externalizeIPandSP.
					"self primitiveResponse. <-replaced with  manually inlined code"
					DoBalanceChecks
						ifTrue: ["check stack balance"
							nArgs := argumentCount.
							delta := stackPointer - activeContext].
					successFlag := true.
					self dispatchFunctionPointer: primitiveFunctionPointer. "branch direct to prim function from address stored in mcache"
					DoBalanceChecks
						ifTrue: [(self balancedStack: delta afterPrimitive: localPrimIndex withArgs: nArgs)
								ifFalse: [self printUnbalancedStack: localPrimIndex]].
					self internalizeIPandSP.
					successFlag
						ifTrue: [self browserPluginReturnIfNeeded.
							^ nil]]].
	"if not primitive, or primitive failed, activate the method"
	self internalActivateNewMethod.

	"check for possible interrupts at each real send"
	self internalQuickCheckForInterrupts! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 4/18/2004 20:57'!
internalFindNewMethod
	"Find the compiled method to be run when the current messageSelector is sent to the class 'lkupClass', setting the values of 'newMethod' and 'primitiveIndex'."

	| ok |
	self inline: true.
	ok := self 
				lookupInMethodCacheSel: messageSelector
				class: lkupClass.
	ok ifFalse: 
			["entry was not found in the cache; look it up the hard way"

			self externalizeIPandSP.
			self lookupMethodInClass: lkupClass.
			self exuperyLookupMethodHook.
			self internalizeIPandSP.
			self addNewMethodToCache]! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 12/26/2004 22:56'!
mapInterpreterOops
	"Map all oops in the interpreter's state to their new values 
	during garbage collection or a become: operation."
	"Assume: All traced variables contain valid oops."
	| oop |
	nilObj := self remap: nilObj.
	falseObj := self remap: falseObj.
	trueObj := self remap: trueObj.
	specialObjectsOop := self remap: specialObjectsOop.
	compilerInitialized
		ifFalse: [stackPointer := stackPointer - activeContext. "*rel to active"
			activeContext := self remap: activeContext.
			stackPointer := stackPointer + activeContext. "*rel to active"
			theHomeContext := self remap: theHomeContext].
	instructionPointer := instructionPointer - method. "*rel to method"
	method := self remap: method.
	instructionPointer := instructionPointer + method. "*rel to method"
	receiver := self remap: receiver.
	messageSelector := self remap: messageSelector.
	newMethod := self remap: newMethod.
	methodClass := self remap: methodClass.
	lkupClass := self remap: lkupClass.
	receiverClass := self remap: receiverClass.
	self exuperyRemapObjectsHook.	"Remap objects that the compiler plugin uses"
	1 to: remapBufferCount do: [:i | 
			oop := remapBuffer at: i.
			(self isIntegerObject: oop)
				ifFalse: [remapBuffer at: i put: (self remap: oop)]]! !

!Interpreter methodsFor: '*Exupery-override' stamp: 'wbk 2/8/2005 22:04'!
transferTo: aProc 
	"Record a process to be awoken on the next interpreter cycle. 
	ikp 11/24/1999 06:07 -- added hook for external runtime 
	compiler "
	| sched oldProc newProc |
	newProc := aProc.
	sched := self schedulerPointer.
	oldProc := self fetchPointer: ActiveProcessIndex ofObject: sched.
	self storePointer: ActiveProcessIndex ofObject: sched withValue: newProc.
	compilerInitialized
		ifTrue: [self compilerProcessChange: oldProc to: newProc]
		ifFalse: [self storePointer: SuspendedContextIndex ofObject: oldProc withValue: activeContext.
			self newActiveContext: (self fetchPointer: SuspendedContextIndex ofObject: newProc).
			self storePointer: SuspendedContextIndex ofObject: newProc withValue: nilObj].
	reclaimableContextCount := 0.
	newNativeMethod := nil.! !

MethodContext variableSubclass: #CompiledMethodContext
	instanceVariableNames: 'compiledCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Plugin'!

MethodDictionary variableSubclass: #ExuperyMethodDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!ExuperyMethodDictionary methodsFor: 'Overridden methods' stamp: 'wbk 7/8/2004 22:10'!
at: key put: value
	"Set the value at key to be value."
	| index |
	index := self findElementOrNil: key.
	(self basicAt: index) == nil
		ifTrue: 
			[tally := tally + 1.
			self basicAt: index put: key].
	array at: index put: value.
	self fullCheck.
	^ value! !

!Array methodsFor: '*Exupery-Additions' stamp: 'wbk 10/24/2004 17:33'!
expressionsDo: aBlock
	aBlock value: self.! !

!CCodeGenerator methodsFor: '*Exupery-override' stamp: 'ar 12/18/2004 18:10'!
generateAddressOf: node on: aStream indent: level
	"Generate the C code for this message onto the given stream."
	aStream nextPutAll: '((int)&'.
	self emitCExpression: node args first on: aStream.
	aStream nextPutAll: ')'.
! !

!CCodeGenerator methodsFor: '*Exupery-override' stamp: 'ar 12/18/2004 18:00'!
initializeCTranslationDictionary 
	"Initialize the dictionary mapping message names to actions for C code generation."

	| pairs |
	pairs _ #(
	#&				#generateAnd:on:indent:
	#|				#generateOr:on:indent:
	#and:			#generateSequentialAnd:on:indent:
	#or:			#generateSequentialOr:on:indent:
	#not			#generateNot:on:indent:

	#+				#generatePlus:on:indent:
	#-				#generateMinus:on:indent:
	#*				#generateTimes:on:indent:
	#/				#generateDivide:on:indent:
	#//				#generateDivide:on:indent:
	#\\				#generateModulo:on:indent:
	#<<				#generateShiftLeft:on:indent:
	#>>				#generateShiftRight:on:indent:
	#min:			#generateMin:on:indent:
	#max:			#generateMax:on:indent:

	#bitAnd:		#generateBitAnd:on:indent:
	#bitOr:			#generateBitOr:on:indent:
	#bitXor:			#generateBitXor:on:indent:
	#bitShift:		#generateBitShift:on:indent:
	#bitInvert32	#generateBitInvert32:on:indent:

	#<				#generateLessThan:on:indent:
	#<=				#generateLessThanOrEqual:on:indent:
	#=				#generateEqual:on:indent:
	#>				#generateGreaterThan:on:indent:
	#>=				#generateGreaterThanOrEqual:on:indent:
	#~=				#generateNotEqual:on:indent:
	#==				#generateEqual:on:indent:
	#~~				#generateNotEqual:on:indent:
	#isNil			#generateIsNil:on:indent:
	#notNil			#generateNotNil:on:indent:

	#whileTrue: 	#generateWhileTrue:on:indent:
	#whileFalse:	#generateWhileFalse:on:indent:
	#whileTrue 		#generateDoWhileTrue:on:indent:
	#whileFalse		#generateDoWhileFalse:on:indent:
	#to:do:			#generateToDo:on:indent:
	#to:by:do:		#generateToByDo:on:indent:

	#ifTrue:		#generateIfTrue:on:indent:
	#ifFalse:		#generateIfFalse:on:indent:
	#ifTrue:ifFalse:	#generateIfTrueIfFalse:on:indent:
	#ifFalse:ifTrue:	#generateIfFalseIfTrue:on:indent:

	#at:				#generateAt:on:indent:
	#at:put:			#generateAtPut:on:indent:
	#basicAt:		#generateAt:on:indent:
	#basicAt:put:	#generateAtPut:on:indent:

	#integerValueOf:	#generateIntegerValueOf:on:indent:
	#integerObjectOf:	#generateIntegerObjectOf:on:indent:
	#isIntegerObject: 	#generateIsIntegerObject:on:indent:
	#cCode:				#generateInlineCCode:on:indent:
	#cCode:inSmalltalk:	#generateInlineCCode:on:indent:
	#cCoerce:to:			#generateCCoercion:on:indent:
	#preIncrement		#generatePreIncrement:on:indent:
	#preDecrement		#generatePreDecrement:on:indent:
	#inline:				#generateInlineDirective:on:indent:
	#sharedCodeNamed:inCase:	#generateSharedCodeDirective:on:indent:
	#asFloat				#generateAsFloat:on:indent:
	#asInteger			#generateAsInteger:on:indent:
	#anyMask:			#generateBitAnd:on:indent:
	#raisedTo:			#generateRaisedTo:on:indent:
	#touch:				#generateTouch:on:indent:

	#perform:						#generatePerform:on:indent:
	#perform:with:					#generatePerform:on:indent:
	#perform:with:with:				#generatePerform:on:indent:
	#perform:with:with:with:		#generatePerform:on:indent:
	#perform:with:with:with:with:	#generatePerform:on:indent:
		
	#addressOf:			#generateAddressOf:on:indent:

	).
	translationDict _ Dictionary new: pairs size // 2.

	1 to: pairs size by: 2 do: [:i |
		translationDict at: (pairs at: i) put: (pairs at: i + 1)].
! !

PasteUpMorph subclass: #ExuperyMethodInspector
	instanceVariableNames: 'blocks edges method drawing text isAnimating'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Inspectors'!

!ExuperyMethodInspector class methodsFor: 'instance creation' stamp: 'wbk 7/11/2004 11:35'!
inspect: aMethod
	self new inspect: aMethod! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 1/23/2005 11:31'!
aMouseEnter: block node: event block: node 
	| stream |
	stream := WriteStream on: String new.
	block printOn: stream.
	text setText: stream contents! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:19'!
colorNodes
	"Color the switch node and the first node"

	(blocks at: (method blockAt: 1) blockName) backgroundColor: Color green.
	(blocks at: (method blockAt: 2) blockName) backgroundColor: Color green.
	method blocksDo: 
			[:eachBlock | 
			eachBlock instructionsDo: 
					[:eachExpression | 
					eachExpression isReturn ifTrue: [(blocks at: eachBlock blockName) backgroundColor: Color red]]]! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 3/6/2005 16:56'!
createEdges
	| connection to from toBlock |
	method blocksDo: 
			[:eachBlock | 
			eachBlock instructionsDo: 
					[:eachExpression | 
					eachExpression isJump ifTrue: 
							[from := blocks at: eachBlock blockName.
							toBlock := eachExpression target.
							toBlock isRegister ifFalse: 
								[to := blocks at: toBlock blockName.
								eachBlock = (method blockAt: 1) 
									ifTrue: [to backgroundColor: Color green]
									ifFalse: 
										["Not to an entry point"
	
										connection := NCAAConnectorMorph 
													fromMorph: from
													toMorph: to.
										connection line makeForwardArrow.
										drawing addMorph: connection.
										(edges at: from) add: to.
										(edges at: to) add: from]]]]]! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 7/11/2004 21:47'!
createNodes
	| blockMorph exuperyBlockMorph |
	method blocksDo: 
			[:each | 
			exuperyBlockMorph := NCTextRectangleMorph new.
			blockMorph := exuperyBlockMorph 
				setTextAt: 1
				to: each blockNumber asString.
			blockMorph 
				on: #mouseEnter  
				send: #aMouseEnter:node:block:
				to: self
				withValue: each.
			blockMorph borderWidth: 2.
			drawing addMorph: blockMorph.
			blockMorph position: drawing center.
			blockMorph extent: 20 @ 20.
			blocks 
				at: each blockName
				put: blockMorph.
			edges 
				at: blockMorph
				put: OrderedCollection new].! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/1/2004 11:49'!
createWindow
	| window |
	window := SystemWindow new.
	drawing := self.
	window 
		addMorph: drawing
		frame: (0 @ 0 corner: 0.85 @ 1).
	text := PluggableTextMorph new.
	text setText: ''.
	window 
		addMorph: text
		frame: (0.85 @ 0.05 corner: 1 @ 1).
		
	"Add the buttons"
	window
		addMorph: (SimpleButtonMorph new
			target: self;
			label: 'Start';
			actionSelector: #start)
		frame: (0.85@0 corner: 0.92@0.05).
	window
		addMorph: (SimpleButtonMorph new
			target: self;
			label: 'Stop';
			actionSelector: #stop)
		frame: (0.92@0 corner: 1@0.05).
		
	window openInWorld.
	self startStepping.! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 7/11/2004 20:54'!
drawGraph
	blocks := Dictionary new.
	edges := Dictionary new.
	self createNodes.
	self createEdges.
	self colorNodes.! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/1/2004 11:45'!
inspect: aMethod 
	isAnimating := true.
	self createWindow.
	method := aMethod.
	self drawGraph! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 7/11/2004 16:56'!
repulsiveMove
	| blockPosition delta edgePosition distance unitDistance |
	blocks do:
		[:eachBlock| 
		blockPosition := eachBlock position.
		delta := 0@0.
		blocks do:
			[:eachOther| 
			edgePosition := eachOther position.
			distance := blockPosition dist: edgePosition.
			distance = 0
				ifTrue: 
					[unitDistance := Point
						r: 1
						degrees: 360 atRandom]
				ifFalse: [unitDistance := (blockPosition - edgePosition) / distance].
			"delta := delta + unitDistance /10."
			distance < 150 ifTrue: [delta := delta + unitDistance].
			distance < 100 ifTrue: [delta := delta + (unitDistance * 3)].
			distance < 40 ifTrue: [delta := delta + (unitDistance * 10)]].
		eachBlock position: blockPosition + delta].! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 7/11/2004 16:58'!
springsMove
	| blockPosition delta edgePosition distance unitDistance |
	blocks do:
		[:eachBlock| 
		blockPosition := eachBlock position.
		delta := 0@0.
		(edges at: eachBlock) do:
			[:eachEdge| 
			edgePosition := eachEdge position.
			distance := blockPosition dist: edgePosition.
			distance = 0
				ifTrue: 
					[unitDistance := Point
						r: 1
						degrees: 360 atRandom]
				ifFalse: [unitDistance := (blockPosition - edgePosition) / distance].
			distance > 70
				ifTrue: [delta := delta - (unitDistance)].
			distance > 150
				ifTrue: [delta := delta - (unitDistance * 2)].
			distance > 300
				ifTrue: [delta := delta - (unitDistance * 4)]].
		eachBlock position: blockPosition + delta].! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/1/2004 11:47'!
start
	isAnimating := true.
	drawing startStepping.
	! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 7/11/2004 11:07'!
stayInsideWalls
	blocks do:
		[:each| 
		each left < drawing left ifTrue: [each left: drawing left + 20].
		each top < drawing top ifTrue: [each top: drawing top + 20].
		each right > drawing right ifTrue: [each right: drawing right - 20].
		each bottom > drawing bottom ifTrue: [each bottom: drawing bottom -20] ]! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 8/1/2004 11:46'!
step
	"blocks do:
		[:eachBlock| eachBlock position: eachBlock position + ((3 atRandom - 2) @ (3 atRandom - 2))]."
	isAnimating ifFalse: [^self stopStepping].
	self springsMove.
	self repulsiveMove.
	self stayInsideWalls.
	
			
! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 7/11/2004 11:04'!
stepTime
	^ 200
! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/1/2004 11:47'!
stop
	isAnimating := false.
	drawing stopStepping.! !
InterferenceNode initialize!
